#include "puzzle.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <set>
#define endl '\n'
using namespace std;

int n0, m0;
int tests;
double TL;

mt19937 rg(439012);

int v;
int br;
bool flag0;
int cnt[50][50];
int num[50][50];
bool used[2505];
int adj[2500][2500];
set<int> row[50], col[50];
vector< vector<int> > a, puzzle0;

double timePassed();

void init(int numSubtests, double timeLimit)
{
    tests = numSubtests;
    TL = timeLimit;
}

void DFS(int u)
{
    used[u] = true;
    br++;
    for (int i = 1; i <= v; ++ i)
    {
        if (adj[u][i] and !used[i]) DFS(i);
    }
}

bool check()
{
    for (int i = 0; i < n0; ++ i)
    {
        for (int j = 0; j < m0; ++ j)
        {
            if (cnt[i][j] != puzzle0[i][j]) return false;
        }
    }

    for (int i = 1; i <= v; ++ i)
    {
        used[i] = false;
    }

    br = 0;
    DFS(1);
    if (br != v and rg() % 2) return false;

    return true;
}

void go(int i, int j)
{
    if (i == n0)
    {
        if (check()) flag0 = true;
        return;
    }
    if (cnt[i][j] != puzzle0[i][j])
    {
        auto it1 = row[i].find(j);
        it1++;
        auto it2 = col[j].find(i);
        it2++;
        if (it1 == row[i].end() and it2 == col[i].end()) return;

        int t = puzzle0[i][j] - cnt[i][j];

        if (it1 == row[i].end())
        {
            if (t > 2) return;
            if (puzzle0[(*it2)][j] - cnt[(*it2)][j] < t) return;
            for (int i0 = i + 1; i0 < (*it2); ++ i0)
            {
                if (a[i0][j] != 0) return;
            }
            cnt[i][j] += t;
            cnt[(*it2)][j] += t;
            adj[num[i][j]][num[(*it2)][j]] = adj[num[(*it2)][j]][num[i][j]] = 1;
            for (int i0 = i + 1; i0 < (*it2); ++ i0)
            {
                a[i0][j] = -2 * t;
            }

            j++;
            if (j == m0)
            {
                j = 0;
                i++;
            }
            go(i, j);
            if (flag0) return;

            cnt[i][j] -= t;
            cnt[(*it2)][j] -= t;
            adj[num[i][j]][num[(*it2)][j]] = adj[num[(*it2)][j]][num[i][j]] = 0;
            for (int i0 = i + 1; i0 < (*it2); ++ i0)
            {
                a[i0][j] = 0;
            }
            return;
        }

        if (it2 == col[i].end())
        {
            if (t > 2) return;
            if (puzzle0[i][(*it1)] - cnt[i][(*it1)] < t) return;
            for (int j0 = j + 1; j0 < (*it1); ++ j0)
            {
                if (a[i][j0] != 0) return;
            }
            cnt[i][j] += t;
            cnt[i][(*it1)] += t;
            adj[num[i][j]][num[i][(*it1)]] = adj[num[i][(*it1)]][num[i][j]] = 1;
            for (int j0 = j + 1; j0 < (*it1); ++ j0)
            {
                a[i][j0] = -2 * t + 1;
            }

            j++;
            if (j == m0)
            {
                j = 0;
                i++;
            }
            go(i, j);
            if (flag0) return;

            cnt[i][j] -= t;
            cnt[i][(*it1)] -= t;
            adj[num[i][j]][num[i][(*it1)]] = adj[num[i][(*it1)]][num[i][j]] = 0;
            for (int j0 = j + 1; j0 < (*it1); ++ j0)
            {
                a[i][j0] = 0;
            }
            return;
        }

        for (int c1 = 0; c1 <= 2; ++ c1)
        {
            for (int c2 = 0; c2 <= 2; ++ c2)
            {
                if (c1 + c2 != t) continue;
                if (puzzle0[i][(*it1)] - cnt[i][(*it1)] < c1) continue;
                if (puzzle0[(*it2)][j] - cnt[(*it2)][j] < c2) continue;
                if (c1 > 0)
                {
                    bool flag = true;
                    for (int j0 = j + 1; j0 < (*it1); ++ j0)
                    {
                        if (a[i][j0] != 0) flag = false;
                    }
                    if (!flag) continue;
                }
                if (c2 > 0)
                {
                    bool flag = true;
                    for (int i0 = i + 1; i0 < (*it2); ++ i0)
                    {
                        if (a[i0][j] != 0) flag = false;
                    }
                    if (!flag) continue;
                }

                cnt[i][j] += t;
                cnt[i][(*it1)] += c1;
                if (c1 > 0) adj[num[i][j]][num[i][(*it1)]] = adj[num[i][(*it1)]][num[i][j]] = 1;
                cnt[(*it2)][j] += c2;
                if (c2 > 0) adj[num[i][j]][num[(*it2)][j]] = adj[num[(*it2)][j]][num[i][j]] = 1;
                for (int j0 = j + 1; j0 < (*it1); ++ j0)
                {
                    if (c1 > 0) a[i][j0] = -2 * c1 + 1;
                }
                for (int i0 = i + 1; i0 < (*it2); ++ i0)
                {
                    if (c2 > 0) a[i0][j] = -2 * c2;
                }

                int i0 = i, j0 = j;

                j++;
                if (j == m0)
                {
                    j = 0;
                    i++;
                }
                go(i, j);
                if (flag0) return;

                i = i0;
                j = j0;

                cnt[i][j] -= t;
                cnt[i][(*it1)] -= c1;
                cnt[(*it2)][j] -= c2;
                adj[num[i][j]][num[i][(*it1)]] = adj[num[i][(*it1)]][num[i][j]] = 0;
                adj[num[i][j]][num[(*it2)][j]] = adj[num[(*it2)][j]][num[i][j]] = 0;
                for (int j0 = j + 1; j0 < (*it1); ++ j0)
                {
                    a[i][j0] = 0;
                }
                for (int i0 = i + 1; i0 < (*it2); ++ i0)
                {
                    a[i0][j] = 0;
                }
            }
        }
    }
    j++;
    if (j == m0)
    {
        j = 0;
        i++;
    }
    go(i, j);
}

bool solve(vector< vector<int> > &puzzle)
{
    a = puzzle;
    puzzle0 = puzzle;
    n0 = a.size();
    m0 = a[0].size();
    v = 0;
    flag0 = false;
    for (int i = 0; i < n0; ++ i)
    {
        for (int j = 0; j < m0; ++ j)
        {
            num[i][j] = 0;
            if (puzzle[i][j])
            {
                v++;
                num[i][j] = v;
                row[i].insert(j);
                col[j].insert(i);
            }
        }
    }
    for (int i = 1; i <= v; ++ i)
    {
        for (int j = 1; j <= v; ++ j)
        {
            adj[i][j] = 0;
        }
    }
    go(0, 0);
    puzzle = a;
    return flag0;
}
