#include <iostream>
#include <vector>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const long long MOD = 100000543;

int n, q;
int a[MAXN + 5];
long long x[1000005];
long long tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = x[a[l]];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

long long query(int v, int l, int r, int ql, int qr)
{
    if (qr < l or r < qr) return 0;
    if (ql <= l and r <= qr) return tree[v];

    int mid = (l + r) / 2;
    return (query(2 * v, l, mid, ql, qr) + query(2 * v + 1, mid + 1, r, ql, qr)) % MOD;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;

    for (int i = 5; i <= 1000000; ++ i)
    {
        x[i] = (5 * x[i - 1] + 4 * x[i - 2] + 3 * x[i - 3] + 2 * x[i - 4] + x[i - 5]) % MOD;
    }

    build(1, 1, n);

    for (int i = 1; i <= q; ++ i)
    {
        int type, l, r, val;
        cin >> type >> l >> r;

        if (type == 1) cout << query(1, 1, n, l, r) << endl;
        else
        {
            while (true) {}
            cin >> val;
            ///update(1, 1, n, l, r, val);
        }
    }

    return 0;
}
