#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MOD = 1e8 + 543;
const int C = 1e4;

typedef vector< vector<int> > mat;

int n, q;
int a[MAXN + 5];
mat m[MAXN + 5];
mat pw1[C + 5], pw2[C + 5];

mat x0 = {{0, -22, 33, -3, -4}};

mat id = {{1, 0, 0, 0, 0},
          {0, 1, 0, 0, 0},
          {0, 0, 1, 0, 0},
          {0, 0, 0, 1, 0},
          {0, 0, 0, 0, 1}};

mat mul = {{5, 1, 0, 0, 0},
           {4, 0, 1, 0, 0},
           {3, 0, 0, 1, 0},
           {2, 0, 0, 0, 1},
           {1, 0, 0, 0, 0}};

mat operator * (mat &a, mat &b)
{
    mat c;
    c.resize(a.size());
    for (int i = 0; i < a.size(); ++ i)
    {
        c[i].resize(5);
        for (int j = 0; j < 5; ++ j)
        {
            c[i][j] = 0;
            for (int k = 0; k < 5; ++ k)
            {
                c[i][j] += 1ll * a[i][k] * b[k][j] % MOD;
                c[i][j] %= MOD;
                c[i][j] = (c[i][j] + MOD) % MOD;
            }
        }
    }
    return c;
}

mat comp(long long pw)
{
    long long x = pw / C, y = pw % C;
    return pw1[y] * pw2[x];
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;

    pw1[0] = id;
    for (int i = 1; i <= C; ++ i)
    {
        pw1[i] = pw1[i - 1] * mul;
    }

    pw2[0] = id;
    for (int i = 1; i <= C; ++ i)
    {
        pw2[i] = pw2[i - 1] * pw1[C];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        auto tmp = comp(a[i]);
        m[i] = x0 * tmp;
    }

    for (int i = 1; i <= q; ++ i)
    {
        int type, l, r, val;
        cin >> type >> l >> r;

        if (type == 1) cout << m[l][0][0] << endl;
        else
        {
            cin >> val;
            auto tmp = comp(val);
            m[l] = m[l] * tmp;
        }
    }

    return 0;
}
