//#include "ones.h"
//#include "Lgrader.cpp"
#include <iostream>
#include <chrono>
#include <vector>
#include <algorithm>
#include <cmath>

#define maxn 200005
#define mod 100000543
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
//#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cerr<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops" , "fast-math")
#pragma GCC target("avx2")

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

typedef long long ll;
typedef pair <int , int> pii;


ll x[1000000];

void gen()
{
    int to = 10;

    x[0] = 0;
    x[1] = 1;
    x[2] = 2;
    x[3] = 3;
    x[4] = 4;

    for(int i = 5; i <= to; i++)
    {
        x[i] += x[i - 1] * 5LL;
        x[i] %= mod;

        x[i] += x[i - 2] * 4LL;
        x[i] %= mod;

        x[i] += x[i - 3] * 3LL;
        x[i] %= mod;

        x[i] += x[i - 4] * 2LL;
        x[i] %= mod;

        x[i] += x[i - 5] * 1LL;
        x[i] %= mod;
    }

    /**for(int i = 0; i <= to ; i++)
        cout << x[i] << " ";
    cout << endl;*/
}




int a[maxn];
int tree[maxn];



void build(int node , int l , int r)
{
    if(l == r)
    {
        tree[node] = x[a[l]];
        return;
    }

    int mid = (l + r) / 2;
    build(node * 2 , l , mid);
    build(node * 2 + 1 , mid + 1 , r);

    tree[node] = (tree[node * 2] + tree[node * 2 + 1]) % mod;
}



int query(int node , int l, int r , int ql , int qr)
{
    if(ql >= l && r <= qr)
        return tree[node];

    if(ql > r || qr < l)
        return 0;

    int mid = (l + r) / 2;

    return query(node * 2 , l , mid , ql , qr) + query(node * 2 + 1 , mid + 1 , r , ql , qr);
}



void update(int node , int l , int r , int qpos , int qval)
{
    if(qpos < l || qpos > r)
        return;

    if(l == r)
    {
        a[l] += qval;
        tree[node] = x[a[l]];
        return;
    }

    int mid = (l + r) / 2;

    if(qpos <= mid)
        update(node * 2 , l , mid , qpos , qval);
    else
        update(node * 2 + 1 , mid + 1 , r , qpos , qval);

    tree[node] = tree[node * 2] + tree[node * 2 + 1];
}



int n , q;


void read()
{
    cin >> n >> q;

    for(int i = 1; i <= n; i++)
        cin >> a[i];
}


void solve()
{
    int type , l , r , val;
    
    build();
    
    while(q--)
    {
        cin >> type;
        cin >> l >> r;

        if(type == 1)
            cout << query(1 , 1 , n , l , r) << endl;
        else
        {
            cin >> val;
            update(1 , 1 , n , l , val);
        }
    }
}


int main()
{

    /**#ifdef ONLINE_JUDGE /// promeni
        freopen("input.in", "r", stdin);
        freopen("taxi.out", "w", stdout);
    #endif*/

    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr);

    //startT = std::chrono::high_resolution_clock::now();

    gen();

    read();
    solve();

    return 0;
}
