#include <iostream>
#include <chrono>
#include <vector>
#include <algorithm>
#include <cmath>

#define maxn 100000544
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
//#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cerr<<"passed"<<endl;

#pragma GCC optimize("O3" , "Ofast" , "unroll-loops" , "fast-math")
#pragma GCC target("avx2")

using namespace std;

std::chrono::high_resolution_clock::time_point startT, currT;
constexpr double TIME_MULT = 1;

double timePassed()
{
    using namespace std::chrono;
    currT = high_resolution_clock::now();
    double time = duration_cast<duration<double>>(currT - startT).count();
    return time * TIME_MULT;
}

const int mod = 1e8 + 543;
typedef long long ll;
typedef pair <int , int> pii;



int num[maxn];

void gen()
{
    num[0] = 0;
    num[1] = 1;
    num[2] = 2;
    num[3] = 3;
    num[4] = 4;

    for(int i = 5; i < maxn; i++)
    {
        ll cur = 5LL * num[i - 1];
        cur %= mod;

        cur += 4LL * num[i - 2];
        cur %= mod;

        cur += 3LL * num[i - 3];
        cur %= mod;

        cur  += 2LL * num[i - 4];
        cur %= mod;

        cur += 1LL * num[i - 5];
        cur %= mod;

        num[i] = (int)(cur);
    }

    /**for(int i = 1; i <= 100; i++)
        cout << num[i] << " ";
    cout << endl;*/

}


int tree[maxn];
int a[maxn];

void build(int node , int l , int r)
{
    if(l == r)
    {
        tree[node] = num[a[l]];
        return;
    }

    int mid = (l + r) / 2;

    build(node * 2 , l , mid);
    build(node * 2 + 1 , mid + 1 , r);

    tree[node] = (tree[node * 2] * 1LL + tree[node * 2 + 1]) % mod;
}


int query(int node , int l , int r , int ql , int qr)
{
    if(l >= ql && r <= qr)
        return tree[node];

    if(l > qr || r < ql)
        return 0;

    int mid = (l + r) / 2;

    return (query(node * 2 , l , mid , ql , qr) * 1LL + query(node * 2 + 1, mid + 1 , r , ql , qr)) % mod;
}

int n , q;

void read()
{
    cin >> n >> q;

    for(int i = 1; i <= n; i++)
        cin >> a[i];

    build(1 , 1 , n);

    int l , r , type;

    while(q--)
    {
        cin >> type;
        cin >> l >> r;
        cout << query(1 , 1 , n , l , r) << endl;
    }

}



int main()
{

    /**#ifdef ONLINE_JUDGE /// promeni
        freopen("input.in", "r", stdin);
        freopen("taxi.out", "w", stdout);
    #endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //startT = std::chrono::high_resolution_clock::now();

    gen();
    read();

    return 0;
}

