#pragma once
#include"puzzle.h"
#include<bits/stdc++.h>
using namespace std;
const int maxr = 48;
struct edge{
    int to;
    int cntbridges;
    edge(){
        to = cntbridges = 0;
    }
    edge(int _to){
        to = _to;
        cntbridges = 0;
    }
};
int SUBTESTS;
double TimeLimit;
int nv, n, m;
vector<int> v[maxn*maxn];
int bridges[maxn*maxn];
priority_queue<pair<int,int> > q;
void init(int numSubtests, double timeLimit){
    SUBTESTS = numSubtests;
    TimeLimit = timeLimit;
}

int get_vertex(pair<int, int> p){
    return p.first * m + p.second;
}

inline void get_vers_index(int numver, int &i, int &j){
    i = numver / m;
    j = numver % m;
    //return (i, j);
}

inline void get_upnb(int i, int j, vector<vector<int> > &table){
    i--;
    while (i >= 0){
        if (table[i][j])
            break;
    }
}

inline void get_rnb(int i, int j, vector<vector<int> > &table){
    j++;
    while (j < m){
        if (table[i][j])
            break;
    }
}

inline void get_dnb(int i, int j, vector<vector<int> > &table){
    i++;
    while (i < n){
        if (table[i][j])
            break;
    }
}

inline void get_lnb(int i, int j, vector<vector<int> > &table){
    j--;
    while (j >= 0){
        if (table[i][j])
            break;
    }
}

inline void add_nb(int cur, int i, j){
    int nb = get_vertex(i, j)
    v[cur].push_back(edge(nb));
}

void init_graph(vector<vector<int> > & table){
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j){
            if (!table[i][j]) continue;
            int cur = get_vertex(i, j);
            bridges[cur] = table[i][j];
            q.push_back({bridges[cur], cur});
            int i1 = i, j1 = j;
            get_upnb(i1, j1);
            if (i1 >= 0) add_nb(cur, i1, j1);

            i1 = i;
            j1 = j;
            get_rnb(i1, j1);
            if (j1 < m) add_nb(cur, i1, j1);

            i1 = i;
            j1 = j;
            get_dnb(i1, j1);
            if (i1 < n) add_nb(cur, i1, j1);

            i1 = i;
            j1 = j;
            get_lnb(i1, j1);
            if (j1 >= 0) add_nb(cur, i1, j1);
        }
}

inline void build_bridge_s(int from, int to, vector<vector<int> > &table, bool &lamp, int cnt){
    int i1, j1, i2, j2;
    get_vers_index(from, i1, j1);
    get_vers_index(to, i2, j2);
    if (i1 == i2){
        if (j1 > j2) j1 ^= j2 ^= j1 ^= j2;
        for (int j = j1 + 1; j < j2; ++j)
            if (table[i1][j] != 0){
                lamp = 0;
                return;
            }
        int code = (cnt == 1)? -1: -2;
        for (int j = j1 + 1; j < j2; ++j)
            table[i1][j] = code;
    }
    else{
        if (i1 > i2) i1 ^= i2 ^= i1 ^= i2;
        for (int i = i1 + 1; i < i2; ++i)
            if (table[i][j1] != 0){
                lamp = 0;
                return;
            }
        int code = (cnt == 1)? -3: -4;
        for (int i = i1 + 1; i < i2; ++i)
            table[i][j] = code;
    }
}


inline void init_table(vector<vector<int> > &table){
    while (!q.empty()){
        pair<int, int> cur = q.top();
        q.pop();
        int ver = cur.second;
        int brver = cur.first;
        if (brver > bridges[ver]){
            brver = bridges[ver];
            q.push({brver, ver});
            continue;
        }
        for (int i = 0; i < (int)v[cur].size(); ++i){
            int nb = v[cur][i].ver;
            if (bridges[nb] == 0)
                continue;
            bool lamp = true;
            if (bridges[nb] == 1){
                build_bridge_s(from, to, table, 1);
                if (lamp){
                    bridges[ver]--;
                    bridges[nb]--;
                }
            }
            else{
                build_bridge_s(from, to, table, 2);
                if (lamp){
                    bridges[ver] -= 2;
                    bridges[nb] -= 2;
                }
            }
        }
    }
}

bool solve(vector<vector<int>> &table){
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++i){
            int cur = get_vertex(i, j);
            v[cur].clear();
        }
    memset(bridges,0, sizeof(bridges));
    int n = table.size();
    int m = table.back.size();
    init_graph(table);
    init_table(table);
}