#include <iostream>
#include <vector>
#include "ones.h"

using namespace std;

const int MAXN = 100000;
long long tree[5 * MAXN];
vector <int> ans;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void buildTree(int v, int l, int r)
{
    if(l == r)
    {
        tree[v] = hasOnes(l, r);
        return;
    }

    int mid = (l + r) / 2;

    if(hasOnes(l, mid))
    {
        buildTree(v * 2, l, mid);
    }
    if(hasOnes(mid + 1 , r))
    {
        buildTree(v * 2 + 1, mid + 1, r);
    }

    tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
}

void query(int v, int l, int r)
{
    //cout << v << ' ' << l << ' ' << r <<endl;
    if(l == r)
    {
        ans.push_back(l);
        //cout << "---> " << l << endl;
        return;
    }

    int mid = (l + r) / 2;

    if(tree[v * 2] == 1)
    {
        query(v * 2, l, mid);
    }
    if(tree[v * 2 + 1] == 1)
    {
        query(v * 2 + 1, mid + 1, r);
    }
}

vector<int> guessOnes(int n, int k)
{
    buildTree(1, 1, n);

    query(1, 1, n);

    //cout << ans.size() <<endl;

    //for(int i = 0 ; i < 4 * n ; i++)
    //    cout << i << " --->" << tree[i] <<endl;

    return ans;
}

/*
11 6 1
11011000110
*/
