#include <iostream>
using namespace std;
const int MAXN = 1 * 1e5 + 1;
const long long MOD = 1e8 + 543;
int a[MAXN];
long long fib[1000001];
struct Ver{
    long long val;
    int lazy;
};
Ver tree[4 * MAXN];
void build(int curr, int from, int to) {
    if (from == to) {
        tree[curr].val = fib[a[from]];
        tree[curr].lazy = 0;
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        tree[curr].val = (tree[curr * 2].val + tree[curr * 2 + 1].val) % MOD;
        tree[curr].lazy = 0;
    }
}
long long query(int curr, int from, int to, int l, int r) {
    if (l <= from && to <= r) {
        return tree[curr].val;
    }
    if (l <= to && from <= r) {
        return (query(curr * 2, from, (from + to) / 2, l, r) + query(curr * 2 + 1, (from + to) / 2 + 1, to, l, r)) % MOD;
    }
    return 0;
}
void solve() {
    for (int i = 0; i < 5; i++) {
        fib[i] = i;
    }
    for (int i = 5; i < 1000001; i++) {
        fib[i] = fib[i - 1] * 5;
        fib[i] %= MOD;
        fib[i] += fib[i - 2] * 4;
        fib[i] %= MOD;
        fib[i] += fib[i - 3] * 3;
        fib[i] %= MOD;
        fib[i] += fib[i - 4] * 2;
        fib[i] %= MOD;
        fib[i] += fib[i - 5];
        fib[i] %= MOD;
    }


    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    build(1, 1, n);

    while (q --> 0) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << query(1, 1, n, l, r) << '\n';
        }
        if (type == 2) {
            int l, r, value;
            cin >> l >> r >> value;
            return;
        }
    }
}
int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
    solve();
    return 0;
}

