#include <iostream>
using namespace std;
const int MAXN = 1 * 1e5 + 1;
const long long MOD = 1e8 + 543;
const long long INF = MOD * (2 * MAXN + 1) + 1;
const int LOGG = 100;
long long a[MAXN];
long long fi[10];
struct Ver{
    long long val[5];
    long long lazy;
};
Ver tree[4 * MAXN];
long long sparse[5][5][LOGG];
inline void shift(long long curr, long long k) {
    bool bt[LOGG];
    int log = 0;
    while (k > 0) {
        bt[log] = k % 2;
        k /= 2;
        log++;
    }
    log--;
    while (log >= 0) {
        if (bt[log]) {
            long long future[5] = {0, 0, 0, 0, 0};
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    future[i] += sparse[i][j][log] * tree[curr].val[j];
                    future[i] %= MOD;
                }
            }
            for (int i = 0; i < 5; i++) {
                tree[curr].val[i] = future[i];
            }
        }
        log--;
    }
}
void build(int curr, int from, int to) {
    if (from == to) {
        for (int i = 0; i < 5; i++) {
            tree[curr].val[i] = i;
        }
        shift(curr, a[from]);
        tree[curr].lazy = 0;
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        for (int i = 0; i < 5; i++) {
            tree[curr].val[i] = (tree[curr * 2].val[i] + tree[curr * 2 + 1].val[i]) % MOD;
        }
        tree[curr].lazy = 0;
    }
}
inline void push(int curr, int from, int to) {
    if (tree[curr].lazy == 0) {
        return;
    }
    shift(curr, tree[curr].lazy);

    tree[curr * 2].lazy += tree[curr].lazy;
    tree[curr * 2 + 1].lazy += tree[curr].lazy;

    tree[curr].lazy = 0;
}
long long query(int curr, int from, int to, const int l, const int r) {
    push(curr, from, to);
    if (l <= from && to <= r) {
        return tree[curr].val[0];
    }
    if (l <= to && from <= r) {
        return (query(curr * 2, from, (from + to) / 2, l, r) + query(curr * 2 + 1, (from + to) / 2 + 1, to, l, r)) % MOD;
    }
    return 0;
}
void update(int curr, int from, int to, const int l, const int r, const long long value) {
    push(curr, from, to);
    if (l <= from && to <= r) {
        tree[curr].lazy += value;
        push(curr, from, to);
        return;
    }
    if (l <= to && from <= r) {
        update(curr * 2, from, (from + to) / 2, l, r, value);
        update(curr * 2 + 1, (from + to) / 2 + 1, to, l, r, value);
        for (int i = 0; i < 5; i++) {
            tree[curr].val[i] = tree[2 * curr].val[i] + tree[2 * curr + 1].val[i];
            tree[curr].val[i] %= MOD;
        }
    }
}
void solve() {
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            if (i == 4) {
                sparse[i][j][0] = (j + 1);
            } else {
                if (i + 1 == j) {
                    sparse[i][j][0] = 1;
                } else {
                    sparse[i][j][0] = 0;
                }
            }
        }
    }

    for (int log = 1; log < LOGG; log++) {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                sparse[i][j][log] = 0;
                for (int h = 0; h < 5; h++) {
                    sparse[i][j][log] += sparse[h][j][log - 1] * sparse[i][h][log - 1];
                    sparse[i][j][log] %= MOD;
                }
            }
        }
    }

    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    build(1, 1, n);

    while (q --> 0) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << query(1, 1, n, l, r) << '\n';
        }
        if (type == 2) {
            int l, r;
            long long value;
            cin >> l >> r >> value;
            update(1, 1, n, l, r, value);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
