/*
    nqma da te pitam
    nananai-na
    iskash li da pravim
    nananai-na
*/
#include <iostream>
using namespace std;
const int MAXN = 1e5 + 1;
const long long MOD = 1e8 + 543;
const int LOGG = 30;
long long a[MAXN];
struct Ver {
    long long val[5];
    long long lazy;
};
Ver tree[8 * MAXN];
long long sparse[LOGG][5][5];
long long neg_sparse[LOGG][5][5];
inline void shift(int curr, long long k) {
    long long power = 1;
    int log = 0;
    while (power < k) {
        power *= 2;
        log++;
    }
    while (k > 0) {
        if (k >= power) {
            k -= power;
            long long tool[5];
            for (int i = 0; i < 5; i++) {
                tool[i] = 0;
                for (int j = 0; j < 5; j++) {
                    tool[i] += (sparse[log][i][j] * tree[curr].val[j]) % MOD;
                    tool[i] %= MOD;
                }
            }
            for (int i = 0; i < 5; i++) {
                tree[curr].val[i] = tool[i];
            }
        }
        power /= 2;
        log--;
    }
}

inline void neg_shift(int curr, long long k) {
    long long power = 1;
    int log = 0;
    while (power < k) {
        power *= 2;
        log++;
    }
    while (k > 0) {
        if (k >= power) {
            k -= power;
            long long tool[5];
            for (int i = 0; i < 5; i++) {
                tool[i] = 0;
                for (int j = 0; j < 5; j++) {
                    tool[i] += (neg_sparse[log][i][j] * tree[curr].val[j]) % MOD;
                    tool[i] %= MOD;
                }
            }
            for (int i = 0; i < 5; i++) {
                tree[curr].val[i] = tool[i];
            }
        }
        power /= 2;
        log--;
    }
}

void build(int curr, int from, int to) {
    if (from == to) {
        for (int i = 0; i < 5; i++) {
            tree[curr].val[i] = i;
        }
        if (a[from] >= 0) {
            shift(curr, a[from]);
        } else {
            neg_shift(curr, -a[from]);
        }
        tree[curr].lazy = 0;
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        for (int i = 0; i < 5; i++) {
            tree[curr].val[i] = (tree[curr * 2].val[i] + tree[curr * 2 + 1].val[i]) % MOD;
        }
        tree[curr].lazy = 0;
    }
}
inline void push_it(int curr, int from, int to) {
    if (tree[curr].lazy == 0) {
        return;
    }
    if (tree[curr].lazy >= 0) {
        shift(curr, tree[curr].lazy);
    } else {
        neg_shift(curr, -tree[curr].lazy);
    }
    tree[curr * 2].lazy += tree[curr].lazy;
    tree[curr * 2 + 1].lazy += tree[curr].lazy;
    tree[curr].lazy = 0;
}
long long query(int curr, int from, int to, const int l, const int r) {
    push_it(curr, from, to);
    if (l <= from && to <= r) {
        return tree[curr].val[0];
    }
    if (l <= to && from <= r) {
        return (query(curr * 2, from, (from + to) / 2, l, r) + query(curr * 2 + 1, (from + to) / 2 + 1, to, l, r)) % MOD;
    }
    return 0;
}
void update(int curr, int from, int to, const int l, const int r, const long long value) {
    push_it(curr, from, to);
    if (l <= from && to <= r) {
        tree[curr].lazy += value;
        push_it(curr, from, to);
    } else if (from <= r && l <= to) {
        update(curr * 2, from, (from + to) / 2, l, r, value);
        update(curr * 2 + 1, (from + to) / 2 + 1, to, l, r, value);
        for (int i = 1; i < 5; i++) {
            tree[curr].val[i] = (tree[curr * 2].val[i] + tree[curr * 2 + 1].val[i]) % MOD;
        }
    }
}
void solve() {
    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            if (i == 4) {
                sparse[0][i][j] = j + 1;
            } else {
                if (i + 1 == j) {
                    sparse[0][i][j] = 1;
                } else {
                    sparse[0][i][j] = 0;
                }
            }
        }
    }
    for (int log = 1; log < LOGG || (1 << log) < MOD; log++) {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                sparse[log][i][j] = 0;
                for (int h = 0; h < 5; h++) {
                    sparse[log][i][j] += (sparse[log - 1][h][j] * sparse[log - 1][i][h]) % MOD;
                    sparse[log][i][j] %= MOD;
                }
            }
        }
    }



    for (int i = 0; i < 5; i++) {
        for (int j = 0; j < 5; j++) {
            if (i == 0) {
                if (j == 4) {
                    neg_sparse[0][i][j] = 1;
                } else {
                    neg_sparse[0][i][j] = (-2 - j) + MOD;
                }
            } else {
                if (i - 1 == j) {
                    neg_sparse[0][i][j] = 1;
                } else {
                    neg_sparse[0][i][j] = 0;
                }
            }
        }
    }
    for (int log = 1; log < LOGG || (1 << log) < MOD; log++) {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                neg_sparse[log][i][j] = 0;
                for (int h = 0; h < 5; h++) {
                    neg_sparse[log][i][j] += (neg_sparse[log - 1][h][j] * neg_sparse[log - 1][i][h]) % MOD;
                    neg_sparse[log][i][j] %= MOD;
                }
            }
        }
    }






    int n, q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    build(1, 1, n);
    while (q --> 0) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << query(1, 1, n, l, r) << '\n';
        }
        if (type == 2) {
            int l, r;
            long long value;
            cin >> l >> r >> value;
            update(1, 1, n, l, r, value);
        }
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
}
