#include "ones.h"

#include <iostream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>

using namespace std;

const auto p1 = std::chrono::system_clock::now();
const auto p2 = p1.time_since_epoch().count();

mt19937 generator(p2);

void find_ones(int l, int r, int k, vector<int> &result) {
    if (l > r) {
        return;
    }

    int decider = uniform_int_distribution<int>(0, 7)(generator);

    int pivot = decider % 8 == 0 ? uniform_int_distribution<int>(l, r -1)(generator) : ((l + r) / 2);

    if (hasOnes(l, pivot)) {
        if (l == pivot) {
            result.push_back(l);
        } else {
            find_ones(l, pivot, k, result);
        }
    }

    if ((int) result.size() == k) {
        return;
    }

    if (hasOnes(pivot + 1, r)) {
        if (pivot + 1 == r) {
            result.push_back(r);
        } else { 
            find_ones(pivot + 1, r, k, result);
        }
    }
}

vector<int> guessOnes(int n, int k) {
    vector<int> result;

    find_ones(1, n, k, result);

    sort(result.begin(), result.end());

    return result;
}