#include "ones.h"

#include <iostream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>

using namespace std;

const auto p1 = std::chrono::system_clock::now();
const auto p2 = p1.time_since_epoch().count();

mt19937 generator(p2);

void find_ones(int l, int r, int k, vector<int> &result) {
    if (l > r) {
        return;
    }

    int decider = uniform_int_distribution<int>(0, 44)(generator);

    int pivot = decider % 45 == 46 ? uniform_int_distribution<int>(l, r -1)(generator) : ((l + r) / 2);

    if (hasOnes(pivot + 1, r)) {
        if (pivot + 1 == r) {
            result.push_back(r);
        } else { 
            find_ones(pivot + 1, r, k, result);
        }
    }

    if ((int) result.size() == k) {
        return;
    }

    if (hasOnes(l, pivot)) {
        if (l == pivot) {
            result.push_back(l);
        } else {
            find_ones(l, pivot, k, result);
        }
    }
}

void find_ones_pivots(int l, int r, vector<int> &pivots, int k, vector<int> &result) {
    if (l > r) {
        return;
    }

    if (l + 1 == r) {
        int newL = pivots[l] + 1;
        int newR = pivots[r] - 1;

        if (newL == newR) {
            if (hasOnes(newL, newL)) {
                result.push_back(newL);
            }
        } else if (newL < newR) {
            find_ones(newL, newR, k, result);
        }

        return;
    }

    int mid = (l + r) / 2;

    if (hasOnes(pivots[mid], pivots[mid])) {
        result.push_back(pivots[mid]);
    }

    int newL = pivots[l] + 1;
    int newR = pivots[mid] - 1;

    if (newL == newR) {
        if (hasOnes(newL, newL)) {
            result.push_back(newL);
        }
    } else if (newL < newR) {
        if (hasOnes(newL, newR)) {
            find_ones_pivots(l, mid, pivots, k, result);
        }
    }

    if ((int) result.size() == k) {
        return;
    }

    newL = pivots[mid] + 1;
    newR = pivots[r] - 1;

    if (newL == newR) {
        if (hasOnes(newL, newL)) {
            result.push_back(newL);
        }
    } else if (newL < newR) {
        if (hasOnes(newL, newR)) {
            find_ones_pivots(mid, r, pivots, k, result);
        }
    }
}

vector<int> guessOnes(int n, int k) {
    vector<int> result;

    int intervalSIze = n / k;

    vector<int> pivots;

    for (int i = 1; i <= n; i += intervalSIze) {
        pivots.push_back(i);
    }

    if (pivots.back() != n) {
        pivots.push_back(n);
    }

    if (hasOnes(1, 1)) {
        result.push_back(1);
    }

    if (hasOnes(n, n)) {
        result.push_back(n);
    }

    find_ones_pivots(0, (int)pivots.size() - 1, pivots, k, result);

    sort(result.begin(), result.end());

    return result;
}