#include <iostream>

#define endl '\n'

using namespace std;

const int MOD = 1e8 + 543;

const int MAX_VALUE = 1e6 + 3;
const int MAXN = 1e5 + 3;

int values[MAX_VALUE];
int nums[MAXN];

int tree[4 * MAXN];

void add_mod(int &x, int y) {
    x += y;

    if (x >= MOD) {
        x -= MOD;
    }
}

int mul_mod(int x, int y) {
    return 1ll * x * y % MOD;
}

void precompute_values() {
    for (int i = 0; i < 5; ++i) {
        values[i] = i;
    }

    for (int i = 5; i < MAX_VALUE; ++i) {
        for (int j = 1; j <= 5; ++j) {
            add_mod(values[i], mul_mod(5 - j + 1, values[i - j]));
        }
    }
}

void build_tree(int ind, int tl, int tr) {
    if (tl == tr) {
        tree[ind] = nums[tl];

        return;
    }

    int mid = (tl + tr) / 2;

    build_tree(2 * ind, tl, mid);
    build_tree(2 * ind + 1, mid + 1, tr);

    add_mod(tree[ind], tree[2 * ind]);
    add_mod(tree[ind], tree[2 * ind + 1]);
}

int query(int ind, int tl, int tr, int l, int r) {
    if (l > r or tl > tr or l > tr or r < tl) {
        return 0;
    }

    if (l == tl and r == tr) {
        return tree[ind];
    }

    int mid = (tl + tr) / 2;

    int result = 0;
    add_mod(result, query(2 * ind, tl, mid, l, min(mid, r)));
    add_mod(result, query(2 * ind + 1, mid + 1, tr, max(mid + 1, l), r));

    return result;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    precompute_values();
    
    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;

        nums[i] = values[x];
    }

    build_tree(1, 0, n - 1);

    for (int i = 0; i < q; ++i) {
        int type, l, r;
        cin >> type >> l >> r;

        --l;
        --r;

        cout << query(1, 0, n - 1, l, r) << endl;
    }

    return 0;
}
