#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;
const int MOD=1e8+543;


int sum(int a,int b)
{
    int c=a+b;
    if(c>=MOD) c-=MOD;
    return c;
}

int mult(int a,int b)
{
    return (long long)a*b%MOD;
}

struct matrix
{
    int t[5][5];
    matrix()
    {
        for(int i=0;i<5;i++)
            for(int j=0;j<5;j++) t[i][j]=0;
        for(int i=0;i<5;i++) t[i][i]=1;
    }

    inline friend matrix operator+ (const matrix& a, const matrix& b)
    {
        matrix c;
        for(int i=0;i<5;i++)
        {
            for(int j=0;j<5;j++) c.t[i][j]=sum(a.t[i][j], b.t[i][j]);
        }
        return c;
    }

    inline friend matrix operator* (const matrix& a,const matrix& b)
    {
        matrix c;
        for(int i=0;i<5;i++)
            for(int j=0;j<5;j++) c.t[i][j]=0;
        for(int i=0;i<5;i++)
        {
            for(int j=0;j<5;j++)
            {
                for(int k=0;k<5;k++)
                    c.t[i][j]=sum(c.t[i][j], mult(a.t[i][k], b.t[k][j]));
            }
        }
        return c;
    }
};

int n,q;
int a[MAXN];
matrix tree[4*MAXN];
matrix base=matrix();
matrix frst=matrix();


void view(matrix a)
{
    for(int i=0;i<5;i++)
{
    for(int j=0;j<5;j++)
    {
        cout<<a.t[i][j]<<" ";
    }
    cout<<endl;
}
cout<<endl;
}

matrix fastPow(int pw) ///
{
    matrix x=base;
    matrix ret=matrix();
    while(pw>0)
    {
        if(pw&1) ret=ret*x;
        pw/=2;
        x=x*x;
    }
    return ret;
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=frst*fastPow(a[l]);
        return;
    }
    int mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    tree[node]=tree[2*node]+tree[2*node+1];
}

int query(int node,int l,int r,int b,int e)
{
    if(b<=l && r<=e) return tree[node].t[0][4];
    int mid=(l+r)/2;
    int ret=0;
    if(b<=mid) ret=sum(ret, query(2*node,l,mid,b,e));
    if(mid<e) ret=sum(ret, query(2*node+1,mid+1,r,b,e));
    return ret;
}

void init()
{
    for(int i=0;i<5;i++) base.t[i][i]=frst.t[i][i]=0;

    base.t[1][0]=1;
    base.t[2][1]=1;
    base.t[3][2]=1;
    base.t[4][3]=1;
    for(int i=0;i<5;i++) base.t[i][4]=i+1;

    frst.t[0][0]=-4+MOD;
    frst.t[0][1]=-3+MOD;
    frst.t[0][2]=33;
    frst.t[0][3]=-22+MOD;
    frst.t[0][4]=0;
}


int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

init();

cin>>n>>q; for(int i=1;i<=n;i++) cin>>a[i];

//build(1,1,n);

for(int i=0;i<q;i++)
{
    int type,l,r;
    cin>>type>>l>>r;
    if(type==1)
    {
        cout<<query(1,1,n,l,r)<<endl;
    }
}

return 0;
}
