/**
 * Kak izobshto imam "20.560000000000002/300 Vidimi tochki"???
 */
#include <bits/stdc++.h>
#include "Lgrader.cpp"
#include "puzzle.h"
using namespace std;
typedef pair<int, int> pii;

const int MAXN = 200;
const int MAXS = 47;

int brSubtests;
double timeLimitSec;

void init(int _numSubtests, double _timeLimit){
    timeLimitSec = _timeLimit*0.95;
    brSubtests = _numSubtests;
}

struct Island{
    pair<pii, int> dirs[4] = { {{-1, -1}, -1}, {{-1, -1}, -1}, {{-1, -1}, -1}, {{-1, -1}, -1} };
    int conns = 0;
    int needs = -1;
};

Island G[MAXS][MAXS];
int totalNeeds = 0;

bool doObvious(pii curr, vector<pair<pii, pii>>& conn){
    if(G[curr.first][curr.second].conns * 2 == G[curr.first][curr.second].needs && G[curr.first][curr.second].needs > 0){
        totalNeeds -= G[curr.first][curr.second].needs;
        G[curr.first][curr.second].needs = 0;
        G[curr.first][curr.second].conns = 0;

        for(int d = 0; d < 4; d++){
            if(G[curr.first][curr.second].dirs[d].second == 0){
                pii nxt = G[curr.first][curr.second].dirs[d].first;
                G[curr.first][curr.second].dirs[d].second = 2;
                G[nxt.first][nxt.second].dirs[(d+2)%4].second = 2;
                G[nxt.first][nxt.second].needs -= 2;
                totalNeeds -= 2;
                G[nxt.first][nxt.second].conns --;
                conn.push_back({curr, nxt});
            }
        }

        for(int d = 0; d < 4; d++){
            if(G[curr.first][curr.second].dirs[d].second == 0){
                pii nxt = G[curr.first][curr.second].dirs[d].first;
                doObvious(nxt, conn);
            }
        }
        return true;
    }
    return false;
}

bool solve(vector<vector<int>>& puzzle){
    int rows = puzzle.size();
    int cols = puzzle[0].size();
    vector<int> prevUp(cols, -1), prevLeft(rows, -1);
    for(int i = 0; i < rows; i++){
        for(int j = 0; j < cols; j++){
            if(puzzle[i][j] <= 0){ continue; }
            pii curr = {i, j};
            totalNeeds += puzzle[i][j];
            G[i][j].needs = puzzle[i][j];
            if(prevUp[j] != -1){
                pii prv = {prevUp[j], j};
                G[prv.first][prv.second].dirs[2] = {curr, 0};
                G[prv.first][prv.second].conns++;
                G[i][j].dirs[0] = {prv, 0};
                G[i][j].conns++;
            }
            prevUp[j] = i;
            if(prevLeft[i] != -1){
                pii prv = {i, prevLeft[i]};
                G[prv.first][prv.second].dirs[3] = {curr, 0};
                G[prv.first][prv.second].conns++;
                G[i][j].dirs[1] = {prv, 0};
                G[i][j].conns++;
            }
            prevLeft[i] = j;
        }
    }
    if(timePassed() >= timeLimitSec){ return false; }
    vector<pair<pii, pii>> conn;
    while(true){
        bool passFlag = false;
        for(int i = 0; i < rows; i++){
            if(timePassed() >= timeLimitSec){ return false; }
            for(int j = 0; j < cols; j++){
                if(puzzle[i][j] <= 0){ continue; }
                passFlag = passFlag || doObvious({i, j}, conn);
            }
        }
        if(!passFlag){ break; }
    }
    for(int i = 0; i < conn.size(); i++){
        pii u = conn[i].first, v = conn[i].second;
        if(u.first == v.first){
            if(u.second > v.second){ swap(u, v); }
            for(int c = u.second+1; c < v.second; c++){ if(puzzle[u.first][c]){ return false; } puzzle[u.first][c] = HOR_DOUBLE; }
        }else if(u.second == v.second){
            if(u.first > v.first){ swap(u, v); }
            for(int r = u.first+1; r < v.first; r++){ if(puzzle[r][u.second]){ return false; } puzzle[r][u.second] = VERT_DOUBLE; }
        }
//        cout << conn[i].first.first << ' ' << conn[i].first.second << "\t==>\t";
//        cout << conn[i].second.first << ' ' << conn[i].second.second << '\n';
    }
//    cout << "needs left: " << totalNeeds << '\n';
    /// do second obvious
    if(timePassed() >= timeLimitSec){ return false; }
    vector<pair<pair<pii, pii>, int>> conn2;
    while(true){
        bool passFlag = false;
        for(int r = 0; r < rows; r++){
            if(timePassed() >= timeLimitSec){ return false; }
            for(int c = 0; c < cols; c++){
                if(G[r][c].needs > 0){
                    for(int d = 0; d < 4; d++){
                        if(G[r][c].dirs[d].second != -1){
                            pii nxt = G[r][c].dirs[d].first;
                            if(G[nxt.first][nxt.second].needs > 0){
                                int connType = min(min(G[r][c].needs, G[nxt.first][nxt.second].needs), 2);
                                G[r][c].dirs[d].second = connType;
                                G[r][c].needs -= connType;
                                G[r][c].conns --;
                                G[nxt.first][nxt.second].dirs[(d+2)%4].second = connType;
                                G[nxt.first][nxt.second].needs -= connType;
                                G[nxt.first][nxt.second].conns --;
                                totalNeeds -= 2*connType;
                                conn2.push_back({{{r, c}, nxt, }, connType});
                            }
                        }
                    }
                }
            }
        }
        if(!passFlag){ break; }
    }
    for(int i = 0; i < conn2.size(); i++){
        pii u = conn2[i].first.first, v = conn2[i].first.second;
        int connType = conn2[i].second;
        if(u.first == v.first){
            if(u.second > v.second){ swap(u, v); }
            for(int c = u.second+1; c < v.second; c++){ if(puzzle[u.first][c]){ return false; }puzzle[u.first][c] = HOR_SINGLE * connType; }
        }else if(u.second == v.second){
            if(u.first > v.first){ swap(u, v); }
            for(int r = u.first+1; r < v.first; r++){ if(puzzle[r][u.second]){ return false; }puzzle[r][u.second] = VERT_SINGLE * connType; }
        }
//        cout << conn2[i].first.first.first << ' ' << conn2[i].first.first.second << "\t-" << connType << "=>\t";
//        cout << conn2[i].first.second.first << ' ' << conn2[i].first.second.second << '\n';
    }
    if(timePassed() >= timeLimitSec){ return false; }
//    cout << "needs left: " << totalNeeds << '\n';
    return (totalNeeds == 0);
}

