#include <bits/stdc++.h>
using namespace std;
typedef signed long long ll;
typedef vector<vector<int>> vvi;

const ll MOD = 1e8+543;
ll mod(ll n){
    return (n%MOD+MOD)%MOD;
}

ll n;
vector<ll> a;
vector<ll> xa;

vector<vector<int>> mat = {
    { 6, 0, 0, 0, 0, 1 },
    { 0, 6, 0, 0, 0, 1 },
    { 0, 0, 6, 0, 0, 1 },
    { 0, 0, 0, 6, 0, 1 },
    { 0, 0, 0, 0, 6, 1 },
    { 0, 0, 0, 0, 0, 1 }
};

vector<vector<int>> matMul(const vvi& a, const vvi& b){
    vvi ret(a.size(), vector<int>(b.size()));
    for(int i = 0; i < a.size(); i++){
        for(int j = 0; j < b.size(); j++){
            for(int k = 0; k < a.size(); k++){
                ret[i][j] += a[i][k] * b[k][j];
                ret[i][j] %= MOD;
            }
        }
    }
    return ret;
}

vvi fastPow(vvi a, int p){
    vvi ret(a.size(), vector<int>(a.size()));
    for(int i = 0; i < a.size(); i++){
        a[i][i] = 1;
    }
    while(p > 0){
        if(p%2 == 1){
            ret = matMul(ret, a);
            p--;
        }else{
            a = matMul(a, a);
            p/=2;
        }
    }
    return ret;
}

vector<ll> x0 = {0,1,2,3,4};
void prevX(){
    ll px = 2*x0[0] + 3*x0[1] + 4*x0[2] + 5*x0[3] - x0[4];
    for(ll i = 1; i < 5; i++){ x0[i] = x0[i-1]; }
    x0[0] = -px;
}
void nextX(){
    ll nx = 5*x0[4] + 4*x0[3] + 3*x0[2] + 2*x0[1] + x0[0];
    for(ll i = 0; i < 4; i++){ x0[i] = x0[i+1]; }
    x0[4] = nx;
}

int repCoeff(int beg, int times){
    int mainPart = mod(pow(6, times) * beg);
    int otherPart = 1;
    for(int i = 0; i < times; i++){

    }
}

vector<ll> getXs(vector<ll> idxs){
    vector<pair<int, int>> vp;
    for(ll i = 0; i < idxs.size(); i++){
        vp.push_back({idxs[i]%MOD, idxs[i]});
    }
    sort(idxs.begin(), idxs.end());
    vvi x0 = {{0}, {1}, {2}, {3}, {4}};
    vector<ll> ret(idxs.size());
    int idx = 0;
    int f = 0;
    while(idx < idxs.size()){
        x0 = matMul(fastPow(mat, idxs[idx].first-f), x0);
        ret[idx++] = x0[0][0]
    }
    return ret;
}

void build(){
//    ll mn = a[0], mx = a[0];
//    for(ll i = 0; i < n; i++){
//        if(a[i] < mn){ mn = a[i]; }
//        if(a[i] > mx){ mx = a[i]; }
//    }
    vector<pair<int, int>> pos;
    vector<ll> a2(a);
    for(int i = 0; i < n; i++){ pos.push_back({a[i], i}); }
    sort(a2.begin(), a2.end());
    sort(pos.begin(), pos.end());
    vector<ll> xs = getXs(a2);
    for(int i = 0; i < n; i++){
        xa[pos[i].second] = xs[i];
    }
}

void update(ll left, ll right, ll value){
    for(ll i = left; i <= right; i++){
        a[i] += value;
    }
    vector<pair<int, int>> pos;
    vector<ll> a2(a.begin()+left, a.begin()+right+1);
    for(int i = left; i <= right; i++){ pos.push_back({a[i], i}); }
    sort(a2.begin(), a2.end());
    sort(pos.begin(), pos.end());
    vector<ll> xs = getXs(a2);
    for(int i = 0; i < xs.size(); i++){
        xa[pos[i].second] = xs[i];
    }
}
ll query(ll left, ll right){
    ll sum = 0;
    for(ll i = left; i <= right; i++){
        sum = mod(sum + xa[i]);
    }
    return sum;
}

signed main(){
    ll Q;
    cin >> n >> Q;
    a.resize(n);
    xa.resize(n);
    for(ll i = 0; i < n; i++){ cin >> a[i]; }

    build();

    ll type, left, right, value;
    for(ll q = 1; q <= Q; q++){
//        cout << "{ "; for(int i = 0; i < xa.size(); i++){ cout << xa[i] << ' '; } cout << "}\n";
        cin >> type >> left >> right;
        left--; right--;
        if(type == 1){
            cout << query(left, right) << '\n';
        } else {
            cin >> value;
            update(left, right, value);
        }
    }
    return 0;
}
