#include<bits/stdc++.h>
#define endl "\n"
using namespace std;
const int MOD=100000543;
struct matrix{
    long long m[5][5];
};
matrix operator+(matrix a,matrix b){
    matrix ans;
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++){
            ans.m[i][j]=a.m[i][j]+b.m[i][j];
            ans.m[i][j]%=MOD;
        }
    }
    return ans;
}
matrix operator*(matrix a,matrix b){
    matrix ans;
    for(int i=0;i<5;i++){
        for(int j=0;j<5;j++){
            ans.m[i][j]=0;
            for(int x=0;x<5;x++){
                ans.m[i][j]+=a.m[i][x]*b.m[x][j];
                ans.m[i][j]%=MOD;
            }
        }
    }
    return ans;
}
matrix id;
matrix m0;
matrix m1;
matrix m2;
matrix x1[30];
matrix x2[30];
void inMatrix(){
    id.m[0][0]=1;
    id.m[1][1]=1;
    id.m[2][2]=1;
    id.m[3][3]=1;
    id.m[4][4]=1;

    m1.m[0][0]=5;
    m1.m[0][1]=4;
    m1.m[0][2]=3;
    m1.m[0][3]=2;
    m1.m[0][4]=1;
    m1.m[1][0]=1;
    m1.m[1][1]=0;
    m1.m[1][2]=0;
    m1.m[1][3]=0;
    m1.m[1][4]=0;
    m1.m[2][0]=0;
    m1.m[2][1]=1;
    m1.m[2][2]=0;
    m1.m[2][3]=0;
    m1.m[2][4]=0;
    m1.m[3][0]=0;
    m1.m[3][1]=0;
    m1.m[3][2]=1;
    m1.m[3][3]=0;
    m1.m[3][4]=0;
    m1.m[4][0]=0;
    m1.m[4][1]=0;
    m1.m[4][2]=0;
    m1.m[4][3]=1;
    m1.m[4][4]=0;

    m2.m[0][0]=0;
    m2.m[0][1]=1;
    m2.m[0][2]=0;
    m2.m[0][3]=0;
    m2.m[0][4]=0;
    m2.m[1][0]=0;
    m2.m[1][1]=0;
    m2.m[1][2]=1;
    m2.m[1][3]=0;
    m2.m[1][4]=0;
    m2.m[2][0]=0;
    m2.m[2][1]=0;
    m2.m[2][2]=0;
    m2.m[2][3]=1;
    m2.m[2][4]=0;
    m2.m[3][0]=0;
    m2.m[3][1]=0;
    m2.m[3][2]=0;
    m2.m[3][3]=0;
    m2.m[3][4]=1;
    m2.m[4][0]=1;
    m2.m[4][1]=-5;
    m2.m[4][2]=-4;
    m2.m[4][3]=-3;
    m2.m[4][4]=-2;
}
int getValue(matrix a){
    long long ans=0;
    for(int i=0;i<5;i++){
        ans+=a.m[0][i]*(5-i-1);
        ans%=MOD;
    }
    return ans;
}
matrix fastPow(int n){
    matrix ans=id;
    for(int i=0;n>0;i++){
        if((n&1)) ans=ans*x1[i];
        n=(n>>1);
    }
    n*=-1;
    for(int i=0;n>0;i++){
        if((n&1)) ans=ans*x2[i];
        n=(n>>1);
    }
    return ans;
}
long long a[100010];
long long segm[400010];
long long lazy[400010];
void create(int u,int from,int to){
    if(from==to){
        segm[u]=getValue(fastPow(a[from]));
        return;
    }
    int mid=(from+to)/2;
    create(2*u,from,mid);
    create(2*u+1,mid+1,to);
    segm[u]=segm[2*u]+segm[2*u+1];
}
/*void lz(int u){
    segm[2*u]=segm[2*u]*fastPow(lazy[u]);
    segm[2*u+1]=segm[2*u+1]*fastPow(lazy[u]);
    lazy[2*u]+=lazy[u];
    lazy[2*u+1]+=lazy[u];
    lazy[u]=0;
}
void update(int u,int from,int to,int l,int r,int x){
    if(to<l || r<from) return;
    if(l<=from && to<=r){
        segm[u]=segm[u]*fastPow(x);
        lazy[u]+=x;
        return;
    }
    lz(u);
    int mid=(from+to)/2;
    update(2*u,from,mid,l,r,x);
    update(2*u+1,mid+1,to,l,r,x);
    segm[u]=segm[2*u]+segm[2*u+1];
}*/
long long query(int u,int from,int to,int l,int r){
    if(to<l || r<from) return 0;
    if(l<=from && to<=r){
        return segm[u];
    }
    //lz(u);
    int mid=(from+to)/2;
    return (query(2*u,from,mid,l,r)+query(2*u+1,mid+1,to,l,r))%MOD;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    inMatrix();
    x1[0]=m1;
    for(int i=1;i<30;i++){
        x1[i]=x1[i-1]*x1[i-1];
    }
    x2[0]=m2;
    for(int i=1;i<30;i++){
        x2[i]=x2[i-1]*x2[i-1];
    }

    int n,q;
    cin>>n>>q;
    for(int i=0;i<n;i++){
        cin>>a[i];
        a[i]-=4;
    }
    create(1,0,n-1);
    while(q--){
        int type,l,r;
        cin>>type>>l>>r;
        l--;
        r--;
        if(type==1){
            cout<<query(1,0,n-1,l,r)<<endl;
        }
        else{
            int value;
            cin>>value;
            //update(1,0,n-1,l,r,value);
        }
    }
    return 0;
}
