#include<bits/stdc++.h>


using namespace std;

const int maxh = 51, maxn = 210;

struct edge
{
    int v, u;

    edge(int _v = 0, int _u = 0)
    {
        v = _v;
        u = _u;
    }
} edges[maxn * maxn];

int num[maxn], N, M;
double TimeLimit;
void init(int numSubtests, double _timeLimit)
{
    TimeLimit = _timeLimit;
}

int c[maxh][maxh], ridx[maxh][maxh];
pair < int, int > rev[maxh * maxh];
int h, w;

void add_edge(int v, int u)
{
    M ++;
    edges[M] = edge(v, u);
}

bool is_horizontal(edge e1)
{
    return (rev[e1.v].first == rev[e1.u].first);
}
bool cross(edge e1, edge e2)
{
    if (is_horizontal(e1) == is_horizontal(e2))
        return false;

    if (is_horizontal(e2))
        swap(e1, e2);

    int dw_row = min(rev[e2.v].first, rev[e2.u].first);
    int up_row = max(rev[e2.v].first, rev[e2.u].first);
    int lf_col = min(rev[e1.v].second, rev[e1.u].second);
    int rf_col = max(rev[e1.v].second, rev[e1.u].second);

    if (dw_row < rev[e1.v].first && up_row > rev[e1.v].first &&
        lf_col < rev[e2.v].second && rf_col > rev[e2.v].second)
            return true;

    return false;
}
void find_edges()
{
    for (int i = 0; i < h; i ++)
    {
        for (int j = 0; j < w; j ++)
        {
            if (c[i][j] == 0)
                continue;

            int r = i - 1;
            while(r >= 0 && c[r][j] == 0)
                r --;
            if (r >= 0)
            {
                add_edge(ridx[r][j], ridx[i][j]);
            }

            r = i + 1;
            while(r < h && c[r][j] == 0)
                r ++;
            if (r < h)
            {
                add_edge(ridx[r][j], ridx[i][j]);
            }

            int l = j - 1;
            while(l >= 0 && c[i][l] == 0)
                l --;
            if (l >= 0)
            {
                add_edge(ridx[i][l], ridx[i][j]);
            }

            l = j + 1;
            while(l < w && c[i][l] == 0)
                l ++;
            if (l < w)
            {
                add_edge(ridx[i][l], ridx[i][j]);
            }
        }
    }
}
bool solve(vector < vector < int > > &puzzle)
{
    h = puzzle.size();
    w = puzzle[0].size();
    int cnt = 0;
    for (int i = 0; i < h; i ++)
        for (int j = 0; j < w; j ++)
        {
            if (puzzle[i][j] != 0)
            {
                ridx[i][j] = ++cnt;
                rev[cnt] = {i, j};
                N ++;
                num[N] = puzzle[i][j];
            }
            c[i][j] = puzzle[i][j];
        }

    find_edges();

    /**for (int i = 0; i < h; i ++, cout << endl)
        for (int j = 0; j < w; j ++)
        cout << setw(2) << ridx[i][j] << " ";
    for (int i = 1; i <= M; i ++)
    {
        cout << "edge " << edges[i].v << " " << edges[i].u << endl;
    }*/

    assert(M <= 20);
    return false;
}
