#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll mod = 1e8 + 543;
const int maxa = 5;
struct matrix
{
    ll mat[maxa][maxa];

    matrix()
    {
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                mat[i][j] = 0;
    }

    matrix mult(matrix &p)
    {
        matrix res;
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                for (int k = 0; k < maxa; k ++)
                {
                    res.mat[i][j] += mat[i][k] * p.mat[k][j];
                    res.mat[i][j] %= mod;
                }

        return res;
    }

    void one()
    {
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
            {
                mat[i][j] = (i == j);
            }
    }
};

matrix power(matrix base, ll st)
{
    matrix res;
    for (int i = 0; i < maxa; i ++)
        res.mat[i][i] = 1;

    while(st > 0)
    {
        if (st % 2 == 1)
            res = res.mult(base);

        base = base.mult(base);
        st /= 2;
    }
    return res;
}


const int maxbit = 32;

const int maxq = 20010;
matrix base_transition, rev_transition;
matrix pw_base[maxbit], pw_rev[maxbit];

vector < ll > base_number;
void init()
{
    base_number = {0, 1, 2, 3, 4};

    base_transition.mat[1][0] = 1;
    base_transition.mat[2][1] = 1;
    base_transition.mat[3][2] = 1;
    base_transition.mat[4][3] = 1;
    base_transition.mat[0][4] = 1;
    base_transition.mat[1][4] = 2;
    base_transition.mat[2][4] = 3;
    base_transition.mat[3][4] = 4;
    base_transition.mat[4][4] = 5;

    rev_transition.mat[0][1] = 1;
    rev_transition.mat[1][2] = 1;
    rev_transition.mat[2][3] = 1;
    rev_transition.mat[3][4] = 1;
    rev_transition.mat[3][4] = 1;
    rev_transition.mat[4][0] =  1;
    rev_transition.mat[3][0] = -5;
    rev_transition.mat[2][0] = -4;
    rev_transition.mat[1][0] = -3;
    rev_transition.mat[0][0] = -2;

    for (ll i = 0; i < maxbit; i ++)
    {
        pw_base[i] = power(base_transition, ((ll)(1) << i));
        pw_rev[i] = power(rev_transition, ((ll)(1) << i));

    }

}

vector < ll > vec_mult(vector < ll > base, matrix cur)
{
    vector < ll > res(maxa, 0);
    for (int i = 0; i < maxa; i ++)
    {
        for (int j = 0; j < maxa; j ++)
        {
            res[j] += base[i] * cur.mat[i][j];
            res[j] %= mod;
            if (res[j] < 0)
                res[j] += mod;
        }
    }

    return res;
}


const int maxn = 1e5 + 10;
int n, q;
int a[maxn];

void input()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
    }
}





struct node
{
    ll arr[maxa];

    node()
    {
        for (int i = 0; i < maxa; i ++)
            arr[i] = 0;
    }


};
ll temp[maxa];
void update_node(node &nd, matrix &cur)
{
    for (int i = 0; i < maxa; i ++)
        temp[i] = 0;

    for (int i = 0; i < maxa; i ++)
    {
        for (int j = 0; j < maxa; j ++)
        {
            temp[j] += nd.arr[i] * cur.mat[i][j];
            temp[j] %= mod;
            if (temp[j] < 0)
                temp[j] += mod;
        }
    }

    for (int i = 0; i < maxa; i ++)
        nd.arr[i] = temp[i];
}

void update_node_power(node &nd, int type, ll st)
{
    int bit = 0;
    while(st > 0)
    {
        if ((st & 1) > 0)
        {
            if (type == 1)
                update_node(nd, pw_base[bit]);
            else
                update_node(nd, pw_rev[bit]);
        }

        bit ++;
        st /= 2;
    }
}


node tree[4 * maxn];
matrix lazy[4 * maxn];

int tag[4 * maxn];


node unite(node lf, node rf)
{
    node mf;
    for (int i = 0; i < maxa; i ++)
    {
        mf.arr[i] = lf.arr[i] + rf.arr[i];
        if (mf.arr[i] >= mod)
            mf.arr[i] -= mod;
    }
    return mf;
}

void push_lazy(int root, int left, int right)
{
    if (!tag[root])
        return;

    update_node(tree[root], lazy[root]);

    if (left != right)
    {
        lazy[root * 2] = lazy[root * 2].mult(lazy[root]);
        lazy[root * 2 + 1] = lazy[root * 2 + 1].mult(lazy[root]);
        tag[root * 2] = tag[root * 2 + 1] = 1;
    }

    lazy[root].one();
    tag[root] = 0;
}
void build(int root, int left, int right)
{
    lazy[root].one();

    if (left == right)
    {
        for (int i = 0; i < maxa; i ++)
            tree[root].arr[i] = i;
        if (a[left] < 4)
        {
            update_node_power(tree[root], 2, 4 - a[left]);
        }
        else
        {
            update_node_power(tree[root], 1, a[left] - 4);
        }
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);
    tree[root] = unite(tree[root * 2], tree[root * 2 + 1]);
}

node query(int root, int left, int right, int qleft, int qright)
{
    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return node();

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return unite(query(root * 2, left, mid, qleft, qright),
                 query(root * 2 + 1, mid + 1, right, qleft, qright));
}



void range_update(int root, int left, int right, int qleft, int qright, matrix &cur)
{
    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return;

    if (left >= qleft && right <= qright)
    {
        lazy[root] = cur;
        tag[root] = 1;
        push_lazy(root, left, right);
        return;
    }

    int mid = (left + right) / 2;
    range_update(root * 2, left, mid, qleft, qright, cur);
    range_update(root * 2 + 1, mid + 1, right, qleft, qright, cur);
    tree[root] = unite(tree[root * 2], tree[root * 2 + 1]);

}
void answer_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        int t, l, r;
        cin >> t;
        if (t == 1)
        {
            cin >> l >> r;
            node cur = query(1, 1, n, l, r);
            cout << cur.arr[maxa - 1] << endl;
        }
        else
        {
            cin >> l >> r;
            int v;
            cin >> v;
            matrix val;
            val.one();
            int to = abs(v);
            for (int bit = 0; (1 << bit) <= to; bit ++)
            {
                if ((to & (1 << bit)) > 0)
                {
                    if (v > 0)
                        val = val.mult(pw_base[bit]);
                    else
                        val = val.mult(pw_rev[bit]);
                }
            }

            range_update(1, 1, n, l, r, val);
        }
    }
}

void solve()
{
    init();
    input();
    build(1, 1, n);
    ///exit(0);
    answer_queries();
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
4 1
3 5 6 4
1 2 3
*/
