#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll mod = 1e8 + 543;
const int maxa = 5;
struct matrix
{
    ll mat[maxa][maxa];

    matrix()
    {
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                mat[i][j] = 0;
    }

    matrix mult(matrix &p)
    {
        matrix res;
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                for (int k = 0; k < maxa; k ++)
                {
                    res.mat[i][j] += mat[i][k] * p.mat[k][j];

                }

        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
                res.mat[i][j] %= mod;

        return res;
    }

    void one()
    {
        for (int i = 0; i < maxa; i ++)
            for (int j = 0; j < maxa; j ++)
            {
                mat[i][j] = (i == j);
            }
    }
};

matrix power(matrix base, ll st)
{
    matrix res;
    for (int i = 0; i < maxa; i ++)
        res.mat[i][i] = 1;

    while(st > 0)
    {
        if (st % 2 == 1)
            res = res.mult(base);

        base = base.mult(base);
        st /= 2;
    }
    return res;
}


const int maxbit = 48;
const int batch_size = 12;

matrix base_transition, rev_transition;
matrix pw_base[maxbit], pw_rev[maxbit];
matrix base_batch[(1 << batch_size)][5];
matrix rev_batch[(1 << batch_size)][5];
vector < ll > base_number;
void init()
{
    base_number = {0, 1, 2, 3, 4};

    base_transition.mat[1][0] = 1;
    base_transition.mat[2][1] = 1;
    base_transition.mat[3][2] = 1;
    base_transition.mat[4][3] = 1;
    base_transition.mat[0][4] = 1;
    base_transition.mat[1][4] = 2;
    base_transition.mat[2][4] = 3;
    base_transition.mat[3][4] = 4;
    base_transition.mat[4][4] = 5;

    rev_transition.mat[0][1] = 1;
    rev_transition.mat[1][2] = 1;
    rev_transition.mat[2][3] = 1;
    rev_transition.mat[3][4] = 1;
    rev_transition.mat[3][4] = 1;
    rev_transition.mat[4][0] =  1;
    rev_transition.mat[3][0] = -5;
    rev_transition.mat[2][0] = -4;
    rev_transition.mat[1][0] = -3;
    rev_transition.mat[0][0] = -2;

    for (ll i = 0; i < maxbit; i ++)
    {
        pw_base[i] = power(base_transition, ((ll)(1) << i));
        pw_rev[i] = power(rev_transition, ((ll)(1) << i));

    }

    for (int mask = 0; mask < (1 << batch_size); mask ++)
    {
        for (int i = 0; i < maxbit / batch_size; i ++)
        {
            matrix cur;
            cur.one();
            for (int bit = 0; bit < batch_size; bit ++)
            {
                if ((mask & (1 << bit)) > 0)
                {
                    cur = cur.mult(pw_base[i * batch_size + bit]);
                }
            }
            matrix df;
            df.one();
            for (int bit = 0; bit < batch_size; bit ++)
            {
                if ((mask & (1 << bit)) > 0)
                {
                    df = df.mult(pw_rev[i * batch_size + bit]);
                }
            }

            base_batch[mask][i] = cur;
            rev_batch[mask][i] = df;
        }
    }

}

vector < ll > vec_mult(vector < ll > base, matrix cur)
{
    vector < ll > res(maxa, 0);
    for (int i = 0; i < maxa; i ++)
    {
        for (int j = 0; j < maxa; j ++)
        {
            res[j] += base[i] * cur.mat[i][j];
            res[j] %= mod;
            if (res[j] < 0)
                res[j] += mod;
        }
    }

    return res;
}


const int maxn = 1e5 + 10;
int n, q;
int a[maxn];

void input()
{
    cin >> n >> q;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
    }
}






ll tree[maxa][4 * maxn];
ll temp[maxa];
void update_node(int root, matrix &cur)
{
    for (int i = 0; i < maxa; i ++)
        temp[i] = 0;

    for (int i = 0; i < maxa; i ++)
    {
        for (int j = 0; j < maxa; j ++)
        {
            temp[j] += tree[i][root] * cur.mat[i][j];

        }
    }



    for (int i = 0; i < maxa; i ++)
    {
        temp[i] %= mod;
        if (temp[i] < 0)
            temp[i] += mod;
        tree[i][root] = temp[i];
    }
}

void update_node_power(int root, int type, ll st)
{
    int bit = 0;
    while(st > 0)
    {
        if ((st & 1) > 0)
        {
            if (type == 1)
                update_node(root, pw_base[bit]);
            else
                update_node(root, pw_rev[bit]);
        }

        bit ++;
        st /= 2;
    }
}



ll lazy[4 * maxn];

int tag[4 * maxn];


void unite(int root)
{
    for (int i = 0; i < maxa; i ++)
    {
        tree[i][root] = tree[i][root * 2] + tree[i][root * 2 + 1];
        if (tree[i][root] >= mod)
            tree[i][root] -= mod;
    }
}

void push_lazy(int root, int left, int right)
{
    if (!tag[root])
        return;

    ll to = abs(lazy[root]);
    for (int i = 0; i < maxbit / batch_size; i ++)
    {
        int mask = 0;

        for (int bit = 0; bit < batch_size; i ++)
        {
            if ((to & ((ll)(1) << (bit + i * batch_size))) > 0)
                mask |= (1 << bit);
        }
        ///cout << "lazy " << root << " " << i << " " << mask << endl;
        if (lazy[root] > 0)
            update_node(root, base_batch[mask][i]);
        else
            update_node(root, rev_batch[mask][i]);
    }
    ///update_node(root, lazy[root]);

    if (left != right)
    {
        lazy[root * 2] += lazy[root];
        lazy[root * 2 + 1] += lazy[root];
        tag[root * 2] = tag[root * 2 + 1] = 1;
    }

    lazy[root] = 0;
    tag[root] = 0;
}
void build(int root, int left, int right)
{
    lazy[root] = 0;

    if (left == right)
    {
        for (int i = 0; i < maxa; i ++)
            tree[i][root] = i;
        if (a[left] < 4)
        {
            update_node_power(root, 2, 4 - a[left]);
        }
        else
        {
            update_node_power(root, 1, a[left] - 4);
        }
        return;
    }

    int mid = (left + right) / 2;
    build(root * 2, left, mid);
    build(root * 2 + 1, mid + 1, right);
    unite(root);
}

ll query(int root, int left, int right, int qleft, int qright)
{
    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return 0;

    if (left >= qleft && right <= qright)
        return tree[maxa - 1][root];

    int mid = (left + right) / 2;
    return (query(root * 2, left, mid, qleft, qright) +
            query(root * 2 + 1, mid + 1, right, qleft, qright)) % mod;
}



void range_update(int root, int left, int right, int qleft, int qright, ll cur)
{
    push_lazy(root, left, right);
    if (left > qright || right < qleft)
        return;

    if (left >= qleft && right <= qright)
    {
        lazy[root] = cur;
        tag[root] = 1;
        push_lazy(root, left, right);
        return;
    }

    int mid = (left + right) / 2;
    range_update(root * 2, left, mid, qleft, qright, cur);
    range_update(root * 2 + 1, mid + 1, right, qleft, qright, cur);
    unite(root);

}
void answer_queries()
{
    for (int i = 1; i <= q; i ++)
    {
        int t, l, r;
        cin >> t;
        if (t == 1)
        {
            cin >> l >> r;
            ll cur = query(1, 1, n, l, r);
            cout << cur << endl;
        }
        else
        {
            cin >> l >> r;
            int v;
            cin >> v;



            range_update(1, 1, n, l, r, v);
        }
    }

}

void solve()
{
    init();
    input();
    build(1, 1, n);
    ///exit(0);
    answer_queries();
}

int main()
{

    speed();
    solve();
    return 0;
}
/**
4 1
3 5 6 4
1 2 3
*/
