#include<bits/stdc++.h>
#include "puzzle.h"

using namespace std;

void init(int numSubtests, double timeLimit)
{

}

int brv=0, br_ed=0;
int pos[2][200], st[200], tek[200], tot=0, expe=0;
bool cros[1000][1000];
vector<pair<int, int> > edges;
vector<int> values;
vector<int> rows[50], cols[50], gr[200];

void addrows(int i, int v)
{
    if(!rows[i].size())
    {
        rows[i].push_back(v);
        return;
    }
    int lv=rows[i][rows[i].size()-1];
    edges.push_back({lv, v});
    gr[v].push_back(edges.size()-1);
    gr[lv].push_back(edges.size()-1);
    rows[i].push_back(v);
}

void addcols(int i, int v)
{
    if(!cols[i].size())
    {
        cols[i].push_back(v);
        return;
    }
    int lv=cols[i][cols[i].size()-1];
    edges.push_back({lv, v});
    gr[v].push_back(edges.size()-1);
    gr[lv].push_back(edges.size()-1);
    cols[i].push_back(v);

}

bool are_crossing(int e1, int e2)
{
    int a1=edges[e1].first, a2=edges[e1].second;
    int b1=edges[e2].first, b2=edges[e2].second;
    int a_pos=1, b_pos=1;
    if(pos[0][a1]==pos[0][a2]) a_pos=0;
    if(pos[0][b1]==pos[0][b2]) b_pos=0;
    if(a_pos==b_pos) return 0;
    if((pos[b_pos][a1]-pos[b_pos][b1])*(pos[b_pos][a2]-pos[b_pos][b1])<0  &&
       (pos[a_pos][b1]-pos[a_pos][a1])*(pos[a_pos][b2]-pos[a_pos][a1])<0) return 1;
    return 0;
}

bool solved=0;
bool used[205];

void dfs(int v)
{
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int tek_edge=gr[v][i];
        if(values[tek_edge]<=0) continue;
        int nv=edges[tek_edge].first+edges[tek_edge].second-v;
        if(!used[nv])
        {
            used[nv]=1;
            dfs(nv);
        }
    }
}

bool check_sol()
{
    ///cout<<tot<<endl;
    for(int i=1; i<=brv; i++) used[i]=0;
    used[1]=1;
    dfs(1);
    for(int i=1; i<=brv; i++) if(!used[i]) return 0;
    return 1;
}

void rec()
{
    if(solved) return;
    if(tot==expe)
    {
        solved=check_sol();
        if(solved) return;
    }

    ///for(int i=1; i<=brv; i++) cout<<tek[i]<<" "<<st[i]<<endl;

    for(int i=0; i<br_ed; i++)
    {
        ///cout<<values[i]<<" ";
        if(values[i]==-1)
        {
            ///cout<<endl;
            int v1=edges[i].first, v2=edges[i].second;
            values[i]=0;

            rec();
            if(solved) return;

            values[i]=-1;
            for(int j=0; j<br_ed; j++) if(cros[i][j] && values[j]>0) return;

            if(st[v1]-tek[v1]>=1 && st[v2]-tek[v2]>=1)
            {
                values[i]=1;
                tek[v1]++;
                tek[v2]++;
                tot++;

                rec();
                if(solved) return;

                values[i]=-1;
                tek[v1]--;
                tek[v2]--;
                tot--;
            }

            if(st[v1]-tek[v1]>=2 && st[v2]-tek[v2]>=2)
            {
                values[i]=2;
                tek[v1]+=2;
                tek[v2]+=2;
                tot+=2;

                rec();
                if(solved) return;

                values[i]=-1;
                tek[v1]-=2;
                tek[v2]-=2;
                tot-=2;
            }
            break;
        }
    }
}


bool solve(std::vector<std::vector<int>>& puzzle)
{
    tot=0;
    expe=0;
    brv=0;
    solved=0;
    edges.resize(0);
    int n=puzzle.size(), m=puzzle[0].size();
    for(int i=0; i<=max(n, m); i++) {rows[i].resize(0); cols[i].resize(0);}

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(puzzle[i][j])
            {
                brv++;
                st[brv]=puzzle[i][j];
                expe+=st[brv];
                tek[brv]=0;
                gr[brv].resize(0);
                pos[0][brv]=i;
                pos[1][brv]=j;
                addrows(i, brv);
                addcols(j, brv);
            }
        }
    }
    expe/=2;
    br_ed=edges.size();
    values.resize(br_ed, -1);
    for(int i=0; i<br_ed; i++)
    {
        for(int j=0; j<br_ed; j++)
        {
            cros[i][j]=0;
            if(are_crossing(i, j)) cros[i][j]=1;
        }
    }
    rec();
    for(int i=0; i<br_ed; i++)
    {
        if(values[i]<=0) continue;
        int v1=edges[i].first, v2=edges[i].second;
        if(pos[0][v1]==pos[0][v2])
        {
            int le=pos[1][v1], ri=pos[1][v2], sv=-2*values[i]+1;
            if(le>ri) swap(le, ri);
            for(int j=le+1; j<=ri-1; j++) puzzle[pos[0][v1]][j]=sv;
        }
        else
        {
            int up=pos[0][v1], dow=pos[0][v2], sv=-2*values[i];
            if(up>dow) swap(up, dow);
            for(int i=up+1; i<=dow-1; i++) puzzle[i][pos[1][v1]]=sv;
        }
    }

    /**for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++) cout<<puzzle[i][j]<<" ";
        cout<<endl;
    }*/

    return 1;
}
