#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long mod=1e8+543;
long long fastpow(long long base, long long st)
{
    if(st<0) st+=mod-1;
    st%=(mod-1);
    if(st==0) return 1;
    long long tres=1, tbase=base;
    while(st)
    {
        if(st&1) tres=(tres*tbase)%mod;
        st/=2;
        tbase*=tbase;
        tbase%=mod;
    }
    return tres;
}

long long roots[5]={1405049, 10002474, 36684046, 69727867, 82181655};
long long coeff[5]={4868204, 92161528, 51211683, 37815043, 13944628};

long long a[100005];
long long segm[5][400005];
long long lazy[400005];

void build_tree(long long v, long long le, long long ri)
{
    if(le==ri)
    {
        for(long long i=0; i<5; i++)
        {
            segm[i][v]=coeff[i]*fastpow(roots[i], a[le])%mod;
        }
        return;
    }
    long long mid=(le+ri)/2;
    build_tree(2*v, le, mid);
    build_tree(2*v+1, mid+1, ri);
    for(long long i=0; i<5; i++)
    {
        segm[i][v]=(segm[i][2*v]+segm[i][2*v+1])%mod;
    }
}

void push_lazy(long long v, long long le, long long ri)
{
    if(lazy[v]==0) return;
    for(long long i=0; i<5; i++)
    {
        segm[i][v]*=fastpow(roots[i], lazy[v]);
        segm[i][v]%=mod;
    }
    if(le!=ri) {lazy[2*v]+=lazy[v]; lazy[2*v+1]+=lazy[v];}
    lazy[v]=0;
}

void update(long long v, long long le, long long ri, long long be, long long en, long long val)
{
    push_lazy(v, le, ri);
    if(le>en  || ri<be) return;
    if(be<=le && ri<=en)
    {
        lazy[v]+=val;
        push_lazy(v, le, ri);
        return;
    }
    long long mid=(le+ri)/2;
    update(2*v, le, mid, be, en, val);
    update(2*v+1, mid+1, ri, be, en, val);
    for(long long i=0; i<5; i++)
    {
        segm[i][v]=(segm[i][2*v]+segm[i][2*v+1])%mod;
    }
}

long long query(long long v, long long le, long long ri, long long be, long long en)
{
    push_lazy(v, le, ri);
    if(le>en  || ri<be) return 0;
    if(be<=le && ri<=en)
    {
        long long sum=0;
        for(long long i=0; i<5; i++) sum+=segm[i][v];
        return sum%mod;
    }
    long long mid=(le+ri)/2;
    return (query(2*v, le, mid, be, en)+query(2*v+1, mid+1, ri, be, en))%mod;

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n, q;
    cin>>n>>q;
    for(long long i=1; i<=n; i++) cin>>a[i];
    build_tree(1, 1, n);
    for(long long i=0; i<q; i++)
    {
        long long ty, be, en, val;
        cin>>ty>>be>>en;
        if(ty==1)
        {
            cout<<query(1, 1, n, be, en)%mod<<endl;
        }
        if(ty==2)
        {
            cin>>val;
            update(1, 1, n, be, en, val);
        }
    }
    return 0;
}
