#include<bits/stdc++.h>
#pragma GCC optimize
#define endl '\n'

using namespace std;

int mod=1e8+543;
int fastpow(long long base, int st)
{
    if(st<0) st+=mod-1;
    st%=(mod-1);
    long long tres=1, tbase=base;
    while(st)
    {
        if(st&1) tres=(tres*tbase)%mod;
        st>>=1;
        tbase*=tbase;
        tbase%=mod;
    }
    return tres;
}

long long roots[5]={1405049, 10002474, 36684046, 69727867, 82181655};
long long coeff[5]={4868204, 92161528, 51211683, 37815043, 13944628};

int a[100005];
long long segm[5][400005];
int lazy[400005];

void build_tree(int v, int le, int ri)
{
    if(le==ri)
    {
        for(int i=0; i<5; i++)
        {
            segm[i][v]=coeff[i]*fastpow(roots[i], a[le])%mod;
        }
        return;
    }
    int mid=(le+ri)/2;
    build_tree(2*v, le, mid);
    build_tree(2*v+1, mid+1, ri);
    for(int i=0; i<5; i++)
    {
        segm[i][v]=(segm[i][2*v]+segm[i][2*v+1]);
        if(segm[i][v]>=mod) segm[i][v]-=mod;
    }
}

void push_lazy(int v, int le, int ri)
{
    if(lazy[v]==0) return;
    for(int i=0; i<5; i++)
    {
        segm[i][v]*=fastpow(roots[i], lazy[v]);
        segm[i][v]%=mod;
    }
    if(le!=ri) {lazy[2*v]+=lazy[v]; lazy[2*v+1]+=lazy[v];}
    lazy[v]=0;
}

void update(int v, int le, int ri, int be, int en, int val)
{
    push_lazy(v, le, ri);
    if(le>en  || ri<be) return;
    if(be<=le && ri<=en)
    {
        lazy[v]+=val;
        push_lazy(v, le, ri);
        return;
    }
    int mid=(le+ri)/2;
    update(2*v, le, mid, be, en, val);
    update(2*v+1, mid+1, ri, be, en, val);
    for(int i=0; i<5; i++)
    {
        segm[i][v]=(segm[i][2*v]+segm[i][2*v+1]);
        if(segm[i][v]>=mod) segm[i][v]-=mod;
    }
}

int query(int v, int le, int ri, int be, int en)
{
    push_lazy(v, le, ri);
    if(le>en  || ri<be) return 0;
    if(be<=le && ri<=en)
    {
        int sum=0;
        for(int i=0; i<5; i++) sum+=segm[i][v];
        return sum%mod;
    }
    int mid=(le+ri)/2;
    long long sum=query(2*v, le, mid, be, en)+query(2*v+1, mid+1, ri, be, en);
    if(sum>=mod) return sum-mod;
    return sum;

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin>>n>>q;
    for(int i=1; i<=n; i++) cin>>a[i];
    build_tree(1, 1, n);
    for(int i=0; i<q; i++)
    {
        int ty, be, en, val;
        cin>>ty>>be>>en;
        if(ty==1)
        {
            cout<<query(1, 1, n, be, en)%mod<<endl;
        }
        if(ty==2)
        {
            cin>>val;
            update(1, 1, n, be, en, val);
        }
    }
    return 0;
}
