#include "puzzle.h"
#include <iostream>
#include <vector>
using namespace std;
double tl;
bool fin;
void init(int numSubtests, double timeLimit) {
    tl=timeLimit;
}
const int MAXN=50;
const int MAXT=1e3;
int n, m;
int t[MAXN][MAXN];
int br[MAXN][MAXN], pref[4];
vector <int> curv;
void print() {
    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) cout << t[i][j] << " ";
        cout << endl;
    }
}
pair <int,int> build_bridge(int i, int j, int pos, int val) {
    if (val==0) return {-1,-1};
    int pl;
    if (pos==0 || pos==3) pl=-1;
    else pl=1;
    bool start=true;
    while (t[i][j]==0 || start) {
        if (!start) {
            if (val<0) t[i][j]=0;
            else if (pos==0 || pos==2) t[i][j]=-2-(val-1)*2;
            else t[i][j]=-1-(val-1)*2;
        }
        start=false;
        if (pos==0 || pos==2) i+=pl;
        else j+=pl;
    }
    br[i][j]-=val;
    return {i,j};
}
vector <int> find_pos(int i, int j) {
    vector <int> res;
    res.resize(4);
    for (int i1=0;i1<4;i1++) res[i1]=0;
    int i1, j1;
    for (i1=i-1;i1>=0;i1--) {
        if (t[i1][j]<0) i1=-1;
        else if (t[i1][j]>0) {
            if (br[i1][j]>0) res[0]=1+(br[i1][j]>1);
        }
    }
    for (j1=j+1;j1<m;j1++) {
        if (t[i][j1]<0) j1=m;
        else if (t[i][j1]>0) {
            if (br[i][j1]>0) res[1]=1+(br[i][j1]>1);
        }
    }
    for (i1=i+1;i1<n;i1++) {
        if (t[i1][j]<0) i1=n;
        else if (t[i1][j]>0) {
            if (br[i1][j]>0) res[2]=1+(br[i1][j]>1);
        }
    }
    for (j1=j-1;j1>=0;j1--) {
        if (t[i][j1]<0) j1=-1;
        else if (t[i][j1]>0) {
            if (br[i][j1]>0) res[3]=1+(br[i][j1]>1);
        }
    }
    return res;
}
void dfs(int i1, int j1) {
    vector <int> cur=find_pos(i1,j1);
    int sum=0;
    for (int i=0;i<4;i++) sum+=cur[i];
    //cout << i1 << ' ' << j1 << ' ' << br[i1][j1] << ' ' << sum << endl;

    if (sum==br[i1][j1]) {
        br[i1][j1]=0;
        for (int i=0;i<4;i++) {
            pair<int,int> nxt=build_bridge(i1,j1,i,cur[i]);
            if (nxt.first!=-1) dfs(nxt.first,nxt.second);
        }
    }
}
bool rec(int ind) {
    if (ind==curv.size()) return true;
    int x=curv[ind];
    int i1, j1;
    i1=x/m; j1=x%m;
    vector <int> cur=find_pos(i1,j1);
    for (int i=0;i<4;i++) {
        if (i==0) pref[i]=cur[i];
        else pref[i]=pref[i-1]+cur[i];
    }
    if (tl-timePassed()<0.1) {
        fin=true;
        return false;
    }

    if (pref[3]<br[i1][j1]) return false;

    for (int i=0;i<=cur[0];i++) {
        if (pref[3]-pref[0]+i<br[i1][j1] || i>br[i1][j1]) continue;
        build_bridge(i1,j1,0,i);

        for (int j=0;j<=cur[1];j++) {
            if (pref[3]-pref[1]+i+j<br[i1][j1] || i+j>br[i1][j1]) continue;
            build_bridge(i1,j1,1,j);

            for (int k=0;k<=cur[2];k++) {
                if (pref[3]-pref[2]+i+j+k<br[i1][j1] || i+j+k>br[i1][j1]) continue;
                build_bridge(i1,j1,2,k);

                for (int p=0;p<=cur[3];p++) {
                    if (i+j+k+p!=br[i1][j1]) continue;
                    build_bridge(i1,j1,3,p);
                    if (rec(ind+1)) return true;
                    if (fin) return false;
                    build_bridge(i1,j1,3,-p);
                }

                build_bridge(i1,j1,2,-k);
            }

            build_bridge(i1,j1,1,-j);
        }

        build_bridge(i1,j1,0,-i);
    }
    return false;
}
bool solve(vector <vector <int> > puzzle) {
    n=puzzle.size(); m=puzzle[0].size();
    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) {
            t[i][j]=br[i][j]=puzzle[i][j];
        }
    }

    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) {
            if (!br[i][j]) continue;
            dfs(i,j);
        }
    }

    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) {
            if (!br[i][j]) continue;
            curv.push_back(i*m+j);
        }
    }
    if (!rec(0)) return false;
    //print();
    //cout << "size " << curv.size() << endl;

    for (int i=0;i<n;i++) {
        for (int j=0;j<m;j++) puzzle[i][j]=t[i][j];
    }
    return true;
}
/*
int main () {
    vector <vector <int> > cur={
{ 0, 0, 2, 0, 3, 0, 3},
{ 4, 0, 0, 0, 0, 2, 0},
{ 0, 0, 0, 0, 0, 0, 0},
{ 6, 0, 0, 0, 0, 2, 0},
{ 0, 0, 0, 0, 0, 0, 0},
{ 0, 0, 0, 0, 0, 0, 0},
{ 4, 0, 0, 0, 0, 0, 4}
};
    solve(cur);
    print();
}*/
