#include "ones.h"
#include <bits/stdc++.h>

using namespace std;

vector<int> ans;

int firstOne(int from, int to)
{
    int l = from;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (hasOnes(from, mid) == false)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return l;
}

int lastOne(int from, int to)
{
    int l = from;
    int r = to;

    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (hasOnes(mid, to) == true)
        {
            l = mid + 1;
        }
        else
        {
            r = mid - 1;
        }
    }

    return r;
}

void dnc(int l, int r, int k)
{
    if (l > r)
    {
        return;
    }

    if (ans.size() == k || hasOnes(l, r) == false)
    {
        return;
    }

    int bsl = l;
    int bsr = r;

    while (bsl <= bsr)
    {
        int bsmid = (bsl + bsr) / 2;

        if (hasOnes(l, bsmid) == false)
        {
            bsl = bsmid + 1;
        }
        else
        {
            bsr = bsmid - 1;
        }
    }

    int first = bsl;

    bsl = first + 1;
    bsr = r;

    while (bsl <= bsr)
    {
        int bsmid = (bsl + bsr) / 2;

        if (hasOnes(bsmid, r) == true)
        {
            bsl = bsmid + 1;
        }
        else
        {
            bsr = bsmid - 1;
        }
    }

    int last = bsr;

    //cout << l << " " << r << " :: " << first << " " << last << endl;

    ans.push_back(first);

    if (first != last)
    {
        ans.push_back(last);
    }
    else
    {
        return;
    }

    ++first;
    --last;

    int mid = (first + last) / 2;

    dnc(first, mid, k);
    dnc(mid + 1, last, k);
}

void solveBlock(int from, int to, int k)
{
    for (int i = from; i <= to; ++i)
    {
        if (ans.size() == k)
        {
            break;
        }

        int l = i - 1;
        int r = to + 1;
        bool isIth = false;

        while (r - l > 1)
        {
            int mid = (l + r) / 2;

            bool res = hasOnes(i, mid);

            if (i == mid)
            {
                isIth = res;
            }

            if (res == false)
            {
                l = mid;
            }
            else
            {
                r = mid;
            }
        }

        if (isIth == true || r <= to)
        {
            ans.push_back(r);
            //cout << "add " << l << endl;
        }

        i = r;
    }
}

vector<int> guessOnes(int n, int k)
{
    ans.clear();

    if (k <= 100)
    {
        int BLOCK_SIZE = (n / k);
        int cntBlocks = (n - 1) / BLOCK_SIZE + 1;

        for (int i = 1; i <= cntBlocks; ++i)
        {
            int from = (i - 1) * BLOCK_SIZE + 1;
            int to = min(n, i * BLOCK_SIZE);
            //cout << "look at " << from << " " << to << endl;
            solveBlock(from, to, k);
        }

        return ans;
    }

    int BLOCK_SIZE = (5 * (n / k)) / 3;
    int cntBlocks = (n - 1) / BLOCK_SIZE + 1;

    for (int i = 1; i <= cntBlocks; ++i)
    {
        int from = (i - 1) * BLOCK_SIZE + 1;
        int to = min(n, i * BLOCK_SIZE);
        dnc(from, to, k);
    }

    sort(ans.begin(), ans.end());
    return ans;
}
