#include "puzzle.h"
#include <bits/stdc++.h>

using namespace std;

void init(int numSubtests, double timeLimit)
{

}

vector<tuple<int, int, int>> g[32][32];
int val[32][32];
vector<pair<int, int>> islands;

bool solve(vector<vector<int>>& puzzle)
{
    int n = puzzle.size();
    int m = puzzle[0].size();

    islands.clear();

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            val[i][j] = 0;
            g[i][j].clear();
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (puzzle[i][j] == 0) continue;
            islands.push_back({i, j});

            int down = -1, up = -1, le = -1, ri = -1;

            for (int k = i + 1; k < n; ++k)
            {
                if (puzzle[k][j] > 0)
                {
                    down = k;
                    break;
                }
            }

            for (int k = i - 1; k >= 0; --k)
            {
                if (puzzle[k][j] > 0)
                {
                    up = k;
                    break;
                }
            }

            for (int k = j + 1; k < m; ++k)
            {
                if (puzzle[i][k] > 0)
                {
                    ri = k;
                    break;
                }
            }

            for (int k = j - 1; k >= 0; --k)
            {
                if (puzzle[i][k] > 0)
                {
                    le = k;
                    break;
                }
            }

            if (down != -1)
            {
                g[i][j].push_back({down, j, 2});
                val[i][j] += 2;
            }

            if (up != -1)
            {
                g[i][j].push_back({up, j, 2});
                val[i][j] += 2;
            }

            if (le != -1)
            {
                g[i][j].push_back({i, le, 2});
                val[i][j] += 2;
            }

            if (ri != -1)
            {
                g[i][j].push_back({i, ri, 2});
                val[i][j] += 2;
            }

            islands.push_back({i, j});
        }
    }

    while (true)
    {
        bool flag = false;

        for (auto [x, y] : islands)
        {
            int idx = 0;

            for (auto [x2, y2, w] : g[x][y])
            {
                if (val[x2][y2] > puzzle[x2][y2] && val[x][y] > puzzle[x][y])
                {
                    int diff = min(2, min(val[x2][y2] - puzzle[x2][y2], val[x][y] - puzzle[x][y]));
                    val[x2][y2] -= diff;
                    val[x][y] -= diff;
                    get<2>(g[x][y][idx]) -= diff;

                    for (int i = 0; i < g[x2][y2].size(); ++i)
                    {
                        if (get<0>(g[x2][y2][i]) == x && get<1>(g[x2][y2][i]) == y)
                        {
                            get<2>(g[x2][y2][i]) -= diff;
                            break;
                        }
                    }

                    flag = true;
                }

                ++idx;
            }
        }

        if (!flag) break;
    }

    for (auto [x, y] : islands)
    {
        for (auto [x2, y2, w] : g[x][y])
        {
            if (w == 0) continue;
            if (x == x2)
            {
                for (int i = y + 1; i < y2; ++i)
                {
                    puzzle[x][i] = (w == 1 ? -1 : -3);
                }
            }

            if (y == y2)
            {
                for (int i = x + 1; i < x2; ++i)
                {
                    puzzle[i][y] = (w == 1 ? -2 : -4);
                }
            }
        }
    }

    return true;
}
