#include "puzzle.h"
#include <bits/stdc++.h>

using namespace std;

void init(int numSubtests, double timeLimit)
{

}

struct Edge
{
    int x, y, x2, y2, w;
};

vector<Edge> edges;
vector<pair<int, int>> islands;
vector<tuple<int, int, int>> g[32][32];

int cnt = 0;
bool vis[32][32];

void dfs(int x, int y)
{
    ++cnt;

    for (auto [x2, y2, w] : g[x][y])
    {
        if (w != 0 && !vis[x2][y2])
        {
            dfs(x2, y2);
        }
    }
}

bool found = false;

int ccccc = 0;

void f(int idx, vector<vector<int>>& puzzle)
{
    if (found == true)
    {
        return;
    }

    if (idx == edges.size())
    {
        for (auto [x, y] : islands)
        {
            for (int i = 0; i < g[x][y].size(); ++i)
            {
                get<2>(g[x][y][i]) = 0;
            }
        }

        for (auto [x, y, x2, y2, w] : edges)
        {
            int idx = 0;

            for (auto& [x3, y3, w3] : g[x][y])
            {
                if (x3 == x2 && y3 == y2)
                {
                    get<2>(g[x][y][idx]) = w;
                    break;
                }

                ++idx;
            }

            idx = 0;

            for (auto& [x3, y3, w3] : g[x2][y2])
            {
                if (x3 == x && y3 == y)
                {
                    get<2>(g[x2][y2][idx]) = w;
                    break;
                }
            }
        }
        cnt = 0;

        for (auto [x, y] : islands)
        {
            vis[x][y] = false;
        }

        dfs(islands[0].first, islands[0].second);

        if (cnt == islands.size())
        {
            found = true;
            for (auto [x, y] : islands)
            {
                for (auto [x2, y2, w] : g[x][y])
                {
                    if (w == 0) continue;
                    if (x == x2)
                    {
                        for (int i = y + 1; i < y2; ++i)
                        {
                            puzzle[x][i] = (w == 1 ? -1 : -3);
                        }
                    }

                    if (y == y2)
                    {
                        for (int i = x + 1; i < x2; ++i)
                        {
                            puzzle[i][y] = (w == 1 ? -2 : -4);
                        }
                    }
                }
            }
        }

        return;
    }

    for (int i = 0; i <= 2; ++i)
    {
        edges[idx].w = i;
        f(idx + 1, puzzle);
    }
}

bool solve(vector<vector<int>>& puzzle)
{
    int n = puzzle.size();
    int m = puzzle[0].size();

    edges.clear();
    islands.clear();

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            g[i][j].clear();
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (puzzle[i][j] == 0) continue;
            islands.push_back({i, j});

            int down = -1, up = -1, le = -1, ri = -1;

            for (int k = i + 1; k < n; ++k)
            {
                if (puzzle[k][j] > 0)
                {
                    down = k;
                    break;
                }
            }

            for (int k = i - 1; k >= 0; --k)
            {
                if (puzzle[k][j] > 0)
                {
                    up = k;
                    break;
                }
            }

            for (int k = j + 1; k < m; ++k)
            {
                if (puzzle[i][k] > 0)
                {
                    ri = k;
                    break;
                }
            }

            for (int k = j - 1; k >= 0; --k)
            {
                if (puzzle[i][k] > 0)
                {
                    le = k;
                    break;
                }
            }

            if (down != -1)
            {
                g[i][j].push_back({down, j, 0});
                edges.push_back({i, j, down, j, 0});
            }

            if (up != -1)
            {
                g[i][j].push_back({up, j, 0});
            }

            if (le != -1)
            {
                g[i][j].push_back({i, le, 0});
            }

            if (ri != -1)
            {
                g[i][j].push_back({i, ri, 0});
                edges.push_back({i, j, i, ri, 0});
            }
        }
    }

    found = false;

    f(0, puzzle);

    return true;
}
