#include "ones.h"
#include <iostream>

int log2(int num)
{
    int lg = 0;
    while ((1 << lg + 1) <= num) lg++;
    return lg;
}

std::vector <int> guessOnes(int n, int k)
{
    std::vector <int> sol;
    sol.reserve(k);

    int from = 1;
    while (sol.size() < k)
    {
        if ((k - sol.size()) * log2(n - from + 1) >= n - from + 1)
        {
            for (int i = from ; i <= n ; ++i)
            {
                if (hasOnes(i, i))
                {
                    sol.push_back(i);
                }
            }

            break;
        }

        int bucketSize = (n + 1 - from) / (1.545 * (k - sol.size()));
        int to = std::min(n, from + bucketSize + 1);
        if (!hasOnes(from, to))
        {
            from = to + 1;
            continue;
        }

        int l = from - 1, r = to, mid;
        while (l < r - 1)
        {
            mid = (l + r) / 2;
            if (!hasOnes(from, mid)) l = mid;
            else r = mid;
        }

        sol.push_back(r);
        from = r + 1;
    }

    return sol;
}