/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfiuma natrapchiv i visoki botushi
    I cigari sled seksa tq obicha da pushi
*/


#include "puzzle.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <random>
#include <chrono>
#include <queue>
#include <set>

const int MAXN = 200 + 10;
const int MAXRC = 50 + 10;
double perTest;

void init(int tests, double timeLimit)
{
    perTest = (timeLimit - 0.2) / (double(tests));
}

int n, m;
struct DSU
{
    int par[MAXN];
    int dep[MAXN];

    void build(int cnt)
    {
        std::iota(par + 1, par + 1 + cnt, 1);
        std::fill(dep + 1, dep + 1 + cnt, 1);
    }

    int find(int node)
    {
        if (par[node] == node) return node;
        return par[node] = find(par[node]);
    }

    void connect(int u, int v)
    {
        u = find(u);
        v = find(v);

        if (u == v)
        {
            return;
            assert(false);
        }

        if (dep[u] > dep[v])
        {
            std::swap(u, v);
        }

        if (dep[u] == dep[v])
        {
            dep[v]++;
        }

        par[u] = v;
    }

    bool areConnected(int u, int v)
    {
        return find(u) == find(v);
    }
};

int dp[MAXN][10];
std::vector <int> g[MAXN];
std::vector <int> t[MAXN];
int lastByRow[MAXRC];
int lastByCol[MAXRC];
int dpChild[MAXN][10];
int bl[MAXN][10];
int blChild[MAXN][10];
int cellRow[MAXN];
int cellCol[MAXN];
int cellIdx[MAXRC][MAXRC];
std::vector <std::pair <int,int>> edges;
int value[MAXN];
int value2[MAXN];
int cntNodes;
int timer;

void reset()
{
    edges.clear();
    for (int i = 0 ; i < MAXN ; ++i)
    {
        std::fill(dp[i], dp[i] + 10, 0);
        std::fill(dpChild[i], dpChild[i] + 10, 0);
        std::fill(bl[i], bl[i] + 10, 0);
        std::fill(blChild[i], blChild[i] + 10, 0);
        g[i].clear();
        t[i].clear();
    }

    for (int i = 0 ; i < MAXRC ; ++i)
    {
        std::fill(cellIdx[i], cellIdx[i] + MAXRC, 0);
    }
}

DSU dsu;

bool intersect(int fromX, int toX, int fromY, int toY)
{
    if ((cellRow[fromX] == cellRow[toX]) == (cellRow[fromY] == cellRow[toY]))
    {
        return false;
    }

    if (cellRow[fromX] != cellRow[toX])
    {
        std::swap(fromX, fromY);
        std::swap(toX, toY);
    }

    if (std::min(cellRow[fromY], cellRow[toY]) < cellRow[fromX] && cellRow[fromX] < std::max(cellRow[fromY], cellRow[toY]) && std::min(cellCol[fromX], cellCol[toX]) < cellCol[fromY] && cellCol[fromY] < std::max(cellCol[fromX], cellCol[toX]))
    {
        return true;
    }

    return false;
}

std::vector <std::vector <int>> solution;
void putRoad(int u, int v, int t)
{
    if (t == 0)
    {
        return;
    }

    int value = (cellRow[u] == cellRow[v] ? -1 : -2);
    if (t == 2) value -= 2;

    // std::cout << "value is: " << value << '\n';
    if (cellRow[u] == cellRow[v])
    {
        for (int col = std::min(cellCol[u], cellCol[v]) + 1 ; col < std::max(cellCol[u], cellCol[v]) ; ++col)
        {
            solution[cellRow[u]][col] = value;
        }
    } else
    {
        for (int row = std::min(cellRow[u], cellRow[v]) + 1 ; row < std::max(cellRow[u], cellRow[v]) ; ++row)
        {
            solution[row][cellCol[u]] = value;
        }
    }
}

std::vector <std::pair <int,int>> used;
std::queue <int> toBeDeleted;
void removeEdge(int u, int v)
{
    for (int &x : t[u])
    {
        if (x == v)
        {
            std::swap(x, t[u].back());
            t[u].pop_back();
            break;
        }
    }

    for (int &x : t[v])
    {
        if (x == u)
        {
            std::swap(x, t[v].back());
            t[v].pop_back();
            break;
        }
    }

    for (auto &p : used)
    {
        if (p.first == u && p.second == v)
        {
            std::swap(p, used.back());
            used.pop_back();
            break;
        }
    }

    for (auto &p : used)
    {
        if (p.first == v && p.second == u)
        {
            std::swap(p, used.back());
            used.pop_back();
            break;
        }
    }
}

int cnt[MAXN];
std::mt19937 rng(std::chrono::steady_clock::now().time_since_epoch().count());
bool run()
{
    dsu.build(cntNodes);
    used.clear();

    std::shuffle(edges.begin(), edges.end(), rng);
    for (const auto &[u, v] : edges)
    {
        bool isBad = false;
        for (const auto &[u2, v2] : used)
        {
            if (intersect(u2, v2, u, v))
            {
                isBad = true;
                break;
            }
        }

        if (isBad)
        {
            continue;
        }

        // if (dsu.areConnected(u, v))
        // {
        //     continue;
        // }

        used.push_back({u, v});
        // dsu.connect(u, v);
    }

    // std::cout << "try: " << used.size() << '\n';
    for (int i = 1 ; i <= cntNodes ; ++i)
    {
        value2[i] = value[i];
        t[i].clear();
    }

    for (const auto &[u, v] : used)
    {
        t[u].push_back(v);
        t[v].push_back(u);
    }   

    while (toBeDeleted.size()) toBeDeleted.pop();
    for (int i = 1 ; i <= cntNodes ; ++i)
    {
        if (t[i].size() == 1)
        {
            toBeDeleted.push(i);
        }
    }

    std::vector <std::pair <std::pair <int,int>, int>> readyEdges;
    while (toBeDeleted.size())  
    {
        int u = toBeDeleted.front();
        toBeDeleted.pop();


        assert(t[u].size() >= 1);
        assert(t[t[u][0]].size() >= 1);

        // std::cout << "pop edge: " << u << ' ' << value2[u] << ' ' << t[u][0] << ' ' << t[t[u][0]].size() << ' ' << used.size() << '\n';
        if (value2[u] > 2 || value2[t[u][0]] < value2[u])
        {
            return false;
        }

        value2[t[u][0]] -= value2[u];
        readyEdges.push_back({{u, t[u][0]}, value2[u]});
        value2[u] = 0;

        if (t[t[u][0]].size() == 2)
        {
            toBeDeleted.push(t[u][0]);
        }

        removeEdge(u, t[u][0]);
    }

    if (used.empty())
    {
        for (const auto &[p, type] : readyEdges)
        {
            auto [u, v] = p;
            putRoad(u, v, type);
        }

        return true;
    }

    // std::cout << "set size: " << set.size() << '\n';
    // std::cout << "try: " << used.size() << "\n";
    // for (const auto &[u, v] : used)
    // {
    //     std::cout << u << ' ' << v << '\n';
    // }

    // std::cout << "value2\n";
    // for (int i = 1 ; i <= cntNodes ; ++i)
    // {
    //     std::cout << value2[i] << ' ';
    // }

    // std::cout << '\n';
    if (used.size() > 14)
    {
        return false;
    }

    int pw = 1;
    for (int i = 0 ; i < used.size() ; ++i) pw *= 3;

    for (int mask = 0 ; mask < pw ; ++mask)
    {
        DSU dsu;
        dsu.build(cntNodes);
        for (const auto &[p, type] : readyEdges)
        {
            auto [u, v] = p;
            dsu.connect(u, v);
        }

        int currMask = mask;
        std::fill(cnt + 1, cnt + 1 + cntNodes, 0);
        for (int i = 0 ; i < used.size() ; ++i)
        {
            cnt[used[i].first] += currMask % 3;
            cnt[used[i].second] += currMask % 3;
            if (currMask % 3 != 0) dsu.connect(used[i].first, used[i].second);
            currMask /= 3;
        }

        bool shouldContinue = false;
        for (int i = 2 ; i <= cntNodes ; ++i)
        {
            if (!dsu.areConnected(1, i))
            {
                shouldContinue = true;
                break;
            }
        }

        if (shouldContinue)
        {
            continue;
        }

        bool isGood = true;
        for (int i = 1 ; i <= cntNodes ; ++i)
        {
            if (value2[i] != cnt[i])
            {
                // std::cout << "not good: " << i << ' ' << value2[i] << ' ' << cnt[i] << '\n';
                isGood = false;
                break;
            }
        }

        if (isGood)
        {
            currMask = mask;
            for (int i = 0 ; i < used.size() ; ++i)
            {
                putRoad(used[i].first, used[i].second, currMask % 3);
                currMask /= 3;
            }

            for (const auto &[p, type] : readyEdges)
            {
                auto [u, v] = p;
                // std::cout << "put road: " << u << ' ' << v << ' ' << type << '\n';
                putRoad(u, v, type);
            }

            return true;
        }
    }

    exit(0);
    return false;
}

void getSolution(std::vector <std::vector <int>> &v)
{
    v = solution;
}

bool solve(std::vector <std::vector <int>> &v)
{
    reset();
    n = v.size();
    m = v[0].size();
    std::fill(lastByRow, lastByRow + n, -1);
    std::fill(lastByCol, lastByCol + m, -1);

    solution.clear();
    solution.resize(n);

    int idx = 0;
    for (auto &row : solution)
    {
        row.resize(m);
        for (int j = 0 ; j < m ; ++j)
        {
            row[j] = v[idx][j];
        }

        idx++;
    }

    cntNodes = 0;
    for (int i = 0 ; i < n ; ++i)
    {
        for (int j = 0 ; j < m ; ++j)
        {
            if (v[i][j] != 0)
            {
                cntNodes++;
                cellIdx[i][j] = cntNodes;
                value[cntNodes] = v[i][j];
                cellRow[cntNodes] = i; 
                cellCol[cntNodes] = j; 

                // std::cout << "number: " << i << ' ' << j << " = " << cellIdx[i][j] << '\n';

                if (lastByRow[i] != -1) 
                {
                    edges.push_back({cntNodes, cellIdx[i][lastByRow[i]]});
                    // g[cntNodes].push_back(cellIdx[i][lastByRow[i]]);
                }

                if (lastByCol[j] != -1) 
                {
                    edges.push_back({cntNodes, cellIdx[lastByCol[j]][j]});
                    // g[cntNodes].push_back(cellIdx[lastByCol[j]][j]);
                }

                lastByRow[i] = j;
                lastByCol[j] = i;
            }
        }
    }

    // std::cout << "here: " << edges.size() << ' ' << cntNodes << '\n';

    while (timePassed() < perTest)
    {
        if (run())
        {
            getSolution(v);
            return true;
        }
    }

    return false;
}