/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfiuma natrapchiv i visoki botushi
    I cigari sled seksa tq obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <random>
#include <chrono>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MATRIX_SIZE = 5;
const int MOD = 1e8 + 543; 

int n, q;
llong __[MATRIX_SIZE][MATRIX_SIZE];

struct Matrix
{
    int t[MATRIX_SIZE][MATRIX_SIZE];
    void operator *= (const Matrix &other)
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                __[i][j] = 0;
            }
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                for (int k = 0 ; k < MATRIX_SIZE ; ++k)
                {
                    __[i][j] += 1LL * t[i][k] * other.t[k][j]; 
                }

                __[i][j] %= MOD;
            }
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = __[i][j];
            }
        }
    }

    void operator += (const Matrix &other)
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] += other.t[i][j];
                if (t[i][j] >= MOD) t[i][j] -= MOD;
            }
        }
    }

    void set()
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = (i == j);
            }
        }
    }

    void setZero()
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = 0;
            }
        }
    }
};

Matrix base[60];
Matrix baseInv[60];
Matrix power(llong m)
{
    Matrix result;
    result.set();

    for (int i = 0 ; (1LL << i) <= m ; ++i)
    {
        if (m & (1LL << i))
        {
            result *= base[i];
        }
    }

    return result;
}

Matrix powerInv(llong m)
{
    Matrix result;
    result.set();

    for (int i = 0 ; (1LL << i) <= m ; ++i)
    {
        if (m & (1LL << i))
        {
            result *= baseInv[i];
        }
    }

    return result;
}

int getNUM(const Matrix &current)
{
    llong num = 0;
    for (int i = 0 ; i < 5 ; ++i)
    {
        num += current.t[0][i] * i;
    }

    return num % MOD;
}

struct SegmentTree
{
    struct Node
    {
        Matrix node;
        llong lazy;

        Node()
        {
            node.setZero();
            lazy = 0;
        }

        void set(const Node &left, const Node &right)
        {
            node.setZero();
            node += left.node;
            node += right.node;
        }

        void operator += (const Node &right)
        {
            node += right.node;
        }
    };

    Node tree[4*MAXN];
    void build(int l, int r, int node, int a[])
    {
        if (l == r)
        {
            if (a[l] >= 5) tree[node].node = power(a[l]);
            else
            {
                tree[node].node = base[0];
                tree[node].node *= powerInv(-a[l]);
            }

            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node, a);
        build(mid + 1, r, 2*node + 1, a);
        tree[node].set(tree[2*node], tree[2*node + 1]);
    }

    void push(int node, int l, int r)
    {
        if (tree[node].lazy == 0)
        {
            return;
        }

        if (tree[node].lazy > 0) tree[node].node *= power(tree[node].lazy);
        else tree[node].node *= powerInv(-tree[node].lazy);

        if (l < r)
        {
            tree[2*node].lazy += tree[node].lazy;
            tree[2*node + 1].lazy += tree[node].lazy;
        }

        tree[node].lazy = 0;
    }

    void update(int l, int r, int node, int queryL, int queryR, int queryVal)
    {
        push(node, l, r);
        if (queryR < l || r < queryL)
        {
            return;
        }

        if (queryL <= l && r <= queryR)
        {
            tree[node].lazy += queryVal;
            push(node, l, r);
            return;
        }

        int mid = l + r >> 1;
        update(l, mid, 2*node, queryL, queryR, queryVal);
        update(mid + 1, r, 2*node + 1, queryL, queryR, queryVal);
        tree[node].set(tree[2*node], tree[2*node + 1]);
    }

    Matrix query(int l, int r, int node, int queryL, int queryR)
    {
        push(node, l, r);
        if (queryL <= l && r <= queryR)
        {
            return tree[node].node;
        }

        Matrix result;
        int mid = l + r >> 1;
        if (queryL <= mid) result = query(l, mid, 2*node, queryL, queryR);
        if (mid + 1 <= queryR) result += query(mid + 1, r, 2*node + 1, queryL, queryR);
        return result;
    }

    void build(int a[])
    {
        build(1, n, 1, a);
    }

    void update(int l, int r, int val)
    {
        update(1, n, 1, l, r, val);
    }

    int query(int l, int r)
    {
        llong num = 0;
        Matrix result = query(1, n, 1, l, r);
        return getNUM(result);
    }
};

int a[MAXN];
SegmentTree tree;
void solve()
{
    base[0].setZero();
    base[0].t[0][1] = 1;
    base[0].t[1][2] = 1;
    base[0].t[2][3] = 1;
    base[0].t[3][4] = 1;
    base[0].t[4][0] = 1;
    base[0].t[4][1] = 2;
    base[0].t[4][2] = 3;
    base[0].t[4][3] = 4;
    base[0].t[4][4] = 5;

    baseInv[0].setZero();
    baseInv[0].t[0][0] = MOD - 2;
    baseInv[0].t[0][1] = MOD - 3;
    baseInv[0].t[0][2] = MOD - 4;
    baseInv[0].t[0][3] = MOD - 5;
    baseInv[0].t[0][4] = 1;
    baseInv[0].t[1][0] = 1;
    baseInv[0].t[2][1] = 1;
    baseInv[0].t[3][2] = 1;
    baseInv[0].t[4][3] = 1;

    for (int i = 1 ; i < 60 ; ++i)
    {
        base[i] = base[i - 1];
        base[i] *= base[i - 1];
        baseInv[i] = baseInv[i - 1];
        baseInv[i] *= baseInv[i - 1];
    }

    tree.build(a);
    for (int  i = 1 ; i <= q ; ++i)
    {
        int qType, l, r, val;
        std::cin >> qType;

        if (qType == 1)
        {
            std::cin >> l >> r;
            std::cout << tree.query(l, r) << '\n';
        } else
        {
            std::cin >> l >> r >> val;
            tree.update(l, r, val);
        }
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}