/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfiuma natrapchiv i visoki botushi
    I cigari sled seksa tq obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <random>
#include <chrono>

typedef long long llong;
const int MAXN = 100000 + 10;
const int MATRIX_SIZE = 5;
const int MOD = 1e8 + 543; 

int n, q;
llong __[MATRIX_SIZE][MATRIX_SIZE];

struct Matrix
{
    int t[MATRIX_SIZE][MATRIX_SIZE];
    void operator *= (const Matrix &other)
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                __[i][j] = 0;
            }
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                for (int k = 0 ; k < MATRIX_SIZE ; ++k)
                {
                    __[i][j] += 1LL * t[i][k] * other.t[k][j]; 
                }

                __[i][j] %= MOD;
            }
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = __[i][j];
            }
        }
    }

    void operator += (const Matrix &other)
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] += other.t[i][j];
                if (t[i][j] >= MOD) t[i][j] -= MOD;
            }
        }
    }

    void set()
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = (i == j);
            }
        }
    }

    void setZero()
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = 0;
            }
        }
    }
};

Matrix base[60];
Matrix baseInv[60];
Matrix power(llong m)
{
    Matrix result;
    result.set();

    for (int i = 0 ; (1LL << i) <= m ; ++i)
    {
        if (m & (1LL << i))
        {
            result *= base[i];
        }
    }

    return result;
}

Matrix powerInv(llong m)
{
    Matrix result;
    result.set();

    for (int i = 0 ; (1LL << i) <= m ; ++i)
    {
        if (m & (1LL << i))
        {
            result *= baseInv[i];
        }
    }

    return result;
}

int getNUM(const Matrix &current)
{
    llong num = 0;
    for (int i = 0 ; i < 5 ; ++i)
    {
        num += current.t[0][i] * i;
    }

    return num % MOD;
}

int a[MAXN];
llong cnt[MAXN];
void solve()
{
    base[0].setZero();
    base[0].t[0][1] = 1;
    base[0].t[1][2] = 1;
    base[0].t[2][3] = 1;
    base[0].t[3][4] = 1;
    base[0].t[4][0] = 1;
    base[0].t[4][1] = 2;
    base[0].t[4][2] = 3;
    base[0].t[4][3] = 4;
    base[0].t[4][4] = 5;

    baseInv[0].setZero();
    baseInv[0].t[0][0] = MOD - 2;
    baseInv[0].t[0][1] = MOD - 3;
    baseInv[0].t[0][2] = MOD - 4;
    baseInv[0].t[0][3] = MOD - 5;
    baseInv[0].t[0][4] = 1;
    baseInv[0].t[1][0] = 1;
    baseInv[0].t[2][1] = 1;
    baseInv[0].t[3][2] = 1;
    baseInv[0].t[4][3] = 1;

    for (int i = 1 ; i < 60 ; ++i)
    {
        base[i] = base[i - 1];
        base[i] *= base[i - 1];
        baseInv[i] = baseInv[i - 1];
        baseInv[i] *= baseInv[i - 1];
    }

    // tree.build(a);
    for (int i = 1 ; i <= n ; ++i)
    {
        cnt[i] += a[i];
        cnt[i + 1] -= a[i];
    }

    for (int  i = 1 ; i <= q ; ++i)
    {
        int qType, l, r, val;
        std::cin >> qType;

        if (qType == 1)
        {
            std::cin >> l >> r;
            
            llong prefix = 0;
            llong result = 0;
            for (int i = 1 ; i <= r ; ++i)
            {
                prefix += cnt[i];
                if (i >= l)
                {
                    if (prefix >= 0) result += getNUM(power(prefix));
                    else result += getNUM(powerInv(-prefix));
                    result %= MOD;
                }
            }

            std::cout << result << '\n';
        } else
        {
            std::cin >> l >> r >> val;
            cnt[l] += val;
            cnt[r + 1] -= val;
        }
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}