/*
    Nevuzpitano ruso e cveta na kosite
    Silikon v ustata silikon v gurdite
    I parfiuma natrapchiv i visoki botushi
    I cigari sled seksa tq obicha da pushi
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <random>
#include <chrono>

#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")

typedef long long llong;
const int MAXN = 100000 + 10;
const int MAXB = 11000 + 10;
const int MATRIX_SIZE = 5;
const int MOD = 1e8 + 543;

int n, q;
struct Matrix
{
    int t[MATRIX_SIZE][MATRIX_SIZE];
    void operator *= (const Matrix &other)
    {
        llong __[MATRIX_SIZE][MATRIX_SIZE];
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                __[i][j] = 0;
            }
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                for (int k = 0 ; k < MATRIX_SIZE ; ++k)
                {
                    __[i][j] += 1LL * t[i][k] * other.t[k][j]; 
                }

                __[i][j] %= MOD;
            }
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = __[i][j];
            }
        }
    }

    void operator += (const Matrix &other)
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] += other.t[i][j];
                if (t[i][j] >= MOD) t[i][j] -= MOD;
            }
        }
    }

    void set()
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = (i == j);
            }
        }
    }

    void setZero()
    {
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                t[i][j] = 0;
            }
        }
    }
};

Matrix bigSqrt[MAXB];
Matrix bigSqrtInv[MAXB];
Matrix smallSqrt[MAXB];
Matrix smallSqrtInv[MAXB];
Matrix base[28];
Matrix baseInv[28];
Matrix result;

inline void power(int m)
{
    result.set();
    for (int i = 0 ; (1 << i) <= m ; ++i)
    {
        if (m & (1 << i))
        {
            result *= base[i];
        }
    }
}

inline void powerInv(int m)
{
    result.set();
    for (int i = 0 ; (1 << i) <= m ; ++i)
    {
        if (m & (1 << i))
        {
            result *= baseInv[i];
        }
    }
}

inline void powerSqrt(int m)
{
    result = bigSqrt[m / MAXB];
    result *= smallSqrt[m % MAXB];
}

inline void powerSqrtInv(int m)
{
    result = bigSqrtInv[m / MAXB];
    result *= smallSqrtInv[m % MAXB];
}

int getNUMRow(int row, const Matrix &current)
{
    int num = 0;
    for (int i = 0 ; i < 5 ; ++i)
    {
        num += current.t[row][i] * i;
    }

    return num % MOD;
}

struct SegmentTree
{
    struct Node
    {
        int nums[5];
        int lazy;

        Node()
        {
            lazy = 0;
            for (int i = 0 ; i < 5 ; ++i)
            {
                nums[i] = 0;
            }
        }

        void set(const Node &left, const Node &right)
        {
            for (int i = 0 ; i < 5 ; ++i)
            {
                nums[i] = left.nums[i] + right.nums[i];
                if (nums[i] >= MOD) nums[i] -= MOD;
            }
        }

        void operator += (const Node &right)
        {
            for (int i = 0 ; i < 5 ; ++i)
            {
                nums[i] += right.nums[i];
                if (nums[i] >= MOD) nums[i] -= MOD;
            }
        }
    };

    Node tree[4*MAXN];
    void build(int l, int r, int node, int a[])
    {
        if (l == r)
        {
            if (a[l] >= 0) 
            {
                power(a[l]);
                tree[node].nums[0] = getNUMRow(0, result);
                tree[node].nums[1] = getNUMRow(1, result);
                tree[node].nums[2] = getNUMRow(2, result);
                tree[node].nums[3] = getNUMRow(3, result);
                tree[node].nums[4] = getNUMRow(4, result);
            }
            else
            {
                powerInv(-a[l]);
                tree[node].nums[0] = getNUMRow(0, result);
                tree[node].nums[1] = getNUMRow(1, result);
                tree[node].nums[2] = getNUMRow(2, result);
                tree[node].nums[3] = getNUMRow(3, result);
                tree[node].nums[4] = getNUMRow(4, result);
            }

            return;
        }

        int mid = l + r >> 1;
        build(l, mid, 2*node, a);
        build(mid + 1, r, 2*node + 1, a);
        tree[node].set(tree[2*node], tree[2*node + 1]);
    }

    void push(int node, int l, int r)
    {
        if (tree[node].lazy == 0)
        {
            return;
        }

        if (tree[node].lazy > 0) powerSqrt(tree[node].lazy);
        else powerSqrtInv(-tree[node].lazy);

        llong newNums[] = {0, 0, 0, 0, 0};
        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            for (int j = 0 ; j < MATRIX_SIZE ; ++j)
            {
                newNums[i] += 1LL * tree[node].nums[j] * result.t[i][j];
            }

            newNums[i] %= MOD;
        }

        for (int i = 0 ; i < MATRIX_SIZE ; ++i)
        {
            tree[node].nums[i] = newNums[i];
        }

        if (l < r)
        {
            tree[2*node].lazy += tree[node].lazy;
            tree[2*node + 1].lazy += tree[node].lazy;
            if (tree[2 * node].lazy >= MOD - 1) tree[2 * node].lazy -= MOD - 1;
            if (tree[2 * node + 1].lazy >= MOD - 1) tree[2 * node + 1].lazy -= MOD - 1;
        }

        tree[node].lazy = 0;
    }

    void update(int l, int r, int node, int queryL, int queryR, int queryVal)
    {
        push(node, l, r);
        if (queryR < l || r < queryL)
        {
            return;
        }

        if (queryL <= l && r <= queryR)
        {
            tree[node].lazy += queryVal;
            if (tree[node].lazy >= MOD - 1) tree[node].lazy -= MOD - 1;
            push(node, l, r);
            return;
        }

        int mid = l + r >> 1;
        update(l, mid, 2*node, queryL, queryR, queryVal);
        update(mid + 1, r, 2*node + 1, queryL, queryR, queryVal);
        tree[node].set(tree[2*node], tree[2*node + 1]);
    }

    int query(int l, int r, int node, int queryL, int queryR)
    {
        push(node, l, r);
        if (queryL <= l && r <= queryR)
        {
            return tree[node].nums[0];
        }

        int res = 0;
        int mid = l + r >> 1;
        if (queryL <= mid) res = query(l, mid, 2*node, queryL, queryR);
        if (mid + 1 <= queryR) res += query(mid + 1, r, 2*node + 1, queryL, queryR);
        if (res >= MOD) res -= MOD;
        return res;
    }

    void build(int a[])
    {
        build(1, n, 1, a);
    }

    void update(int l, int r, int val)
    {
        update(1, n, 1, l, r, val);
    }

    int query(int l, int r)
    {
        return query(1, n, 1, l, r);
    }
};

int a[MAXN];
SegmentTree tree;
void solve()
{
    base[0].setZero();
    base[0].t[0][1] = 1;
    base[0].t[1][2] = 1;
    base[0].t[2][3] = 1;
    base[0].t[3][4] = 1;
    base[0].t[4][0] = 1;
    base[0].t[4][1] = 2;
    base[0].t[4][2] = 3;
    base[0].t[4][3] = 4;
    base[0].t[4][4] = 5;

    baseInv[0].setZero();
    baseInv[0].t[0][0] = MOD - 2;
    baseInv[0].t[0][1] = MOD - 3;
    baseInv[0].t[0][2] = MOD - 4;
    baseInv[0].t[0][3] = MOD - 5;
    baseInv[0].t[0][4] = 1;
    baseInv[0].t[1][0] = 1;
    baseInv[0].t[2][1] = 1;
    baseInv[0].t[3][2] = 1;
    baseInv[0].t[4][3] = 1;

    for (int i = 1 ; i < 28 ; ++i)
    {
        base[i] = base[i - 1];
        base[i] *= base[i - 1];
        baseInv[i] = baseInv[i - 1];
        baseInv[i] *= baseInv[i - 1];
    }

    smallSqrt[0].set();
    smallSqrtInv[0].set();
    for (int i = 1 ; i < MAXB ; ++i)
    {
        smallSqrt[i] = smallSqrt[i - 1];
        smallSqrt[i] *= base[0];

        smallSqrtInv[i] = smallSqrtInv[i - 1];
        smallSqrtInv[i] *= baseInv[0];
    }

    bigSqrt[0].set();
    bigSqrtInv[0].set();
    power(MAXB);
    bigSqrt[1] = result;
    powerInv(MAXB);
    bigSqrtInv[1] = result;

    for (int i = 2 ; i < MAXB ; ++i)
    {
        bigSqrt[i] = bigSqrt[i - 1];
        bigSqrt[i] *= bigSqrt[1];

        bigSqrtInv[i] = bigSqrtInv[i - 1];
        bigSqrtInv[i] *= bigSqrtInv[1];
    }

    tree.build(a);
    for (int  i = 1 ; i <= q ; ++i)
    {
        int qType, l, r, val;
        std::cin >> qType;

        if (qType == 1)
        {
            std::cin >> l >> r;
            std::cout << tree.query(l, r) << '\n';
        } else
        {
            std::cin >> l >> r >> val;
            tree.update(l, r, val);
        }
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}