//#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
const int N = 1e5 + 10;
const int M = 1e8 + 543;
int n;
ll a[N];
int b[N];
int fenwick[N];
int cur_mat[5][5], skzb[5][5], cur_ans[5][5], nxt_mat[5][5];
int skzb_vec[5] = { 0, 1, 2, 3, 4 };
int calc(int ind) {
    if (ind <= 4) return ind;
    int n = 5;
    int w = ind - 4;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) cur_ans[i][j] = 1;
            else cur_ans[i][j] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cur_mat[i][j] = skzb[i][j];
        }
    }
    while (w) {
        if (w % 2 == 1) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    nxt_mat[i][j] = 0;
                    for (int k = 0; k < n; k++) {
                        nxt_mat[i][j] = (nxt_mat[i][j] + ((cur_ans[i][k] * 1ll * cur_mat[k][j]) % M)) % M;
                    }
                }
            }
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    cur_ans[i][j] = nxt_mat[i][j];
                }
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                nxt_mat[i][j] = 0;
                for (int k = 0; k < n; k++) {
                    nxt_mat[i][j] = (nxt_mat[i][j] + ((cur_mat[i][k] * 1ll * cur_mat[k][j]) % M)) % M;
                }
            }
        }
        w >>= 1;
    }
    int ret = (cur_ans[n - 1][1] * 1 + cur_ans[n - 1][2] * 2 + cur_ans[n - 1][3] * 3 + cur_ans[n - 1][4] * 4) % M;
    return ret;
}
void update(int pos, int diff) {
    while (pos <= n) {
        fenwick[pos] = (fenwick[pos] + diff) % M;
        pos += (pos & (-pos));
    }
}
int sm(int pos) {
    int ans = 0;
    while (pos) {
        ans = (ans + fenwick[pos]) % M;
        pos -= (pos & (-pos));
    }
    return ans;
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    skzb[0][0] = 0; skzb[0][1] = 1; skzb[0][2] = 0; skzb[0][3] = 0; skzb[0][4] = 0;
    skzb[1][0] = 0; skzb[1][1] = 0; skzb[1][2] = 1; skzb[1][3] = 0; skzb[1][4] = 0;
    skzb[2][0] = 0; skzb[2][1] = 0; skzb[2][2] = 0; skzb[2][3] = 1; skzb[2][4] = 0;
    skzb[3][0] = 0; skzb[3][1] = 0; skzb[3][2] = 0; skzb[3][3] = 0; skzb[3][4] = 1;
    skzb[4][0] = 1; skzb[4][1] = 2; skzb[4][2] = 3; skzb[4][3] = 4; skzb[4][4] = 5;
    int q;
    cin >> n >> q;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        b[i] = calc(a[i]);
        update(i, b[i]);
    }
    while (q--) {
        int type;
        cin >> type;     
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            cout << (sm(r) - sm(l - 1) + M) % M << "\n";
        }
        else {
            int l, r, val;
            cin >> l >> r >> val;
            if (l == r) {
                a[l] += val;
                int u = calc(a[l]);
                int diff = (u - b[l] + M) % M;
                b[l] = u;
                update(l, diff);
            }
        }
    }
}