//#include "ones.h"
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <unordered_map>
#include <cassert>
#include <set>
#include <stack>
#include <chrono>
#include <random>
#include <iomanip>
#include <fstream>
#include <chrono>
#include <random>
typedef long long ll;
typedef long double ld;
using namespace std;
const int N = 1e5 + 10;
const int M = 1e8 + 543;
int n;
int a[N], b[N];
bool marked[M + 100];
int fenwick[N];
int dp[10];
struct query {
	int type;
	int l;
	int r;
	int val;
};
void update(int pos, int diff) {
    while (pos <= n) {
        fenwick[pos] = (fenwick[pos] + diff) % M;
        pos += (pos & (-pos));
    }
}
int sm(int pos) {
    int ans = 0;
    while (pos) {
        ans = (ans + fenwick[pos]) % M;
        pos -= (pos & (-pos));
    }
    return ans;
}
int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int q;
    cin >> n >> q;
    map <int, int> mp;
    for (int i = 0; i < M; i++) {
    	marked[i] = false;
    }
    for (int i = 1; i <= n; i++) {
        cin >> a[i]; a[i] %= (M - 1);
        b[i] = a[i]; marked[b[i]] = true;
    }
    vector <query> v;
    while (q--) {
    	int type;
    	cin >> type;
    	if (type == 1) {
    		int l, r;
    		cin >> l >> r;
    		v.push_back({ 1, l, r, 0 });
    	}
    	else {
    		int l, r, val;
    		cin >> l >> r >> val;
    		v.push_back({ 2, l, r, val });
    		b[l] = (b[l] + val) % (M - 1);
    		marked[b[l]] = true;
    	}
    }
	for (int i = 0; i <= 4; i++) {
        dp[i] = i;
        if (marked[i]) mp[i] = dp[i];
    }
    for (int i = 5; i < M - 1; i++) {
        int new_v = 5 * dp[4] + 4 * dp[3] + 3 * dp[2] + 2 * dp[1] + 1 * dp[0];
        new_v %= M;
        if (marked[i]) {
        	mp[i] = new_v; 
        }
        swap(dp[0], dp[1]);
        swap(dp[1], dp[2]);
        swap(dp[2], dp[3]);
        swap(dp[3], dp[4]);
        dp[4] = new_v;
    }
    for (int i = 1; i <= n; i++) {
    	update(i, mp[a[i]]);
    }
    for (int i = 0; i < (int)v.size(); i++) {
    	query esim = v[i];
    	if (esim.type == 1) {
    		cout << (sm(esim.r) - sm(esim.l - 1) + M) % M << "\n";
    	}
    	else {
    		int prev_val = mp[a[esim.l]];
    		a[esim.l] = (a[esim.l] + esim.val) % (M - 1);
    		int new_val = mp[a[esim.l]];
    		update(esim.l, (new_val - prev_val + M) % M);
    	}
    }
}