#include "puzzle.h"
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first 
#define ss second 

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9;
const ll N = 50;
ll n,m,k;
int curvals[N][N];
int d[N][N];
vector<int>g[N*N];
unordered_map<int,pair<int,int>>dd;
int dirr[N*N][N*N];
int TOTAL = 0;

void clear(int cur){
    TOTAL = 0;
    dd.clear();
    for(int v=0;v<cur;v++){
        g[v].clear();
        for(int u=0;u<cur;u++){
            dirr[v][u]=0;
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            d[i][j]=0;
            curvals[i][j]=0;
        }
    }
}

int getcurval(int v){
    return curvals[dd[v].first][dd[v].second];
}

void subtractcurval(int v){
    curvals[dd[v].first][dd[v].second]--;
    TOTAL--;
}

void tardoublekox(std::vector<std::vector<int>>& p, int v, int u){
    int vl;
    if(dirr[v][u]==2){
        vl = HOR_DOUBLE;
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            p[dd[v].first][j]=vl;
        }
    }
    else{
        vl = VERT_DOUBLE;
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            p[i][dd[v].second]=vl;
        }
    }
    subtractcurval(v);
    subtractcurval(v);
    subtractcurval(u);
    subtractcurval(u);
}

void tarsinglekox(std::vector<std::vector<int>>& p, int v, int u){
    int vl;
    if(dirr[v][u]==2){
        vl = HOR_SINGLE;
        for(int j=min(dd[v].second,dd[u].second)+1;j<max(dd[v].second,dd[u].second);j++){
            p[dd[v].first][j]=vl;
        }
    }
    else{
        vl = VERT_SINGLE;
        for(int i=min(dd[v].first,dd[u].first)+1;i<max(dd[v].first,dd[u].first);i++){
            p[i][dd[v].second]=vl;
        }
    }
    subtractcurval(v);
    subtractcurval(u);
}

void init(int x, double y){}

bool solve(std::vector<std::vector<int>>& p){
    n = p.size();
    m = p[0].size();
    int cur=1;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            curvals[i][j]=p[i][j];
            TOTAL += p[i][j];
            if(p[i][j]){
                d[i][j]=cur;
                dd[cur++] = {i,j};
            }
        }
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            if(p[i][j]){
                int v=d[i][j];
                for(int ii=i-1;ii>=0;ii--){
                    if(p[ii][j]){
                        int u=d[ii][j];
                        g[v].push_back(u);
                        dirr[v][u]=1;
                        break;
                    }
                }
                for(int ii=i+1;ii<n;ii++){
                    if(p[ii][j]){
                        int u=d[ii][j];
                        g[v].push_back(u);
                        dirr[v][u]=1;
                        break;
                    }
                }
                for(int jj=j-1;jj>=0;jj--){
                    if(p[i][jj]){
                        int u=d[i][jj];
                        g[v].push_back(u);
                        dirr[v][u]=2;
                        break;
                    }
                }
                for(int jj=j+1;jj<m;jj++){
                    if(p[i][jj]){
                        int u=d[i][jj];
                        g[v].push_back(u);
                        dirr[v][u]=2;
                        break;
                    }
                }
            }
        }
    }
    // for(int v=1;v<cur;v++){
    //     cout<<v<<endl;
    //     cout<<"curval: "<<getcurval(v)<<endl;
    //     cout<<"g[v].size(): "<<g[v].size()<<endl<<endl;
    // }
    for(int _=0;_<cur;_++){
        for(int v=1;v<cur;v++){
            if(getcurval(v)==g[v].size()*2){
                for(int to:g[v]){
                    tardoublekox(p,v,to);
                    g[to].erase(find(g[to].begin(),g[to].end(),v));
                }
                g[v].clear();
            }
        }
        for(int v=1;v<cur;v++){
            if(getcurval(v)==1&&g[v].size()==1){
                for(int to:g[v]){
                    tarsinglekox(p,v,to);
                    g[to].erase(find(g[to].begin(),g[to].end(),v));
                }
                g[v].clear();
            }
        }
    }
    // for(int v=1;v<cur;v++){
    //     cout<<v<<endl;
    //     cout<<"curval: "<<getcurval(v)<<endl;
    //     cout<<"g[v].size(): "<<g[v].size()<<endl<<endl;
    // }
    // for(int i=0;i<n;i++){
    //     for(int j=0;j<m;j++){
    //         cout<<p[i][j]<<" ";
    //     }
    //     cout<<endl;
    // }
    if(TOTAL){
        clear(cur);
        return false;
    }
    clear(cur);
    return true;
}
