#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <numeric>
#include <climits>
using namespace std;

typedef long long ll;
#define pb push_back;
#define mkp make_pair;

const int N = 1000003;
ll a[N];
ll dp[N];
ll mod = 100000543LL;
int n, q;

ll tree[4 * N];

void build(int v, int tl, int tr)
{
	if (tl == tr) {
		tree[v] = dp[a[tl]];
		return;
	}

	int mid = (tl + tr) / 2;

	build(2 * v, tl, mid);
	build(2 * v + 1, mid + 1, tr);

	tree[v] = (tree[2 * v] + tree[2 * v + 1]) % mod;
	return;
}

ll query(int v, int tl, int tr, int l, int r)
{
	if (tl > r || tr < l) return 0LL;
	if (tl >= l && tr <= r) return tree[v];

	int mid = (tl + tr) / 2;

	return (query(2 * v, tl, mid, l, r) + query(2 * v + 1, mid + 1, tr, l, r)) % mod;
}

void solve()
{
	int i, j;

	cin >> n >> q;
	for (i = 1; i <= n; i++) {
		cin >> a[i];
	}

	dp[0] = 0LL;
	dp[1] = 1LL;
	dp[2] = 2LL;
	dp[3] = 3LL;
	dp[4] = 4LL;
	for (i = 5; i <= 1e6; i++) {
		dp[i] += 5LL * dp[i - 1];
		dp[i] %= mod;
		dp[i] += 4LL * dp[i - 2];
		dp[i] %= mod;
		dp[i] += 3LL * dp[i - 3];
		dp[i] %= mod;
		dp[i] += 2LL * dp[i - 4];
		dp[i] %= mod;
		dp[i] += dp[i - 5];
		dp[i] %= mod;
	}

	for (i = 1; i <= 1; i++) {
		int type;
		cin >> type;
		if (type == 1) {
			int l, r;
			cin >> l >> r;
			cout << query(1, 1, n, l, r) << "\n";
		}
		else {
			int l, r;
			ll c;
			cin >> l >> r >> c;
		}
	}

	return;
}

int main()
{
	int mt = 1;
	//cin >> mt;
	while (mt--) {
		solve();
	}
	return 0;
}