#include "puzzle.h"

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <vector>
#include <utility>
#include <random>
#include <numeric>
#include <cstring>
#include <set>
#include <cassert>
#include <assert.h>
using namespace std;

typedef long long ll;

#define pb push_back
#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define sz(x) (int(x.size()))
#define all(x) (x).begin(), (x).end()
#define clr(x) (x).clear()

mt19937 rnf(109);

double tle;

void init(int numSubtests, double timeLimit)
{
	tle = timeLimit;
	return;
}

const int N = 50, M = 50;
int p[N][M];
int n, m;

//set<pr<pr<int, int>, int>> st;
vector< pr<pr<int, int>, int>> vv;

vector<int> hor[N], ver[M];

pr<int, int> chtw()
{
	int i, j;

	for (i = 0; i < n; i++) clr(hor[i]);
	for (i = 0; i < m; i++) clr(ver[i]);


	for (i = 0; i < sz(vv); i++) {
		hor[vv[i].ff.ff].pb(vv[i].ff.ss);
		ver[vv[i].ff.ss].pb(vv[i].ff.ff);
	}

	for (i = 0; i < n; i++) sort(all(hor[i]));
	for (i = 0; i < m; i++) sort(all(ver[i]));

	pr<int, int> p1, p2;
	int ro = rnf() % 2;

	if (ro) {
		int r = rnf() % n;
		while (r < n && sz(hor[r]) <= 1) r++;

		if (r == n) return { -1,-1 };

		int w = rnf() % (sz(hor[r]) - 1);

		p1 = mpr(r, hor[r][w]);
		p2 = mpr(r, hor[r][w + 1]);
	}
	else {
		int r = rnf() % m;
		while (r < m && sz(ver[r]) <= 1) r++;

		if (r == m) return { -1,-1 };

		int w = rnf() % (sz(ver[r]) - 1);

		p1 = mpr(ver[r][w], r);
		p2 = mpr(ver[r][w + 1], r);
	}

	int a1 = -1, a2 = -1;

	for (i = 0; i < sz(vv); i++) {
		if (vv[i].ff == p1 || vv[i].ff == p2) {
			if (a1 == -1) a1 = i;
			else if (a2 == -1) a2 = i;
			else assert(false);
		}
	}

	return mpr(a1, a2);
}

void func()
{
	int i, j;

	int x, y;

	pr<int, int> h, q, op;

	int cnt = 0;

	while (sz(vv) > 1) {

		//cout << "\n";
		//for (auto u : vv) cout << u.ff.ff << ' ' << u.ff.ss << ' ' << u.ss << "\n";

		if (cnt > 100) return;

		op = chtw();

		if (op.ff == -1) {
			cnt++;
			continue;
		}


		x = op.ff;
		y = op.ss;

		//cout << x << ' ' << y << ".\n";

		h = vv[x].ff;
		q = vv[y].ff;

		if (h.ff != q.ff && h.ss != q.ss) {
			cnt++;
			continue;
		}

		j = min(vv[x].ss, vv[y].ss);
		j = min(j, 2);

		if (h.ff == q.ff) {
			for (i = min(h.ss, q.ss) + 1; i < max(h.ss, q.ss); i++) {
				if (p[h.ff][i]) {
					cnt++;
					goto end;
				}

				p[h.ff][i] = 1 - 2 * j;
			}
		}
		else {
			for (i = min(h.ff, q.ff) + 1; i < max(h.ff, q.ff); i++) {
				if (p[i][h.ss]) {
					cnt++;
					goto end;
				}

				p[i][h.ss] = 0 - 2 * j;
			}
		}

		if (x < y) swap(x, y);

		vv[x].ss -= j;
		vv[y].ss -= j;

		if (!vv[x].ss) vv.erase(vv.begin() + x);
		if (!vv[y].ss) vv.erase(vv.begin() + y);

		cnt = 0;

	end:;
	}

	return;
}

bool solve(vector<vector<int>>& v)
{
	int i, j;

	n = sz(v);
	m = sz(v[0]);

	//cout << n << ' ' << m << "..\n";

	while (timePassed() < tle - 0.05) {
		//cout << 1 << "\n";
		for (i = 0; i < n; i++) {
			for (j = 0; j < m; j++) {
				p[i][j] = v[i][j];
			}
		}

		clr(vv);


		for (i = 0; i < n; i++) {
			for (j = 0; j < m; j++) {
				if (v[i][j]) {
					//st.insert(mpr(mpr(i, j), v[i][j]));
					vv.pb(mpr(mpr(i, j), v[i][j]));
				}
			}
		}
		
		func();

		if (vv.empty()) break;
	}

	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			v[i][j] = p[i][j];
		}
	}

	return 1;
}
