#include <bits/stdc++.h>

using namespace std;

typedef vector<vector<int> > mat;

const int mod = 1e8 + 543;

mat mult(const mat &a, const mat&b) {
    mat neww = mat(5, vector<int>(5));
    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            for (int k = 0; k < 5; k++)
                neww[i][j] = ((long long)neww[i][j] + ((long long)a[i][k] * (long long)b[k][j]) % mod) % mod;
    return neww;
}

mat base_vals, base_mult;

mat binary_expo(mat a, int xp) {
    mat neww = mat(5, vector<int>(5));
    neww[0][0] = 1, neww[1][1] = 1, neww[2][2] = 1, neww[3][3] = 1, neww[4][4] = 1;
    for (int bit = 30; bit >= 0; bit--) {
        neww = mult(neww, neww);
        if ((1 << bit) & xp)
            neww = mult(neww, a);
    }
    return neww;
}

void pmat(mat a) {
    for (int i = 0; i < 5; i++)
    {
        for (int j = 0; j < 5; j++)
            cout << a[i][j] << " ";
        cout << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    base_vals = mat( {
        {0, 0, 0, 0, 0},
        {-22, 0, 0, 0, 0},
        {33, 0, 0, 0, 0},
        {-3, 0, 0, 0, 0},
        {-4, 0, 0, 0, 0}
    });
    base_mult = mat( {
        {5, 4, 3, 2, 1},
        {1, 0, 0, 0, 0},
        {0, 1, 0, 0, 0},
        {0, 0, 1, 0, 0},
        {0, 0, 0, 1, 0}
    });

    int n, q;
    cin >> n >> q;
    vector<mat> a(n, base_vals);
    for (int i = 0; i < n; i++) {
        int c;
        cin >> c;
        a[i] = mult(binary_expo(base_mult, c), a[i]);
    }

    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r;
            cin >> l >> r;
            cout << a[l - 1][0][0] << "\n";
        } else {
            int l, r, val;
            cin >> l >> r >> val;
            a[l - 1] = mult(binary_expo(base_mult, val), a[l - 1]);
        }
    }
}
