#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
typedef long long ll;
const int N=100005,mod=(1e8)+543;
ll add(ll a,ll b){
	a+=b;
	if(a>=mod)a-=mod;
	if(a<0)a+=mod;
	return a;
}
void addto(ll&a,ll b){
	a=add(a,b);
}
vector<ll> operator+(vector<ll>A,vector<ll>B){
	for(int i=0;i<5;i++)addto(A[i],B[i]);
	return A;
}
struct Matrix{
	ll mat[5][5];
	Matrix(int diag=0){
		memset(mat,0,sizeof(mat));
		for(int i=0;i<5;i++)mat[i][i]=diag;
	}
	ll* operator[](int i){return mat[i];}
	friend Matrix operator*(Matrix&A,Matrix&B){
		Matrix C=Matrix();
		for(int i=0;i<5;i++){
			for(int j=0;j<5;j++){
				for(int k=0;k<5;k++){
					C[i][j]=(C[i][j]+A[i][k]*B[k][j]);
				}
				C[i][j]%=mod;
			}
		}
		return C;
	}
	friend vector<ll> operator*(Matrix&A,vector<ll>&B){
		vector<ll>C(5);
		for(int i=0;i<5;i++){
			for(int k=0;k<5;k++)C[i]=(C[i]+A[i][k]*B[k]);
			C[i]%=mod;
		}
		return C;
	}
};
Matrix nxt[60],prv[60];
Matrix Power(ll k){
	Matrix res=Matrix(1);
	if(k==0)return res;
	if(k>0){
		for(int i=0;(1LL<<i)<=k;i++){
			if(k&(1LL<<i))res=nxt[i]*res;
		}
	}else{
		k=-k;
		for(int i=0;(1LL<<i)<=k;i++){
			if(k&(1LL<<i))res=prv[i]*res;
		}
	}
	return res;
}
vector<ll>zero;
vector<ll>MoveK(vector<ll>B,ll k){//m^2 logK = 
	if(k==0)return B;
	if(k>0){
		for(int i=0;(1LL<<i)<=k;i++){
			if(k&(1LL<<i))B=nxt[i]*B;
		}
	}else{
		k=-k;
		for(int i=0;(1LL<<i)<=k;i++){
			if(k&(1LL<<i))B=prv[i]*B;
		}
	}
	return B;
}
struct SegTree{
	vector<vector<ll>>tree;
	vector<Matrix>lazy;vector<bool>marked;
	int sz;
	void build(int l,int r,int p,vector<int>&a){
		if(l==r){
			if(l<a.size())tree[p]=MoveK(zero,a[l]);
			return;
		}
		int md=(l+r)>>1;
		build(l,md,p*2+1,a);
		build(md+1,r,p*2+2,a);
		tree[p]=tree[p*2+1]+tree[p*2+2];
	}
	void init(int n,vector<int>a){
		sz=1;
		while(sz<n)sz*=2;
		tree.assign(2*sz,zero);
		lazy.assign(2*sz,Matrix(1));
		marked.assign(2*sz,0);
		build(0,sz-1,0,a);
	}
	void put_lazy(int p,Matrix&upd){
		lazy[p]=upd*lazy[p];
		tree[p]=upd*tree[p];
		marked[p]=1;
	}
	void push_lazy(int p){
		if(marked[p]){
			put_lazy(p*2+1,lazy[p]);
			put_lazy(p*2+2,lazy[p]);
			lazy[p]=Matrix(1);
			marked[p]=0;
		}
	}
	void update(int l,int r,int p,int l_q,int r_q,Matrix&pw){
		if(l>r_q||r<l_q)return;
		if(l>=l_q&&r<=r_q){
			put_lazy(p,pw);
			return;
		}
		push_lazy(p);
		int md=(l+r)>>1;
		update(l,md,p*2+1,l_q,r_q,pw);
		update(md+1,r,p*2+2,l_q,r_q,pw);
		tree[p]=tree[p*2+1]+tree[p*2+2];
	}
	void update(int l,int r,Matrix&pw){
		update(0,sz-1,0,l,r,pw);
	}
	ll query(int l,int r,int p,int l_q,int r_q){
		if(l>r_q||r<l_q)return 0;
		if(l>=l_q&&r<=r_q)return tree[p][0];
		push_lazy(p);
		int md=(l+r)>>1;
		return add(query(l,md,p*2+1,l_q,r_q),query(md+1,r,p*2+2,l_q,r_q));
	}
	ll query(int l,int r){
		return query(0,sz-1,0,l,r);
	}
}tree;
void preprocess(){
	Matrix x=Matrix();
	for(int i=0;i<5;i++)x[0][i]=5-i;
	for(int i=1;i<5;i++)x[i][i-1]=1;
	nxt[0]=x;
	x=Matrix();
	for(int i=1;i<5;i++)x[i-1][i]=1;
	for(int i=0;i<5;i++)x[4][i]=(i==0?1:i-6);
	prv[0]=x;
	for(int i=1;i<60;i++){
		nxt[i]=nxt[i-1]*nxt[i-1];
		prv[i]=prv[i-1]*prv[i-1];
	}
	zero={4,3,2,1,0};
	zero=prv[2]*zero;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	preprocess();
	int n,q;
	cin>>n>>q;
	vector<int>a(n+1);
	for(int i=1;i<=n;i++)cin>>a[i];
	tree.init(n+1,a);
	while(q--){
		int type,l,r;
		cin>>type>>l>>r;
		if(type==1){
			cout<<((tree.query(l,r)%mod+mod)%mod)<<"\n";
		}else{
			int v;
			cin>>v;
			Matrix pw=Power(v);
			tree.update(l,r,pw);
		}
	}
	return 0;
}