#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
using namespace std;
typedef long long ll;
const int BUF_SZ=1<<16;
char buf[BUF_SZ];
int pos,len;
char next_char(){
	if(pos==len){
		pos=0;
		len=fread(buf,1,BUF_SZ,stdin);
		if(!len){return EOF;}
	}
	return buf[pos++];
}
int read_int(){
	int x;
	char ch;
	int sgn=1;
	while(!isdigit(ch=next_char()))if(ch=='-')sgn*=-1;
	x=ch-'0';
	while(isdigit(ch=next_char()))x=x*10+(ch-'0');
	return x*sgn;
}
const int N=100005,M=(1<<15),SH=15,mod=(1e8)+543;
ll add(ll a,ll b){
	a+=b;
	if(a>=mod)a-=mod;
	return a;
}
void addto(ll&a,ll b){
	a=add(a,b);
}
vector<ll> operator+(vector<ll>A,vector<ll>B){
	for(int i=0;i<5;i++)A[i]=add(A[i],B[i]);
	return A;
}
struct Matrix{
	ll mat[5][5];
	Matrix(int diag=0){
		memset(mat,0,sizeof(mat));
		for(int i=0;i<5;i++)mat[i][i]=diag;
	}
	ll* operator[](int i){return mat[i];}
	friend Matrix operator*(Matrix&A,Matrix&B){
		Matrix C=Matrix();
		for(int i=0;i<5;i++){
			for(int j=0;j<5;j++){
				for(int k=0;k<5;k++){
					C.mat[i][j]=(C.mat[i][j]+A.mat[i][k]*B.mat[k][j]);
				}
				C.mat[i][j]%=mod;
			}
		}
		return C;
	}
	friend vector<ll> operator*(Matrix&A,vector<ll>&B){
		vector<ll>C(5);
		for(int i=0;i<5;i++){
			for(int k=0;k<5;k++)C[i]=(C[i]+A.mat[i][k]*B[k]);
			C[i]%=mod;
		}
		return C;
	}
};
Matrix nxt[3][M+1],prv[3][M+1];//M^i=(M-1)*M^(i-1), nxt[i][0]=nxt[i-1][M-1]*nxt[i-1][0];
vector<ll>zero;
vector<ll>MoveK(vector<ll>B,ll k){//m^2 logK = 
	if(k==0)return B;
	if(k>0){
		int lvl=0;
		while(k){
			if(k&(M-1))B=nxt[lvl][k&(M-1)]*B;
			k>>=SH;
			lvl++;
		}
	}else{
		k=-k;
		int lvl=0;
		while(k){
			if(k&(M-1))B=prv[lvl][k&(M-1)]*B;
			k>>=SH;
			lvl++;
		}
	}
	return B;
}
struct SegTree{
	vector<ll> tree[1<<18];
	ll lazy[1<<18];
	int sz;
	void build(int l,int r,int p,vector<int>&a){
		if(l==r){
			tree[p]=MoveK(zero,a[l]);
			return;
		}
		int md=(l+r)>>1;
		build(l,md,p*2+1,a);
		build(md+1,r,p*2+2,a);
		tree[p]=tree[p*2+1]+tree[p*2+2];
	}
	void init(int n,vector<int>a){
		sz=1;
		while(sz<n)sz*=2;
		for(int i=0;i<2*sz;i++)tree[i]=zero,lazy[i]=0;
		sz=n;
		build(0,sz-1,0,a);
	}
	void put_lazy(int p,ll pw){
		lazy[p]+=pw;
		tree[p]=MoveK(tree[p],pw);
	}
	void push_lazy(int p){
		if(lazy[p]){
			put_lazy(p*2+1,lazy[p]);
			put_lazy(p*2+2,lazy[p]);
			lazy[p]=0;
		}
	}
	void update(int l,int r,int p,int l_q,int r_q,ll pw){
		if(l>r_q||r<l_q)return;
		if(l>=l_q&&r<=r_q){
			put_lazy(p,pw);
			return;
		}
		push_lazy(p);
		int md=(l+r)>>1;
		update(l,md,p*2+1,l_q,r_q,pw);
		update(md+1,r,p*2+2,l_q,r_q,pw);
		tree[p]=tree[p*2+1]+tree[p*2+2];
	}
	void update(int l,int r,ll pw){
		update(0,sz-1,0,l,r,pw);
	}
	ll query(int l,int r,int p,int l_q,int r_q){
		if(l>r_q||r<l_q)return 0;
		if(l>=l_q&&r<=r_q)return tree[p][0];
		push_lazy(p);
		int md=(l+r)>>1;
		return add(query(l,md,p*2+1,l_q,r_q),query(md+1,r,p*2+2,l_q,r_q));
	}
	ll query(int l,int r){
		return query(0,sz-1,0,l,r);
	}
}tree;
void preprocess(){
	Matrix x=Matrix();
	for(int i=0;i<5;i++)x[0][i]=5-i;
	for(int i=1;i<5;i++)x[i][i-1]=1;
	nxt[0][1]=x;
	x=Matrix();
	for(int i=1;i<5;i++)x[i-1][i]=1;
	for(int i=0;i<5;i++)x[4][i]=(i==0?1:mod+i-6);
	prv[0][1]=x;
	nxt[0][0]=nxt[1][0]=prv[0][0]=prv[1][0]=Matrix(1);
	for(int i=0;i<3;i++){
		for(int j=1;j<=M;j++){
			if(i||j>1){
				if(j>1){
					nxt[i][j]=nxt[i][j-1]*nxt[i][1];
					prv[i][j]=prv[i][j-1]*prv[i][1];
				}else{
					nxt[i][j]=nxt[i-1][M];
					prv[i][j]=prv[i-1][M];
				}
			}
		}
	}
	zero={4,3,2,1,0};
	zero=prv[0][4]*zero;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	preprocess();
	int n=read_int(),q=read_int();
	//cin>>n>>q;
	vector<int>a(n+1);
	for(int i=1;i<=n;i++)a[i]=read_int();
	tree.init(n+1,a);
	while(q--){
		int type=read_int(),l=read_int(),r=read_int();
		//cin>>type>>l>>r;
		if(type==1){
			cout<<((tree.query(l,r)%mod+mod)%mod)<<"\n";
		}else{
			int v=read_int();
			//cin>>v;
			tree.update(l,r,v);
		}
	}
	return 0;
}