#include "bits/stdc++.h"
using namespace std;
typedef long long ll;
#define row vector<ll>
#define matrix vector<row>
const ll mod=1e8+543;
ll mul(ll a,ll b){
    return a%mod*(b%mod)%mod;
}
ll add(ll a,ll b){
    return ((a+b)%mod+mod)%mod;
}
ll sub(ll a,ll b){
    return ((a-b)%mod+mod)%mod;
}
matrix identity(int n){
    matrix ret(n,row(n));
    for(int i=0;i<n;i++)ret[i][i]=1;
    return ret;
}
matrix multiply(matrix a,matrix b){
    int n=a.size();
    matrix ret(n,row(n));
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            for(int k=0;k<n;k++){
                ret[i][j]=add(ret[i][j],mul(a[i][k],b[k][j]));
            }
        }
    }
    return ret;
}
matrix power(matrix a,ll k){
    if(k==0)return identity(6);
    if(k==1)return a;
    matrix r=power(a,k/2);
    if(k&1){
        return multiply(multiply(r,r),a);
    }
    else{
        return multiply(r,r);
    }
}
matrix a(6,row(6)),b(6,row(6));
void build(){
    for(int i=0;i<5;i++)a[0][i]=i;
    a[0][5]=40;
    for(int i=0;i<5;i++)b[i+1][i]=1;
    for(int i=1;i<6;i++)b[i][5]=i;
}
ll get(ll n){
    a=multiply(a,power(b,n));
    return a[0][5];
}
int main(){
    vector<double>x(1000005);
    x[0]=0;x[1]=1;x[2]=2;x[3]=3;x[4]=4;x[5]=40;
    for(int i=6;i<=1000000;i++){
        x[i]=(double)x[i-1]*5.79132;
    }
    int n,q;cin>>n>>q;
    vector<ll>a(n+1);
    for(int i=1;i<=n;i++){
        cin>>a[i];a[i]=x[a[i]];
        a[i]=add(a[i],a[i-1]);
    }
    while(q--){
        int type,l,r;cin>>type>>l>>r;
        cout<<sub(a[r],a[l-1])<<endl;
    }
}