#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll MOD = 1e8 + 543; 
ll add(ll a, ll b) {
	if ((a += b) >= MOD) a -= MOD;
	return a;
}
ll mul(ll a, ll b) {
	return a * b % MOD;
}
ll sub(ll a, ll b) {
	if ((a -= b) < 0) a += MOD;
	return a;
}
struct Matrix {
	vector<vector<ll>> mat;
	Matrix() {
		mat = vector<vector<ll>>(5, vector<ll>(5));
	}
	Matrix(vector<vector<ll>> a) : mat(a) {};
	friend vector<ll> operator*(const vector<ll>& lhs, const Matrix& rhs) {
		vector<ll> ret(5);
		for (int i = 0; i < 5; ++i)
			for (int j = 0; j < 5; ++j)
				ret[i] = add(ret[i], mul(lhs[j], rhs.mat[i][j]));
		return ret;
	}
	friend Matrix operator*(const Matrix& lhs, const Matrix& rhs) {
		Matrix ret;
		for (int i = 0; i < 5; ++i)
			for (int j = 0; j < 5; ++j)
				for (int k = 0; k < 5; ++k)
					ret.mat[i][j] = add(ret.mat[i][j], mul(lhs.mat[i][k], rhs.mat[k][j]));
		return ret;
	}
};
const Matrix identity = Matrix({{1, 0, 0, 0, 0}, {0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}});
const vector<ll> base_case = {0, 1, 2, 3, 4};
const Matrix multiplier = Matrix({{0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}, {1, 2, 3, 4, 5}});
Matrix binpow(Matrix base, ll exp) {
	if (exp < 2) return exp ? base : identity;
	Matrix half = binpow(base * base, exp >> 1);
	return half * binpow(base, exp & 1);
}
ll gt(ll idx) {
	if (idx < 5) return base_case[idx];
	else {
		Matrix other = binpow(multiplier, idx - 4);
		vector<ll> ret = base_case * other;
		return ret.back();
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	vector<ll> pref(n);
	vector<ll> val(n);
	vector<bool> up(n);
	for (auto& i : a) cin >> i; 
	pref[0] = gt(a[0]); 
	val[0] = pref[0];
	for (int i = 1; i < n; ++i) {
		pref[i] = add(pref[i - 1], gt(a[i]));
		val[i] = sub(pref[i], pref[i - 1]);
	}
	while (q--) {
		int t;
		cin >> t;
		if (t & 1) {
			int l, r;
			cin >> l >> r;
			--l, --r;
			if (l == r) {
				if (up[l]) val[l] = gt(a[l]), up[l] = false;
				cout << val[l] << '\n';
			}
			else {
				ll ans = pref[r];
				if (l) ans = sub(ans, pref[l - 1]);
				cout << ans << '\n';
			}
		} else {
			int l, r, v;
			cin >> l >> r >> v;
			assert(l == r);
			up[l - 1] = true;
			a[l - 1] += v;
		}
	}
}