#include <bits/stdc++.h>
using namespace std;
#define ll int
const ll MOD = 1e8 + 543;
ll add(ll a, ll b) {
	if ((a += b) >= MOD) a -= MOD;
	return a;
}
ll mul(ll a, ll b) {
	long long ret = (long long) a * b % MOD;
	return (ll) ret;
}
struct Matrix {
	vector<vector<ll>> mat;
	Matrix() {
		mat = vector<vector<ll>>(5, vector<ll>(5));
	}
	Matrix(vector<vector<ll>> a) : mat(std::move(a)) {};
	friend Matrix operator*(const Matrix& lhs, const Matrix& rhs) {
		Matrix ret;
		for (int i = 0; i < 5; ++i)
			for (int j = 0; j < 5; ++j)
				for (int k = 0; k < 5; ++k)
					ret.mat[i][j] = add(ret.mat[i][j], mul(lhs.mat[i][k], rhs.mat[k][j]));
		return ret;
	}
};
const Matrix iden = Matrix({{1, 0, 0, 0, 0}, {0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}});
const vector<ll> base_case = {0, 1, 2, 3, 4};
const Matrix multiplier = Matrix({{0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}, {1, 2, 3, 4, 5}});
Matrix pw[30];
ll gt(ll idx) {
	if (idx < 5) return base_case[idx];
	else {
		Matrix other = iden;
		ll exp = idx - 4;
		for (int i = 0; i < 30; ++i)
			if (exp & (1ll << i))
				other = other * pw[i];
		ll ret = 0;
		for (int i = 0; i < 5; ++i)
			ret = add(ret, mul(base_case[i], other.mat[4][i]));
		return ret;
	}
}
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	pw[0] = multiplier;
	for (int i = 1; i < 30; ++i) pw[i] = pw[i - 1] * pw[i - 1];
	int n, q;
	cin >> n >> q;
	vector<ll> a(n);
	vector<ll> val(n);
	for (auto& i : a) cin >> i;
	for (int i = 0; i < n; ++i) {
		val[i] = gt(a[i]);
	}
	while (q--) {
		int t;
		cin >> t;
		if (t & 1) {
			ll l, r;
			cin >> l >> r;
			--l, --r;
			cout << val[l] << '\n';
		} else {
			ll l, r, v;
			cin >> l >> r >> v;
			a[l - 1] += v;
			val[l - 1] = gt(a[l - 1]);
		}
	}
}