#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define md ((l + r) >> 1)

const int mod = 1e8 + 543;
struct mint {
	int v;
	mint(ll x) {
		if (x >= mod) {
			x %= mod;
		}
		v = x;
	}
	mint() {
		v = 0;
	}
	mint& operator+=(const mint &b) {
		if ((v += b.v) >= mod) {
			v -= mod;
		}
		return *this;
	}
	mint& operator-=(const mint &b) {
		if ((v -= b.v) < 0) {
			v += mod;
		}
		return *this;
	}
	mint operator*=(const mint &b) {
		v = 1ll * v * b.v % mod;
		return *this;
	}
	friend mint operator+(mint a, mint b) {
		return a += b;
	}
	friend mint operator-(mint a, mint b) {
		return a -= b;
	}
	friend mint operator*(mint a, mint b) {
		return a *= b;
	}
	friend ostream& operator<<(ostream &os, mint a) {
		return os << a.v;
	}
	friend istream& operator>>(istream &is, mint &a) {
		return is >> a.v;
	}
};

const int M = 6;
struct matrix {
	mint m[M][M];
	matrix() {}
	matrix(vector<vector<int>> x) {
		for (int i = 0; i < M; i++) {
			for (int j = 0; j < M; j++) {
				m[i][j] = x[i][j];
			}
		}
	}
	friend matrix operator*(const matrix &a, const matrix &b) {
		matrix ret;
		for (int i = 1; i < M; i++) {
			for (int j = 1; j < M; j++) {
				for (int k = 0; k < M; k++) {
					ret.m[i][k] += a.m[i][j] * b.m[j][k];
				}
			}
		}
		return ret;
	}
};
struct Vector {
	mint v[6];
	Vector() {};
	Vector(vector<int> x) {
		for (int j = 0; j < M; j++) {
			v[j] = x[j];
		}
	}
	friend Vector operator*(const matrix &a, const Vector &b) {
		Vector ret;
		for (int i = 0; i < M; i++) {
			for (int j = 1; j < M; j++) {
				ret.v[i] += a.m[i][j] * b.v[j];
			}
		}
		return ret;
	}
	friend Vector operator+(const Vector &a, const Vector &b) {
		Vector ret;
		for (int i = 0; i < M; i++) {
			ret.v[i] = a.v[i] + b.v[i];
		}
		return ret;
	}
};
struct node {
	Vector sum;
	matrix lazy;
	bool on;
	node() {}
} seg[1 << 18];
void build(int i, int l, int r) {
	for (int j = 0; j < M; j++) {
		seg[i].lazy.m[j][j] = 1;
	}
	seg[i].on = 0;
	if (l == r) {
		seg[i].sum = (vector<int>) {0, 1, 2, 3, 4, 40};
		return;
	}
	build(i << 1, l, md);
	build(i << 1 | 1, md + 1, r);
	seg[i].sum = seg[i << 1].sum + seg[i << 1 | 1].sum;
}
void process(int i, int l, int r) {
	if (!seg[i].on) return;
	if (l != r) {
		for (auto c : {i << 1, i << 1 | 1}) {
			seg[c].lazy = seg[i].lazy * seg[c].lazy;
			seg[c].on = 1;
		}
	}
	seg[i].sum = seg[i].lazy * seg[i].sum;
	seg[i].on = 0;
	for (int j = 0; j < M; j++) {
		for (int k = 0; k < M; k++) {
			seg[i].lazy.m[j][k] = (j == k);
		}
	}
}
void upd(int i, int l, int r, int s, int e, const matrix &m) {
	process(i, l, r);
	if (s <= l && r <= e) {
		seg[i].lazy = m * seg[i].lazy;
		seg[i].on = 1;
		process(i, l, r);
		return;
	}
	if (r < s || e < l) {
		return;
	}
	upd(i << 1, l, md, s, e, m);
	upd(i << 1 | 1, md + 1, r, s, e, m);
	seg[i].sum = seg[i << 1].sum + seg[i << 1 | 1].sum;
}
matrix pws[30];
void upd2(int i, int l, int r, int x, int v) {
	process(i, l, r);
	if (l == r) {
		for (int j = 29; j >= 0; j--) {
			if (v - (1 << j) >= 0) {
				seg[i].sum = pws[j] * seg[i].sum;
				v -= 1 << j;
			}
		}
		return;
	}
	if (x <= md) {
		upd2(i << 1, l, md, x, v);
	} else {
		upd2(i << 1 | 1, md + 1, r, x, v);
	}
	seg[i].sum = seg[i << 1].sum + seg[i << 1 | 1].sum;
}
Vector get(int i, int l, int r, int s, int e) {
	process(i, l, r);
	if (s <= l && r <= e) {
		return seg[i].sum;
	}
	if (r < s || e < l) {
		return Vector();
	}
	return get(i << 1, l, md, s, e) + get(i << 1 | 1, md + 1, r, s, e);
}
matrix power(matrix a, int b) {
	matrix ans;
	for (int j = 0; j < M; j++) {
		ans.m[j][j] = 1;
	}
	while (b) {
		if (b & 1) {
			ans = ans * a;
		}
		a = a * a;
		b >>= 1;
	}
	return ans;
}
const int N = 100'005;
int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	matrix m = (vector<vector<int>>) {
		{0, 1, 0, 0, 0, 0},
		{0, 0, 1, 0, 0, 0},
		{0, 0, 0, 1, 0, 0},
		{0, 0, 0, 0, 1, 0},
		{0, 0, 0, 0, 0, 1},
		{0, 1, 2, 3, 4, 5}
	};
	pws[0] = m;
	for (int j = 1; j < 30; j++) {
		pws[j] = pws[j - 1] * pws[j - 1];
	}
	int n, q;
	cin >> n >> q;
	build(1, 1, n);
	int a[n + 1];
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
		upd2(1, 1, n, i, a[i]);
	}
	while (q--) {
		int t;
		cin >> t;
		if (t == 1) {
			int l, r;
			cin >> l >> r;
			Vector v = get(1, 1, n, l, r);
			cout << v.v[0] << '\n';
		} else {
			int l, r, v;
			cin >> l >> r >> v;
			if (l == r) {
				upd2(1, 1, n, l, v);
			} else {
				matrix mv = power(m, v);
				upd(1, 1, n, l, r, mv);
			}
		}
	}
	return 0;
}
