#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;
#define int long long
const int mod = 1e8 + 543;
vector < vector < int >> Mul(vector < vector < int >> &a, vector < vector < int >> &b) {
    int n = a.size(), m = a[0].size();
    vector < vector < int >> ans(n, vector < int > (m));
    for(int i = 0 ; i < n ; i++) {
        for(int j = 0 ; j < n ; j++) {
            for(int k = 0 ; k < n ; k++) {
                ans[i][j] += a[i][k] * b[k][j];
                ans[i][j] %= mod;
            }
        }
    }
    return ans;
}
vector < vector < int >> ini = {{1, 0, 0, 0, 0},
                                {0, 1, 0, 0, 0},
                                {0, 0, 1, 0, 0},
                                {0, 0, 0, 1, 0},
                                {0, 0, 0, 0, 1}};
vector < vector < int >> power(vector < vector < int >> &a, int b) {
    if(!b) return ini;
    auto ans = power(a, b >> 1);
    ans = Mul(ans, ans);
    if(b & 1) ans = Mul(ans, a);
    return ans;
}
const int N = 1e6 + 6;
vector < int > values(N);
void init() {
    values[1] = 1, values[2] = 2, values[3] = 3, values[4] = 4;
    for(int i = 5 ; i < N ; i++) {
        values[i] = (values[i - 1] * 5) + (values[i - 2] * 4) + (values[i - 3] * 3) + (values[i - 4] * 2) + (values[i - 5] * 1);
        values[i] %= mod;
    }
    // for(int i = 0 ; i < 100 ; i++) {
    //     cout << values[i] << " ";
    // }
    // cout << endl;
}
int query(int k) {
    if(k < N) {
        // cout << k << " " << values[k] << endl;
        return values[k];
    }
    k = k - 4;
    vector < vector < int >> a = {{5, 1, 0, 0, 0}, 
                                  {4, 0, 1, 0, 0},
                                  {3, 0, 0, 1, 0},
                                  {2, 0, 0, 0, 1},
                                  {1, 0, 0, 0, 0}};
    a = power(a, k);
    vector < int > arr2;
    for(int i = 0 ; i < 5 ; i++)
        arr2.push_back(a[i][0]);
    vector < int > arr = {4, 3, 2, 1, 0};
    int ans = 0;
    for(int i = 0 ; i < 5 ; i++) {
        ans += (arr2[i] * arr[i]);
        ans %= mod;
    }
    return ans;
}
struct segtree {
    int sz;
    vector < int > tree;
    void init(int n) { 
        sz = 1;
        while(sz <= n) sz <<= 1;
        tree = vector < int > (sz << 2);
    }
    void update(int node, int lnode, int rnode, int idx, int x) {
        if(rnode - lnode == 1) {
            tree[node] = x;
            return;
        }
        int mid = (lnode + rnode) >> 1;
        if(idx < mid)
            update(node * 2 + 1, lnode, mid, idx, x);
        else
            update(node * 2 + 2, mid, rnode, idx, x);
        tree[node] = (tree[node * 2 + 1] + tree[node * 2 + 2]) % mod;
    }
    void update(int idx, int x) {
        update(0, 0, sz, idx, x);
    }
    int query(int node, int lnode, int rnode, int l, int r) {
        if(rnode <= l || r <= lnode) return 0;
        if(lnode >= l && rnode <= r) return tree[node];
        int mid = (lnode + rnode) >> 1;
        int a = query(node * 2 + 1, lnode, mid, l, r);
        int b = query(node * 2 + 2, mid, rnode, l, r);
        return (a + b) % mod;
    }
    int query(int l, int r) {
        return query(0, 0, sz, l, r);
    }
};
signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    init();
    int n, q;
    cin >> n >> q;
    vector < int > a(n);
    for(auto &i : a) cin >> i;
    segtree s;
    s.init(n);
    for(int i = 0 ; i < n ; i++) {
        // a[i] = query(a[i]);
        // a[i] += (i > 0? a[i - 1] : 0);
        s.update(i, query(a[i]));
    }
    while(q--) {
        int ty;
        cin >> ty;
        if(ty == 1) {
            int l, r;
            cin >> l >> r;
            cout << s.query(l - 1, r) << endl;
        } else {
            int l, r, x;
            cin >> l >> r >> x;
            l -= 1;
            a[l] += x;
            s.update(l, query(a[l]));
        }
    }
    return 0;
}