#include <bits/stdc++.h>
#define vc vector

using ll = long long;
using namespace std;
const int M = 1e8 + 543;
const int mod = M;
const int N = 1e6;

int add (int a, int b) {
    a += b;
    if (a >= mod)
        a -= mod;
    return a;
}

int sub (int a, int b) {
    return add(a, mod - b);
}

struct matrix {
    vc <vc <int>> v; int n;
    matrix (vc <vc <int>> v): v(v) {
        n = v.size();
    }
    matrix() {}
    matrix operator * (matrix const &b) const {
        matrix c(vc <vc <int>> (n, vc <int> (n)));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < n; ++k) {
                    c.v[i][k] = ::add(c.v[i][k], v[i][j] * 1ll * b.v[j][k] % mod);
                }
            }
        }
        return c;
    }
};

vc <matrix> muled(29);

matrix bin_pow (matrix a, int b) {
    int n = a.n;
    matrix res(vc <vc <int>> (n, vc <int> (n)));
    for (int i = 0; i < n; ++i)
        res.v[i][i] = 1;
    for (int i = 0; (1 << i) <= b; ++i) {
        if (b >> i & 1)
            res = res * muled[i];
    }
    return res;
}

struct fw {
    vc <int> t; int n;
    fw (int n): n(n) {
        t.resize(n + 1);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] = add(t[i], x);
    }
    int get (int i) {
        int res = 0;
        for (++i; i > 0; i -= i & -i)
            res = add(res, t[i]);
        return res;
    }
    int get (int l, int r) {
        return sub(get(r), get(l - 1));
    }
};
int x[N + 1];

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    vc <vc <int>> matr(5, vc <int> (5));
    matr[0][1] = 1;
    matr[1][2] = 1;
    matr[2][3] = 1;
    matr[3][4] = 1;
    for (int i = 0; i < 5; ++i)
        matr[4][i] = i + 1;
    matrix base(matr);
    muled[0] = base;
    for (int i = 1; i < muled.size(); ++i)
        muled[i] = muled[i - 1] * muled[i - 1];
    vc <int> bb = {0, 1, 2, 3, 4};
    for (int i = 0; i < 5; ++i)
        x[i] = bb[i];
    for (int i = 5; i <= N; ++i) {
        x[i] = (1ll * x[i - 1] * 5 + x[i - 2] * 4 + x[i - 3] * 3 + x[i - 4] * 2 + x[i - 5]) % mod;
    }
    vc <int> a(n);
    vc <int> b(n);
    auto get = [&](int i) {
        if (i <= N)
            return x[i];
        i -= N;
        matrix nw = bin_pow(base, i);
        int res = 0;
        for (int j = 0; j < 5; ++j)
            res = ::add(res, nw.v[4][j] * 1ll * x[N - 4 + j] % mod);
        return res;
    };
    fw t(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; a[i] = (a[i] + mod - 1) % (mod - 1);
    }
    while (q--) {
        int cmd, l, r;
        cin >> cmd >> l >> r; --l; --r;
        if (cmd == 1) {
            cout << get(a[l]) << '\n';
        } else {
            int x;
            cin >> x;
            a[l] = (a[l] + x) % (mod - 1);
        };
    }
    return 0;
}