#include <bits/stdc++.h>
#define vc vector

using ll = long long;
using namespace std;
const int M = 1e8 + 543;
const int mod = M;
const int N = 1e6;

int add (int a, int b) {
    a += b;
    if (a >= mod)
        a -= mod;
    return a;
}

int sub (int a, int b) {
    return add(a, mod - b);
}

struct matrix {
    vc <vc <int>> v; int n;
    matrix (vc <vc <int>> v): v(v) {
        n = v.size();
    }
    matrix() {}
    matrix operator * (matrix const &b) const {
        matrix c(vc <vc <int>> (n, vc <int> (n)));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                for (int k = 0; k < n; ++k) {
                    c.v[i][k] = ::add(c.v[i][k], v[i][j] * 1ll * b.v[j][k] % mod);
                }
            }
        }
        return c;
    }
    matrix operator + (matrix const &b) const {
        matrix c(vc <vc <int>> (n, vc <int> (n)));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                c.v[i][j] = ::add(v[i][j], b.v[i][j]);
            }
        }
        return c;
    }
};

vc <matrix> muled(29);

matrix bin_pow (matrix a, int b) {
    int n = a.n;
    matrix res(vc <vc <int>> (n, vc <int> (n)));
    for (int i = 0; i < n; ++i)
        res.v[i][i] = 1;
    for (int i = 0; (1 << i) <= b; ++i) {
        if (b >> i & 1)
            res = res * muled[i];
    }
    return res;
}

struct segtree {
    vc <matrix> t, add;
    int n;
    segtree (int n, matrix zero) {
        t.resize(n * 4, zero);
        add.resize(n * 4, zero);
    }
    void apply (int v) {
        t[v] = (t[v << 1] + t[v << 1 | 1]) * add[v];
    }
    matrix get (int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) / 2;
        if (r <= tm)
            return get(v << 1, tl, tm, l, r);
        if (tm <= l)
            return get(v << 1 | 1, tm, tr, l, r);
        return (get(v << 1, tl, tm, l, r) + get(v << 1 | 1, tm, tr, l, r)) * add[v];
    }
    void upd (int v, int tl, int tr, int l, int r, matrix &x) {
        if (tr <= l || r <= tl) return;
        if (l <= tl && tr <= r) {
            add[v] = add[v] * x;
            if (tr - tl > 1)
                apply(v);
            else
                t[v] = add[v];
            return;
        }
        int tm = (tl + tr) / 2;
        upd(v << 1, tl, tm, l, r, x);
        upd(v << 1 | 1, tm, tr, l, r, x);
        apply(v);
    }
};
int x[N + 1];

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    vc <vc <int>> matr(5, vc <int> (5)), zero(5, vc <int> (5));
    matr[0][1] = 1;
    matr[1][2] = 1;
    matr[2][3] = 1;
    matr[3][4] = 1;
    for (int i = 0; i < 5; ++i) {
        matr[4][i] = i + 1;
        zero[i][i] = 1;
    }
    matrix base(matr);
    muled[0] = base;
    for (int i = 1; i < muled.size(); ++i)
        muled[i] = muled[i - 1] * muled[i - 1];
    vc <int> bb = {0, 1, 2, 3, 4};

    vc <int> a(n);
    vc <int> b(n);
    auto get = [&](int i) {
        matrix nw = bin_pow(base, i);
        return nw;
    };
    segtree t(n, matrix(zero));
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; a[i] = (a[i] + mod - 1) % (mod - 1);
        matrix upd = bin_pow(base, a[i]);
        t.upd(1, 0, n, i, i + 1, upd);
    }
    while (q--) {
        int cmd, l, r;
        cin >> cmd >> l >> r; --l; --r;
        if (cmd == 1) {
            matrix result = t.get(1, 0, n, l, r + 1);
            int res = 0;
            for (int i = 0; i < 5; ++i) {
                res = ::add(res, result.v[0][i] * i % mod);
            }
            cout << res << '\n';
        } else {
            int x;
            cin >> x; x = (x + mod - 1) % (mod - 1);
            matrix upd = bin_pow(base, x);
            t.upd(1, 0, n, l, r + 1, upd);
        }
    }
    return 0;
}