#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include "ones.h"

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

const int INF = 1e18, MAXN = 1e5 + 10;

ld t[4 * MAXN];

void build(int v, int tl, int tr) {
	if (tr - tl == 1)
		t[v] = tl;
	else {
		int m = (tr + tl) / 2;
		build(v * 2, tl, m);
		build(v * 2 + 1, m, tr);
		t[v] = t[v * 2] * t[v * 2 + 1];
	}
}

ld get(int v, int tl, int tr, int l, int r) {
	if (tr <= l || r <= tl)
		return 1;
	if (l <= tl && r >= tr)
		return t[v];
	int m = (tr + tl) / 2;
	return get(v * 2, tl, m, l, r) * get(v * 2 + 1, m, tr, l, r);
}

bool built = false;

vi guessOnes(int n, int k) {
	if (!built)
		build(1, 1, MAXN);
	built = true;
	int now = 1;
	vi ans;
	do {
		int l = now - 1, r = n;
		bool flag = false;
		int cnt = 0;
		while (r - l > 1) {
			int m;
			++cnt;
			if (!flag) {
				int L = l + 1, R = r;
				ld x = pow((ld)n - l, k);
				while (R - L > 1) {
					int m = (L + R) / 2;
					ld chance = get(1, 1, MAXN, n - m - k + 1, n - m + 1);
					chance /= x;
					if (chance <= 0.5)
						R = m;
					else
						L = m;
				}
				m = L;
			}
			else
				m = (r + l) / 2;
			if (hasOnes(now, m))
				r = m, flag = true;
			else
				l = m;
		}
		ans.push_back(r);
		now = r + 1;
	} while (--k);
	return ans;
}