#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <queue>
#include "puzzle.h"

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper_bound

using namespace std;

typedef long long ll;
typedef double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << '\n';
}

const int INF = 1e18, MAXN = 1e5 + 10, MOD = (int)1e8 + 543;

void init(int num, double tl) {

}

bool check(vvi& a, pi v, pi u, int k) {
	auto [x1, y1] = v;
	auto [x2, y2] = u;
	bool flag = true;
	for (int x = min(x1, x2) + 1; x < max(x1, x2); ++x)
		flag &= (a[x][y1] == 0);
	for (int y = min(y1, y2) + 1; y < max(y1, y2); ++y)
		flag &= (a[x1][y] == 0);
	return flag;
}

void join(vvi& a, pi v, pi u, int k) {
	auto [x1, y1] = v;
	auto [x2, y2] = u;
	for (int x = min(x1, x2) + 1; x < max(x1, x2); ++x)
		a[x][y1] = (k == 2 ? -4 : -2);
	for (int y = min(y1, y2) + 1; y < max(y1, y2); ++y)
		a[x1][y] = (k == 2 ? -3 : -1);
}

bool solve(vvi& a) {
	vpi b = { {0, 0,} };
	vi c = { 0 };
	int n = a.size(), m = a[0].size();
	map<pi, int> mp;
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			if (a[i][j]) {
				b.push_back({ i, j });
				c.push_back(a[i][j]);
				mp[{i, j}] = b.size() - 1;
			}
	vi d = c;
	int k = b.size() - 1;
	vvi g(k + 1);
	for (int i = 1; i <= k; ++i) {
		auto [x, y] = b[i]; 
		for (int x1 = x + 1; x1 < n; ++x1)
			if (a[x1][y]) {
				g[i].push_back(mp[{x1, y}]);
				break;
			}
		for (int x1 = x - 1; x1 >= 0; --x1)
			if (a[x1][y]) {
				g[i].push_back(mp[{x1, y}]);
				break;
			}
		
		for (int y1 = y + 1; y1 < m; ++y1)
			if (a[x][y1]) {
				g[i].push_back(mp[{x, y1}]);
				break;
			}
		for (int y1 = y - 1; y1 >= 0; --y1)
			if (a[x][y1]) {
				g[i].push_back(mp[{x, y1}]);
				break;
			}
	}
	vb used(k + 1, false);
	queue<int> q;
	for (int u = 1; u <= k; ++u) {
		int sum = 0, cnt = 0;
		for (auto u1 : g[u]) {
			if (d[u] == 1 && d[u1] == 1)
				continue;

			if (!check(a, b[u1], b[u], min({ c[u], c[u1], 2 })))
				continue;
			sum += min(c[u1], 2);
			if (c[u1])
				cnt++;
		}
		if (!used[u] && (sum == c[u] || cnt == 1))
			q.push(u);
	}
	while (q.size()) {
		int v = q.front();
		q.pop();
		if (used[v]) {
			if (q.empty()) {
				for (int i = 1; i <= k; ++i)
					if (!used[i]) {
						q.push(i);
						break;
					}
			}
			continue;
		}
		used[v] = true;
		for (auto u : g[v]) {
			if (used[u] || !c[v] || !c[u] || (d[u] == 1 && d[v] == 1))
				continue;
			if (!check(a, b[v], b[u], min({ c[u], c[v], 2 })))
				continue;
			join(a, b[v], b[u], min({ c[u], c[v], 2 }));
			int val = min({ c[u], c[v], 2 });
			c[v] -= val;
			c[u] -= val;
		}
		for (int u = 1; u <= k; ++u) {
			int sum = 0, cnt = 0;
			for (auto u1 : g[u]) {
				if (d[u] == 1 && d[u1] == 1)
					continue;

				if (!check(a, b[u1], b[u], min({ c[u], c[u1], 2 })))
					continue;
				sum += min(c[u1], 2);
				if (c[u1])
					cnt++;
			}
			if (!used[u] && (sum == c[u] || cnt == 1))
				q.push(u);
		}
		if (q.empty()) {
			for (int i = 1; i <= k; ++i)
				if (!used[i]) {
					q.push(i);
					break;
				}
		}
		/*
		for (const std::vector<int>& row : a) {
			for (int elem : row) {
				if (elem > 0 && elem <= 8) std::cerr << elem;
				else if (elem == EMPTY) std::cerr << " ";
				else if (elem == HOR_SINGLE) std::cerr << "-";
				else if (elem == HOR_DOUBLE) std::cerr << "=";
				else if (elem == VERT_SINGLE) std::cerr << "|";
				else if (elem == VERT_DOUBLE) std::cerr << "$";
				else std::cerr << "?";
			}
			std::cerr << std::endl;
		}
		std::cerr << std::endl;
		*/
	}
	return true;
}