#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = int(1e8) + 543;

void madd(int &x, int y) {
    if ((x += y) >= MOD) {
        x -= MOD;
    }
}

using mat = array<array<int, 5>, 5>;

mat neut, prv, nxt;

mat operator*(const mat &a, const mat &b) {
    mat res{};
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            for (int k = 0; k < 5; ++k) {
                madd(res[i][j], 1LL * a[i][k] * b[k][j] % MOD);
            }
        }
    }
    return res;
}

mat operator+(mat a, const mat &b) {
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            madd(a[i][j], b[i][j]);
        }
    }
    return a;
}

mat power(mat a, int b) {
    mat res = neut;
    for (; b > 0; b >>= 1, a = a * a) {
        if (b & 1) {
            res = res * a;
        }
    }
    return res;
}

vector<mat> t, tag;
int sz = 1;

void tapply(int x, const mat &tg) {
    t[x] = tg * t[x];
    tag[x] = tg * tag[x];
}

void push(int x) {
    if (tag[x] != neut) {
        tapply(x << 1, tag[x]);
        tapply(x << 1 | 1, tag[x]);
        tag[x] = neut;
    }
}

void pull(int x) {
    t[x] = t[x << 1] + t[x << 1 | 1];
}

void init(int n, vector<int> a) {
    sz = 1 << __lg(n) + !!(n & (n - 1));
    t.assign(sz << 1, {});
    tag.assign(sz << 1, neut);
    for (int i = 0; i < n; ++i) {
        t[i + sz] = (a[i] >= 0 ? power(nxt, a[i]) : power(prv, -a[i]));
    }
    for (int i = sz - 1; i > 0; --i) {
        pull(i);
    }
}

void rangeApply(int l, int r, const mat &tg, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
        return tapply(x, tg);
    }
    int mid = lx + rx >> 1;
    push(x);
    rangeApply(l, r, tg, x << 1, lx, mid);
    rangeApply(l, r, tg, x << 1 | 1, mid, rx);
    pull(x);
}

mat rangeSum(int l, int r, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return {};
    }
    if (l <= lx && rx <= r) {
        return t[x];
    }
    push(x);
    int mid = lx + rx >> 1;
    return rangeSum(l, r, x << 1, lx, mid) + rangeSum(l, r, x << 1 | 1, mid, rx);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    for (int i = 0; i < 5; ++i) {
        neut[i][i] = 1;
    }

    nxt[0] = {5, 4, 3, 2, 1};
    nxt[1] = {1, 0, 0, 0, 0};
    nxt[2] = {0, 1, 0, 0, 0};
    nxt[3] = {0, 0, 1, 0, 0};
    nxt[4] = {0, 0, 0, 1, 0};

    prv[0] = {0, 1, 0, 0, 0};
    prv[1] = {0, 0, 1, 0, 0};
    prv[2] = {0, 0, 0, 1, 0};
    prv[3] = {0, 0, 0, 0, 1};
    prv[4] = {1, MOD - 5, MOD - 4, MOD - 3, MOD - 2};

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    init(n, a);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        --l;
        if (type == 1) {
            auto res = rangeSum(l, r);
            int ans = 0;
            vector<int> mul(5);
            mul = vector{4, 3, 2, 1, 0};
            for (int j = 0; j < 1; ++j) {
                for (int k = 0; k < 5; ++k) {
                    madd(ans, 1LL * mul[k] * res[4][k] % MOD);
                }
            }
            cout << ans << '\n';
        } else {
            int v;
            cin >> v;
            auto mul = (v >= 0 ? power(nxt, v) : power(prv, -v));
            rangeApply(l, r, mul);
        }
    }

    return 0;
}