#prag\
ma GCC optimize("O3,unroll-loops")
#prag\
ma GCC target("avx,avx2,bmi,sse,sse3,popcnt")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = int(1e8) + 543;

inline void madd(int &x, int y) {
    if ((x += y) >= MOD) {
        x -= MOD;
    }
}

using mat = array<array<int, 5>, 5>;

mat neut, prv, nxt;

constexpr int F = 1 << 14;

mat powers[2][F + 1];
mat fpower[2][F];

inline mat operator*(const mat &a, const mat &b) {
    mat res{};
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
#prag\
ma ivdep
            ll sum = 0; //ll(a[i][0]) * b[0][j] + ll(a[i][1]) * b[1][j] + ll(a[i][2]) * b[2][j] + ll(a[i][3]) * b[3][j] + ll(a[i][4]) * b[4][j];
            for (int k = 0; k < 5; ++k) {
                sum += ll(a[i][k]) * b[k][j];
            }
            res[i][j] = sum % MOD;
        }
    }
    return res;
}

inline mat power(int side, int b) {
    return fpower[side][b >> 14] * powers[side][b & (F - 1)];
}

vector<mat> t, tag;
bool here[1 << 18];
int sz = 1;

inline void tapply(int x, const mat &tg) {
    t[x] = tg * t[x];
    tag[x] = tg * tag[x];
    here[x] = true;
}

inline void push(int x) {
    if (here[x]) {
        tapply(x << 1, tag[x]);
        tapply(x << 1 | 1, tag[x]);
        tag[x] = neut;
        here[x] = false;
    }
}

inline void pull(int x) {
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            t[x][i][j] = t[x << 1][i][j] + t[x << 1 | 1][i][j];
            if (t[x][i][j] >= MOD) {
                t[x][i][j] -= MOD;
            }
        }
    }
//    t[x] = t[x << 1] + t[x << 1 | 1];
}

inline void init(int n, vector<int> a) {
    sz = 1 << __lg(n) + !!(n & (n - 1));
    t.assign(sz << 1, {});
    tag.assign(sz << 1, neut);
    fill(here, here + sz * 2, 0);
    for (int i = 0; i < n; ++i) {
        t[i + sz] = (a[i] >= 0 ? power(0, a[i]) : power(1, -a[i]));
    }
    for (int i = sz - 1; i > 0; --i) {
        pull(i);
    }
}

inline void rangeApply(int l, int r, const mat &tg, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
        return tapply(x, tg);
    }
    int mid = lx + rx >> 1;
    push(x);
    rangeApply(l, r, tg, x << 1, lx, mid);
    rangeApply(l, r, tg, x << 1 | 1, mid, rx);
    pull(x);
}

mat result{};

inline void rangeSum(int l, int r, int x = 1, int lx = 0, int rx = sz) {
    if (l >= rx || lx >= r) {
        return;
    }
    if (l <= lx && rx <= r) {
//        for (int i = 4; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            madd(result[4][j], t[x][4][j]);
        }
//        }
        return;
    }
    push(x);
    int mid = lx + rx >> 1;
    rangeSum(l, r, x << 1, lx, mid);
    rangeSum(l, r, x << 1 | 1, mid, rx);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    for (int i = 0; i < 5; ++i) {
        neut[i][i] = 1;
    }

    nxt[0] = {5, 4, 3, 2, 1};
    nxt[1] = {1, 0, 0, 0, 0};
    nxt[2] = {0, 1, 0, 0, 0};
    nxt[3] = {0, 0, 1, 0, 0};
    nxt[4] = {0, 0, 0, 1, 0};

    prv[0] = {0, 1, 0, 0, 0};
    prv[1] = {0, 0, 1, 0, 0};
    prv[2] = {0, 0, 0, 1, 0};
    prv[3] = {0, 0, 0, 0, 1};
    prv[4] = {1, MOD - 5, MOD - 4, MOD - 3, MOD - 2};

    for (int f = 0; f < 2; ++f) {
        auto now = f == 0 ? nxt : prv;
        powers[f][0] = neut;
        for (int i = 1; i < size(powers[f]); ++i) {
            powers[f][i] = powers[f][i - 1] * now;
        }
    }
    for (int f = 0; f < 2; ++f) {
        auto now = powers[f][F];
        fpower[f][0] = neut;
        for (int i = 1; i < size(fpower[f]); ++i) {
            fpower[f][i] = fpower[f][i - 1] * now;
        }
    }

    int n, q;
    cin >> n >> q;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    init(n, a);

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        --l;
        if (type == 1) {
            for (int j = 0; j < 5; ++j) {
                result[4][j] = 0;
            }
            rangeSum(l, r);
            int ans = 0;
            for (int k = 0; k < 5; ++k) {
                madd(ans, 1LL * (4 - k) * result[4][k] % MOD);
            }
            cout << ans << '\n';
        } else {
            int v;
            cin >> v;
            auto mul = (v >= 0 ? power(0, v) : power(1, -v));
            rangeApply(l, r, mul);
        }
    }

    return 0;
}