#include <bits/stdc++.h>
#include "puzzle.h"
using namespace std;

struct DSU {
    int n;
    vector<int> par, sz;
    // vector<pair<int, int>> hist;
    DSU() {}
    DSU(int _n) {
        n = _n;
        par.resize(n);
        sz.resize(n);
        clear();
    }
    void clear() {
        for (int i = 0; i < n; ++i) {
            par[i] = i, sz[i] = 1;
        }
    }
    int getParent(int v) {
        /*while (par[v] != v) {
            v = par[v];
        }
        return v;*/
        if (par[v] != v) {
            par[v] = getParent(par[v]);
        }
        return par[v];
    }
    bool uniteSets(int v, int u) {
        v = getParent(v), u = getParent(u);
        if (v == u) {
            return false;
        }
        if (sz[v] < sz[u]) { swap(v, u); }
        par[u] = v;
        sz[v] += sz[u];
        // hist.emplace_back(v, u);
        return true;
    }
    /*void cancel() {
        assert(!hist.empty());
        sz[hist.back().first] -= sz[hist.back().second];
        par[hist.back().second[ = hist.back().second;
        hist.pop_back();
    }*/
    ~DSU() {}
};

void print(const vector<vector<int>>& a, int n, int m) {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cerr << a[i][j] << ' ';
        }
        cerr << '\n';
    }
    cerr << "\n\n";
}

void init(int numSubtests, double timeLimit) {
    
}

bool solve(vector<vector<int>>& puzzle) {
    int n = puzzle.size(), m = puzzle[0].size();
    vector<pair<int, int>> islands;
    vector<vector<int>> byRow(n), byCol(m);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (puzzle[i][j] != 0) {
                islands.emplace_back(i, j);
                byRow[i].emplace_back(j);
                byCol[j].emplace_back(i);
            }
        }
    }
    sort(islands.begin(), islands.end(), [&](const pair<int, int>& A, const pair<int, int>& B) {
        return puzzle[A.first][A.second] < puzzle[B.first][B.second];
    });
    vector<vector<int>> posOf(n, vector<int>(m, -1));
    for (int i = 0; i < (int)islands.size(); ++i) {
        posOf[islands[i].first][islands[i].second] = i;
    }
    vector<vector<int>> up(n, vector<int>(m, -1));
    vector<vector<int>> down(n, vector<int>(m, -1));
    vector<vector<int>> left(n, vector<int>(m, -1));
    vector<vector<int>> right(n, vector<int>(m, -1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < (int)byRow[i].size(); ++j) {
            if (j != 0) {
                left[i][byRow[i][j]] = byRow[i][j - 1];
            }
            if (j != (int)byRow[i].size() - 1) {
                right[i][byRow[i][j]] = byRow[i][j + 1];
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < (int)byCol[j].size(); ++i) {
            if (i != 0) {
                up[byCol[j][i]][j] = byCol[j][i - 1];
            }
            if (i != (int)byCol[j].size() - 1) {
                down[byCol[j][i]][j] = byCol[j][i + 1];
            }
        }
    }
    vector<vector<bool>> locked(n, vector<bool>(m, false));
    vector<vector<int>> ans = puzzle;
    bool found = false;
    DSU dsu(islands.size());
    vector<pair<int, int>> edges;
    auto rec = [&](auto self, int num) -> void {
        if (num == (int)islands.size()) {
            // check connectivity
            // cerr << "!\n";
            int comps = islands.size();
            for (const auto& [i, j] : edges) {
                comps -= dsu.uniteSets(i, j);
            }
            dsu.clear();
            if (comps == 1) {
                found = true;
            }
            return;
        }
        // print(puzzle, n, m);
        // print(ans, n, m);
        auto [i, j] = islands[num];
        // cerr << "i: " << i << ", j: " << j << '\n';
        int limup = 0;
        if (up[i][j] != -1 && !locked[up[i][j]][j]) {
            limup = min(2, min(puzzle[i][j], puzzle[up[i][j]][j]));
            for (int x = i - 1; x > up[i][j]; --x) {
                if (ans[x][j] != 0) {
                    limup = 0;
                    break;
                }
            }
        }
        int limright = 0;
        if (right[i][j] != -1 && !locked[i][right[i][j]]) {
            limright = min(2, min(puzzle[i][j], puzzle[i][right[i][j]]));
            for (int y = j + 1; y < right[i][j]; ++y) {
                if (ans[i][y] != 0) {
                    limright = 0;
                    break;
                }
            }
        }
        int limdown = 0;
        if (down[i][j] != -1 && !locked[down[i][j]][j]) {
            limdown = min(2, min(puzzle[i][j], puzzle[down[i][j]][j]));
            for (int x = i + 1; x < down[i][j]; ++x) {
                if (ans[x][j] != 0) {
                    limdown = 0;
                    break;
                }
            }
        }
        int limleft = 0;
        if (left[i][j] != -1 && !locked[i][left[i][j]]) {
            limleft = min(2, min(puzzle[i][j], puzzle[i][left[i][j]]));
            for (int y = j - 1; y > left[i][j]; --y) {
                if (ans[i][y] != 0) {
                    limleft = 0;
                    break;
                }
            }
        }
        // cerr << "limup: " << limup << ", limright: " << limright << ", limdown: " << limdown << ", limleft: " << limleft << '\n';
        for (int cup = 0; cup <= limup; ++cup) {
            if (cup != 0) {
                for (int x = i - 1; x > up[i][j]; --x) {
                    ans[x][j] = -cup - cup;
                }
                edges.emplace_back(num, posOf[up[i][j]][j]);
                puzzle[i][j] -= cup;
                puzzle[up[i][j]][j] -= cup;
            }
            for (int cright = 0; cright <= limright; ++cright) {
                if (cright != 0) {
                    for (int y = j + 1; y < right[i][j]; ++y) {
                        ans[i][y] = 1 - cright - cright;
                    }
                    edges.emplace_back(num, posOf[i][right[i][j]]);
                    puzzle[i][j] -= cright;
                    puzzle[i][right[i][j]] -= cright;
                }
                for (int cdown = 0; cdown <= limdown; ++cdown) {
                    if (cdown != 0) {
                        for (int x = i + 1; x < down[i][j]; ++x) {
                            ans[x][j] = -cdown - cdown;
                        }
                        edges.emplace_back(num, posOf[down[i][j]][j]);
                        puzzle[i][j] -= cdown;
                        puzzle[down[i][j]][j] -= cdown;
                    }
                    int cleft = puzzle[i][j];
                    if (cleft <= limleft && cleft >= 0) {
                        if (cleft != 0) {
                            for (int y = j - 1; y > left[i][j]; --y) {
                                ans[i][y] = 1 - cleft - cleft;
                            }
                            edges.emplace_back(num, posOf[i][left[i][j]]);
                            puzzle[i][j] -= cleft;
                            puzzle[i][left[i][j]] -= cleft;
                        }
                        locked[i][j] = true;
                        self(self, num + 1);
                        if (found) {
                            return;
                        }
                        locked[i][j] = false;
                        if (cleft != 0) {
                            for (int y = j - 1; y > left[i][j]; --y) {
                                ans[i][y] = 0;
                            }
                            edges.pop_back();
                            puzzle[i][j] += cleft;
                            puzzle[i][left[i][j]] += cleft;
                        }
                    }
                    if (cdown != 0) {
                        for (int x = i + 1; x < down[i][j]; ++x) {
                            ans[x][j] = 0;
                        }
                        edges.pop_back();
                        puzzle[i][j] += cdown;
                        puzzle[down[i][j]][j] += cdown;
                    }
                }
                if (cright != 0) {
                    for (int y = j + 1; y < right[i][j]; ++y) {
                        ans[i][y] = 0;
                    }
                    edges.pop_back();
                    puzzle[i][j] += cright;
                    puzzle[i][right[i][j]] += cright;
                }
            }
            if (cup != 0) {
                for (int x = i - 1; x > up[i][j]; --x) {
                    ans[x][j] = 0;
                }
                edges.pop_back();
                puzzle[i][j] += cup;
                puzzle[up[i][j]][j] += cup;
            }
        }
    };
    rec(rec, 0);
    assert(found);
    puzzle = ans;
    return true;
}
