#include <bits/stdc++.h>
using namespace std;

const int mod = 1e8 + 543;

struct Modint {
    int x;
    Modint() {}
    Modint(int _x) {
        while (_x >= mod) { _x -= mod; }
        while (_x < 0) { _x += mod; }
        x = _x;
    }
    Modint(long long _x) {
        if (_x >= mod || _x <= -mod) { _x %= mod; }
        if (_x < 0) { _x += mod; }
        x = _x;
    }
    Modint operator+(const Modint& other) const {
        return Modint(x + other.x);
    }
    Modint operator-(const Modint& other) const {
        return Modint(x - other.x);
    }
    Modint operator*(const Modint& other) const {
        return Modint(x * 1ll * other.x);
    }
    Modint operator^(long long k) const {
        Modint tmp = x, res = 1;
        while (k > 0) {
            if (k & 1) {
                res = res * tmp;
            }
            tmp = tmp * tmp;
            k >>= 1;
        }
        return res;
    }
    Modint operator/(const Modint& other) const {
        return *this * (other ^ (mod - 2));
    }
    ~Modint() {}
};

Modint roots[5] = {1405049, 10002474, 36684046, 69727867, 82181655};
Modint c[5] = {4868204, 92161528, 51211683, 37815043, 13944628};

Modint negroots[5] = {18299193, 56689861, 62149668, 71169222, 91693683};
Modint negc[5] = {42100171, 51256142, 65031664, 98856483, 42757173};

Modint getNth(int n) {
    Modint res = 0;
    if (n < 0) {
        n = -n + 4;
        for (int i = 0; i < 5; ++i) {
            res = res + negc[i] * (negroots[i] ^ n);
        }
    } else {
        for (int i = 0; i < 5; ++i) {
            res = res + c[i] * (roots[i] ^ n);
        }
    }
    return res;
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        --l, --r;
        if (type == 1) {
            Modint res = 0;
            for (int i = l; i <= r; ++i) {
                res = res + getNth(a[i]);
            }
            cout << res.x << '\n';
        } else {
            int val;
            cin >> val;
            for (int i = l; i <= r; ++i) {
                a[i] += val;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "-----------\n";
        cout << "-----------\n";
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif
    
    return 0;
}
