#include <bits/stdc++.h>
// #include "ones.h"
using namespace std;
using ll = long long;
const ll mod = 1e8 + 543;

vector<vector<ll>> merge(vector<vector<ll>> a, vector<vector<ll>> b) {
    vector<vector<ll>> ans(a.size(), vector<ll>(b.size()));
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < b[0].size(); j++) {
            for (int k = 0; k < b.size(); k++) {
                ans[i][j] += (a[i][k] * b[k][j]) % mod;
                ans[i][j] %= mod;
            }
        }
    }
    return ans;
}

vector<vector<ll>> binpow(vector<vector<ll>> a, ll step) {
    if (step == 0) {
        return {{1, 0, 0, 0, 0}, {0, 1, 0, 0, 0}, {0, 0, 1, 0, 0}, {0, 0, 0, 1, 0}, {0, 0, 0, 0, 1}};
    }
    if (step == 1) {
        return a;
    }
    vector<vector<ll>> b = binpow(a, step / 2);
    b = merge(b, b);
    if (step % 2) {
        b = merge(b, a);
    }
    return b;
}
struct node {
    vector<ll> pred;
    ll mn = 0;
};
vector<vector<ll>> per = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, 2}, {0, 1, 0, 0, 3}, {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};
node operator+(node a, node b) {
    if (a.mn > b.mn) {
        swap(a, b);
    }
    if (a.mn == b.mn) {
        for (int j = 0; j < 5; j++) {
            a.pred[j] = (a.pred[j] + b.pred[j]) % mod;
        }
        return a;
    }
    vector<vector<ll>> f = binpow(per, b.mn - a.mn);
    for (int j = 0; j < 5; j++) {
        for (int i = 0; i < 5; i++) {
            a.pred[j] += (b.pred[i] * f[j][i]) % mod;
            a.pred[j] %= mod;
        }
    }
    return a;
}
node nei = {{0, 0, 0, 0, 0}, 0};
struct segtree {
    vector<node> tr;
    vector<ll> add;
    ll sz = 1;
    segtree(ll n, vector<ll>& a) {
        while (sz < n) {
            sz *= 2;
        }
        tr.resize(2 * sz - 1);
        add.resize(2 * sz - 1, 0);
        for (int i = sz - 1; i < 2 * sz - 1; i++) {
            tr[i].pred = {1, 0, 0, 0, 0};
            if (i - (sz - 1) < n) {
                tr[i].mn = a[i - (sz - 1)];
            }
        }
        for (int i = sz - 2; i > -1; i--) {
            tr[i] = tr[2 * i + 1] + tr[2 * i + 2];
        }
    }

    void plus(int v, int l, int r, int lseg, int rseg, ll x) {
        if (lseg <= l && r <= rseg) {
            add[v] += x;
            tr[v].mn += x;
            return;
        }
        if (r <= lseg || rseg <= l) {
            return;
        }
        int mid = (r + l) / 2;
        plus(2 * v + 1, l, mid, lseg, rseg, x);
        plus(2 * v + 2, mid, r, lseg, rseg, x);
        tr[v] = tr[2 * v + 1] + tr[2 * v + 2];
        tr[v].mn += add[v];
    }

    void plus(int lseg, int rseg, ll x) {
        plus(0, 0, sz, lseg, rseg, x);
    }

    node sum(int v, int l, int r, int lseg, int rseg) {
        if (lseg <= l && r <= rseg) {
            return tr[v];
        }
        if (r <= lseg || rseg <= l) {
            return nei;
        }
        int mid = (r + l) / 2;
        node m1 = sum(2 * v + 1, l, mid, lseg, rseg);
        node m2 = sum(2 * v + 2, mid, r, lseg, rseg);
        m1 = m1 + m2;
        m1.mn += add[v];
        return m1;
    }

    node sum(int lseg, int rseg) {
        return sum(0, 0, sz, lseg, rseg);
    }
};

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    segtree mach(n, a);
    for (int i = 0; i < q; i++) {
        ll t, l, r, x;
        cin >> t >> l >> r;
        l--;
        if (t == 1) {
            node g = mach.sum(l, r);
            vector<vector<ll>> trans = binpow(per, g.mn);
            ll ans = 0;
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    ans = (ans + g.pred[i] * trans[j][i] * (j)) % mod;
                }
            }
            cout << ans << "\n";
        } else {
            cin >> x;
            mach.plus(l, r, x);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}