#ifndef LOCAL
  #include "ones.h"
#endif 
#include<iostream>
#include<deque>
#include<algorithm>
#include<vector>
#include<map>
#include<random>
#include<time.h>
#include<cassert>
#include<chrono>
#include<set>
#include<unordered_set>
#include<array>

using namespace std;

#define pb push_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

mt19937 rnd(51);

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;
    vector<int> _ones;
    if (0) {
      for (int j = 0; j < k; j++) {
        int val;
        cin >> val;
        _ones.pb(val);
        input[val] = 1;
      }
    } else {
      for (int i = 0; i < k; i++) {
        int pos = rnd() % n + 1;
        while (input[pos]) {
          pos = rnd() % n + 1;
        }
        input[pos] = 1;
        _ones.pb(pos);
      }
    }
    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());
    for (int i : _ones) {
      cout << i << ' ';
    }
    cout << endl;
    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

#endif 

vector<int> ans;

int total_mid = -1;
int cnt = 0, kek;

int solve(int l, int r) {
  if (l == r) {
    cnt++;
    return l;
  }
  int m = (l + r) / 2;
  if (r <= total_mid) {
    if (hasOnes(m + 1, r)) {
      return solve(m + 1, r);
    } else {
      return solve(l, m);
    }
  } else {
    if (hasOnes(l, m)) {
      return solve(l, m);
    } else {
      return solve(m + 1, r);
    }
  }
}

void rec(int l, int r) {
  total_mid = (r + l) / 2;
  int p = solve(l, r);
  ans.pb(p);
  if (cnt < kek && p - 1 >= l && hasOnes(l, p - 1)) {
    rec(l, p - 1);
  }
  if (cnt < kek && p + 1 <= r && hasOnes(p + 1, r)) {
    rec(p + 1, r);
  }
}

vector<int> guessOnes(int n, int K) {
  kek = K;
  ans.clear();
  cnt = 0;
  vector<pair<int, int>> segs;
  int D = 2.3 * kek;
  int cur = 1, d = n / D;
  for (int i = 0; i < D; i++) {
    if (i < n % D) {
      segs.pb({cur, cur + d});
      cur += d + 1;
    } else {
      if (d == 0) continue;
      segs.pb({cur, cur + d - 1});
      cur += d;
    }
  }
  for (auto [l, r] : segs) {
    if (hasOnes(l, r)) {
      ans.pb(solve(l, r));
    }
  }
  sort(all(ans));
  int sz = ans.size();
  if (ans.back() + 1 <= n && cnt < kek && hasOnes(ans.back() + 1, n)) {
    rec(ans.back() + 1, n);
  }
  if (ans[0] > 1 && cnt < kek && hasOnes(1, ans[0] - 1)) {
    rec(1, ans[0] - 1);
  }
  vector<int> ord(sz - 1);
  for (int i = 0; i < sz - 1; i++) {
    ord[i] = i;
  }
  shuffle(all(ord), rnd);
  for (int i : ord) {
    if (cnt < kek) {
      int L = ans[i] + 1, R = ans[i + 1] - 1;
      if (L <= R) {
        if (hasOnes(L, R)) {
          rec(L, R);
        }
      }
    }
  }
  sort(all(ans));
  return ans;
}

#ifdef LOCAL

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        for (int j : guess) {
          cout << j << ' ';
        }
        cout << endl;
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}

#endif 