#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>
#include "ones.h"
//#include "Lgrader_A1.cpp"

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MAGIC = chrono::high_resolution_clock::now().time_since_epoch().count();

struct Hasher
{
    size_t operator()(const pair<int, int>& p) const
    {
        return ((ll) p.first << 32ll) + (p.second ^ MAGIC);
    }
};

vector<int> guessOnes(int n, int k)
{
    unordered_set<pair<int, int>, Hasher> segments;
    for (int i = 1; i <= n; i += (n / k))
    {
        if (hasOnes(i, min(n, i + (n / k) - 1)))
        {
            segments.insert({i, min(n + 1, i + (n / k))});
        }
    }
    vector<int> res;
    while (!segments.empty())
    {
        unordered_set<pair<int, int>, Hasher> news;
        for (pair<int, int> x : segments)
        {
            int l = x.first;
            int r = x.second;
            if (l + 1 == r)
            {
                res.push_back(l);
            }
            else
            {
                int step = max(1, (int) (r - l) / (k - (int) segments.size() + 1));
                for (int i = l; i < r; i += step)
                {
                    if (hasOnes(i, min(r - 1, i + step - 1)))
                    {
                        news.insert({i, min(r, i + step)});
                    }
                }
                /*
                int m = (l + r) / 2;
                if (hasOnes(l, m - 1))
                {
                    news.insert({l, m});
                }
                if (hasOnes(m, r - 1))
                {
                    news.insert({m, r});
                }
                */
            }
        }
        swap(segments, news);
    }
    sort(res.begin(), res.end());
    if (res.size() != k)
        throw(0);
    return res;
}
