#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>
#include "puzzle.h"
//#include "Lgrader_A2.cpp"

using namespace std;

typedef long long ll;
typedef long double ld;

int tests = 1;
double tl = 10;
mt19937 gener(chrono::high_resolution_clock::now().time_since_epoch().count());

void init(int numSubtests, double timeLimit)
{
    tests = numSubtests;
    tl = timeLimit;
}

static void dfs(vector<vector<int>>& p, int i, int j, vector<vector<bool>>& v)
{
    if (i < 0) return;
    if (i >= p.size()) return;
    if (j < 0) return;
    if (j >= p[0].size()) return;

    if (p[i][j] == 0) return;
    if (v[i][j]) return;

    v[i][j] = true;

    dfs(p, i - 1, j, v);
    dfs(p, i + 1, j, v);
    dfs(p, i, j - 1, v);
    dfs(p, i, j + 1, v);
}

bool step(vector<vector<int>>& p, int ind, vector<pair<int, int>>& islands)
{
    if (ind == islands.size())
    {
        vector<vector<bool>> v(p.size(), vector<bool>(p[0].size()));
        bool found = false;
        for (int i = 0; i < p.size(); ++i)
        {
            for (int j = 0; j < p[0].size(); ++j)
            {
                if (p[i][j] == 0) continue;
                if (!found)
                {
                    dfs(p, i, j, v);
                    found = true;
                }
                if (!v[i][j])
                    return false;
            }
        }
        return true;
    }
    int x = islands[ind].first;
    int y = islands[ind].second;
    if (p[x][y] > 4)
        return false;
    int ny = y + 1;
    bool yok = false;
    for (; ny < p[x].size(); ++ny)
    {
        if (p[x][ny] > 0)
        {
            yok = true;
            break;
        }
        if (p[x][ny] < 0)
            break;
    }
    int nx = x + 1;
    bool xok = false;
    for (; nx < p.size(); ++nx)
    {
        if (p[nx][y] > 0)
        {
            xok = true;
            break;
        }
        if (p[nx][y] < 0)
            break;
    }
    int ymax = 0;
    if (yok)
        ymax = min(2, p[x][ny]);
    int xmax = 0;
    if (xok)
        xmax = min(2, p[nx][y]);
    if (p[x][y] > xmax + ymax)
        return false;
    vector<int> xvals;
    for (int xv = max(0, p[x][y] - ymax); xv <= min(xmax, p[x][y]); ++xv)
    {
        xvals.push_back(xv);
    }
    shuffle(xvals.begin(), xvals.end(), gener);
    for (int xv : xvals)
    {
        if (xok)
        {
            p[nx][y] -= xv;
            if (xv > 0)
            {
                for (int i = x + 1; i < nx; ++i)
                {
                    if (xv == 1)
                    {
                        p[i][y] = -2;
                    }
                    else if (xv == 2)
                    {
                        p[i][y] = -4;
                    }
                }
            }
        }
        if (yok)
        {
            int yv = p[x][y] - xv;
            p[x][ny] -= yv;
            if (yv > 0)
            {
                for (int i = y + 1; i < ny; ++i)
                {
                    if (yv == 1)
                    {
                        p[x][i] = -1;
                    }
                    else if (yv == 2)
                    {
                        p[x][i] = -3;
                    }
                }
            }
        }
        if (step(p, ind + 1, islands))
            return true;
        if (xok)
        {
            p[nx][y] += xv;
            if (xv > 0)
            {
                for (int i = x + 1; i < nx; ++i)
                {
                    if (xv == 1)
                    {
                        p[i][y] = 0;
                    }
                    else if (xv == 2)
                    {
                        p[i][y] = 0;
                    }
                }
            }
        }
        if (yok)
        {
            int yv = p[x][y] - xv;
            p[x][ny] += yv;
            if (yv > 0)
            {
                for (int i = y + 1; i < ny; ++i)
                {
                    if (yv == 1)
                    {
                        p[x][i] = 0;
                    }
                    else if (yv == 2)
                    {
                        p[x][i] = 0;
                    }
                }
            }
        }
    }
    return false;
}

bool solve(vector<vector<int>>& puzzle)
{
    vector<pair<int, int>> islands;
    vector<int> values;
    for (int i = 0; i < puzzle.size(); ++i)
    {
        for (int j = 0; j < puzzle[i].size(); ++j)
        {
            if (puzzle[i][j] > 0)
            {
                islands.emplace_back(i, j);
                values.emplace_back(puzzle[i][j]);
            }
        }
    }
    step(puzzle, 0, islands);
    for (int i = 0; i < islands.size(); ++i)
    {
        puzzle[islands[i].first][islands[i].second] = values[i];
    }
    return true;
}
