#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>
#include "puzzle.h"
//#include "Lgrader_A2.cpp"

using namespace std;

typedef long long ll;
typedef long double ld;

int tests = 1;
double tl = 10;
int cnt = 1;
mt19937 gener(chrono::high_resolution_clock::now().time_since_epoch().count());

void init(int numSubtests, double timeLimit)
{
    tests = numSubtests;
    tl = timeLimit;
}

void dfs(vector<vector<int>>& p, int i, int j, vector<vector<int>>& v, vector<vector<bool>>& isl)
{
    if (i < 0) return;
    if (i >= p.size()) return;
    if (j < 0) return;
    if (j >= p[0].size()) return;
    if (p[i][j] == 0 && (!isl[i][j])) return;
    if (v[i][j] == cnt) return;
    v[i][j] = cnt;
    dfs(p, i - 1, j, v, isl);
    dfs(p, i + 1, j, v, isl);
    dfs(p, i, j - 1, v, isl);
    dfs(p, i, j + 1, v, isl);
}

bool dfs2(vector<vector<int>>& p, int i, int j, vector<vector<int>>& v, vector<vector<bool>>& isl)
{
    if (i < 0) return false;
    if (i >= p.size()) return false;
    if (j < 0) return false;
    if (j >= p[0].size()) return false;

    if (p[i][j] == 0 && (!isl[i][j])) return false;
    if (p[i][j] > 0) return true;
    if (v[i][j] == cnt) return false;

    v[i][j] = cnt;

    if (dfs2(p, i - 1, j, v, isl))
        return true;
    if (dfs2(p, i + 1, j, v, isl))
        return true;
    if (dfs2(p, i, j - 1, v, isl))
        return true;
    if (dfs2(p, i, j + 1, v, isl))
        return true;
    return false;
}

bool step(vector<vector<int>>& p, int ind, vector<pair<int, int>>& islands, vector<vector<bool>>& isl, vector<vector<int>>& v)
{
    if (ind == islands.size())
    {
        /*
        vector<vector<bool>> v(p.size(), vector<bool>(p[0].size()));
        bool found = false;
        for (int i = 0; i < p.size(); ++i)
        {
            for (int j = 0; j < p[0].size(); ++j)
            {
                if (p[i][j] == 0 && (!isl[i][j])) continue;
                if (!found)
                {
                    dfs(p, i, j, v, isl);
                    found = true;
                }
                if (!v[i][j])
                    return false;
            }
        }
        */
        return true;
    }
    int x = islands[ind].first;
    int y = islands[ind].second;
    int ny = y + 1;
    bool yok = false;
    for (; ny < p[x].size(); ++ny)
    {
        if (p[x][ny] > 0 || isl[x][ny])
        {
            yok = true;
            break;
        }
        if (p[x][ny] < 0)
            break;
    }
    int nx = x + 1;
    bool xok = false;
    for (; nx < p.size(); ++nx)
    {
        if (p[nx][y] > 0 || isl[nx][y])
        {
            xok = true;
            break;
        }
        if (p[nx][y] < 0)
            break;
    }
    int ymax = 0;
    if (yok)
        ymax = min(2, p[x][ny]);
    int xmax = 0;
    if (xok)
        xmax = min(2, p[nx][y]);
    if (p[x][y] > xmax + ymax)
        return false;
    vector<int> xvals;
    for (int xv = max(0, p[x][y] - ymax); xv <= min(xmax, p[x][y]); ++xv)
    {
        xvals.push_back(xv);
    }
    if ((!xok) || (!yok) || (p[nx][y] > p[ny][x]))
        reverse(xvals.begin(), xvals.end());
    shuffle(xvals.begin(), xvals.end(), gener);
    for (int xv : xvals)
    {
        if (timePassed() > tl - 0.01)
            return false;
        if (xok)
        {
            p[nx][y] -= xv;
            if (xv > 0)
            {
                for (int i = x + 1; i < nx; ++i)
                {
                    if (xv == 1)
                    {
                        p[i][y] = -2;
                    }
                    else if (xv == 2)
                    {
                        p[i][y] = -4;
                    }
                }
            }
        }
        if (yok)
        {
            int yv = p[x][y] - xv;
            p[x][ny] -= yv;
            if (yv > 0)
            {
                for (int i = y + 1; i < ny; ++i)
                {
                    if (yv == 1)
                    {
                        p[x][i] = -1;
                    }
                    else if (yv == 2)
                    {
                        p[x][i] = -3;
                    }
                }
            }
        }
        int pxy = p[x][y];
        p[x][y] = 0;

        ++cnt;
        if (dfs2(p, x, y, v, isl))
        {
            if (step(p, ind + 1, islands, isl, v))
                return true;
        }
        else
        {
            bool ok = true;
            for (int i = ind + 1; i < islands.size(); ++i)
            {
                if (p[islands[i].first][islands[i].second] != 0)
                {
                    ok = false;
                    break;
                }
            }
            //ok = true;
            if (ok)
            {
                if (step(p, ind + 1, islands, isl))
                    return true;
            }
        }

        p[x][y] = pxy;
        if (xok)
        {
            p[nx][y] += xv;
            if (xv > 0)
            {
                for (int i = x + 1; i < nx; ++i)
                {
                    if (xv == 1)
                    {
                        p[i][y] = 0;
                    }
                    else if (xv == 2)
                    {
                        p[i][y] = 0;
                    }
                }
            }
        }
        if (yok)
        {
            int yv = p[x][y] - xv;
            p[x][ny] += yv;
            if (yv > 0)
            {
                for (int i = y + 1; i < ny; ++i)
                {
                    if (yv == 1)
                    {
                        p[x][i] = 0;
                    }
                    else if (yv == 2)
                    {
                        p[x][i] = 0;
                    }
                }
            }
        }
    }
    return false;
}

int neighbours(vector<vector<int>>& p, int x, int y, vector<vector<bool>>& isl)
{
    int res = 0;
    for (int i = x + 1; i < p.size(); ++i)
    {
        if (p[i][y] > 0 || isl[i][y])
        {
            ++res;
            break;
        }
        if (p[i][y] < 0)
            break;
    }
    for (int i = x - 1; i >= 0; --i)
    {
        if (p[i][y] > 0 || isl[i][y])
        {
            ++res;
            break;
        }
        if (p[i][y] < 0)
            break;
    }
    for (int i = y + 1; i < p[0].size(); ++i)
    {
        if (p[x][i] > 0 || isl[x][i])
        {
            ++res;
            break;
        }
        if (p[x][i] < 0)
            break;
    }
    for (int i = y - 1; i >= 0; --i)
    {
        if (p[x][i] > 0 || isl[x][i])
        {
            ++res;
            break;
        }
        if (p[x][i] < 0)
            break;
    }
    return res;
}

void drawall(vector<vector<int>>& p, int x, int y, vector<vector<bool>>& isl)
{
    bool ok = false;
    for (int i = x + 1; i < p.size(); ++i)
    {
        if (p[i][y] > 0 || isl[i][y])
        {
            ok = true;
            break;
        }
        if (p[i][y] < 0)
            break;
    }
    if (ok)
    {
        for (int i = x + 1; i < p.size(); ++i)
        {
            if (p[i][y] > 0 || isl[i][y])
            {
                p[i][y] -= 2;
                break;
            }
            p[i][y] = -4;
        }
    }
    ok = false;
    for (int i = x - 1; i >= 0; --i)
    {
        if (p[i][y] > 0 || isl[i][y])
        {
            ok = true;
            break;
        }
        if (p[i][y] < 0)
            break;
    }
    if (ok)
    {
        for (int i = x - 1; i >= 0; --i)
        {
            if (p[i][y] > 0 || isl[i][y])
            {
                p[i][y] -= 2;
                break;
            }
            p[i][y] = -4;
        }
    }
    ok = false;
    for (int i = y + 1; i < p[0].size(); ++i)
    {
        if (p[x][i] > 0 || isl[x][i])
        {
            ok = true;
            break;
        }
        if (p[x][i] < 0)
            break;
    }
    if (ok)
    {
        for (int i = y + 1; i < p[0].size(); ++i)
        {
            if (p[x][i] > 0 || isl[x][i])
            {
                p[x][i] -= 2;
                break;
            }
            p[x][i] = -3;
        }
    }
    ok = false;
    for (int i = y - 1; i >= 0; --i)
    {
        if (p[x][i] > 0 || isl[x][i])
        {
            ok = true;
            break;
        }
        if (p[x][i] < 0)
            break;
    }
    if (ok)
    {
        for (int i = y - 1; i >= 0; --i)
        {
            if (p[x][i] > 0 || isl[x][i])
            {
                p[x][i] -= 2;
                break;
            }
            p[x][i] = -3;
        }
    }
}

bool solve(vector<vector<int>>& puzzle)
{
    vector<pair<int, int>> islands;
    vector<int> values;
    vector<vector<bool>> isl(puzzle.size(), vector<bool>(puzzle[0].size()));
    for (int i = 0; i < puzzle.size(); ++i)
    {
        for (int j = 0; j < puzzle[i].size(); ++j)
        {
            if (puzzle[i][j] > 0)
            {
                islands.emplace_back(i, j);
                values.emplace_back(puzzle[i][j]);
                isl[i][j] = true;
            }
        }
    }
    for (int i = 0; i < puzzle.size(); ++i)
    {
        for (int j = 0; j < puzzle[i].size(); ++j)
        {
            if (puzzle[i][j] == 8 || 
            (puzzle[i][j] == 6 && neighbours(puzzle, i, j, isl) == 3) ||
            (puzzle[i][j] == 4 && neighbours(puzzle, i, j, isl) == 2) ||
            (puzzle[i][j] == 2 && neighbours(puzzle, i, j, isl) == 1) )
            {
                drawall(puzzle, i, j, isl);
                puzzle[i][j] = 0;
            }
        }
    }
    vector<vector<int>> v(p.size(), vector<int>(p[0].size()));
    step(puzzle, 0, islands, isl, v);
    for (int i = 0; i < islands.size(); ++i)
    {
        puzzle[islands[i].first][islands[i].second] = values[i];
    }
    return true;
}
