﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "Lgrader.cpp"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
vector<int> pa;
#ifdef LOCAL
bool hasOnes(int l, int r) {
    return pa[r] != pa[l - 1];
}
#endif
struct DSU {
    vector<int> p, r, R;
    DSU(int n) : p(n), r(n) {
        iota(p.begin(), p.end(), 0);
        R = p;
    }
    int find(int v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }
    bool join(int a, int b) {
        a = find(a), b = find(b);
        if (a == b) return false;
        if (r[a] < r[b]) swap(a, b);
        p[b] = a;
        if (r[a] == r[b]) r[a]++;
        R[a] = max(R[a], R[b]);
        return true;
    }
    int getR(int v) {
        return R[find(v)];
    }
};
vector<int> guessOnes(int n, int k) {
    DSU dsu(n + 1);
    while (true) {
        vector<int> poss;
        for (int i = 1; i <= n; i++) {
            if (dsu.find(i) == i) {
                poss.push_back(dsu.getR(i));
            }
        }
        shuffle(poss.begin(), poss.end(), rnd);
        vector<int> ends = {0, n};
        for (int i = 0; i < k - 1; i++) ends.push_back(poss[i]);
        sort(ends.begin(), ends.end());
        bool ok = true;
        for (int id = 0; id + 1 < ends.size(); id++) {
            int l = ends[id] + 1, r = ends[id + 1];
            if (!hasOnes(l, r)) {
                ok = false;
                if (l == 0) {
                    dsu.join(r, r + 1);
                } else if (r == n) {
                    dsu.join(l, l - 1);
                } else if (dsu.find(l) != dsu.find(l - 1)) {
                    dsu.join(l, l - 1);
                } else {
                    dsu.join(r, r + 1);
                }
            }
        }
        if (!ok) continue;
        vector<int> ans;
        for (int id = 0; id + 1 < ends.size(); id++) {
            int left = ends[id], right = ends[id + 1];
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (hasOnes(ends[id] + 1, mid)) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            ans.push_back(right);
        }
        return ans;
    }
}
#ifdef LOCAL
void solve_case() {
    int n, k; cin >> n >> k;
    pa.assign(n + 1, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        pa[i + 1] = pa[i] + x;
    }
    debug(guessOnes(n, k));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif