﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "ones.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
vector<int> pa;
#ifdef LOCAL
bool hasOnes(int l, int r) {
    return pa[r] != pa[l - 1];
}
#endif
struct DSU {
    vector<int> p, r, R;
    DSU(int n) : p(n), r(n) {
        iota(p.begin(), p.end(), 0);
        R = p;
    }
    int find(int v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }
    bool join(int a, int b) {
        a = find(a), b = find(b);
        if (a == b) return false;
        if (r[a] < r[b]) swap(a, b);
        p[b] = a;
        if (r[a] == r[b]) r[a]++;
        R[a] = max(R[a], R[b]);
        return true;
    }
    int getR(int v) {
        return R[find(v)];
    }
};
vector<int> guessOnes(int n, int k) {
    DSU dsu(n + 1);
    vector<int> ans;
    int bl = 1 << 13;
    for (int l = 1; l <= n; l += bl) {
        int r = min(n, l + bl - 1);
        if (!hasOnes(l, r)) continue;
        int prv = l - 1;
        while (true) {
            int left = l - 1, right = r;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (prv < mid && hasOnes(prv + 1, mid)) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            prv = right;
            ans.push_back(right);
            if (prv == r) break;
            if (!hasOnes(prv + 1, r)) break;
        }
    }
    return ans;
}
#ifdef LOCAL
void solve_case() {
    int n, k = 0; cin >> n >> k;
    pa.assign(n + 1, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        pa[i + 1] = pa[i] + x;
    }
    debug(1 << 14);
    debug(guessOnes(n, k));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif