﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "ones.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
vector<int> pa;
#ifdef LOCAL
bool hasOnes(int l, int r) {
    return pa[r] != pa[l - 1];
}
#endif
struct DSU {
    vector<int> p, r, R;
    DSU(int n) : p(n), r(n) {
        iota(p.begin(), p.end(), 0);
        R = p;
    }
    int find(int v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }
    bool join(int a, int b) {
        a = find(a), b = find(b);
        if (a == b) return false;
        if (r[a] < r[b]) swap(a, b);
        p[b] = a;
        if (r[a] == r[b]) r[a]++;
        R[a] = max(R[a], R[b]);
        return true;
    }
    int getR(int v) {
        return R[find(v)];
    }
};
vector<int> guessOnes(int n, int k) {
    DSU dsu(n + 1);
    vector<int> ans;
    int bl = n / k;
    function<int(int, int)> solve2 = [&](int l, int r) {
        if (l > r || !hasOnes(l, r)) return 0;
        int z = 0;
        int prv = l - 1;
        while (true) {
            int left = l - 1, right = r;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (prv < mid && hasOnes(prv + 1, mid)) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            prv = right;
            z += 1;
            ans.push_back(right);
            if (prv == r) break;
            if (!hasOnes(prv + 1, r)) break;
        }
        return z;
    };
    function<int(int, int, int)> solve = [&](int l, int r, int ost) {
        if (l > r || !hasOnes(l, r) || ost == 0) return 0;
        int m = (l + r) / 2;
        if (!hasOnes(m, r)) return solve(l, m - 1, ost);
        int left = m - 1, right = r;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (hasOnes(m, mid)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        ans.push_back(right);
        int sl = m - l, sr = r - right;
        int w = 1;
        if (sl < sr) {
            w += solve(l, m - 1, ost - 1);
            if (ost - w <= 5) {
                w += solve2(right + 1, r);
            } else {
                w += solve(right + 1, r, ost - w);
            }
        } else {
            w += solve(right + 1, r, ost - 1);
            if (ost - w <= 5) {
                w += solve2(l, m - 1);
            } else {
                w += solve(l, m - 1, ost - w);
            }
        }
        return w;
    };
    solve(1, n, k);
    sort(ans.begin(), ans.end());
    return ans;
}
#ifdef LOCAL
void solve_case() {
    int n, k = 0; cin >> n >> k;
    pa.assign(n + 1, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        pa[i + 1] = pa[i] + x;
    }
    debug(guessOnes(n, k));
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif