﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "ones.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
vector<int> pa;
int Q = 0;
#ifdef LOCAL
bool hasOnes(int l, int r) {
    Q += 1;
    return pa[r] != pa[l - 1];
}
#endif
struct DSU {
    vector<int> p, r, R;
    DSU(int n) : p(n), r(n) {
        iota(p.begin(), p.end(), 0);
        R = p;
    }
    int find(int v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }
    bool join(int a, int b) {
        a = find(a), b = find(b);
        if (a == b) return false;
        if (r[a] < r[b]) swap(a, b);
        p[b] = a;
        if (r[a] == r[b]) r[a]++;
        R[a] = max(R[a], R[b]);
        return true;
    }
    int getR(int v) {
        return R[find(v)];
    }
};
int cnt = 0;
vector<int> guessOnes(int n, int k) {
    DSU dsu(n + 1);
    vector<int> ans;
    int bl = n / k;
    function<int(int, int, int)> solve2 = [&](int L, int R, int mx) {
        if (L > R || !hasOnes(L, R)) return 0;
        int bl = max(1, (R - L + 1) / mx);
        int z = 0;
        for (int l = L; l <= R; l += bl) {
            int r = min(l + bl - 1, R);
            if (!hasOnes(l, r)) continue;
            int prv = L - 1;
            while (true) {
                int left = L - 1, right = R;
                while (right - left > 1) {
                    int mid = (left + right) / 2;
                    if (prv < mid && hasOnes(prv + 1, mid)) {
                        right = mid;
                    } else {
                        left = mid;
                    }
                }
                prv = right;
                z += 1;
                ans.push_back(right);
                if (prv == R) break;
                if (!hasOnes(prv + 1, R)) break;
            }
        }
        return z;
    };
    function<int(int, int, int)> solve = [&](int l, int r, int ost) {
        ost = min(ost, r - l + 1);
        if (l > r || !hasOnes(l, r) || ost == 0) return 0;
        if (ost == r - l + 1) {
            int w = 0;
            for (int i = l; i <= r; i++) {
                if (hasOnes(i, i)) {
                    ans.push_back(i);
                    w += 1;
                }
            }
            return w;
        }
        if (ost > 100) {
            cnt += 1;
            int bl = (r - l + 1) / 20;
            vector<pair<int, int>> good;
            int emp = 0;
            for (int lx = l; lx <= r; lx += bl) {
                int rx = min(lx + bl - 1, r);
                if (!hasOnes(lx, rx)) {
                    emp += 1;
                } else {
                    good.push_back({lx, rx});
                }
            }
            int w = 0;
            for (auto [lx, rx] : good) w += solve(lx, rx, ost - w);
            return w;
        }
        int m = (l + r) / 2;
        if (!hasOnes(m, r)) return solve(l, m - 1, ost);
        int left = m - 1, right = r;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            if (hasOnes(m, mid)) {
                right = mid;
            } else {
                left = mid;
            }
        }
        ans.push_back(right);
        int w = 1;
        w += solve(right + 1, r, ost - w);
        w += solve(l, m - 1, ost - w);
        return w;
    };
    solve(1, n, k);
    sort(ans.begin(), ans.end());
    return ans;
}
#ifdef LOCAL
void solve_case() {
    int n, k = 0; cin >> n >> k;
    pa.assign(n + 1, 0);
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    shuffle(ord.begin(), ord.end(), rnd);
    for (int i = 0; i < n; i++) {
        int x = 0;
        if (ord[i] < k) x = 1;
        pa[i + 1] = pa[i] + x;
    }
    guessOnes(n, k);
    debug(cnt);
    debug(ld(Q * 100) / 1422396);
    debug(ld(9100103) / 1422396);
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif