﻿#include <bits/stdc++.h>
#ifndef LOCAL
#include "park.h"
#endif
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
ld rnd_double() {
    ll num = rnd() % (100ll * inf);
    return ld(num) / (100ll * inf);
}
void init(int numSubtests, double timeLimit);
bool solve(std::vector<std::vector<int>>& puzzle) {
    int n = puzzle.size(), m = puzzle[0].size();
    vector<pair<int, int>> edg;
    vector<int> need(n * m, 0);
    int want = 0;
    for (int i = 0; i < n; i++) {
        vector<int> in;
        for (int j = 0; j < m; j++) {
            if (puzzle[i][j] == 0) continue;
            need[i * m + j] = puzzle[i][j];
            in.push_back(i * m + j);
            want += need[i * m + j];
        }
        for (int id = 0; id + 1 < in.size(); id++) {
            edg.push_back({in[id], in[id + 1]});
        }
    }
    for (int j = 0; j < m; j++) {
        vector<int> in;
        for (int i = 0; i < m; i++) {
            if (puzzle[i][j] == 0) continue;
            in.push_back(i * m + j);
            want += need[i * m + j];
        }
        for (int id = 0; id + 1 < in.size(); id++) {
            edg.push_back({in[id], in[id + 1]});
        }
    }
    vector<int> score(n * m);
    function<int(int)> score_ver = [&](int v) {
        if (score[v] > need[v]) return 100 * (score[v] - need[v]);
        return (need[v] - score[v]) * (need[v] - score[v]);
    };
    ld temp = 1;
    int cur_score = 0;
    for (int i = 0; i < n * m; i++) cur_score += score_ver(i);
    vector<int> cnt(edg.size());
    function<void(int)> add_edge = [&](int id) {
        int a = edg[id].fi, b = edg[id].se;
        cur_score -= score_ver(a), cur_score -= score_ver(b);
        cnt[id]++;
        score[a]++, score[b]++;
        cur_score += score_ver(a), cur_score += score_ver(b);
    };
    function<void(int)> del_edge = [&](int id) {
        int a = edg[id].fi, b = edg[id].se;
        cur_score -= score_ver(a), cur_score -= score_ver(b);
        cnt[id]--;
        score[a]--, score[b]--;
        cur_score += score_ver(a), cur_score += score_ver(b);
    };
    while (cur_score != 0) {
        int w = rnd() % edg.size();
        int t = rnd() % 2;
        if (cnt[w] == 0 && t == 1) continue; // del
        if (cnt[w] == 2 && t == 0) continue; // add
        int was_score = cur_score;
        if (t == 0) {
            add_edge(w);
        } else {
            del_edge(w);
        }
        //debug(cur_score, cnt);
        if (was_score >= cur_score || rnd_double() < exp((was_score - cur_score) / temp)) {
            // good
        } else {
            if (t == 0) {
                del_edge(w);
            } else {
                add_edge(w);
            }
        }
        temp *= 0.9999999;
    }
    for (int id = 0; id < edg.size(); id++) {
        if (cnt[id] == 0) continue;
        int a = edg[id].fi, b = edg[id].se;
        if (a / m == b / m) {
            int i = a / m;
            int l = a % m, r = b % m;
            for (int j = l + 1; j < r; j++) {
                if (cnt[id] == 1) {
                    puzzle[i][j] = -1;
                } else {
                    puzzle[i][j] = -2;
                }
            }
        } else {
            int l = a / m, r = b / m;
            int j = a % m;
            for (int i = l + 1; i < r; i++) {
                if (cnt[id] == 1) {
                    puzzle[i][j] = -3;
                } else {
                    puzzle[i][j] = -4;
                }
            }
        }
    }
    return true;
}
void solve_case() {
    vector<vector<int>> puzzle = {{ 0, 0, 2, 0, 3, 0, 3},
                                  { 4, 0, 0, 0, 0, 2, 0},
                                  { 0, 0, 0, 0, 0, 0, 0},
                                  { 6, 0, 0, 0, 0, 2, 0},
                                  { 0, 0, 0, 0, 0, 0, 0},
                                  { 0, 0, 0, 0, 0, 0, 0},
                                  { 4, 0, 0, 0, 0, 0, 4}};
    solve(puzzle);
    int n = puzzle.size(), m = puzzle[0].size();
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (puzzle[i][j] >= 0) cout << " ";
            cout << puzzle[i][j] << " ";
        }
        cout << "\n";
    }
}
#ifdef LOCAL
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
#endif