﻿#include <bits/stdc++.h>

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a + b;
}
struct Fenwick {
    vector<int> tree;
    int n;
    Fenwick(int _n) : n(_n), tree(_n) {}
    void update(int pos, int val) {
        for (; pos < n; pos |= (pos + 1)) {
            tree[pos] = add(tree[pos], val);
        }
    }
    int query(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans = add(ans, tree[r]);
        }
        return ans;
    }
};
void solve_case() {
    int n, q; cin >> n >> q;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    Fenwick fnw(n);
    function<int(ll)> calc_val = [&](ll v) {
        array<int, 5> X = {0, 1, 2, 3, 4};
        array<array<int, 5>, 5> a({0});
        if (v > 0) {
            a[1][0] = a[2][1] = a[3][2] = a[4][3] = 1;
            a[0][4] = 1;
            a[1][4] = 2;
            a[2][4] = 3;
            a[3][4] = 4;
            a[4][4] = 5;
        } else {
            v = abs(v);
            a[0][1] = a[1][2] = a[2][3] = a[3][4] = 1;
            a[0][0] = sub(0, 2);
            a[1][0] = sub(0, 3);
            a[2][0] = sub(0, 4);
            a[3][0] = sub(0, 5);
            a[4][0] = 1;
        }
        while (v) {
            if (v & 1) {
                array<int, 5> nX = {0, 0, 0, 0, 0};
                for (int j = 0; j < 5; j++) {
                    ll sum = 0;
                    for (int i = 0; i < 5; i++) {
                        sum += 1ll * X[i] * a[i][j];
                    }
                    nX[j] = sum % mod;
                }
                X = nX;
            }
            array<array<int, 5>, 5> b({0});
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    ll sum = 0;
                    for (int k = 0; k < 5; k++) {
                        sum += 1ll * a[i][k] * a[k][j];
                    }
                    b[i][j] = sum % mod;
                }
            }
            a = b;
            v >>= 1;
        }
        return X[0];
    };
    vector<int> val(n);
    vector<int> X = {0, 1, 2, 3, 4};
    for (int i = 0; i < n; i++) {
        val[i] = calc_val(a[i]);
        while (X.size() <= a[i]) {
            int w = X.size();
            ll s = 5ll * X[w - 1] + 4ll * X[w - 2] + 3ll * X[w - 3] + 2ll * X[w - 4] + X[w - 5];
            X.push_back(s % mod);
        }
        assert(X[a[i]] == val[i]);
        fnw.update(i, val[i]);
    }
    for (int iq = 0; iq < q; iq++) {
        int t, l, r; cin >> t >> l >> r; l--, r--;
        if (t == 1) {
           int ans = 0;
           for (int i = l; i <= r; i++) ans = add(ans, val[i]);
           cout << ans << "\n";
        } else {
            int v; cin >> v;
            for (int i = l; i <= r; i++) {
                a[i] += v;
                val[i] = calc_val(a[i]);
            }
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
