﻿#include <bits/stdc++.h>

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = 100000000 + 543;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}
int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int sub(int a, int b) {
    if (a - b < 0) return a - b + mod;
    return a + b;
}

const int L = 32, B = 8;
array<array<int, 5>, 5> positive[L], negative[L];
array<array<int, 5>, 5> mask_p[L / B][1 << B], mask_n[L / B][1 << B];
array<array<int, 5>, 5> get_matrix(int v) {
    array<array<int, 5>, 5> ans({0});
    for (int i = 0; i < 5; i++) {
        ans[i][i] = 1;
    }
    if (v >= 0) {
        for (int layer = 0; layer < L / B; layer++) {
            array<array<int, 5>, 5> nans({0});
            int mask = (v >> (layer * B)) & ((1 << B) - 1);
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    ll sum = 0;
                    for (int k = 0; k < 5; k++) {
                        sum += 1ll * ans[i][k] * mask_p[layer][mask][k][j];
                    }
                    nans[i][j] = sum % mod;
                }
            }
            ans = nans;
        }
    } else {
        v = abs(v);
        for (int layer = 0; layer < L / B; layer++) {
            array<array<int, 5>, 5> nans({0});
            int mask = (v >> (layer * B)) & ((1 << B) - 1);
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    ll sum = 0;
                    for (int k = 0; k < 5; k++) {
                        sum += 1ll * ans[i][k] * mask_n[layer][mask][k][j];
                    }
                    nans[i][j] = sum % mod;
                }
            }
            ans = nans;
        }
    }
    return ans;
}
const int N = 1e5 + 52;
array<array<int, 5>, 5> md[4 * N];
array<int, 5> tree[4 * N];
void build(int v, int l, int r) {
    if (l == r - 1) {
        for (int i = 0; i < 5; i++) {
            tree[v][i] = i;
        }
    } else {
        int m = (l + r) / 2;
        build(2 * v, l, m), build(2 * v + 1, m, r);
        for (int i = 0; i < 5; i++) {
            tree[v][i] = add(tree[2 * v][i], tree[2 * v + 1][i]);
        }
    }
    for (int i = 0; i < 5; i++) {
        md[v][i][i] = 1;
    }
}
void add(int v, int l, int r, int ql, int qr, array<array<int, 5>, 5> &mat) {
    if (l >= qr || ql >= r) return;
    if (ql <= l && r <= qr) {
        array<array<int, 5>, 5> nw;
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                ll sum = 0;
                for (int k = 0; k < 5; k++) {
                    sum += 1ll * md[v][i][k] * mat[k][j];
                }
                nw[i][j] = sum % mod;
            }
        }
        md[v] = nw;
        array<int, 5> ntree;
        for (int j = 0; j < 5; j++) {
            ll sum = 0;
            for (int i = 0; i < 5; i++) {
                sum += 1ll * tree[v][i] * mat[i][j];
            }
            ntree[j] = sum % mod;
        }
        tree[v] = ntree;
    } else {
        int m = (l + r) / 2;
        add(2 * v, l, m, ql, qr, mat);
        add(2 * v + 1, m, r, ql, qr, mat);
        for (int i = 0; i < 5; i++) {
            tree[v][i] = add(tree[2 * v][i], tree[2 * v + 1][i]);
        }
        array<int, 5> ntree;
        for (int j = 0; j < 5; j++) {
            ll sum = 0;
            for (int i = 0; i < 5; i++) {
                sum += 1ll * tree[v][i] * md[v][i][j];
            }
            ntree[j] = sum % mod;
        }
        tree[v] = ntree;
    }

}
array<int, 5> query(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) return tree[0];
    if (ql <= l && r <= qr) return tree[v];
    int m = (l + r) / 2;
    array<int, 5> ret_l = query(2 * v, l, m, ql, qr);
    array<int, 5> ret_r = query(2 * v, l, m, ql, qr);
    array<int, 5> ret;
    for (int i = 0; i < 5; i++) ret[i] = ret_l[i] + ret_r[i];
    array<int, 5> ntree;
    for (int j = 0; j < 5; j++) {
        ll sum = 0;
        for (int i = 0; i < 5; i++) {
            sum += 1ll * ret[i] * md[v][i][j];
        }
        ntree[j] = sum % mod;
    }
    return ntree;
}
void solve_case() {
    {
        array<array<int, 5>, 5> a({0});
        a[1][0] = a[2][1] = a[3][2] = a[4][3] = 1;
        a[0][4] = 1;
        a[1][4] = 2;
        a[2][4] = 3;
        a[3][4] = 4;
        a[4][4] = 5;
        positive[0] = a;
    }
    {
        array<array<int, 5>, 5> a({0});
        a[0][1] = a[1][2] = a[2][3] = a[3][4] = 1;
        a[0][0] = sub(0, 2);
        a[1][0] = sub(0, 3);
        a[2][0] = sub(0, 4);
        a[3][0] = sub(0, 5);
        a[4][0] = 1;
        negative[0] = a;
    }
    for (int id = 1; id < L; id++) {
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                ll sum = 0;
                for (int k = 0; k < 5; k++) {
                    sum += 1ll * positive[id - 1][i][k] * positive[id - 1][k][j];
                }
                positive[id][i][j] = sum % mod;
            }
        }
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                ll sum = 0;
                for (int k = 0; k < 5; k++) {
                    sum += 1ll * negative[id - 1][i][k] * negative[id - 1][k][j];
                }
                negative[id][i][j] = sum % mod;
            }
        }
    }
    for (int id = 0, l = 0; l < L; id++, l += B) {
        for (int mask = 0; mask < (1 << B); mask++) {
            for (int i = 0; i < 5; i++) {
                mask_p[id][mask][i][i] = 1;
            }
            for (int w = 0; w < B; w++) {
                if ((mask >> w) & 1) {
                    array<array<int, 5>, 5> matr({0});
                    for (int i = 0; i < 5; i++) {
                        for (int j = 0; j < 5; j++) {
                            ll sum = 0;
                            for (int k = 0; k < 5; k++) {
                                sum += 1ll * mask_p[id][mask][i][k] * positive[w + l][k][j];
                            }
                            matr[i][j] = sum % mod;
                        }
                    }
                    mask_p[id][mask] = matr;
                }
            }
        }
        for (int mask = 0; mask < (1 << B); mask++) {
            for (int i = 0; i < 5; i++) {
                mask_n[id][mask][i][i] = 1;
            }
            for (int w = 0; w < B; w++) {
                if ((mask >> w) & 1) {
                    array<array<int, 5>, 5> matr({0});
                    for (int i = 0; i < 5; i++) {
                        for (int j = 0; j < 5; j++) {
                            ll sum = 0;
                            for (int k = 0; k < 5; k++) {
                                sum += 1ll * mask_n[id][mask][i][k] * negative[w + l][k][j];
                            }
                            matr[i][j] = sum % mod;
                        }
                    }
                    mask_n[id][mask] = matr;
                }
            }
        }
    }
    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    build(1, 0, n);
    for (int i = 0; i < n; i++) {
        auto mt = get_matrix(a[i]);
        add(1, 0, n, i, i + 1, mt);
    }
    for (int iq = 0; iq < q; iq++) {
        int t, l, r; cin >> t >> l >> r; l--, r--;
        if (t == 1) {
            auto ret = query(1, 0, n, l, r + 1);
            cout << ret[0] << "\n";
        } else {
            int v; cin >> v;
            auto mt = get_matrix(v);
            add(1, 0, n, l, r + 1, mt);
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
