#pra\
gma GCC optimize("Ofast")
#pra\
gma target("avx,avx2")

#include <bits/stdc++.h>


template<class t>
using vc = std::vector<t>;
typedef long double ld;

using namespace std;


// vc<vc<int> > ok = {
//     {40, 1, 0, 0, 0, 0},
//     {5, 0, 1, 0, 0, 0},
//     {4, 0, 0, 1, 0, 0},
//     {3, 0, 0, 0, 1, 0},
//     {2, 0, 0, 0, 0, 1},
//     {1, 0, 0, 0, 0, 0}
// };

vc<vc<int> > ok = {
    {5, 4, 3, 2, 1}, //40
    {1, 0, 0, 0, 0}, //4
    {0, 1, 0, 0, 0}, //3
    {0, 0, 1, 0, 0}, //2
    {0, 0, 0, 1, 0}, //1
};

typedef long long ll;

const int MOD = 1e8 + 543;

struct matrix {
    int a[5][5]{};

    int *operator[](size_t i) { return a[i]; }

    matrix(int h = 1) {
        a[0][0] = a[1][1] = a[2][2] = a[3][3] = a[4][4] = h;
    }

    friend matrix operator*(matrix &x, matrix &y) {
        matrix ans(0);
        matrix s;
        for (int i = 0; i < 5; ++i) for (int j = 0; j < 5; ++j) s[j][i] = y[i][j];
        for (int i = 0; i < 5; ++i) {
            for (int j = 0; j < 5; ++j) {
                ll ss = 0;
#pra\
gma ivdep
                for (int k = 0; k < 5; ++k) {
                    ss += (ll) x[i][k] * s[j][k];
                }
                ans[i][j] = ss % MOD;
            }
        }
        return ans;
    }

    friend matrix operator+(matrix x, matrix &y) {
        for (int i = 0; i < 5; ++i) {
#pra\
gma ivdep
            for (int j = 0; j < 5; ++j) {
                x[i][j] = (x[i][j] + y[i][j]) % MOD;
            }
        }
        return x;
    }

    bool operator==(matrix &x) const {
#pra\
gma ivdep
        for (int i = 0; i < 5; ++i) for (int j = 0; j < 5; ++j) if (a[i][j] != x[i][j]) return false;
        return true;
    }
};

matrix base;

matrix flix[30];

matrix pw(int c) {
    matrix ans;
    if (c <= 0) return ans;
    for (int i = 0; i < 30; ++i) if (c >> i & 1) ans = ans * flix[i];
    return ans;
}

void print(matrix c) {
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            cout << c[i][j] << ' ';
        }
        cout << '\n';
    }
}

vc<vc<int> > zo = {
    {40}, {4}, {3}, {2}, {1}
};

ll get(matrix w) {
    ll ans = 0;
    for (int k = 0; k < 5; ++k) ans += (ll) w[0][k] * zo[k][0];
    return ans % MOD;
}

const int N = 1e5 + 5;
matrix t[N * 4];
matrix mod[N * 4];

matrix z;
void push(int l, int r, int v) {
    if (mod[v] == z) return;
    t[v] = t[v] * mod[v];
    if (l != r) mod[v * 2] = mod[v * 2] * mod[v], mod[v * 2 + 1] = mod[v * 2 + 1] * mod[v];
    mod[v] = 1;
}

matrix x;
void modify(int l_, int r_, int l = 0, int r = N - 1, int v = 1) {
    if (l_ <= l && r <= r_) return mod[v] = mod[v] * x, push(l, r, v);
    push(l, r, v);
    if (r_ < l || r < l_) return;
    int mid = (l + r) / 2;
    modify(l_, r_, l, mid, v * 2), modify(l_, r_, mid + 1, r, v * 2 + 1);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

ll ask(int l_, int r_, int l = 0, int r = N - 1, int v = 1) {
    if (r_ < l || r < l_) return 0;
    push(l, r, v);
    if (l_ <= l && r <= r_) return get(t[v]);
    int mid = (l + r) / 2;
    return
            ask(l_, r_, l, mid, v * 2) +
            ask(l_, r_, mid + 1, r, v * 2 + 1);
}

vc<int> o;

void build(int l = 0, int r = N - 1, int v = 1) {
    if (l == r && l >= o.size()) return;
    if (l == r) return void(t[v] = pw(o[l]));
    int mid = (l + r) / 2;
    build(l, mid, v * 2), build(mid + 1, r, v * 2 + 1);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    for (int i = 0; i < 5; ++i) for (int j = 0; j < 5; ++j) base[i][j] = ok[i][j];
    // print(pw(base, MOD - 3));
    // cout.flush();
    // cout << get(pw(base, MOD - 5)) << endl;;
    int n = 1, q = 100000;
    cin >> n >> q;
    o.resize(n);
    int s = 0;
    flix[0] = base;
    set<int> bib;
    for (int i = 1; i < 30; ++i) flix[i] = flix[i - 1] * flix[i - 1];
    const int zex = MOD - 1;
    for (auto &i: o) cin >> i, i -= 5, i %= zex, i += zex, i %= zex;
    build();
    vc<int> z = {0, 1, 2, 3, 4, 40};
    for (int t; q-- && cin >> t;) {
        if (t == 1) {
            int l = 0, r = 0;
            cin >> l >> r, --l, --r;
            ll ans = 0;
            cout << ask(l, r) % MOD << '\n';
        } else {
            int l, r, x;
            cin >> l >> r >> x, --l, --r;
            x %= zex;
            if (x < 0) x += zex;
            ::x = pw(x);
            modify(l, r);
        }
    }
}

// 84677809
// 8215574
// 65977619