#include<bits/stdc++.h>
#include"puzzle.h"

using namespace std;

double TL;
int remtests;

void init(int numTests, double TL_) {
    remtests = numTests;
    TL = TL_;
}

mt19937 rng(time(0));


bool solve(vector<vector<int>>& puzzle) {
    double st = timePassed();
    double TIME = (TL - timePassed()) / remtests-- - 0.1;
    int n = puzzle.size(), m = puzzle[0].size();
    vector<pair<int, int>> pos;
    vector<vector<int>> num(n, vector<int>(m, -1));
    int sum = 0;
    for (auto i : puzzle) {
        for (auto j : i) {
            sum += j;
        }
    }
    if (sum & 1) return false;
    sum /= 2;
    {
        int ptr = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (puzzle[i][j]) {
                    pos.emplace_back(i, j);
                    num[i][j] = ptr++;
                }
            }
        }
    }
    int c = pos.size();
    vector<pair<int, int>> edg;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!puzzle[i][j]) continue;
            for (int k = i + 1; k < n; ++k) {
                if (puzzle[k][j]) {
                    edg.emplace_back(num[i][j], num[k][j]);
                    edg.emplace_back(num[i][j], num[k][j]);
                    break;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!puzzle[i][j]) continue;
            for (int k = j + 1; k < m; ++k) {
                if (puzzle[i][k]) {
                    edg.emplace_back(num[i][j], num[i][k]);
                    edg.emplace_back(num[i][j], num[i][k]);
                    break;
                }
            }
        }
    }
    shuffle(edg.begin(), edg.end(), rng);
    auto go = [&]() -> int {
        vector<int> cnt(c);
        vector<pair<int, int>> used;
        for (auto [x, y] : edg) {
            if (cnt[x] == puzzle[pos[x].first][pos[x].second] || cnt[y] == puzzle[pos[y].first][pos[y].second]) continue;
            bool ok = true;
            pair<int, int> xx = minmax(pos[x].first, pos[y].first);
            auto [lx, rx] = xx;
            if (lx < rx) lx++, rx--;
            pair<int, int> yy = minmax(pos[x].second, pos[y].second);
            auto [ly, ry] = yy;
            if (ly < ry) ly++, ry--;
            for (auto [x_, y_] : used) {
                if (x == x_ && y == y_) continue;
                pair<int, int> xx_ = minmax(pos[x_].first, pos[y_].first);
                auto [lx_, rx_] = xx_;
                if (lx_ < rx_) lx_++, rx_--;
                pair<int, int> yy_ = minmax(pos[x_].second, pos[y_].second);
                auto [ly_, ry_] = yy_;
                if (ly_ < ry_) ly_++, ry_--;
                if (!(rx < lx_ || rx_ < lx) && !(ry < ly_ || ry_ < ly)) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                used.emplace_back(x, y);
                cnt[x]++;
                cnt[y]++;
            }
        }
        return sum - used.size();
    };
    shuffle(edg.begin(), edg.end(), rng);
    int cur = go();
    double temp = 1;
    double dt = 0.99;
    while (cur != 0 && (timePassed() - st) <= TIME) {
        int x = rng() % edg.size(), y = rng() % edg.size();
        swap(edg[x], edg[y]);
        int nw = go();
        if (nw < cur || (double)rng() / UINT_MAX <= temp) {
            cur = nw;
        } else {
            swap(edg[x], edg[y]);
        }
    }
    if (cur != 0) return false;
    else {
        vector<int> cnt(c);
        vector<pair<int, int>> used;
        for (auto [x, y] : edg) {
            if (cnt[x] == puzzle[pos[x].first][pos[x].second] || cnt[y] == puzzle[pos[y].first][pos[y].second]) continue;
            bool ok = true;
            pair<int, int> xx = minmax(pos[x].first, pos[y].first);
            auto [lx, rx] = xx;
            if (lx < rx) lx++, rx--;
            pair<int, int> yy = minmax(pos[x].second, pos[y].second);
            auto [ly, ry] = yy;
            if (ly < ry) ly++, ry--;
            for (auto [x_, y_] : used) {
                if (x == x_ && y == y_) continue;
                pair<int, int> xx_ = minmax(pos[x_].first, pos[y_].first);
                auto [lx_, rx_] = xx_;
                if (lx_ < rx_) lx_++, rx_--;
                pair<int, int> yy_ = minmax(pos[x_].second, pos[y_].second);
                auto [ly_, ry_] = yy_;
                if (ly_ < ry_) ly_++, ry_--;
                if (!(rx < lx_ || rx_ < lx) && !(ry < ly_ || ry_ < ly)) {
                    ok = false;
                    break;
                }
            }
            if (ok) {
                used.emplace_back(x, y);
                cnt[x]++;
                cnt[y]++;
            }
        }
        for (auto [x, y] : used) {
            bool horiz = false;
            pair<int, int> xx = minmax(pos[x].first, pos[y].first);
            auto [lx, rx] = xx;
            if (lx < rx) lx++, rx--;
            pair<int, int> yy = minmax(pos[x].second, pos[y].second);
            auto [ly, ry] = yy;
            if (ly < ry) ly++, ry--, horiz = true;
            for (int i = lx; i <= rx; ++i) {
                for (int j = ly; j <= ry; ++j) {
                    if (puzzle[i][j] == 0) puzzle[i][j] = -1 - !horiz;
                    else puzzle[i][j] -= 2;
                }
            }
        }
        return true;
    }
}