#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int mod = 1e8 + 543;

using mat = array<array<int, 5>, 5>;
using mat2 = array<int, 5>;
mat null() {
    mat res;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = 0;
        }
    }
    return res;
}
mat e() {
    mat res;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = i == j;
        }
    }
    return res;
}
mat operator*(mat& a, mat& b) {
    array<array<ll, 5>, 5> c;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) c[i][j] = 0;
    }
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            for (int k = 0; k < 5; ++k) {
                c[i][k] += 1ll * a[i][j] * b[j][k];
            }
        }
    }
    array<array<int, 5>, 5> c_;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            c_[i][j] = c[i][j] % mod;
        }
    }
    return c_;
}
mat2 operator+(mat2& a, mat2& b) {
    mat2 c;
    for (int i = 0; i < 5; ++i) {
        c[i] = (a[i] + b[i]);
        if (c[i] >= mod) c[i] -= mod;
    }
    return c;
}
mat2 operator*(mat2& bim, mat bam) {
    array<ll, 5> res;
    res.fill(0);
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[j] += 1ll * bim[i] * bam[i][j];
        }
    }
    array<int, 5> res_;
    for (int i = 0; i < 5; ++i) res_[i] = res[i] % mod;
    return res_;
}
mat nxt, prv;
mat2 start;

const int A = 1e6 + 1;

mat precalc_nxt[A];

mat power(mat m, int b) {
    mat res = e();
    for (; b; b >>= 1, m = m * m) if (b & 1) res = res * m;
    return res;
}
mat get(int x) {
    if (x < 0) return power(prv, -x);
    else return precalc_nxt[x];
}
const int N = 1e5;
int n;
int a[N];
mat2 tr[4 * N];
mat upd[4 * N];

void apply(int node, mat m) {
    tr[node] = tr[node] * m;
    upd[node] = upd[node] * m;
}

void build(int node = 1, int l = 0, int r = n - 1) {
    if (l == r) {
        tr[node] = start * get(a[l]);
        return;
    } else {
        int mid = (l + r) / 2;
        build(node << 1, l, mid);
        build(node << 1 | 1, mid + 1, r);
        tr[node] = tr[node << 1] + tr[node << 1 | 1];
    }
}

void update(int ql, int qr, mat m, int node = 1, int l = 0, int r = n - 1) {
    if (r < ql || qr < l) return;
    if (ql <= l && r <= qr) {
        apply(node, m);
        return;
    }
    apply(node << 1, upd[node]);
    apply(node << 1 | 1, upd[node]);
    upd[node] = e();
    int mid = (l + r) / 2;
    update(ql, qr, m, node << 1, l, mid);
    update(ql, qr, m, node << 1, mid + 1, r);
    tr[node] = tr[node << 1] + tr[node << 1 | 1];
}

ll get(int ql, int qr, int node = 1, int l = 0, int r = n - 1) {
    if (r < ql || qr < l) return 0;
    if (ql <= l && r <= qr) {
        return tr[node][0];
    }
    apply(node << 1, upd[node]);
    apply(node << 1 | 1, upd[node]);
    upd[node] = e();
    int mid = (l + r) / 2;
    return get(ql, qr, node << 1, l, mid) + get(ql, qr, node << 1 | 1, mid + 1, r);
}
int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            if (j == 4) nxt[i][j] = i + 1;
            else nxt[i][j] = j == i - 1;
        }
    }
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            if (j == 0) {
                prv[i][j] = i < 4 ? -(i + 2) + mod : 1;
            } else {
                prv[i][j] = j == i + 1;
            }
        }
    }
    precalc_nxt[0] = e();
    for (int i = 1; i < A; ++i) {
        precalc_nxt[i] = precalc_nxt[i - 1] * nxt;
    }

    iota(start.begin(), start.end(), 0);
    int q;
    cin >> n >> q;
    fill(tr, tr + 4 * n, start);
    fill(upd, upd + 4 * n, e());
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build();
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            --l, --r;
            cout << get(l, r) << '\n';
        } else {
            int l, r, x;
            cin >> l >> r >> x;
            --l, --r;
            update(l, r, get(x));
        }
    }
}