#pra\
gma GCC optimize("O3")
#pra\
gma GCC target("avx,avx2")

#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const int mod = 1e8 + 543;
using mat = array<array<int, 5>, 5>;
using mat2 = array<int, 5>;
mat null() {
    mat res;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = 0;
        }
    }
    return res;
}
mat e() {
    mat res;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = i == j;
        }
    }
    return res;
}
mat operator*(mat& a, mat& b) {
    array<array<ll, 5>, 5> c;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) c[i][j] = 0;
    }
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            for (int k = 0; k < 5; ++k) {
                c[i][k] += 1ll * a[i][j] * b[j][k];
            }
        }
    }
    array<array<int, 5>, 5> c_;
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            c_[i][j] = c[i][j] % mod;
        }
    }
    return c_;
}
mat2 operator+(mat2& a, mat2& b) {
    mat2 c;
    for (int i = 0; i < 5; ++i) {
        c[i] = (a[i] + b[i]);
        if (c[i] >= mod) c[i] -= mod;
    }
    return c;
}
mat2 operator*(mat2& bim, mat bam) {
    array<ll, 5> res;
    res.fill(0);
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[j] += 1ll * bim[i] * bam[i][j];
        }
    }
    array<int, 5> res_;
    for (int i = 0; i < 5; ++i) res_[i] = res[i] % mod;
    return res_;
}
mat nxt, prv;
mat2 start;
const int Q = 11;
const int A = (mod >> Q) + 1;
mat precalc_nxt[A], precalc_prv[A];
mat get(int x) {
    if (x < 0) {
        x = -x;
        mat res = precalc_prv[x >> Q];
        for (int i = Q - 1; i >= 0; --i) {
            res = res * res;
            if (x >> i & 1) res = res * prv;
        }
        return res;
    } else {
        mat res = precalc_nxt[x >> Q];
        for (int i = Q - 1; i >= 0; --i) {
            res = res * res;
            if (x >> i & 1) res = res * nxt;
        }
        return res;
    }
}
const int N = 1e5 + 100;
int n;
int a[N];
mat2 tr[2 * N];
mat upd[2 * N];
void apply(int node, mat m) {
    tr[node] = tr[node] * m;
    upd[node] = upd[node] * m;
}
void push(int node) {
    apply(node << 1, upd[node]);
    apply(node << 1 | 1, upd[node]);
    upd[node] = e();
}
void build() {
    fill(upd, upd + 2 * n, e());
    for (int i = 0; i < n; ++i) tr[i + n] = start * get(a[i]);
    for (int i = n - 1; i; --i) tr[i] = tr[i << 1] + tr[i << 1 | 1];
}
void tpush(int node) {
    for (int k = 20; k; --k) {
        push(node >> k);
    }
}
void tpull(int node) {
    for (; node > 1; node >>= 1, tr[node] = tr[node << 1] + tr[node << 1 | 1], tr[node] = tr[node] * upd[node]);
}
int get(int l, int r) {
    ll res = 0;
    for (tpush(l += n), tpush(r += n); l <= r; l >>= 1, r >>= 1) {
        if (l & 1) res += tr[l++][0];
        if (~r & 1) res += tr[r--][0];
    }
    return res % mod;
}
void update(int l, int r, mat m) {
    int sl = l += n, sr = r += n;
    for (; l <= r; l >>= 1, r >>= 1) {
        if (l & 1) apply(l++, m);
        if (~r & 1) apply(r--, m);
    }
    tpull(sl);
    tpull(sr);
}
int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            if (j == 4) nxt[i][j] = i + 1;
            else nxt[i][j] = j == i - 1;
        }
    }
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            if (j == 0) {
                prv[i][j] = i < 4 ? -(i + 2) + mod : 1;
            } else {
                prv[i][j] = j == i + 1;
            }
        }
    }
    precalc_prv[0] = precalc_nxt[0] = e();
    for (int i = 1; i < A; ++i) {
        precalc_nxt[i] = precalc_nxt[i - 1] * nxt;
        precalc_prv[i] = precalc_prv[i - 1] * prv;
    }
    iota(start.begin(), start.end(), 0);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    build();
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            --l, --r;
            cout << get(l, r) << '\n';
        } else {
            int l, r, x;
            cin >> l >> r >> x;
            --l, --r;
            update(l, r, get(x));
        }
    }
}