#include <iostream>
#include<bits/stdc++.h>
using namespace std;
const int INF = 1e8 + 543;
vector<vector<int> > inc_mat;
vector<vector<int> > dec_mat;
vector<int> start_mat;
vector<vector<int> > bin_pow(const vector<vector<int> > &mat, int b){
    vector<vector<int> > ans(5, vector<int>(5, 0));
    if(b == 0){
        for(int i = 0; i < 5; i++) ans[i][i] = 1;
        return ans;
    }
    if(b % 2){
        vector<vector<int> > c = bin_pow(mat, b - 1);
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++){
                for(int k = 0; k < 5; k++){
                    ans[i][j] += (mat[i][k] * 1ll * c[k][j]) % INF;
                    ans[i][j] += INF;
                    ans[i][j] %= INF;
                }
            }
        }
        return ans;
    }
    else{
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++){
                for(int k = 0; k < 5; k++){
                    ans[i][j] += (mat[i][k] * 1ll * mat[k][j]) % INF;
                    ans[i][j] += INF;
                    ans[i][j] %= INF;
                }
            }
        }
        return bin_pow(ans, b / 2);
    }
}
vector<vector<vector<int> > > t;
vector<int> p;
vector<int> a;
void merge(const vector<vector<int> > &l, const vector<vector<int> > &r, vector<vector<int> > &c){
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
           c[i][j] = l[i][j] + r[i][j];
            c[i][j] += INF;
            c[i][j] %= INF;
        }
    }
}
vector<vector<int> > mul(const vector<vector<int> > &a, const vector<vector<int> > &b){
    vector<vector<int> > ans(5, vector<int>(5, 0));
    for(int i = 0; i< 5; i++){
        for(int j = 0; j < 5; j++){
            for(int k = 0; k < 5; k++){
                ans[i][j] += (a[i][k] * 1ll * b[k][j]) % INF;
                ans[i][j] += INF;
                ans[i][j] %= INF;
            }
        }
    }
    return ans;
}
void push(int v, int l, int r){
    if(p[v] == 0) return;
    if(p[v] < 0){
        t[v] = mul(t[v], bin_pow(dec_mat, -p[v]));
    }
    else{
        t[v] = mul(t[v], bin_pow(inc_mat, p[v]));
    }
    if(l != r){
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }
    p[v] = 0;
}
void build(int v, int l, int r){
    if(l == r){
        int d = a[l] - 4;
        if(d >= 0){
            t[v] = bin_pow(inc_mat, d);
        }
        else{
            t[v] = bin_pow(dec_mat, -d);
        }
        return;
    }
    int mid = (l + r) >> 1;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);
    merge(t[v * 2], t[v * 2 + 1], t[v]);
}
void upd(int v, int l, int r, int ql, int qr, int x){
    push(v, l, r);
    if(qr < l || r < ql){
        return;
    }
    if(ql <= l && r <= qr){
        p[v] += x;
        push(v, l, r);
        return;
    }
    int mid = (l + r) >> 1;
    upd(v * 2, l, mid, ql, qr, x);
    upd(v * 2 + 1, mid + 1, r, ql, qr, x);
    merge(t[v * 2], t[v * 2 + 1], t[v]);
}
vector<vector<int> > find_ans(int v, int l, int r, int ql, int qr){
    push(v, l, r);
    if(qr < l || r < ql){
        vector<vector<int> > ans(5, vector<int>(5, 0));
        return ans;
    }
    if(ql <= l && r <= qr) return t[v];
    int mid = (l + r) >> 1;
    vector<vector<int> > ans(5, vector<int>(5, 0));
    merge(find_ans(v * 2, l, mid, ql, qr), find_ans(v * 2 + 1, mid + 1, r, ql, qr), ans);
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    inc_mat.resize(5, vector<int>(5, 0));
    dec_mat.resize(5, vector<int>(5, 0));
    start_mat.resize(5, 0);
    start_mat = {0, 1, 2, 3, 4};
    inc_mat = {
    {0, 0, 0, 0, 1},
    {1, 0, 0, 0, 2},
    {0, 1, 0, 0, 3},
    {0, 0, 1, 0, 4},
    {0, 0, 0, 1, 5}
    };
    dec_mat = {
    {-2, 1, 0, 0, 0},
    {-3, 0, 1, 0, 0},
    {-4, 0, 0, 1, 0},
    {-5, 0, 0, 0, 1},
    { 1, 0, 0, 0, 0}
    };
    int n, q;
    cin >> n >> q;
    a.resize(n + 1);
    t.resize(4 * (n + 1));
    p.resize(4 * (n + 1), 0);
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    build(1, 1, n);
    while(q--){
        int T, l, r;
        cin >> T >> l >> r;
        if(T == 1){
            vector<vector<int> > ans = find_ans(1, 1, n, l, r);
            /*for(int i = 0; i < 5; i++){
                for(int j = 0; j < 5; j++){
                    cout << ans[i][j] << " ";
                }
                cout << endl;
            }*/
            int sum = 0;
            for(int i = 0; i < 5; i++){
                    sum += (ans[i][4] * start_mat[i]) % INF;
                    sum += INF;
                    sum %= INF;
            }
            cout << sum << "\n";
        }
        else{
            int x;
            cin >> x;
            upd(1, 1, n, l, r, x);
        }
    }
    return 0;
}
