#include <iostream>
#include<bits/stdc++.h>
using namespace std;
const int INF = 1e8 + 543;
class matr{
public:
    int a[5][5];
    matr(){
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++) a[i][j] = 0;
        }
    }
    matr(bool b){
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++){
                if(i == j) a[i][j] = 1;
                else a[i][j] = 0;
            }
        }
    }
    matr operator + (const matr &b){
        matr c;
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++){
                c.a[i][j] += b.a[i][j];
                c.a[i][j] += this -> a[i][j];
                c.a[i][j] += INF;
                c.a[i][j] %= INF;
            }
        }
        return c;
    }
    matr operator - (const matr&b){
        matr c;
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++){
                c.a[i][j] += this -> a[i][j];
                c.a[i][j] -= b.a[i][j];
                c.a[i][j] += INF;
                c.a[i][j] %= INF;
            }
        }
        return c;
    }
    matr operator * (const matr &b){
        matr c;
        for(int i = 0; i < 5; i++){
            for(int j = 0; j < 5; j++){
                for(int k = 0; k < 5; k++){
                c.a[i][j] += (this -> a[i][k] * 1ll * b.a[k][j]) % INF;
                c.a[i][j] += INF;
                c.a[i][j] %= INF;
                }
            }
        }
        return c;
    }
};
matr inc_mat;
matr dec_mat;
vector<int> start_mat;
matr bin_pow(matr mat, int b){
    if(b == 0){
        matr ans(1);
        return ans;
    }
    if(b & 1){
        return mat * bin_pow(mat, b - 1);
    }
    else{
        return bin_pow(mat * mat, b / 2);
    }
}
vector<matr> t;
vector<int> p;
vector<int> a;
void push(int v, int l, int r){
    if(p[v] == 0) return;
    if(p[v] < 0){
        t[v] = t[v] * bin_pow(dec_mat, -p[v]);
    }
    else{
        t[v] = t[v] * bin_pow(inc_mat, p[v]);
    }
    if(l != r){
        p[v * 2] += p[v];
        p[v * 2 + 1] += p[v];
    }
    p[v] = 0;
}
void build(int v, int l, int r){
    if(l == r){
        int d = a[l] - 4;
        if(d >= 0){
            t[v] = bin_pow(inc_mat, d);
        }
        else{
            t[v] = bin_pow(dec_mat, -d);
        }
        return;
    }
    int mid = (l + r) >> 1;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);
    t[v] = new matr();
    t[v] = t[v * 2] + t[v * 2 + 1];
}
void upd(int v, int l, int r, int ql, int qr, int x){
    push(v, l, r);
    if(qr < l || r < ql){
        return;
    }
    if(ql <= l && r <= qr){
        p[v] += x;
        push(v, l, r);
        return;
    }
    int mid = (l + r) >> 1;
    upd(v * 2, l, mid, ql, qr, x);
    upd(v * 2 + 1, mid + 1, r, ql, qr, x);
    t[v] = t[v * 2] + t[v * 2 + 1];
}
matr find_ans(int v, int l, int r, int ql, int qr){
    push(v, l, r);
    if(qr < l || r < ql){
        matr ans;
        return ans;
    }
    if(ql <= l && r <= qr) return t[v];
    int mid = (l + r) >> 1;
    return find_ans(v * 2, l, mid, ql, qr) + find_ans(v * 2 + 1, mid + 1, r, ql, qr);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //ifstream cin("output.txt");
    start_mat.resize(5, 0);
    start_mat = {0, 1, 2, 3, 4};
    inc_mat.a[0][0] = 0;
    inc_mat.a[0][1] = 0;
    inc_mat.a[0][2] = 0;
    inc_mat.a[0][3] = 0;
    inc_mat.a[0][4] = 1;
    inc_mat.a[1][0] = 1;
    inc_mat.a[1][1] = 0;
    inc_mat.a[1][2] = 0;
    inc_mat.a[1][3] = 0;
    inc_mat.a[1][4] = 2;
    inc_mat.a[2][0] = 0;
    inc_mat.a[2][1] = 1;
    inc_mat.a[2][2] = 0;
    inc_mat.a[2][3] = 0;
    inc_mat.a[2][4] = 3;
    inc_mat.a[3][0] = 0;
    inc_mat.a[3][1] = 0;
    inc_mat.a[3][2] = 1;
    inc_mat.a[3][3] = 0;
    inc_mat.a[3][4] = 4;
    inc_mat.a[4][0] = 0;
    inc_mat.a[4][1] = 0;
    inc_mat.a[4][2] = 0;
    inc_mat.a[4][3] = 1;
    inc_mat.a[4][4] = 5;

    dec_mat.a[0][0] = -2;
    dec_mat.a[0][1] = 1;
    dec_mat.a[0][2] = 0;
    dec_mat.a[0][3] = 0;
    dec_mat.a[0][4] = 0;
    dec_mat.a[1][0] = -3;
    dec_mat.a[1][1] = 0;
    dec_mat.a[1][2] = 1;
    dec_mat.a[1][3] = 0;
    dec_mat.a[1][4] = 0;
    dec_mat.a[2][0] = -4;
    dec_mat.a[2][1] = 0;
    dec_mat.a[2][2] = 0;
    dec_mat.a[2][3] = 1;
    dec_mat.a[2][4] = 0;
    dec_mat.a[3][0] = -5;
    dec_mat.a[3][1] = 0;
    dec_mat.a[3][2] = 0;
    dec_mat.a[3][3] = 0;
    dec_mat.a[3][4] = 1;
    dec_mat.a[4][0] = 1;
    dec_mat.a[4][1] = 0;
    dec_mat.a[4][2] = 0;
    dec_mat.a[4][3] = 0;
    int n, q;
    cin >> n >> q;
    a.resize(n + 1);
    t.resize(4 * (n + 1));
    //cout << sizeof(t) << endl;
    p.resize(4 * (n + 1), 0);
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    build(1, 1, n);
    while(q--){
        int T, l, r;
        cin >> T >> l >> r;
        if(T == 1){
            matr ans = find_ans(1, 1, n, l, r);
            /*for(int i = 0; i < 5; i++){
                for(int j = 0; j < 5; j++){
                    cout << ans.a[i][j] << " ";
                }
                cout << endl;
            }*/
            int sum = 0;
            for(int i = 0; i < 5; i++){
                    sum += (ans.a[i][4] * start_mat[i]) % INF;
                    sum += INF;
                    sum %= INF;
            }
            cout << sum << "\n";
        }
        else{
            int x;
            cin >> x;
            upd(1, 1, n, l, r, x);
        }
    }
    return 0;
}
