#include <bits/stdc++.h>
using namespace std;
const int MOD = 1e8 + 543;
typedef vector < vector < int > > matrix;
matrix mult(matrix B, matrix C) {
    int N = B.size(), M = C[0].size(), K = C.size();
    assert(K == B[0].size());
    matrix A(N, vector < int > (M, 0));
    for (int i = 0; i < N; i++)
        for (int j = 0; j < M; j++)
            for (int k = 0; k < K; k++)
                (A[i][j] += 1LL * B[i][k] * C[k][j] % MOD) %= MOD;
    return A;
}
matrix binp(matrix x, int y) {
    matrix res = x; y--;
    while (y) {
        if (y & 1) res = mult(res, x);
        x = mult(x, x);
        y /= 2;
    }
    return res;
}
const int N = 1e6 + 1;
int x[N];

main() {
    for (int i = 0; i < N; i++) {
        x[i] = (i < 5 ? i : 5 * x[i - 1] + 4 * x[i - 2] + 3 * x[i - 3] + 2 * x[i - 4] + 1 * x[i - 5]) % MOD;
    }
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    matrix st = {{0}, {1}, {2}, {3}, {4}};
    matrix X = {{0, 1, 0, 0, 0},
                {0, 0, 1, 0, 0},
                {0, 0, 0, 1, 0},
                {0, 0, 0, 0, 1},
                {1, 2, 3, 4, 5}};
    st = mult(binp(X, N - 4), st);
    function < int(int) > get = [&](int p) {
        if (p < N) return x[p];
        return mult(binp(X, p - N), st)[3][0];
    };
    int n, q;
    cin >> n >> q;
    vector < int > a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    while (q--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--; r--;
        if (t == 1) {
            int ans = 0;
            assert(l == r);
            for (int i = l; i <= r; i++) ans = (ans + get(a[i])) % MOD;
            cout << ans << '\n';
        } else {
            int x;
            cin >> x;
            assert(l == r);
            for (int i = l; i <= r; i++) {
                a[i] += x;
            }
        }
    }
}
