#include <bits/stdc++.h>
using namespace std;
const int MOD = 1e8 + 543;
typedef vector < vector < int > > matrix;
matrix mult(matrix B, matrix C) {
    int N = B.size(), M = C[0].size(), K = C.size();
    assert(K == B[0].size());
    matrix A(N, vector < int > (M, 0));
    for (int i = 0; i < N; i++)
        for (int j = 0; j < M; j++)
            for (int k = 0; k < K; k++)
                (A[i][j] += 1LL * B[i][k] * C[k][j] % MOD) %= MOD;
    return A;
}
matrix binp(matrix x, int y) {
    matrix res = {{1, 0, 0, 0, 0},
                  {0, 1, 0, 0, 0},
                  {0, 0, 1, 0, 0},
                  {0, 0, 0, 1, 0},
                  {0, 0, 0, 0, 1}};
    while (y) {
        if (y & 1) res = mult(res, x);
        x = mult(x, x);
        y /= 2;
    }
    return res;
}
const int N = 1e6 + 1;
int x[N];
void print(matrix FK) {
    for (auto u : FK) { for (auto uu : u) cout << uu << ' '; cout << endl; }
};
main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    matrix st = {{0}, {1}, {2}, {3}, {4}};
    matrix X = {{0, 1, 0, 0, 0},
                {0, 0, 1, 0, 0},
                {0, 0, 0, 1, 0},
                {0, 0, 0, 0, 1},
                {1, 2, 3, 4, 5}};
    const int M = sqrt(MOD);
    vector < matrix > A(M + 10), B(M);
    B[0] = binp(X, 0); for (int i = 1; i < M; i++) B[i] = mult(B[i - 1], X);
    matrix XX = mult(B[M - 1], X);
    A[0] = binp(X, 0); for (int i = 1; i < M + 10; i++) A[i] = mult(A[i - 1], XX);

    function < matrix(int) > get = [&](int p) {
        if (p <= 0) return binp(X, 0);
        int k = p / M, o = p % M;
        return mult(A[k], B[o]);
    };
    int n, q;
    cin >> n >> q;
    vector < int > a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector < matrix > inp(n);
    for (int i = 0; i < n; i++) {
        inp[i] = get(a[i] - 4);
    }
    while (q--) {
        int t, l, r;
        cin >> t >> l >> r;
        l--; r--;
        if (t == 1) {
            int ans = 0, ANS = 0;
            for (int i = l; i <= r; i++) {
                if (a[i] < 5) ans += a[i]; else ans += mult(inp[i], st)[4][0];
            }
            cout << ans << endl;
        } else {
            int x;
            cin >> x;
            for (int i = l; i <= r; i++) {
                int kk = x;
                if (a[i] < 4) {
                    kk -= 4 - a[i];
                }
                if (a[i] < 100) {
                    a[i] += x;
                }
                inp[i] = mult(inp[i], get(kk));
            }
        }
    }
}
