#include <bits/stdc++.h>
#include "puzzle.h"

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef int ll;
typedef double ld;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=2e9+2;
const ll N=1e6+2;

bool intersects(ll l1, ll r1, ll l2, ll r2)
{
    if(l1>r1) swap(l1,r1);
    if(l2>r2) swap(l2,r2);
    return max(l1,l2)<=min(r1,r2);
}

ll tc;
ld tl;

void init(ll _tc, ld _tl)
{
    tc=_tc;
    tl=_tl;
}

ve<ll> adj[N],conf[N];
char used[N];
ve<pll> ed;
ve<ll> u;

void dfs(ll s)
{
    if(used[s]) return;
    used[s]=1;
    
    for(ll i:adj[s])
    {
        if(u[i]==0) continue;
        dfs((s==ed[i].F? ed[i].S:ed[i].F));
    }
}

bool solve(ve<ve<ll>> &arr)
{
    ll n=sz(arr),m=sz(arr[0]);
    ve<pll> pt;
    
    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<m;j++)
        {
            if(arr[i][j]!=0)
                pt.PB({i,j});
        }
    }
    
    ll k=sz(pt);
    ed.clear();
    
    for(ll i=0;i<k;i++)
    {
        for(ll j=i+1;j<k;j++)
        {
            ll x1,y1,x2,y2;
            tie(x1,y1)=pt[i];
            tie(x2,y2)=pt[j];
            
            if(x1==x2)
            {
                bool ok=1;
                
                for(ll i=min(y1,y2)+1;i<=max(y1,y2)-1;i++)
                    ok&=(arr[x1][i]==0);
                
                if(ok) ed.PB({i,j});
            }
            
            else if(y1==y2)
            {
                bool ok=1;
                
                for(ll i=min(x1,x2)+1;i<=max(x1,x2)-1;i++)
                    ok&=(arr[i][y1]==0);
                
                if(ok) ed.PB({i,j});
            }
        }
    }
    
    ll s=sz(ed);
    
    for(ll i=0;i<k;i++)
        adj[i].clear();
    
    for(ll i=0;i<s;i++)
        conf[i].clear();
    
    for(ll i=0;i<s;i++)
    {
        ll a,b;
        tie(a,b)=ed[i];
        adj[a].PB(i);
        adj[b].PB(i);
    }
    
    for(ll i=0;i<s;i++)
    {
        for(ll j=i+1;j<s;j++)
        {
            ll x1,y1,x2,y2,x3,y3,x4,y4;
            tie(x1,y1)=pt[ed[i].F];
            tie(x2,y2)=pt[ed[i].S];
            tie(x3,y3)=pt[ed[j].F];
            tie(x4,y4)=pt[ed[j].S];
            
            if(x1==x2)
            {
                if(y1<y2) y1++, y2--;
                else y2++, y1--;
            }
            
            else
            {
                if(x1<x2) x1++, x2--;
                else y1++, y2--;
            }
            
            if(x3==x4)
            {
                if(y3<y4) y3++, y4--;
                else y4++, y3--;
            }
            
            else
            {
                if(x3<x4) x3++, x4--;
                else y3++, y4--;
            }
            
            if(intersects(x1,x2,x3,x4)&&intersects(y1,y2,y3,y4))
            {
                conf[i].PB(j);
                conf[j].PB(i);
            }
        }
    }
    
    ve<ll> v(s,0);
    ll ans=INF;
    uniform_real_distribution<ld> unif(0,1);
    ld t=1;
    
    while(ans>=1)
    {
        t*=0.9999;
        u=v;
        ll x=gen()%s;
        while(u[x]==v[x]) u[x]=gen()%3;
        
        if(v[x]==0)
        {
            for(ll i:conf[x])
                u[i]=0;
        }
        
        ve<ll> cnt(k,0);
        ll cur=0;
        
        for(ll i=0;i<s;i++)
        {
            cnt[ed[i].F]+=u[i];
            cnt[ed[i].S]+=u[i];
        }
        
        for(ll i=0;i<k;i++)
            cur+=abs(cnt[i]-arr[pt[i].F][pt[i].S]);
        
        fill(used,used+k,0);
        ll comp=0;
        
        for(ll i=0;i<k;i++)
        {
            if(!used[i]) comp++;
            dfs(i);
        }
        
        cur+=max(0,(comp-1)*10);
        
        if(cur<=ans||unif(gen)<exp((ans-cur)/t))
        {
            v=u;
            ans=cur;
        }
        
        if(ans==0) break;
    }
    
    for(ll i=0;i<s;i++)
    {
        if(v[i]==0) continue;
        ll x1,y1,x2,y2;
        tie(x1,y1)=pt[ed[i].F];
        tie(x2,y2)=pt[ed[i].S];
        
        if(x1==x2)
        {
            for(ll j=min(y1,y2)+1;j<=max(y1,y2)-1;j++)
                arr[x1][j]=(v[i]==1? -1:-3);
        }
        
        else
        {
            for(ll j=min(x1,x2)+1;j<=max(x1,x2)-1;j++)
                arr[j][y1]=(v[i]==1? -2:-4);
        }
    }
    
    return true;
}

#ifdef LOCAL
#include <iostream>
#include <vector>
#include <ctime>

#include "puzzle.h"

static int n, m;
static std::vector<std::vector<int>> puzzle;
static std::vector<std::vector<int>> puzzleOut;

static void input()
{
    std::cin >> n >> m;

    puzzle.resize(n);
    for (int i = 0; i < n; ++i)
    {
        puzzle[i].resize(m);
        for (int j = 0; j < m; ++j)
        {
            std::cin >> puzzle[i][j];
        }
    }
}

static int numSubtests;
static int currSubtest;
static double timeLimit;

static void myAssert(bool f, int t)
{
    if (f) return;

    std::cout << "wa " << t << std::endl;
    std::cout << "Invalid solution on subtest: " << currSubtest + 1 <<  " / " << numSubtests << std::endl;
    std::cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
    std::cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;

    exit(0);
}

static std::vector<std::vector<bool>> visited;

static void DFS(int i, int j)
{
    if (i < 0) return;
    if (i >= n) return;
    if (j < 0) return;
    if (j >= m) return;

    if (puzzleOut[i][j] == EMPTY) return;
    if (visited[i][j]) return;

    visited[i][j] = true;

    DFS(i - 1, j);
    DFS(i + 1, j);
    DFS(i, j - 1);
    DFS(i, j + 1);
}

static bool run()
{
    puzzleOut = puzzle;
    bool res = solve(puzzleOut);

    if (!res) return false;

    std::cerr << n << " " << m << std::endl;
    for (const std::vector<int>& row : puzzleOut)
    {
        for (int elem : row)
        {
            if (elem > 0 && elem <= 8) std::cerr << elem;
            else if (elem == EMPTY) std::cerr << " ";
            else if (elem == HOR_SINGLE) std::cerr << "-";
            else if (elem == HOR_DOUBLE) std::cerr << "=";
            else if (elem == VERT_SINGLE) std::cerr << "|";
            else if (elem == VERT_DOUBLE) std::cerr << "$";
            else std::cerr << "?";
        }
        std::cerr << std::endl;
    }
    std::cerr << std::endl;

    myAssert((int) puzzleOut.size() == n, 1);
    for (int i = 0; i < n; ++i)
    {
        myAssert((int) puzzleOut[i].size() == m, 2);
        for (int j = 0; j < m; ++j)
        {
            if (puzzle[i][j] > 0)
            {
                myAssert(puzzleOut[i][j] == puzzle[i][j],3);
            }
            else
            {
                myAssert(
                    puzzleOut[i][j] == EMPTY ||
                    puzzleOut[i][j] == HOR_SINGLE ||
                    puzzleOut[i][j] == VERT_SINGLE ||
                    puzzleOut[i][j] == HOR_DOUBLE ||
                    puzzleOut[i][j] == VERT_DOUBLE,4);
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {

            if (puzzleOut[i][j] > 0)
            {
                int sum = 0;
                if (j > 0 && puzzleOut[i][j - 1] == HOR_SINGLE) sum += 1;
                if (j > 0 && puzzleOut[i][j - 1] == HOR_DOUBLE) sum += 2;
                if (j < m - 1 && puzzleOut[i][j + 1] == HOR_SINGLE) sum += 1;
                if (j < m - 1 && puzzleOut[i][j + 1] == HOR_DOUBLE) sum += 2;
                if (i > 0 && puzzleOut[i - 1][j] == VERT_SINGLE) sum += 1;
                if (i > 0 && puzzleOut[i - 1][j] == VERT_DOUBLE) sum += 2;
                if (i < n - 1 && puzzleOut[i + 1][j] == VERT_SINGLE) sum += 1;
                if (i < n - 1 && puzzleOut[i + 1][j] == VERT_DOUBLE) sum += 2;
                myAssert(sum == puzzleOut[i][j],5);
            }
            else if (puzzleOut[i][j] != EMPTY)
            {
                if (puzzleOut[i][j] == HOR_SINGLE)
                {
                    myAssert(j > 0 && (puzzleOut[i][j - 1] == HOR_SINGLE || puzzleOut[i][j - 1] > 0),6);
                    myAssert(j < m - 1 && (puzzleOut[i][j + 1] == HOR_SINGLE || puzzleOut[i][j + 1] > 0),7);
                }
                if (puzzleOut[i][j] == HOR_DOUBLE)
                {
                    myAssert(j > 0 && (puzzleOut[i][j - 1] == HOR_DOUBLE || puzzleOut[i][j - 1] > 0),8);
                    myAssert(j < m - 1 && (puzzleOut[i][j + 1] == HOR_DOUBLE || puzzleOut[i][j + 1] > 0),9);
                }
                if (puzzleOut[i][j] == VERT_SINGLE)
                {
                    myAssert(i > 0 && (puzzleOut[i - 1][j] == VERT_SINGLE || puzzleOut[i - 1][j] > 0),10);
                    myAssert(i < n - 1 && (puzzleOut[i + 1][j] == VERT_SINGLE || puzzleOut[i + 1][j] > 0),11);
                }
                if (puzzleOut[i][j] == VERT_DOUBLE)
                {
                    myAssert(i > 0 && (puzzleOut[i - 1][j] == VERT_DOUBLE || puzzleOut[i - 1][j] > 0),12);
                    myAssert(i < n - 1 && (puzzleOut[i + 1][j] == VERT_DOUBLE || puzzleOut[i + 1][j] > 0),13);
                }
            }
        }
    }

    visited.clear();
    visited.resize(n);
    for (int i = 0; i < n; ++i)
    {
        visited[i].resize(m, false);
    }

    bool found = false;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (puzzleOut[i][j] == EMPTY) continue;
            if (!found)
            {
                DFS(i, j);
                found = true;
            }
            myAssert(visited[i][j],14);
        }
    }

    return true;
}

static clock_t startT;

double timePassed()
{
    clock_t currT = clock();

    return (double) (currT - startT) / CLOCKS_PER_SEC;
}

int main()
{
    freopen("puzzle.08.in","r",stdin);
    
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cin >> numSubtests;
    std::cin >> timeLimit;

    startT = clock();

    init(numSubtests, timeLimit);

    for (currSubtest = 0; currSubtest < numSubtests; ++currSubtest)
    {
        input();
        if (!run())
        {
            std::cout << "Stopped on subtest: " << currSubtest + 1 << " / " << numSubtests << std::endl;
            break;
        }
        if (timePassed() > timeLimit)
        {
            std::cout << "Timed out during subtest: " << currSubtest + 1 << " / " << numSubtests << std::endl;
            break;
        }
    }

    std::cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
    std::cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;

    return 0;
}
#endif
