#ifndef LOCAL
#pragma GCC target("arch=skylake")
#pragma GCC optimize("O3,inline")
#endif // LOCAL

#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

const ll mod=1e8+543;

typedef ve<ve<ll>> matrix;

matrix operator*(const matrix &a, const matrix &b)
{
    ll n1=sz(a),m=sz(a[0]),n2=sz(b);
    matrix c(n1,ve<ll>(n2,0));
    
    for(ll i=0;i<n1;i++)
    {
        for(ll j=0;j<n2;j++)
        {
            for(ll k=0;k<m;k++)
                c[i][j]=(c[i][j]+a[i][k]*b[k][j])%mod;
        }
    }
    
    return c;
}

matrix bpow(matrix a, ll b)
{
    if(b==1) return a;
    if(b%2==1) return bpow(a,b-1)*a;
    matrix x=bpow(a,b/2);
    return x*x;
}

ll get(ll k)
{
    if(k<=4) return k;
    
    matrix a
    {
        {0,1,2,3,4}
    };
    
    matrix b
    {
        {0,0,0,0,1},
        {1,0,0,0,2},
        {0,1,0,0,3},
        {0,0,1,0,4},
        {0,0,0,1,5},
    };
    
    a=a*bpow(b,k-4);
    return a[0][4];
}

ll arr[N],pref[N];
tuple<ll,ll,ll,ll> qr[N];
ll n,q;

void solve_prefs()
{
    pref[0]=get(arr[0]);
    
    for(ll i=1;i<n;i++)
        pref[i]=(pref[i-1]+get(arr[i]))%mod;
    
    auto sum = [&](ll l, ll r)
    {
        if(l==0) return pref[r];
        return (pref[r]-pref[l-1]+mod)%mod;
    };
    
    for(ll i=0;i<q;i++)
    {
        ll t,l,r,x;
        tie(t,l,r,x)=qr[i];
        cout<<sum(l,r)<<endl;
    }
}

void solve()
{
    cin>>n>>q;
    
    for(ll i=0;i<n;i++)
        cin>>arr[i];
    
    bool ok=1;
    
    for(ll i=0;i<q;i++)
    {
        ll t,l,r;
        cin>>t>>l>>r;
        t--, l--, r--;
        ok&=(l==r);
        
        if(t==0) qr[i]=make_tuple(t,l,r,0);
        
        else
        {
            ll x;
            cin>>x;
            qr[i]=make_tuple(t,l,r,x);
        }
    }
    
    solve_prefs();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    solve();
    return 0;
}
