#ifndef LOCAL
#pragma GCC target("arch=skylake")
#endif // LOCAL

#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math,inline")

#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

const ll mod=1e8+543;

typedef array<array<ll,5>,5> matrix;

matrix operator*(const matrix &a, const matrix &b)
{
    ll n=sz(a);
    matrix c;
    
    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<n;j++)
        {
            c[i][j]=0;
            
            for(ll k=0;k<n;k++)
                c[i][j]+=a[i][k]*b[k][j];
            
            c[i][j]%=mod;
        }
    }
    
    return c;
}

matrix bpow(matrix a, ll b)
{
    if(b==1) return a;
    if(b%2==1) return bpow(a,b-1)*a;
    matrix x=bpow(a,b/2);
    return x*x;
}

ll get(ll k)
{
    if(k<=4) return k;
    matrix a,b;
    
    for(ll i=0;i<5;i++)
    {
        for(ll j=0;j<5;j++)
            a[i][j]=b[i][j]=0;
    }
    
    a[0][1]=1;
    a[0][2]=2;
    a[0][3]=3;
    a[0][4]=4;
    
    b[1][0]=1;
    b[2][1]=1;
    b[3][2]=1;
    b[4][3]=1;
    b[0][4]=1;
    b[1][4]=2;
    b[2][4]=3;
    b[3][4]=4;
    b[4][4]=5;
    
    a=a*bpow(b,k-4);
    return a[0][4];
}

ll arr[N],pref[N],dp[N];
tuple<ll,ll,ll,ll> qr[N];
ll n,q;

void solve_prefs()
{
    pref[0]=get(arr[0]);
    
    for(ll i=1;i<n;i++)
        pref[i]=(pref[i-1]+get(arr[i]))%mod;
    
    auto sum = [&](ll l, ll r)
    {
        if(l==0) return pref[r];
        return (pref[r]-pref[l-1]+mod)%mod;
    };
    
    for(ll i=0;i<q;i++)
    {
        ll t,l,r,x;
        tie(t,l,r,x)=qr[i];
        cout<<sum(l,r)<<endl;
    }
}

void solve_lr()
{
    for(ll i=0;i<q;i++)
    {
        ll t,l,r,x;
        tie(t,l,r,x)=qr[i];
        if(t==0) cout<<get(arr[l])<<endl;
        else arr[l]+=x;
    }
}

void solve()
{
    cin>>n>>q;
    
    for(ll i=0;i<n;i++)
        cin>>arr[i];
    
    bool ok=1;
    
    for(ll i=0;i<q;i++)
    {
        ll t,l,r;
        cin>>t>>l>>r;
        t--, l--, r--;
        ok&=(l==r);
        
        if(t==0) qr[i]=make_tuple(t,l,r,0);
        
        else
        {
            ll x;
            cin>>x;
            qr[i]=make_tuple(t,l,r,x);
        }
    }
    
    if(ok) solve_lr();
    else solve_prefs();
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    solve();
    return 0;
}
