#include <bits/stdc++.h>
#define ll long long
#define ve vector
#define all(x) x.begin(), x.end()
#define fi first
#define se second

using namespace std;
typedef pair<int, int> pii;

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

const int MOD = 1e8+543;

ve<ve<int> > mat(5, ve<int>(5, 0));
ve<ve<int> > invmat(5, ve<int>(5, 0));
ve<ve<int> > ones(5, ve<int>(5, 0));
ve<ve<int> > start = {{0, 1, 2, 3, 4}};

void precalc(){
    for(int i = 1; i < 5; i++)
        invmat[i - 1][i] = 1;
    for(int i = 0; i < 4; i++)
        invmat[i][0] = MOD-(i + 2);
    invmat[4][0] = 1;
    for(int i = 0; i < 4; i++)
        mat[i + 1][i] = 1;
    for(int i = 0; i < 5; i++)
        mat[i][4] = i + 1;
    for(int i = 0; i < 5; i++)
        ones[i][i] = 1;

}

ve<ve<int> > operator *(const ve<ve<int> >& a, const ve<ve<int> >& b){
    ve<ve<int> > res(a.size(), ve<int>(b[0].size(), 0));
    for(int i = 0; i < a.size(); i++)
        for(int j = 0; j < b[0].size(); j++)
            for(int k = 0; k < b.size(); k++){
                res[i][j] = ((ll)a[i][k] * b[k][j] + res[i][j]) % MOD;
            }
    return res;
}

ve<ve<int> > operator +(const ve<ve<int> >& a, const ve<ve<int> >& b){
    ve<ve<int> > res(a.size(), ve<int>(b[0].size(), 0));
    for(int i = 0; i < a.size(); i++)
        for(int j = 0; j < b[0].size(); j++){
            res[i][j] = (a[i][j] + b[i][j]) % MOD;
        }
    return res;
}

const int K = 10000, K2 = K*K;
const int MAXQ = 2e5+10;
ve<ve<int> > mps[K + 10];
ve<ve<int> > mpsmult[K + 10];
ve<ve<int> > invmps[K + 10];
ve<ve<int> > invmpsmult[K + 10];
ve<ve<int> > umps[MAXQ];
ve<ve<int> > invumps[MAXQ];


ve<ve<int> > updmat(ve<ve<int> >& a, ll n){
    if(n < 0){
        n = -n;
        a = a * invumps[n / K2] * invmps[(n / K) % K] * invmpsmult[n % K];
    }
    else
        a = a * umps[n / K2] * mps[(n / K) % K] * mpsmult[n % K];
}

const int MAXN = 1e5+10;

ve<ve<int> > t[4*MAXN];
ll mod[4*MAXN];
int a[MAXN];
ve<ve<int> > mts[MAXN];

void build(int v, int tl, int tr){
    if(tl == tr){
        t[v] = mts[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

void push(int v){
    if(mod[v] && v * 2 + 1 < 4*MAXN){
        mod[v * 2] += mod[v];
        mod[v * 2 + 1] += mod[v];
        updmat(t[v], mod[v]);
        updmat(t[v * 2 + 1], mod[v]);
        mod[v] = 0;
    }
}

void update(int l, int r, int val, int v, int tl, int tr){
    if(tl >= l && tr <= r){
        mod[v] = val;
        updmat(t[v], val);
        return;
    }
    if(tl > r || tr < l)
        return;
    push(v);
    int tm = (tl + tr) >> 1;
    update(l, r, val, v * 2, tl, tm);
    update(l, r, val, v * 2 + 1, tm + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int l, int r, int v, int tl, int tr){
    if(tl >= l && tr <= r)
        return t[v][0][4];
    if(tl > r || tr < l)
        return 0;
    push(v);
    int tm = (tl + tr) >> 1;
    return (get(l, r, v * 2, tl, tm) + get(l, r, v * 2 + 1, tm + 1, tr)) % MOD;
}


int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    precalc();
    int n, q;
    cin >> n >> q;
    ve<pii> v;
    mpsmult[0] = ones;
    for(int i = 1; i <= K; i++)
        mpsmult[i] = mpsmult[i - 1] * mat;
    mps[0] = ones;
    for(int i = 1; i <= K; i++)
        mps[i] = mps[i - 1] * mpsmult[K];
    umps[0] = ones;
    for(int i = 1; i < MAXQ; i++)
        umps[i] = umps[i - 1] * mps[K];
    invmpsmult[0] = ones;
    for(int i = 1; i <= K; i++)
        invmpsmult[i] = invmpsmult[i - 1] * invmat;
    invmps[0] = ones;
    for(int i = 1; i <= K; i++)
        invmps[i] = invmps[i - 1] * invmpsmult[K];
    invumps[0] = ones;
    for(int i = 1; i < MAXQ; i++)
        invumps[i] = invumps[i - 1] * mps[K];
    for(int i = 0; i < n; i++){
        cin >> a[i];
        mts[i] = start;
        updmat(mts[i], a[i] - 4);
    }
    build(1, 0, n - 1);
    while(q--){
        int type, l, r, val;
        cin >> type >> l >> r;
        l--; r--;
        if(type == 1){
            cout << get(l, r, 1, 0, n - 1) << "\n";
        }
        else{
            cin >> val;
            update(l, r, val, 1, 0, n - 1);
        }
    }
    return 0;
}
