#include <iostream>
#include "puzzle.h"
#ifdef LOCAL
#include "Lgrader.cpp"
#endif // LOCAL

using namespace std;

#ifdef LOCAL
void init(int nm, double tl) {
    numSubtests = nm;
    timeLimit = tl;
}
#endif // LOCAL

bool solve(vector<vector<int>> &puzzle) {
    if (timePassed() > timeLimit)
        return false;
    int n = puzzle.size(), m = puzzle[0].size();
    vector<vector<int>> ost = puzzle;
    int cnt = 0;
    for (vector<int> u : puzzle)
        for (int v : u)
            if (v > 0)
                cnt++;
    for (int x = 1; x <= cnt; x++) {
        bool f = false;
        for (int i = 0; i < n && !f; i++)
            for (int j = 0; j < m && !f; j++)
                if (ost[i][j] > 0) {
                    int cup = 0, cdown = 0, cleft = 0, cright = 0;
                    for (int k = i - 1; k >= 0; k--) {
                        if (puzzle[k][j] < 0)
                            break;
                        if (ost[k][j] > 0) {
                            cup = min(ost[k][j], 2);
                            break;
                        }
                    }
                    for (int k = i + 1; k < n; k++) {
                        if (puzzle[k][j] < 0)
                            break;
                        if (ost[k][j] > 0) {
                            cdown = min(ost[k][j], 2);
                            break;
                        }
                    }
                    for (int k = j - 1; k >= 0; k--) {
                        if (puzzle[i][k] < 0)
                            break;
                        if (ost[i][k] > 0) {
                            cleft = min(ost[i][k], 2);
                            break;
                        }
                    }
                    for (int k = j + 1; k < m; k++) {
                        if (puzzle[i][k] < 0)
                            break;
                        if (ost[i][k] > 0) {
                            cright = min(ost[i][k], 2);
                            break;
                        }
                    }
                    int cnn0 = (cup > 0) + (cleft > 0) + (cright > 0) + (cdown > 0);
                    if (cnn0 == 1) {
                        cup = min(cup, ost[i][j]);
                        cdown = min(cdown, ost[i][j]);
                        cleft = min(cleft, ost[i][j]);
                        cright = min(cright, ost[i][j]);
                    }
                    if (cup + cdown + cleft + cright == ost[i][j]) {
                        ost[i][j] = 0;
                        if (cup > 0) for (int k = i - 1; k >= 0; k--) {
                            if (ost[k][j] > 0) {
                                ost[k][j] -= cup;
                                break;
                            }
                            if (cup == 1)
                                puzzle[k][j] = VERT_SINGLE;
                            else
                                puzzle[k][j] = VERT_DOUBLE;
                        }
                        if (cdown > 0) for (int k = i + 1; k < n; k++) {
                            if (ost[k][j] > 0) {
                                ost[k][j] -= cdown;
                                break;
                            }
                            if (cdown == 1)
                                puzzle[k][j] = VERT_SINGLE;
                            else
                                puzzle[k][j] = VERT_DOUBLE;
                        }
                        if (cleft > 0) for (int k = j - 1; k >= 0; k--) {
                            if (ost[i][k] > 0) {
                                ost[i][k] -= cleft;
                                break;
                            }
                            if (cleft == 1)
                                puzzle[i][k] = HOR_SINGLE;
                            else
                                puzzle[i][k] = HOR_DOUBLE;
                        }
                        if (cright > 0) for (int k = j + 1; k < m; k++) {
                            if (ost[i][k] > 0) {
                                ost[i][k] -= cright;
                                break;
                            }
                            if (cright == 1)
                                puzzle[i][k] = HOR_SINGLE;
                            else
                                puzzle[i][k] = HOR_DOUBLE;
                        }
                        f = true;
                        break;
                    }
                }
    }
    return true;
}

