#include <iostream>
#include <vector>

#pragma GCC optimize("O3")

using namespace std;

using ll = long long;
const int mod = 1e8 + 543;
const int N = 1e6 + 6;

int n, tt;
long long a[100001];

int add (int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}

int sub (int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}

int mul (int a, int b) {
    return 1ll * a * b % mod;
}

int B[6][6][44], _B[6][6][44][44];
int A[6][6];
int pref[N];

int C[6][6], res[6][6];
void mul_matrix (int l) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                B[i][j][l] = add (B[i][j][l], mul (B[i][k][l - 1], B[k][j][l - 1]));
            }
        }
    }
}
void mul_matrix1 (int l) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                C[i][j] = add (C[i][j], mul (res[i][k], B[k][j][l]));
            }
        }
    }
}
void mul_matrix2 (int x, int y) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { C[i][j] = 0;
            for (int k = 0; k < 6; ++ k) {
                C[i][j] = add (C[i][j], mul (res[i][k], _B[k][j][x][y]));
            }
        }
    }
}


void mul_mm (int x, int y) {
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) { _B[i][j][x][y] = 0;
            for (int k = 0; k < 6; ++ k) {
                _B[i][j][x][y] = add (_B[i][j][x][y], mul (B[i][k][x], B[k][j][y]));
            }
        }
    }
}

void print (vector < vector < int > > A) {
    cout << "=====================\n";
    for (int i = 0; i < 6; ++ i) {
        for (int j = 0; j < 6; ++ j) cout << A[i][j] << " ";
        cout << "\n";
    }
    cout << "=====================\n";
}

int bpow (long long b) {
    for (int j = 0; j < 6; ++ j) {
        for (int z = 0; z < 6; ++ z) res[j][z] = A[j][z];
    }
    int lg = 0;
    vector < int > bits;
    while (b){
        if (b & 1) bits.push_back(lg);
        b >>= 1;
        ++ lg;
    }

    for (int i = 0; i < bits.size(); i += 2) {
        if (i == bits.size() - 1) {
            mul_matrix1 (bits[i]);
            for (int j = 0; j < 6; ++ j) for (int z = 0; z < 6; ++ z) res[j][z] = C[j][z];
        } else {
            mul_matrix2 (bits[i], bits[i + 1]);
            for (int j = 0; j < 6; ++ j) for (int z = 0; z < 6; ++ z) res[j][z] = C[j][z];
        }
    }

//    print (B[0]);

    return res[0][5];
}


int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    for (int i = 0; i <= 5; ++ i) A[0][i] = (i < 5 ? i : 40);
    for (int i = 0; i < 5; ++ i) B[i + 1][i][0] = 1;
    for (int i = 0; i < 6; ++ i) B[i][5][0] = i;

    for (int i = 1; i < 44; ++ i) mul_matrix (i);

    for (int i = 0; i < 44; ++ i) {
        for (int j = i + 1; j < 44; ++ j) mul_mm (i, j);
    }

    bool flag = true;
    cin >> n >> tt;
    for (int i = 1; i <= n; ++ i) cin >> a[i], flag &= a[i] < N;
    if(flag) {
        vector < int > x(N, 0);
        for (int i = 0; i < 5; ++ i) x[i] = i;

        for (int i = 5; i < N; ++ i) {
            for (int k = 1; k <= 5; ++ k) x[i] = add(x[i], mul(x[i - k], (5 - k + 1)));
        }

        for (int i = 1; i <= n; ++ i) pref[i] = add(pref[i - 1], x[a[i]]);
    }
    while (tt --) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            if (flag) cout << sub(pref[r], pref[l - 1]) << '\n';
            else cout << (a[r] <= 5 ? A[0][a[r]] : bpow (a[r] - 5)) << '\n';
        } else {
            int val, l, r;
            flag = false;
            cin >> l >> r >> val;
            for (int i = l; i <= r; ++ i) a[i] += val;
        }
    }

    return 0;
}
