#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
const int mod=1e8+543;
const int k=5;
long long int mult_val(vector<int>base,vector<int>coef)
{
  long long int rs=0;
  for(int i=0;i<base.size();i++)
  rs+=base[i]*coef[i],rs%=mod;
  return rs;
}
struct matrix
{
    long long int a[k][k];
    matrix()
    {
        for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            a[i][j]=0;
    }
    matrix operator *(matrix &other)
    {
        matrix rs;
        for(int v=0;v<k;v++)
            for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            rs.a[i][j]+=a[i][v]*other.a[v][j],rs.a[i][j]%=mod;
        return rs;
    }
};
matrix qpow(matrix a,int val)
{
    matrix rs=a;
    val--;
    while(val)
    {
        if(val%2)rs=rs*a;
        a=a*a;
        val/=2;
    }
    return rs;
}
int main()
{
    matrix base_pow;
    for(int i=0;i<4;i++)
      base_pow.a[i+1][i]=1;
    for(int i=0;i<5;i++)
    base_pow.a[0][i]=5-i;
    matrix inv_pow;
    for(int i=0;i<4;i++)
        inv_pow.a[i][i+1]=1;
    for(int i=0;i<5;i++)
    {
        if(i==0)inv_pow.a[4][i]=1;
        else inv_pow.a[4][i]=mod-(5-i+1);
    }
    /*
    matrix rs=qpow(base_pow,1);
    for(int i=0;i<5;i++)cout<<rs.a[0][i]<<" ";
    cout<<endl;
    cout<<mult_val({4,3,2,1,0},{rs.a[0][0],rs.a[0][1],rs.a[0][2],rs.a[0][3],rs.a[0][4]});
    */
    int n,q;
    cin>>n>>q;
    vector<int>a(n);
    for(auto &x:a)cin>>x;
    for(auto &x:a)
    {
        x-=4;
        if(x==0)x=40;
        else if(x<0)
        {
            matrix rs=qpow(inv_pow,-x);
            x=mult_val({4,3,2,1,0},{rs.a[0][0],rs.a[0][1],rs.a[0][2],rs.a[0][3],rs.a[0][4]});
        }
        else if(x>0)
        {
            matrix rs=qpow(base_pow,x);
            x=mult_val({4,3,2,1,0},{rs.a[0][0],rs.a[0][1],rs.a[0][2],rs.a[0][3],rs.a[0][4]});
        }
    }
    vector<long long int>pref(n);
    pref[0]=a[0];
    for(int i=1;i<n;i++)pref[i]=(pref[i-1]+a[i])%mod;
    while(q--)
    {
        int d;
        cin>>d;
        int l,r;
        cin>>l>>r;
        l--,r--;
        cout<<(pref[r]-(l?pref[l-1]:0)+mod)%mod<<endl;
    }
}