#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
const int mod=1e8+543;
const int k=5;
long long int mult_val(vector<long long int>base,vector<long long int>coef)
{
  long long int rs=0;
  for(int i=0;i<base.size();i++)
  rs+=base[i]*coef[i],rs%=mod;
  return rs;
}
struct matrix
{
    long long int a[k][k];
    matrix()
    {
        for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            a[i][j]=0;
    }

};
matrix tmp;
void mult(matrix &a,matrix &other)
{
    for(int i=0;i<k;i++)
        for(int j=0;j<k;j++)
        tmp.a[i][j]=0;
        for(int v=0;v<k;v++)
            for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            tmp.a[i][j]+=a.a[i][v]*other.a[v][j];
    for(int i=0;i<k;i++)
        for(int j=0;j<k;j++)
        tmp.a[i][j]%=mod;
        for(int i=0;i<5;i++)
            for(int j=0;j<5;j++)
    swap(a,tmp);
}
matrix base_pow,inv_pow;
matrix base_pwr[60],inv_pwr[60];
vector<int>based_pow(vector<int>a,long long int pwr)
{
    if(pwr>0)
    {
        for(int it=0;it<60;it++)
        {
            if(pwr&(1LL<<it))
            {
                vector<long long int>tmp(5);
                for(int i=0;i<5;i++)
                    for(int j=0;j<5;j++)
                    tmp[i]+=base_pwr[it].a[i][j]*a[j];
                for(int i=0;i<5;i++)tmp[i]%=mod;
                for(int i=0;i<5;i++)a[i]=tmp[i];
            }
        }
    }
    else if(pwr<0)
    {
        pwr=abs(pwr);
        for(int it=0;it<60;it++)
        {
            if(pwr&(1LL<<it))
            {
                vector<long long int>tmp(5);
                for(int i=0;i<5;i++)
                    for(int j=0;j<5;j++)
                    tmp[i]+=inv_pwr[it].a[i][j]*a[j];
                for(int i=0;i<5;i++)tmp[i]%=mod;
                for(int i=0;i<5;i++)a[i]=tmp[i];
            }
        }
    }
    return a;
}
matrix qpow(matrix a,long long int val)
{
    matrix rs=a;
    val--;
    while(val)
    {
        if(val%2)mult(rs,a);
        mult(a,a);
        val/=2;
    }
    return rs;
}
struct seg_tree
{
    vector<vector<int>>tree;
    vector<long long int>lazy;
    vector<int>align(vector<int>a,vector<int>b)
    {
        vector<int>rs(5);
        for(int i=0;i<5;i++)rs[i]=a[i]+b[i],rs[i]%=mod;
        return rs;
    }
    void push(int v,int tl,int tr)
    {
        if(lazy[v]==0)return;
        tree[v]=based_pow(tree[v],lazy[v]);
        if(tl!=tr)
        {
            lazy[v*2]+=lazy[v];
            lazy[v*2+1]+=lazy[v];
        }
        lazy[v]=0;
    }
    void build(int v,int tl,int tr,vector<vector<int>>&a)
    {
        if(tl==tr)
        {
            tree[v]=a[tl];
            return;
        }
        int tm=(tl+tr)/2;
        build(v*2,tl,tm,a),build(v*2+1,tm+1,tr,a);
        tree[v]=align(tree[v*2],tree[v*2+1]);
    }
    void update(int l,int r,int val,int v,int tl,int tr)
    {
        push(v,tl,tr);
        if(tr<l||tl>r)return;
        if(tr<=r&&tl>=l)
        {
            lazy[v]+=val;
            push(v,tl,tr);
            return;
        }
        int tm=(tl+tr)/2;
        update(l,r,val,v*2,tl,tm),update(l,r,val,v*2+1,tm+1,tr);
        tree[v]=align(tree[v*2],tree[v*2+1]);
    }
    vector<int>seg_sum(int l,int r,int v,int tl,int tr)
    {
        push(v,tl,tr);
        if(tr<l||tl>r)return {0,0,0,0,0};
        if(tr<=r&&tl>=l)return tree[v];
        int tm=(tl+tr)/2;
        return align(seg_sum(l,r,v*2,tl,tm),seg_sum(l,r,v*2+1,tm+1,tr));
    }
    seg_tree(vector<vector<int>>a)
    {
        tree.resize(a.size()*4,vector<int>(5));
        lazy.resize(a.size()*4);
        build(1,0,a.size()-1,a);
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    for(int i=0;i<4;i++)
      base_pow.a[i+1][i]=1;
    for(int i=0;i<5;i++)
    base_pow.a[0][i]=5-i;
    for(int i=0;i<4;i++)
        inv_pow.a[i][i+1]=1;
    for(int i=0;i<5;i++)
    {
        if(i==0)inv_pow.a[4][i]=1;
        else inv_pow.a[4][i]=mod-(5-i+1);
    }
    for(int i=0;i<60;i++)base_pwr[i]=qpow(base_pow,(1LL<<i)),inv_pwr[i]=qpow(inv_pow,(1LL<<i));
    /*
    matrix rs=qpow(base_pow,1);
    for(int i=0;i<5;i++)cout<<rs.a[0][i]<<" ";
    cout<<endl;
    cout<<mult_val({4,3,2,1,0},{rs.a[0][0],rs.a[0][1],rs.a[0][2],rs.a[0][3],rs.a[0][4]});
    */
    int n,q;
    cin>>n>>q;
    vector<int>a(n);
    for(auto &x:a)cin>>x;
    vector<vector<int>>s_val(n,vector<int>(5));
    for(int i=0;i<n;i++)
    {
        int x=a[i];
        x-=4;
        s_val[i]=based_pow({4,3,2,1,0},x);
    }
    seg_tree st(s_val);
    while(q--)
    {
        int d;
        cin>>d;
        if(d==1)
        {
                    int l,r;
                    l=r=1;
        cin>>l>>r;
        l--,r--;
        cout<<st.seg_sum(l,r,1,0,n-1)[0]<<"\n";
        }
        if(d==2)
        {
            int l,r,val;
            cin>>l>>r>>val;
            l--,r--;
            st.update(l,r,val,1,0,n-1);
        }
    }
}
