#include <iostream>
#include <vector>
#include <cmath>
#pragma GCC optimize("Ofast,unroll-loops")
using namespace std;
const int mod=1e8+543;
const int k=5;
const int base=14;
struct matrix
{
    long long int a[k][k];
    matrix()
    {
        for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            a[i][j]=0;
    }

};
matrix tmp;
void mult(matrix &a,matrix &other)
{
    for(int i=0;i<k;i++)
        for(int j=0;j<k;j++)
        tmp.a[i][j]=0;
        for(int v=0;v<k;v++)
            for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            tmp.a[i][j]+=a.a[i][v]*other.a[v][j];
    for(int i=0;i<k;i++)
        for(int j=0;j<k;j++)
        tmp.a[i][j]%=mod;
    swap(a,tmp);
}
matrix fix_mult(matrix &a,matrix &other)
{
        for(int i=0;i<k;i++)
        for(int j=0;j<k;j++)
        tmp.a[i][j]=0;
        for(int v=0;v<k;v++)
            for(int i=0;i<k;i++)
            for(int j=0;j<k;j++)
            tmp.a[i][j]+=a.a[i][v]*other.a[v][j];
    for(int i=0;i<k;i++)
        for(int j=0;j<k;j++)
        tmp.a[i][j]%=mod;
        return tmp;
}
matrix base_pow,inv_pow;
matrix base_pwr[5][(1<<base)],inv_pwr[5][(1<<base)];
vector<long long int>tmp_v(5);
vector<int>based_pow(vector<int>a,long long int pwr)
{
    if(pwr>0)
    {
        for(int it=0;it<5;it++)
        {
            if(pwr==0)break;
            int val=pwr&((1<<base)-1);
            if(val)
            {
                for(int i=0;i<5;i++)tmp_v[i]=0;
                for(int i=0;i<5;i++)
                    for(int j=0;j<5;j++)
                    tmp_v[i]+=base_pwr[it][val].a[i][j]*a[j];
                for(int i=0;i<5;i++)tmp_v[i]%=mod;
                for(int i=0;i<5;i++)a[i]=tmp_v[i];
            }
            pwr/=(1<<base);
        }
    }
    else if(pwr<0)
    {
        pwr=abs(pwr);
        for(int it=0;it<5;it++)
        {
            if(pwr==0)break;
            int val=pwr&((1<<base)-1);
            if(val)
            {
                for(int i=0;i<5;i++)tmp_v[i]=0;
                for(int i=0;i<5;i++)
                    for(int j=0;j<5;j++)
                    tmp_v[i]+=inv_pwr[it][val].a[i][j]*a[j];
                for(int i=0;i<5;i++)tmp_v[i]%=mod;
                for(int i=0;i<5;i++)a[i]=tmp_v[i];
            }
            pwr/=(1<<base);
        }
    }
    return a;
}
void ret_based_pow(vector<int>&a,long long int pwr)
{
    if(pwr>0)
    {
        for(int it=0;it<4;it++)
        {
            if(pwr==0)break;
            int val=pwr&((1<<base)-1);
            if(val)
            {
                for(int i=0;i<5;i++)tmp_v[i]=0;
                for(int i=0;i<5;i++)
                    for(int j=0;j<5;j++)
                    tmp_v[i]+=base_pwr[it][val].a[i][j]*a[j];
                for(int i=0;i<5;i++)tmp_v[i]%=mod;
                for(int i=0;i<5;i++)a[i]=tmp_v[i];
            }
            pwr/=(1<<base);
        }
    }
    else if(pwr<0)
    {
        pwr=abs(pwr);
        for(int it=0;it<4;it++)
        {
            if(pwr==0)break;
            int val=pwr&((1<<base)-1);
            if(val)
            {
                for(int i=0;i<5;i++)tmp_v[i]=0;
                for(int i=0;i<5;i++)
                    for(int j=0;j<5;j++)
                    tmp_v[i]+=inv_pwr[it][val].a[i][j]*a[j];
                for(int i=0;i<5;i++)tmp_v[i]%=mod;
                for(int i=0;i<5;i++)a[i]=tmp_v[i];
            }
            pwr/=(1<<base);
        }
    }
}
matrix qpow(matrix a,long long int val)
{
    matrix rs=a;
    val--;
    while(val)
    {
        if(val%2)mult(rs,a);
        mult(a,a);
        val/=2;
    }
    return rs;
}
struct seg_tree
{
    vector<vector<int>>tree;
    vector<long long int>lazy;
    inline void align(vector<int>&rs,vector<int>&a,vector<int>&b)
    {
        for(int i=0;i<5;i++)rs[i]=(a[i]+b[i])%mod;
    }
    void push(int v,int tl,int tr)
    {
        if(lazy[v]==0)return;
        ret_based_pow(tree[v],lazy[v]);
        if(tl!=tr)
        {
            lazy[v*2]+=lazy[v];
            lazy[v*2+1]+=lazy[v];
        }
        lazy[v]=0;
    }
    void build(int v,int tl,int tr,vector<vector<int>>&a)
    {
        if(tl==tr)
        {
            tree[v]=a[tl];
            return;
        }
        int tm=(tl+tr)/2;
        build(v*2,tl,tm,a),build(v*2+1,tm+1,tr,a);
        align(tree[v],tree[v*2],tree[v*2+1]);
    }
    void update(int l,int r,int val,int v,int tl,int tr)
    {
        if(tr<=r&&tl>=l)
        {
            lazy[v]+=val;
            push(v,tl,tr);
            return;
        }
        push(v,tl,tr);
        if(tr<l||tl>r)return;
        int tm=(tl+tr)/2;
        update(l,r,val,v*2,tl,tm),update(l,r,val,v*2+1,tm+1,tr);
        align(tree[v],tree[v*2],tree[v*2+1]);
    }
    int seg_sum(int l,int r,int v,int tl,int tr)
    {
        if(tr<l||tl>r)return 0;
        push(v,tl,tr);
        if(tr<=r&&tl>=l)return tree[v][0];
        int tm=(tl+tr)/2;
        return (seg_sum(l,r,v*2,tl,tm)+seg_sum(l,r,v*2+1,tm+1,tr))%mod;
    }
    seg_tree(vector<vector<int>>a)
    {
        tree.resize(a.size()*4,vector<int>(5));
        lazy.resize(a.size()*4);
        build(1,0,a.size()-1,a);
    }
};
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    for(int i=0;i<4;i++)
      base_pow.a[i+1][i]=1;
    for(int i=0;i<5;i++)
    base_pow.a[0][i]=5-i;
    for(int i=0;i<4;i++)
        inv_pow.a[i][i+1]=1;
    for(int i=0;i<5;i++)
    {
        if(i==0)inv_pow.a[4][i]=1;
        else inv_pow.a[4][i]=mod-(5-i+1);
    }
    long long int pwr=1;
 //   auto tm=time(0);
  //  auto start = std::chrono::system_clock::now();
    matrix base_p=base_pow,inv_p=inv_pow;
    for(int it=0;it<5;it++)
    {
       for(int j=0;j<(1<<base);j++)
       {
           if(j==0)continue;
           if(j==1)base_pwr[it][j]=base_p,inv_pwr[it][j]=inv_p;
           else
           {
               base_pwr[it][j]=fix_mult(base_pwr[it][j-1],base_p);
               inv_pwr[it][j]=fix_mult(inv_pwr[it][j-1],inv_p);
           }

       }
       base_p=qpow(base_p,(1<<base)),inv_p=qpow(inv_p,(1<<base));
       pwr*=(1<<base);
    }
    //    auto end = std::chrono::system_clock::now();

 //   std::chrono::duration<double> elapsed_seconds = end-start;
   // std::time_t end_time = std::chrono::system_clock::to_time_t(end);

   // std::cout << "finished computation at " << std::ctime(&end_time)
 //             << "elapsed time: " << elapsed_seconds.count() << "s\n";
    /*
    matrix rs=qpow(base_pow,1);
    for(int i=0;i<5;i++)cout<<rs.a[0][i]<<" ";
    cout<<endl;
    cout<<mult_val({4,3,2,1,0},{rs.a[0][0],rs.a[0][1],rs.a[0][2],rs.a[0][3],rs.a[0][4]});
    */
    int n,q;
    cin>>n>>q;
    vector<int>a(n);
    for(auto &x:a)cin>>x;
    vector<vector<int>>s_val(n,vector<int>(5));
    for(int i=0;i<n;i++)
    {
        int x=a[i];
        x-=4;
        for(int j=0;j<5;j++)s_val[i][j]=4-j;
        ret_based_pow(s_val[i],x);
    }
    seg_tree st(s_val);
    while(q--)
    {
        int d;
        cin>>d;
        if(d==1)
        {
                    int l,r;
                    l=r=1;
        cin>>l>>r;
        l--,r--;
        cout<<st.seg_sum(l,r,1,0,n-1)<<"\n";
        }
        if(d==2)
        {
            int l,r,val;
            cin>>l>>r>>val;
            l--,r--;
            st.update(l,r,val,1,0,n-1);
        }
    }
}
