#include "ones.h"
#include <algorithm>

std::vector<int> guessOnes(int n, int k) {
    if (k == 0) {
        return {};
    }
    std::vector<int> positions;

    int pref = 1, suff = n;

    while (positions.size() < k) {
        int l = pref, r = suff;

        while (l < r) {
            int mid = (l + r) >> 1;
            if (hasOnes(pref, mid)) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }
        positions.push_back(l);

        if (positions.size() == k) {
            break;
        }
        pref = l + 1;
        l = pref, r = suff + 1;
        while (l + 1 < r) {
            int mid = (l + r) >> 1;
            if (hasOnes(mid, suff)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        positions.push_back(l);
        suff = l - 1;
    }
    sort(positions.begin(), positions.end());

    return positions;
}
