#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;
#define ve vector
#define ll long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define fi first
#define se second

typedef pair<int, int> pii;
const int M = 1e8+543;
const int N = 1e6+5;
ll x[N];
int T;
double TL;

static std::vector<std::vector<int>> puzzle2;
static std::vector<std::vector<int>> puzzleOut2;
static std::vector<std::vector<bool>> visited2;

void init(int T_, double TL_){
    T = T_;
    TL = TL_;
}

//mt19937 rng(130293)

int rnd(){
    return rand();
}

//static void myAssert(bool f)
//{
//    if (f) return;
//
//    std::cout << "Invalid solution on subtest: " << currSubtest + 1 <<  " / " << numSubtests << std::endl;
//    std::cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
//    std::cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;
//
//    exit(0);
//}

static void DFS2(int i, int j, int n, int m)
{
    if (i < 0) return;
    if (i >= n) return;
    if (j < 0) return;
    if (j >= m) return;

    if (puzzleOut2[i][j] == EMPTY) return;
    if (visited2[i][j]) return;

    visited2[i][j] = true;

    DFS2(i - 1, j, n, m);
    DFS2(i + 1, j, n, m);
    DFS2(i, j - 1, n, m);
    DFS2(i, j + 1, n, m);
}



static bool OK(ve<ve<int>>&b, ve<ve<int>>&a)
{
    puzzleOut2 = b;
    puzzle2 = a;

    int n = sz(b);
    int m = sz(b[0]);

    bool ok = 1;

//    for (const std::vector<int>& row : puzzleOut2)
//    {
//        for (int elem : row)
//        {
//            if (elem > 0 && elem <= 8) std::cerr << elem;
//            else if (elem == EMPTY) std::cerr << " ";
//            else if (elem == HOR_SINGLE) std::cerr << "-";
//            else if (elem == HOR_DOUBLE) std::cerr << "=";
//            else if (elem == VERT_SINGLE) std::cerr << "|";
//            else if (elem == VERT_DOUBLE) std::cerr << "$";
//            else std::cerr << "?";
//        }
//        std::cerr << std::endl;
//    }
//    std::cerr << std::endl;
//
    ok &= ((int) puzzleOut2.size() == n);
    for (int i = 0; i < n; ++i)
    {
        ok &= ((int) puzzleOut2[i].size() == m);
        for (int j = 0; j < m; ++j)
        {
            if (puzzle2[i][j] > 0)
            {
                ok &= (puzzleOut2[i][j] == puzzle2[i][j]);
            }
            else
            {
                ok &= (
                    puzzleOut2[i][j] == EMPTY ||
                    puzzleOut2[i][j] == HOR_SINGLE ||
                    puzzleOut2[i][j] == VERT_SINGLE ||
                    puzzleOut2[i][j] == HOR_DOUBLE ||
                    puzzleOut2[i][j] == VERT_DOUBLE);
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {

            if (puzzleOut2[i][j] > 0)
            {
                int sum = 0;
                if (j > 0 && puzzleOut2[i][j - 1] == HOR_SINGLE) sum += 1;
                if (j > 0 && puzzleOut2[i][j - 1] == HOR_DOUBLE) sum += 2;
                if (j < m - 1 && puzzleOut2[i][j + 1] == HOR_SINGLE) sum += 1;
                if (j < m - 1 && puzzleOut2[i][j + 1] == HOR_DOUBLE) sum += 2;
                if (i > 0 && puzzleOut2[i - 1][j] == VERT_SINGLE) sum += 1;
                if (i > 0 && puzzleOut2[i - 1][j] == VERT_DOUBLE) sum += 2;
                if (i < n - 1 && puzzleOut2[i + 1][j] == VERT_SINGLE) sum += 1;
                if (i < n - 1 && puzzleOut2[i + 1][j] == VERT_DOUBLE) sum += 2;
                ok &= (sum == puzzleOut2[i][j]);
            }
            else if (puzzleOut2[i][j] != EMPTY)
            {
                if (puzzleOut2[i][j] == HOR_SINGLE)
                {
                    ok &= (j > 0 && (puzzleOut2[i][j - 1] == HOR_SINGLE || puzzleOut2[i][j - 1] > 0));
                    ok &= (j < m - 1 && (puzzleOut2[i][j + 1] == HOR_SINGLE || puzzleOut2[i][j + 1] > 0));
                }
                if (puzzleOut2[i][j] == HOR_DOUBLE)
                {
                    ok &= (j > 0 && (puzzleOut2[i][j - 1] == HOR_DOUBLE || puzzleOut2[i][j - 1] > 0));
                    ok &= (j < m - 1 && (puzzleOut2[i][j + 1] == HOR_DOUBLE || puzzleOut2[i][j + 1] > 0));
                }
                if (puzzleOut2[i][j] == VERT_SINGLE)
                {
                    ok &= (i > 0 && (puzzleOut2[i - 1][j] == VERT_SINGLE || puzzleOut2[i - 1][j] > 0));
                    ok &= (i < n - 1 && (puzzleOut2[i + 1][j] == VERT_SINGLE || puzzleOut2[i + 1][j] > 0));
                }
                if (puzzleOut2[i][j] == VERT_DOUBLE)
                {
                    ok &= (i > 0 && (puzzleOut2[i - 1][j] == VERT_DOUBLE || puzzleOut2[i - 1][j] > 0));
                    ok &= (i < n - 1 && (puzzleOut2[i + 1][j] == VERT_DOUBLE || puzzleOut2[i + 1][j] > 0));
                }
            }
        }
    }

    visited2.clear();
    visited2.resize(n);
    for (int i = 0; i < n; ++i)
    {
        visited2[i].resize(m, false);
    }

    bool found = false;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (puzzleOut2[i][j] == EMPTY) continue;
            if (!found)
            {
                DFS2(i, j, n, m);
                found = true;
            }
            ok &= (visited2[i][j]);
        }
    }

//    cout<<(ok ? "OK" : "NOT")<<'\n';
    return ok;
}




bool solve(ve<ve<int>>& a){
    ve<ve<int>>ans = a, b = a;
    srand(time(0));
    int n = sz(a);
    int m = sz(a[0]);
    int k = 0;
    ve<pii>c;

    ve<ve<int>>cnt(n, ve<int>(m, 0));
    ve<ve<int>>used(n, ve<int>(m));
    int cl = 0;

    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            if(a[i][j]){
                c.push_back({i, j});
                k++;
            }
        }
    }
    ve<int>cx = {1, 0, -1, 0}, cy = {0, 1, 0, -1};

    bool go = 1;
    while(go){
//        cout<<"Gen "<<endl;
        int ver = rnd()%k;
        ve<int>st(4);
        int x = c[ver].se, y = c[ver].fi;
        int need = a[y][x];
        int cur = 0;
        while(need){
            int x_ = x+cx[cur], y_ = y+cy[cur];
            if((x_ >=0 && x_<m && y_>=0 && y_<n && !a[y_][x_] && st[cur] < 2 && rnd()%2)){
                st[cur]++;
                need--;
            }
            cur++;
            if(cur == 4)cur = 0;
        }
//    cout<<ver<<endl;
//    for(auto i : st)cout<<i<<' ';
//    cout<<endl;

        /// draw new bridges
        for(int h =  0;h<4;h++){
            if(st[h]){
                if(h==0){
                    for(int j = x+1; j<m && !a[y][j]; j++){
                        b[y][j] = (st[0] == 1 ? -1 : -3);
                    }
                }
                else if(h==1){
                    for(int i = y+1; i<n && !a[i][x]; i++){
                        b[i][x] = (st[1] ==1 ? -2 : -4);
                    }
                }
                else if(h==2){
                    for(int j = x-1; j>=0 && !a[y][j]; j--){
                        b[y][j] = (st[2] == 1 ? -1 : -3);
                    }
                }
                else{
                    for(int i = y-1; i>=0 && !a[i][x]; i--){
                        b[i][x] = (st[3] ==1 ? -2 : -4);
                    }
                }
            }
            else{
                int x_ = x+cx[h], y_ = y+cy[h];
                if(x_ >=0 && x_<m && y_>=0 && y_<n && !a[y_][x_]){
                    b[y_][x_] = 0;
                }
            }
        }
//        cout<<"after modify\n";
//        for (const std::vector<int>& row : b)
//        {
//            for (int elem : row)
//            {
//                if (elem > 0 && elem <= 8) std::cerr << elem;
//                else if (elem == EMPTY) std::cerr << " ";
//                else if (elem == HOR_SINGLE) std::cerr << "-";
//                else if (elem == HOR_DOUBLE) std::cerr << "=";
//                else if (elem == VERT_SINGLE) std::cerr << "|";
//                else if (elem == VERT_DOUBLE) std::cerr << "$";
//                else std::cerr << "?";
//            }
//            std::cerr << std::endl;
//        }
//        std::cerr << std::endl;

        /// delete useless bridges
        cl++;
        for(int i=0;i<n;i++){
            for(int j=0;j<m;j++)if(b[i][j] < 0 && used[i][j] != cl){
                int res = 0;
                if(b[i][j] == -1 || b[i][j] == -3){
                    for(int x_ = j-1; x_>=0; x_--){
                        if(a[i][x_]){
                            res++;
                            used[i][x_] = cl;
                            break;
                        }
                        else if(b[i][x_] != b[i][j])break;
                    }
                    for(int x_ = j+1; x_<m; x_++){
                        if(a[i][x_]){
                            res++;
                            used[i][x_] = cl;
                            break;
                        }
                        else if(b[i][x_] != b[i][j])break;
                    }
                }
                else{
                    for(int y_ = i-1; y_>=0; y_--){
                        if(a[y_][j]){
                            res++;
                            used[y_][j] = cl;
                            break;
                        }
                        else if(b[y_][j] != b[i][j])break;
                    }
                    for(int y_ = i+1; y_<n; y_++){
                        if(a[y_][j]){
                            res++;
                            used[y_][j] = cl;
                            break;
                        }
                        else if(b[y_][j] != b[i][j])break;
                    }
                }
                if(res != 2){/// need to remove
                    if(b[i][j] == -1 || b[i][j] == -3){
                        for(int x_ = j-1; x_>=0 && b[i][j] == b[i][x_]; x_--){
                            b[i][x_] = 0;
                        }
                        for(int x_ = j+1; x_<m && b[i][j] == b[i][x_]; x_++){
                            b[i][x_] = 0;
                        }
                    }
                    else{
                        for(int y_ = i-1; y_>=0 && b[i][j] == b[y_][j]; y_--){
                            b[y_][j] = 0;
                        }
                        for(int y_ = i+1; y_<n && b[i][j] == b[y_][j]; y_++){
                            b[y_][j] = 0;
                        }
                    }
                    b[i][j] = 0;
                }
            }
        }
//        cout<<"after delete\n";
//        for (const std::vector<int>& row : b)
//        {
//            for (int elem : row)
//            {
//                if (elem > 0 && elem <= 8) std::cerr << elem;
//                else if (elem == EMPTY) std::cerr << " ";
//                else if (elem == HOR_SINGLE) std::cerr << "-";
//                else if (elem == HOR_DOUBLE) std::cerr << "=";
//                else if (elem == VERT_SINGLE) std::cerr << "|";
//                else if (elem == VERT_DOUBLE) std::cerr << "$";
//                else std::cerr << "?";
//            }
//            std::cerr << std::endl;
//        }
//        std::cerr << std::endl;



        /// check correctness

        if(OK(b, a)){
            a = b;
            return 1;
        }

//        /// calc W, solve
    }


    a = ans;
    return 1;
}
