#include "puzzle.h"
#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)x.size()

int NUM;
double TL;
int passed;

struct str {
    int x1;
    int y1;
    int x2;
    int y2;
};

const int N = 100001;
int p[N], siz[N];

void init(int n) {
    for (int i = 0; i <= n; i++) {
        p[i] = i;
        siz[i] = 1;
    }
}

int get(int v) {
    if (p[v] == v) return v;
    return p[v] = get(p[v]);
}

void merge(int u, int v) {
    int x = get(u), y = get(v);
    if (x == y) return;
    if (siz[x] > siz[y]) swap(x, y);
    p[x] = y;
    siz[y] += siz[x];
    siz[x] = 0;
}

bool solve(std::vector<std::vector<int>>& puzzle) {
    int n = sz(puzzle);
    int m = sz(puzzle[0]);

    vector<str> v;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (!puzzle[i][j]) continue;
            for (int j1 = j + 1; j1 < m; j1++) {
                if (puzzle[i][j1]) {
                    v.push_back({i, j, i, j1});
                    break;
                }
            }
        }
    }
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (!puzzle[i][j]) continue;
            for (int i1 = i + 1; i1 < n; i1++) {
                if (puzzle[i1][j]) {
                    v.push_back({i, j, i1, j});
                    break;
                }
            }
        }
    }

    int s = sz(v);
    vector<int> order(s);
    for (int i = 0; i < s; i++) order[i] = i;
    mt19937 gen(time(nullptr));
    while (timePassed() < 1.95) {
        shuffle(order.begin(), order.end(), gen);
        for (int mask = 0; mask < (1 << s); mask++) {
            vector<vector<int>> mat = puzzle;
            vector<vector<int>> cnt(n, vector<int>(m));
            init(n * m + n + m);
            bool br = false;
            for (int i = 0; i < s; i++) {
                merge(v[order[i]].x1 * m + v[order[i]].y1, v[order[i]].x2 * m + v[order[i]].y2);
                if (v[order[i]].x1 == v[order[i]].x2) {
                    int x = v[order[i]].x1;
                    int place = -1;
                    cnt[x][v[order[i]].y1]++;
                    cnt[x][v[order[i]].y2]++;
                    if ((mask >> i) & 1) {
                        place = -3;
                        cnt[x][v[order[i]].y1]++;
                        cnt[x][v[order[i]].y2]++;
                    }
                    for (int it = v[order[i]].y1 + 1; it < v[order[i]].y2; it++) {
                        if (mat[x][it]) {
                            br = true;
                            break;
                        }
                        mat[x][it] = place;
                    }
                } else {
                    int y = v[order[i]].y1;
                    int place = -2;
                    cnt[v[order[i]].x1][y]++;
                    cnt[v[order[i]].x2][y]++;
                    if ((mask >> i) & 1) {
                        place = -4;
                        cnt[v[order[i]].x1][y]++;
                        cnt[v[order[i]].x2][y]++;
                    }
                    for (int it = v[order[i]].x1 + 1; it < v[order[i]].x2; it++) {
                        if (mat[it][y]) {
                            br = true;
                            break;
                        }
                        mat[it][y] = place;
                    }
                }

                if (br) break;
                set<int> comps;
                bool cur = 1;
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        if (puzzle[i][j]) {
                            comps.insert(get(i * m + j));
                            if (cnt[i][j] > puzzle[i][j]) {
                                br = true;
                                break;
                            } else if (cnt[i][j] < puzzle[i][j]) {
                                cur = 0;
                            }
                        }
                    }
                }
                if (sz(comps) == 1 && cur) {
                    puzzle = mat;
                    passed++;
                    return true;
                }
            }
        }
    }

    passed++;
    return true;
}

void init(int numSubtests, double timeLimit) {
    NUM = numSubtests;
    TL = timeLimit;
}
