#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;
#define ll long long
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(),x.end()

vector<vector<int>> to_check, the_first;
static std::vector<std::vector<bool>> used;
static int n, m;

static void DFS2(int i, int j) {
    if (i < 0) return;
    if (i >= n) return;
    if (j < 0) return;
    if (j >= m) return;

    if (to_check[i][j] == EMPTY) return;
    if (used[i][j]) return;

    used[i][j] = true;

    DFS2(i - 1, j);
    DFS2(i + 1, j);
    DFS2(i, j - 1);
    DFS2(i, j + 1);
}

static bool check() {
    if ((int) to_check.size() != n) {
        return false;
    }
    for (int i = 0; i < n; ++i) {
        if ((int) to_check[i].size() != m) {
            return false;
        }
        for (int j = 0; j < m; ++j) {
            if (the_first[i][j] > 0) {
                if (to_check[i][j] != the_first[i][j]) {
                    return false;
                }
            } else {
                if (!(
                        to_check[i][j] == EMPTY ||
                        to_check[i][j] == HOR_SINGLE ||
                        to_check[i][j] == VERT_SINGLE ||
                        to_check[i][j] == HOR_DOUBLE ||
                        to_check[i][j] == VERT_DOUBLE)) {
                    return false;
                }
            }
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {

            if (to_check[i][j] > 0) {
                int sum = 0;
                if (j > 0 && to_check[i][j - 1] == HOR_SINGLE) sum += 1;
                if (j > 0 && to_check[i][j - 1] == HOR_DOUBLE) sum += 2;
                if (j < m - 1 && to_check[i][j + 1] == HOR_SINGLE) sum += 1;
                if (j < m - 1 && to_check[i][j + 1] == HOR_DOUBLE) sum += 2;
                if (i > 0 && to_check[i - 1][j] == VERT_SINGLE) sum += 1;
                if (i > 0 && to_check[i - 1][j] == VERT_DOUBLE) sum += 2;
                if (i < n - 1 && to_check[i + 1][j] == VERT_SINGLE) sum += 1;
                if (i < n - 1 && to_check[i + 1][j] == VERT_DOUBLE) sum += 2;
                if (sum != to_check[i][j]) {
                    return false;
                }
            } else if (to_check[i][j] != EMPTY) {
                if (to_check[i][j] == HOR_SINGLE) {
                    if (!(j > 0 && (to_check[i][j - 1] == HOR_SINGLE || to_check[i][j - 1] > 0))) {
                        return false;
                    }
                    if (!(j < m - 1 && (to_check[i][j + 1] == HOR_SINGLE || to_check[i][j + 1] > 0))) {
                        return false;
                    }
                }
                if (to_check[i][j] == HOR_DOUBLE) {
                    if (!(j > 0 && (to_check[i][j - 1] == HOR_DOUBLE || to_check[i][j - 1] > 0))) {
                        return false;
                    }
                    if (!(j < m - 1 && (to_check[i][j + 1] == HOR_DOUBLE || to_check[i][j + 1] > 0))) {
                        return false;
                    }
                }
                if (to_check[i][j] == VERT_SINGLE) {
                    if (!(i > 0 && (to_check[i - 1][j] == VERT_SINGLE || to_check[i - 1][j] > 0))) {
                        return false;
                    }
                    if (!(i < n - 1 && (to_check[i + 1][j] == VERT_SINGLE || to_check[i + 1][j] > 0))) {
                        return false;
                    }
                }
                if (to_check[i][j] == VERT_DOUBLE) {
                    if (!(i > 0 && (to_check[i - 1][j] == VERT_DOUBLE || to_check[i - 1][j] > 0))) {
                        return false;
                    }
                    if (!(i < n - 1 && (to_check[i + 1][j] == VERT_DOUBLE || to_check[i + 1][j] > 0))) {
                        return false;
                    }
                }
            }
        }
    }

    used.clear();
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        used[i].resize(m, false);
    }

    bool found = false;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (to_check[i][j] == EMPTY) continue;
            if (!found) {
                DFS2(i, j);
                found = true;
            }
            if (!(used[i][j])) {
                return false;
            }
        }
    }

    return true;
}


mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int get(int l, int r) {
    uniform_int_distribution a(l, r);
    return a(rnd);
}


void init(int numSubtests, double timeLimit) {

}

const int N = 50;
vector<vector<int>> a, b;

void draw(int i, int j, int x, int y, int cnt = 3) {
    if (cnt == 4) {
        cnt = min(b[i][j], b[x][y]);
        cnt = min(cnt, 2);
        if (cnt == 0) {
            return;
        }
        cnt = get(1, cnt);
    }
    if (cnt == 3) {
        cnt = min(b[i][j], b[x][y]);
        cnt = min(cnt, 2);
    }
    if (cnt == 0) {
        return;
    }
    b[i][j] -= cnt;
    b[x][y] -= cnt;
    if (i == x) {
        int r = max(j, y);
        for (int k = min(j, y) + 1; k < r; ++k) {
            if (cnt == 1) {
                a[i][k] = -1;
            } else {
                a[i][k] = -3;
            }
        }
    } else if (j == y) {
        int r = max(i, x);
        for (int k = min(i, x) + 1; k < r; ++k) {
            if (cnt == 1) {
                a[k][j] = -2;
            } else {
                a[k][j] = -4;
            }
        }
    } else {
        assert(false);
    }
}

vector<vector<int>> l, r, u, d;

void calc() {
    l = a;
    r = a;
    u = a;
    d = a;
    for (int i = 0; i < n; ++i) {
        int last = -1;
        for (int j = 0; j < m; ++j) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                l[i][j] = last;
                last = j;
            }
        }
        last = -1;
        for (int j = m - 1; j >= 0; --j) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                r[i][j] = last;
                last = j;
            }
        }
    }
    for (int j = 0; j < m; ++j) {
        int last = -1;
        for (int i = 0; i < n; ++i) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                u[i][j] = last;
                last = i;
            }
        }
        last = -1;
        for (int i = n - 1; i >= 0; --i) {
            if (a[i][j] < 0) {
                last = -1;
            } else if (a[i][j] > 0) {
                d[i][j] = last;
                last = i;
            }
        }
    }
}


vector<pair<int, int>> must, v2;

//vector<vector<int>>
bool anymust(vector<pair<int, int>> &v) {
    must.clear();
    v2.clear();
    for (auto [i, j]: v) {
        int sum = 0;
        int cnt = 0;
        if (l[i][j] != -1) {
            sum += min(2, b[i][l[i][j]]);
            ++cnt;
        }
        if (r[i][j] != -1) {
            sum += min(2, b[i][r[i][j]]);
            ++cnt;
        }
        if (u[i][j] != -1) {
            sum += min(2, b[u[i][j]][j]);
            ++cnt;
        }
        if (d[i][j] != -1) {
            sum += min(2, b[d[i][j]][j]);
            ++cnt;
        }
        if (sum == b[i][j] || (b[i][j] == 1 && cnt == 1)) {
//            cerr << i << " " << j << endl;
            must.pb({i, j});
        } else {
            v2.pb({i, j});
        }
    }
    if (must.empty()) {
        return false;
    }
    return true;
}

vector<vector<int>> bsave;
vector<pair<int, int>> vsave;

bool solve(std::vector<std::vector<int>> &puzzle) {
    the_first = puzzle;
    a = puzzle;
    vector<pair<int, int>> v;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] != 0) {
                v.pb({i, j});
            }
        }
    }
    b = a;
    calc();
    while (!v.empty() && anymust(v)) {
        for (auto [i, j]: must) {
            if (l[i][j] != -1) {
                draw(i, j, i, l[i][j]);
            }
            if (r[i][j] != -1) {
                draw(i, j, i, r[i][j]);
            }
            if (d[i][j] != -1) {
                draw(i, j, d[i][j], j);
            }
            if (u[i][j] != -1) {
                draw(i, j, u[i][j], j);
            }
        }
        v = v2;
//        for(int i=0;i<n;++i){
//            for(int j=0;j<m;++j){
//                cerr << a[i][j] << ' ';
//            }
//            cerr << "\n";
//        }
        calc();
    }
    puzzle = a;
    bsave = b;
    vsave = v;
    bool ans_is_ready = v.empty();
    while (!ans_is_ready) {
        while (!v.empty()) {
            int x = get(0, (int) v.size() - 1);
            int i = v[x].F;
            int j = v[x].S;
            vector<pair<int, int>> vars;
            if (l[i][j] != -1) {
                vars.pb({i, l[i][j]});
            }
            if (r[i][j] != -1) {
                vars.pb({i, r[i][j]});
            }
            if (d[i][j] != -1) {
                vars.pb({d[i][j], j});
            }
            if (u[i][j] != -1) {
                vars.pb({u[i][j], j});
            }
            x = get(0, (int) vars.size() - 1);
            draw(i, j, vars[x].F, vars[x].S, 4);
            calc();
            while (!v.empty() && anymust(v)) {
                for (auto [i, j]: must) {
                    if (l[i][j] != -1) {
                        draw(i, j, i, l[i][j]);
                    }
                    if (r[i][j] != -1) {
                        draw(i, j, i, r[i][j]);
                    }
                    if (d[i][j] != -1) {
                        draw(i, j, d[i][j], j);
                    }
                    if (u[i][j] != -1) {
                        draw(i, j, u[i][j], j);
                    }
                }
                v = v2;
//        for(int i=0;i<n;++i){
//            for(int j=0;j<m;++j){
//                cerr << a[i][j] << ' ';
//            }
//            cerr << "\n";
//        }
                calc();
            }
        }
        to_check = a;
        if (check()) {
            ans_is_ready = true;
            puzzle = a;
        } else {
            v = vsave;
            b = bsave;
            a = puzzle;
        }
    }
    return true;
}