#include <bits/stdc++.h>
#include "puzzle.h"

#define int long long
#define ll long long
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;


//HOR_SINGLE = -1;
//VERT_SINGLE = -2;
//HOR_DOUBLE = -3;
//VERT_DOUBLE = -4;

void init(int numSubtests, double timeLimit) {

}

int cost(int w) {
    if (w >= 0) return 0;
    if (w >= -2) return 1;
    return 2;
}

int n, m;
vector<int> p, sz;

int get(int v) {
    if (v == p[v]) return v;
    return p[v] = v;
}

void un(int u, int v) {
    u = get(u), v = get(v);
    if (u == v) return;
    if (sz[u] > sz[v]) swap(u, v);
    sz[v] += sz[u], p[u] = v;
}

int V(int i, int j) {
    return i * m + j;
}

void dsu() {
    p.clear(), sz.clear();
    p.resize(n * m), sz.resize(n * m, 1);
    for (int i = 0; i < n * m; ++i) {
        p[i] = i;
    }
}

int check(vector<vector<int>> &t) {
    dsu();
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (t[i][j] <= 0) continue;
            sum++;
            int uv, dv, lv, rv;
            if (i) uv = cost(t[i - 1][j]);
            if (j) lv = cost(t[i][j - 1]);
            if (i + 1 < n) dv = cost(t[i + 1][j]);
            if (j + 1 < m) rv = cost(t[i][j + 1]);
            int tot = uv + dv + lv + rv;
            if (tot != t[i][j]) return 0;
            int v = V(i, j);
            if (uv) un(v, V(i - 1, j));
            if (dv) un(v, V(i + 1, j));
            if (lv) un(v, V(i, j - 1));
            if (rv) un(v, V(i, j + 1));
        }
    }
    return sz[get(0)] == sum;
}

const int N = 50;
int L[N], R[N], U[N], D[N];
int BAD;

void putl(int i, int j, int ty, vector<vector<int>> &t) {
    for (int k = L[i] + 1; k < j; ++k) {
        if (t[i][k] != 0 && t[i][k] != ty) {
            BAD = 1;
            return;
        }
        t[i][k] = ty;
    }
}

void putr(int i, int j, int ty, vector<vector<int>> &t) {
    for (int k = j + 1; k < R[j]; ++k) {
        if (t[i][k] != 0 && t[i][k] != ty) {
            BAD = 1;
            return;
        }
        t[i][k] = ty;
    }
}

void putu(int i, int j, int ty, vector<vector<int>> &t) {
    for (int k = U[j] + 1; k < i; ++k) {
        if (t[k][j] != 0 && t[k][j] != ty) {
            BAD = 1;
            return;
        }
        t[k][j] = ty;
    }
}

void putd(int i, int j, int ty, vector<vector<int>> &t) {
    for (int k = i + 1; k < D[j]; ++k) {
        if (t[k][j] != 0 && t[k][j] != ty) {
            BAD = 1;
            return;
        }
        t[k][j] = ty;
    }
}

mt19937 rnd(239);

bool solve(vector<vector<int>> &t) {
    n = sz(t), m = sz(t[0]);
    auto a = t;
    fill(L, L + n, n), fill(R, R + n, -1);
    fill(U, U + m, m), fill(D, D + m, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!a[i][j]) continue;
            L[i] = min(L[i], j);
            R[i] = max(R[i], j);
            U[j] = min(U[j], i);
            D[j] = max(D[j], i);
        }
    }
    BAD = 1;
    while (BAD || !check(t)) {
        t = a;
        BAD = 0;
        for (int i = 0; i < n && !BAD; ++i) {
            for (int j = 0; j < m && !BAD; ++j) {
                int okl = L[i] < j;
                int okr = R[i] > j;
                int oku = U[j] < i;
                int okd = D[j] > i;
                vector<pair<char, int>> pos;
                if (okl) pos.emplace_back('l', -1), pos.emplace_back('l', -3);
                if (okr) pos.emplace_back('r', -1), pos.emplace_back('r', -3);

                if (oku) pos.emplace_back('u', -2), pos.emplace_back('u', -4);
                if (okd) pos.emplace_back('d', -2), pos.emplace_back('d', -4);

                shuffle(all(pos), rnd);
                int sum = 0;
                map<char, int> was;
                for (auto [c, ty]: pos) {
                    if (sum == a[i][j]) break;
                    if (was[c]) continue;
                    was[c] = 1;
                    sum += cost(ty);
                    if (c == 'l') putl(i, j, ty, t);
                    if (c == 'r') putr(i, j, ty, t);
                    if (c == 'u') putu(i, j, ty, t);
                    if (c == 'd') putd(i, j, ty, t);
                }
                if (sum != a[i][j]) {
                    BAD = 1;
                    break;
                }
            }
        }
    }
    return true;
}
