#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
const ll mod = 1e8 + 543;

struct node {
    int sum;
};
vector<node> tree;

unordered_map<int, int> mp;

void build(int v, int l, int r, vector<int> &a) {
    if (r - l == 1) {
        tree[v].sum = mp[a[l]];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, a);
    build(2 * v + 2, m, r, a);
    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
}

void update(int v, int l, int r, int pos, int x, vector<int> &a) {
    if (pos >= r || pos < l) {
        return;
    }
    if (r - l == 1) {
        a[l] += x;
        tree[v].sum = mp[a[l]];
        return;
    }
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, pos, x, a);
    update(2 * v + 2, m, r, pos, x, a);
    tree[v].sum = tree[2 * v + 1].sum + tree[2 * v + 2].sum;
}

ll query(int v, int l, int r, int ql, int qr) {
    if (r <= ql || l >= qr) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return tree[v].sum;
    }
    int m = (l + r) / 2;
    return query(2 * v + 1, l, m, ql, qr) + query(2 * v + 2, m, r, ql, qr);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    set<int> st;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        st.insert(a[i]);
    }
    vector<int> b = a;
    vector<vector<int>> p(q);
    for(int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        p[i].push_back(type);
        int l, r;
        cin >> l >> r;
        p[i].push_back(l - 1);
        p[i].push_back(r);
        if (type == 2) {
            int val;
            cin >> val;
            b[l - 1] += val;
            st.insert(b[l - 1]);
            p[i].push_back(val);
        }
    }
    vector<int> needmn, needpl;
    for(auto it : st) {
        if (it < 0) {
            needmn.push_back(-it);
        } else {
            needpl.push_back(it);
        }
    }
    reverse(needmn.begin(), needmn.end());
    vector<int> ch(5);
    ch[0] = 0;
    ch[1] = 1;
    ch[2] = 2;
    ch[3] = 3;
    ch[4] = 4;
    vector<pair<int, int>> gg;
    if ((int)needmn.size()) {
        int pos = 0;
        for(int i = 0; i < abs(needmn[(int)needmn.size() - 1]); ++i) {
            int x = ch[4] - ch[3] * 5 - ch[2] * 4 - ch[1] * 3 - ch[0] * 2;
            x %= mod;
            x = (x + mod) % mod;
            if (needmn[pos] == (i + 1)) {
                pos++;
                gg.push_back({-(i + 1), x});
            }
            ch[4] = ch[3];
            ch[3] = ch[2];
            ch[2] = ch[1];
            ch[1] = ch[0];
            ch[0] = x;
        }
    }
    ch[0] = 0;
    ch[1] = 1;
    ch[2] = 2;
    ch[3] = 3;
    ch[4] = 4;
    if ((int)needpl.size()) {
        int pos = 0;
        while(pos < (int)needpl.size() && needpl[pos] <= 4) {
            gg.push_back({needpl[pos], needpl[pos]});
            pos++;
        }
        for(int i = 5; i <= abs(needpl[(int)needpl.size() - 1]); ++i) {
            int x = ch[4] * 5 + ch[3] * 4 + ch[2] * 3 + ch[1] * 2 + ch[0] * 1;
            x %= mod;
            if (needpl[pos] == (i)) {
                pos++;
                gg.push_back({i, x});
            }
            ch[0] = ch[1];
            ch[1] = ch[2];
            ch[2] = ch[3];
            ch[3] = ch[4];
            ch[4] = x;
        }
    }
    for(auto [u, v] : gg) {
        mp[u] = v;
    }
    tree.resize(4 * n);
    build(0, 0, n, a);
    for(int i = 0; i < q; ++i) {
        if (p[i][0] == 1) {
            int l = p[i][1], r = p[i][2];
            cout << query(0, 0, n, l, r) % mod << '\n';
        } else {
            int l = p[i][1], r = p[i][2], x = p[i][3];
            update(0, 0, n, l, x, a);
        }
    }

}
