#include "ones.h"
#include <random>
#include <iostream>

std::vector<int> answer;

std::mt19937 rnd(std::random_device{}());

const int blockSZ = 377;

int pickInt() {
	std::uniform_int_distribution<int> pick(0, INT_MAX);
	return pick(rnd);
}

int splitFind(int l, int r, int mx) {
	mx = std::min(mx, r - l);
	//std::cout << "Trying to find " << l << ' ' << r << ' ' << mx << std::endl;
	if (l + 1 == r) {
		if (hasOnes(l + 1, l + 1)) {
			answer.push_back(l + 1);
			//std::cout << "Finded " << l << '!' << std::endl;
			return 1;
		} else {
			return 0;
		}
	}
	int mg = (l + r) / 2;
	int res = 0;
	if (pickInt() % 2) {
		if (hasOnes(l + 1, mg)) {
			res = splitFind(l, mg, mx);
			if (res >= mx)
				return res;
		}
		if (res == 0) {
			res += splitFind(mg, r, mx);
		} else if (hasOnes(mg + 1, r)) {
			res += splitFind(mg, r, mx - res);
		}
	} else {
		if (hasOnes(mg + 1, r)) {
			res = splitFind(mg, r, mx);
			if (res >= mx)
				return res;
		}
		if (res == 0) {
			res += splitFind(l, mg, mx);
		} else if (hasOnes(l + 1, mg)) {
			res += splitFind(l, mg, mx - res);
		}
	}
	return res;
}

std::vector<int> guessOnes(int n, int k) {
	answer.clear();
	splitFind(0, n, k);
	std::sort(answer.begin(), answer.end());
	return answer;
}