#include "ones.h"
#include <random>
#include <iostream>
#include <algorithm>

std::vector<int> answer;

std::mt19937 rnd(std::random_device{}());

const int blockSplit = 10;

int pickInt() {
	std::uniform_int_distribution<int> pick(0, 2147483647);
	return pick(rnd);
}

int splitFind(int l, int r, int mx) {
	mx = std::min(mx, r - l);
	if (l + 1 == r) {
		answer.push_back(l + 1);
		return 1;
	}
	int res = 0;
	int BlockSZ = (r - l + blockSplit - 1) / blockSplit;
	for (int i = l; i < r; i += BlockSZ) {
		if (res == 0 && i + BlockSZ >= r) {
			res += splitFind(i, std::min(r, i + BlockSZ), mx);
		} else if (hasOnes(i + 1, std::min(r, i + BlockSZ))) {
			res += splitFind(i, std::min(r, i + BlockSZ), mx - res);
		}
		if (res >= mx)
			return res;
	}
	return res;
}

std::vector<int> guessOnes(int n, int k) {
	answer.clear();
	splitFind(0, n, k);
	std::sort(answer.begin(), answer.end());
	return answer;
}