#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

const int mod = 1e8 + 543;
const int maxn = 1e5 + 5;

struct Node {
	int pos = 0;
	deque<int> last5;
};

vector<int> tree(maxn * 4);
vector<Node> nodes(maxn);

#define segl i * 2 + 1, l, (r + l) / 2
#define segr i * 2 + 2, (r + l) / 2, r

void advanceNode(Node& a, int n) {
	if (n < 0)
		exit(-1);
	for (int i = 0; i < n; ++i) {
		int res = 0;
		for (int j = 5; j >= 1; --j) {
			res += a.last5[j - 1] * j;
			res %= mod;
		}
		a.pos++;
		a.last5.pop_front();
		a.last5.push_back(res);
	}
}

void build(int i, int l, int r) {
	if (l + 1 == r) {
		tree[i] = nodes[l].last5.back();
		return;
	}
	build(segl);
	build(segr);
	tree[i] = (tree[i * 2 + 1] + tree[i * 2 + 2]) % mod;
}

void mupdate(int i, int l, int r, int q, int x) {
	if (q >= r || q < l)
		return;
	if (l + 1 == r) {
		advanceNode(nodes[l], x);
		tree[i] = nodes[l].last5.back();
		return;
	}
	mupdate(segl, q, x);
	mupdate(segr, q, x);
	tree[i] = (tree[i * 2 + 1] + tree[i * 2 + 2]) % mod;
}

int mget(int i, int l, int r, int ql, int qr) {
	if (ql >= r || l >= qr)
		return 0;
	if (ql <= l && r <= qr)
		return tree[i];
	return (mget(segl, ql, qr) + mget(segr, ql, qr)) % mod;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector<pair<int, int>> a(n);
	int cnt = 0;
	for (auto& [x, y] : a) {
		cin >> x;
		y = cnt++;
	}
	sort(a.begin(), a.end());
	Node tmp;
	tmp.last5 = { -4, -3, 33, -22, 0 };
	for (auto [x, y] : a) {
		advanceNode(tmp, x - tmp.pos);
		nodes[y] = tmp;
	}

	build(0, 0, n);

	for (int i = 0; i < q; ++i) {
		int t, l, r;
		cin >> t >> l >> r;
		if (t == 1) {
			cout << mget(0, 0, n, l - 1, r) << '\n';
		}
		else {
			int x;
			cin >> x;
			for (int i = l; i <= r; ++i) {
				mupdate(0, 0, n, i - 1, x);
			}
		}
	}
}

int main() {
	solve();
	return 0;
}