#include <bits/stdc++.h>

#include "puzzle.h"
using namespace std;
template<typename T>
using v1 = vector<T>;
template<typename T>
using v2 = v1<v1<T>>;

double timeLimit_;

void init(int numSubtests, double timeLimit) {
    timeLimit_ = timeLimit;
}

const int MAX = 47*47;
int H, W;
vector<int> rs, cs;
int sz;
int nextR[MAX], nextL[MAX], nextU[MAX], nextD[MAX];
int getValL(v2<int> &puzzle, int r, int c) {
    while(c > 0) {
        c--;
        if(puzzle[r][c]) {
            return puzzle[r][c];
        }
    }
    return -2;
}
int getValR(v2<int> &puzzle, int r, int c) {
    while(c < W-1) {
        c++;
        if(puzzle[r][c]) {
            return puzzle[r][c];
        }
    }
    return -2;
}
int getValU(v2<int> &puzzle, int r, int c) {
    while(r > 0) {
        r--;
        if(puzzle[r][c]) {
            return puzzle[r][c];
        }
    }
    return -1;
}
int getValD(v2<int> &puzzle, int r, int c) {
    while(r < H - 1) {
        r++;
        if(puzzle[r][c]) {
            return puzzle[r][c];
        }
    }
    return -1;
}
void sendLineL(v2<int> &puzzle, int r, int c, int strength) {
    strength = 1 - strength*2;
    while(c > 0) {
        c--;
        if(puzzle[r][c]) {
            return;
        }
        puzzle[r][c] = strength;
    }
}
void sendLineR(v2<int> &puzzle, int r, int c, int strength) {
    strength = 1 - strength*2;
    while(c < W-1) {
        c++;
        if(puzzle[r][c]) {
            return;
        }
        puzzle[r][c] = strength;
    }
}
void sendLineU(v2<int> &puzzle, int r, int c, int strength) {
    strength = 0 - strength*2;
    while(r > 0) {
        r--;
        if(puzzle[r][c]) {
            return;
        }
        puzzle[r][c] = strength;
    }
}
void sendLineD(v2<int> &puzzle, int r, int c, int strength) {
    strength = 0 - strength*2;
    while(r < H - 1) {
        r++;
        if(puzzle[r][c]) {
            return;
        }
        puzzle[r][c] = strength;
    }
}

bool rec(v2<int> &puzzle) {
    if(timePassed() > 9.6) { return false; }
    // for(v1<int> &row : puzzle) {
    //     for(int x : row) {
    //         cout << x << ' ';
    //     }
    //     cout << endl;
    // }
    int opti = -1, optr = 0, optc = 0, optmarg = 1000;
    int optvalL, optvalR, optvalU, optvalD, optneed;
    for(int i = 0; i < sz; i ++) {
        int r = rs[i], c = cs[i];
        int need = puzzle[r][c];
        int valL = getValL(puzzle,r,c);
        int valR = getValR(puzzle,r,c);
        int valU = getValU(puzzle,r,c);
        int valD = getValD(puzzle,r,c);
        if(valL < 0) {
            valL = -valL;
            if(valL&1) {
                need -= 1 + valL/2;
            }
            valL = 0;
        }
        if(valR < 0) {
            valR = -valR;
            if(valR&1) {
                need -= 1 + valR/2;
            }
            valR = 0;
        }
        if(valU < 0) {
            valU = -valU;
            if(!(valU&1)) {
                need -= valU/2;
            }
            valU = 0;
        }
        if(valD < 0) {
            valD = -valD;
            if(!(valD&1)) {
                need -= valD/2;
            }
            valD = 0;
        }
        if(need == 0) { continue; }
        int marg = min(valL,2) + min(valR,2) + min(valU,2) + min(valD,2) - need;
        if(marg < 0) { return false; }
        if(marg >= optmarg) {
            continue;
        }
        opti = i;
        optr = r;
        optc = c;
        optmarg = marg;
        optvalL = valL;
        optvalR = valR;
        optvalU = valU;
        optvalD = valD;
        optneed = need;
    }
    if(opti == -1) { return true; }
    
    int i = opti;
    int r = optr;
    int c = optc;
    int marg = optmarg;
    int valL = optvalL;
    int valR = optvalR;
    int valU = optvalU;
    int valD = optvalD;
    int need = optneed;
    if(need && valL) {
        int strength = min(valL,need);
        sendLineL(puzzle,r,c,strength);
        need -= strength;
    }
    if(need && valR) {
        int strength = min(valR,need);
        sendLineR(puzzle,r,c,strength);
        need -= strength;
    }
    if(need && valU) {
        int strength = min(valU,need);
        sendLineU(puzzle,r,c,strength);
        need -= strength;
    }
    if(need && valD) {
        int strength = min(valD,need);
        sendLineD(puzzle,r,c,strength);
        need -= strength;
    }
    return rec(puzzle);
}
bool solve(std::vector<std::vector<int>>& puzzle) {
    H = puzzle.size();
    W = puzzle[0].size();
    rs.clear();
    cs.clear();
    sz = 0;
    for(int r = 0; r < H; r ++) {
        int lstl = -1;
        for(int c = 0; c < W; c ++) {
            if(puzzle[r][c]) {
                nextL[sz] = lstl;
                lstl = sz;
                {
                    int k = c+1;
                    while(k < W && !puzzle[r][k]) {
                        k ++;
                    }
                    nextR[sz] = k == W ? -1 : puzzle[r][k];
                }
                {
                    int k = r+1;
                    while(k < H && !puzzle[k][c]) {
                        k ++;
                    }
                    nextD[sz] = k == H ? -1 : puzzle[k][c];
                }
                {
                    int k = r-1;
                    while(k >= 0 && !puzzle[k][c]) {
                        k --;
                    }
                    nextU[sz] = k == -1 ? -1 : puzzle[k][c];
                }
                rs.push_back(r);
                cs.push_back(c);
                sz++;
            }
        }
    }
    return rec(puzzle);
}