#include <bits/stdc++.h>

#include "puzzle.h"
// #define DEBUGGING

#ifdef DEBUGGING
#define dcout(msg) cout << msg
#else
#define dcout(msg)
#endif

using namespace std;
template<typename T>
using v1 = vector<T>;
template<typename T>
using v2 = v1<v1<T>>;

double timeLimit_;

void init(int numSubtests, double timeLimit) {
    timeLimit_ = timeLimit;
}

const int MAX = 47*47;
int H, W;
vector<int> rs, cs;
v2<int> needs;
int sz;
int nextR[MAX], nextL[MAX], nextU[MAX], nextD[MAX];
int getValL(v2<int> &puzzle, int r, int c) {
    while(c > 0) {
        c--;
        int p = puzzle[r][c];
        if(p) {
            return p < 0 ? p : needs[r][c];
        }
    }
    return -2;
}
int getValR(v2<int> &puzzle, int r, int c) {
    while(c < W-1) {
        c++;
        int p = puzzle[r][c];
        if(p) {
            return p < 0 ? p : needs[r][c];
        }
    }
    return -2;
}
int getValU(v2<int> &puzzle, int r, int c) {
    while(r > 0) {
        r--;
        int p = puzzle[r][c];
        if(p) {
            return p < 0 ? p : needs[r][c];
        }
    }
    return -1;
}
int getValD(v2<int> &puzzle, int r, int c) {
    while(r < H - 1) {
        r++;
        int p = puzzle[r][c];
        if(p) {
            return p < 0 ? p : needs[r][c];
        }
    }
    return -1;
}
void sendLineL(v2<int> &puzzle, int r, int c, int strength) {
    int ch = 1 - strength*2;
    while(c > 0) {
        c--;
        if(puzzle[r][c]) {
            needs[r][c] -= strength;
            return;
        }
        puzzle[r][c] = ch;
    }
}
void sendLineR(v2<int> &puzzle, int r, int c, int strength) {
    int ch = 1 - strength*2;
    while(c < W-1) {
        c++;
        if(puzzle[r][c]) {
            needs[r][c] -= strength;
            return;
        }
        puzzle[r][c] = ch;
    }
}
void sendLineU(v2<int> &puzzle, int r, int c, int strength) {
    int ch = 0 - strength*2;
    while(r > 0) {
        r--;
        if(puzzle[r][c]) {
            needs[r][c] -= strength;
            return;
        }
        puzzle[r][c] = ch;
    }
}
void sendLineD(v2<int> &puzzle, int r, int c, int strength) {
    int ch = 0 - strength*2;
    while(r < H - 1) {
        r++;
        if(puzzle[r][c]) {
            needs[r][c] -= strength;
            return;
        }
        puzzle[r][c] = ch;
    }
}
void removeLineL(v2<int> &puzzle, int r, int c, int strength) {
    while(c > 0) {
        c--;
        if(puzzle[r][c] > 0) {
            needs[r][c] += strength;
            return;
        }
        puzzle[r][c] = 0;
    }
}
void removeLineR(v2<int> &puzzle, int r, int c, int strength) {
    while(c < W-1) {
        c++;
        if(puzzle[r][c] > 0) {
            needs[r][c] += strength;
            return;
        }
        puzzle[r][c] = 0;
    }
}
void removeLineU(v2<int> &puzzle, int r, int c, int strength) {
    while(r > 0) {
        r--;
        if(puzzle[r][c] > 0) {
            needs[r][c] += strength;
            return;
        }
        puzzle[r][c] = 0;
    }
}
void removeLineD(v2<int> &puzzle, int r, int c, int strength) {
    while(r < H - 1) {
        r++;
        if(puzzle[r][c] > 0) {
            needs[r][c] += strength;
            return;
        }
        puzzle[r][c] = 0;
    }
}
int DEPTH = 0;
bool rec(v2<int> &puzzle);
struct State {
    int i;
    int r;
    int c;
    int marg;
    int valL;
    int valR;
    int valU;
    int valD;
    int need;
};
bool brute(v2<int> &puzzle, State &state, int it = 0) {
    // dcout(it << ": " << endl);
    // dcout("   " << state.i << endl);
    // dcout("   " << state.r << endl);
    // dcout("   " << state.c << endl);
    // dcout("   " << state.marg << endl);
    // dcout("   " << state.valL << endl);
    // dcout("   " << state.valR << endl);
    // dcout("   " << state.valU << endl);
    // dcout("   " << state.valD << endl);
    // dcout("   " << state.need << endl);
    // dcout(endl);
    if(it == 0) {
        if(state.need && state.valL) {
            int strength = min(2,min(state.valL,state.need));
            sendLineL(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] -= strength;
            state.need -= strength;
            if(brute(puzzle,state,it+1)) {
                return true;
            }
            removeLineL(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] += strength;
            state.need += strength;
            if(strength == 2) {
                strength--;
                sendLineL(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] -= strength;
                state.need -= strength;
                if(brute(puzzle,state,it+1)) {
                    return true;
                }
                removeLineL(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] += strength;
                state.need += strength;

            }
        }
        return brute(puzzle,state,it+1);
    } else if(it == 1) {
        dcout(state.need << ' ' << state.valR << endl);
        if(state.need && state.valR) {
            int strength = min(2,min(state.valR,state.need));
            sendLineR(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] -= strength;
            state.need -= strength;
            if(brute(puzzle,state,it+1)) {
                return true;
            }
            removeLineR(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] += strength;
            state.need += strength;
            if(strength == 2) {
                strength--;
                sendLineR(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] -= strength;
                state.need -= strength;
                if(brute(puzzle,state,it+1)) {
                    return true;
                }
                removeLineR(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] += strength;
                state.need += strength;

            }
        }
        return brute(puzzle,state,it+1);
    } else if(it == 2) {
        if(state.need && state.valU) {
            int strength = min(2,min(state.valU,state.need));
            sendLineU(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] -= strength;
            state.need -= strength;
            if(brute(puzzle,state,it+1)) {
                return true;
            }
            removeLineU(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] += strength;
            state.need += strength;
            if(strength == 2) {
                strength--;
                sendLineU(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] -= strength;
                state.need -= strength;
                if(brute(puzzle,state,it+1)) {
                    return true;
                }
                removeLineU(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] += strength;
                state.need += strength;

            }
        }
        return brute(puzzle,state,it+1);
    } else if(it == 3) {
        if(state.need && state.valD) {
            int strength = min(2,min(state.valD,state.need));
            sendLineD(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] -= strength;
            state.need -= strength;
            if(brute(puzzle,state,it+1)) {
                return true;
            }
            dcout("OH NO" << endl);
            removeLineD(puzzle,state.r,state.c,strength);
            needs[state.r][state.c] += strength;
            state.need += strength;
            if(strength == 2) {
                strength--;
                sendLineD(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] -= strength;
                state.need -= strength;
                if(brute(puzzle,state,it+1)) {
                    return true;
                }
                removeLineD(puzzle,state.r,state.c,strength);
                needs[state.r][state.c] += strength;
                state.need += strength;

            }
        }
        return brute(puzzle,state,it+1);
    }
    if(state.need) { return false; }
    return rec(puzzle);
}
// int tmp = 0;
bool rec(v2<int> &puzzle) {
    // if(tmp ++ > 10) {
    //     exit(0);
    // }
    if(timePassed() > 9.6) { return false; }
    dcout("REC ~~~~~~~~~~~~~~~~~~~~~ " << DEPTH << endl);
    for(v1<int> &row : puzzle) {
        for(int x : row) {
            dcout(x << ' ');
        }
        dcout(endl);
    }
    dcout(endl);
    for(v1<int> &row : needs) {
        for(int x : row) {

            dcout(x << ' ');
        }
        dcout(endl);
    }
    dcout(endl);
    int opti = -1, optr = 0, optc = 0, optmarg = 1000;
    int optvalL, optvalR, optvalU, optvalD, optneed;
    for(int i = 0; i < sz; i ++) {
        int r = rs[i], c = cs[i];
        int need = puzzle[r][c];
        int valL = getValL(puzzle,r,c);
        int valR = getValR(puzzle,r,c);
        int valU = getValU(puzzle,r,c);
        int valD = getValD(puzzle,r,c);
        if(valL < 0) {
            valL = -valL;
            if(valL&1) {
                need -= 1 + valL/2;
            }
            valL = 0;
        }
        if(valR < 0) {
            valR = -valR;
            if(valR&1) {
                need -= 1 + valR/2;
            }
            valR = 0;
        }
        if(valU < 0) {
            valU = -valU;
            if(!(valU&1)) {
                need -= valU/2;
            }
            valU = 0;
        }
        if(valD < 0) {
            valD = -valD;
            if(!(valD&1)) {
                need -= valD/2;
            }
            valD = 0;
        }
        if(need == 0) { continue; }
        int marg = min(valL,2) + min(valR,2) + min(valU,2) + min(valD,2) - need;
        if(marg < 0) {
            return false; }
        if(marg >= optmarg) {
            continue;
        }
        opti = i;
        optr = r;
        optc = c;
        optmarg = marg;
        optvalL = valL;
        optvalR = valR;
        optvalU = valU;
        optvalD = valD;
        optneed = need;
    }
    if(opti == -1) {
        vector<int> vis(sz);
        vis[0] = true;
        stack<int> dfs;
        dfs.push(0);
        while(!dfs.empty()) {
            int cur = dfs.top();
            dfs.pop();
            {
                int ne = nextL[cur];
                if(ne != -1 && !vis[ne]) {
                    vis[ne] = true;
                    dfs.push(ne);
                }
            }
            {
                int ne = nextR[cur];
                if(ne != -1 && !vis[ne]) {
                    vis[ne] = true;
                    dfs.push(ne);
                }
            }
            {
                int ne = nextU[cur];
                if(ne != -1 && !vis[ne]) {
                    vis[ne] = true;
                    dfs.push(ne);
                }
            }
            {
                int ne = nextD[cur];
                if(ne != -1 && !vis[ne]) {
                    vis[ne] = true;
                    dfs.push(ne);
                }
            }
        }
        for(int v : vis) {
            if(!v) { return false; }
        }
        return true;
    }
    State state{opti,optr,optc,optmarg,optvalL,optvalR,optvalU,optvalD,optneed};
    DEPTH ++;
    bool res = brute(puzzle,state);
    DEPTH--;
    return res;
    // return rec(puzzle);
}
bool solve(std::vector<std::vector<int>>& puzzle) {
    H = puzzle.size();
    W = puzzle[0].size();
    rs.clear();
    cs.clear();
    needs = puzzle;
    v2<int> idx = puzzle;
    sz = 0;
    for(int r = 0; r < H; r ++) {
        int lstl = -1;
        for(int c = 0; c < W; c ++) {
            if(puzzle[r][c]) {
                nextL[sz] = lstl;
                idx[r][c] = sz;
                lstl = sz;
                
                rs.push_back(r);
                cs.push_back(c);
                sz++;
            }
        }
    }
    for(int r = 0; r < H; r ++) {
        for(int c = 0; c < W; c ++) {
                if(idx[r][c]) {
                    int cidx = idx[r][c];
                {
                    int k = c+1;
                    while(k < W && !puzzle[r][k]) {
                        k ++;
                    }
                    nextR[cidx] = k == W ? -1 : idx[r][k];
                }
                {
                    int k = r+1;
                    while(k < H && !puzzle[k][c]) {
                        k ++;
                    }
                    nextD[cidx] = k == H ? -1 : idx[k][c];
                }
                {
                    int k = r-1;
                    while(k >= 0 && !puzzle[k][c]) {
                        k --;
                    }
                    nextU[cidx] = k == -1 ? -1 : idx[k][c];
                }
            }
        }
    }
    return rec(puzzle);
}

/*
1 2
7 7
2 0 0 0 5 0 3
0 0 2 0 0 0 0
0 0 0 0 0 0 2
0 0 0 0 0 0 0
4 0 5 0 0 0 2
0 0 0 0 2 0 0
1 0 1 0 0 0 1

*/