#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int K = 5;
const int MOD = 1e8 + 543;
const int MAX_P = 60;
ll binpow[MAX_P][K][K] = {
    {{0,1,0,0,0},
    {0,0,1,0,0},
    {0,0,0,1,0},
    {0,0,0,0,1},
    {1,2,3,4,5}},
};
ll negbinpow[MAX_P][K][K] = {
    {{MOD-2,MOD-3,MOD-4,MOD-5,1},
    {1,0,0,0,0},
    {0,1,0,0,0},
    {0,0,1,0,0},
    {0,0,0,1,0}},
};
void matmul(ll mat[K][K], ll a[K][K], ll b[K][K]) {
    for (int i = 0; i < K; i++) {
        for(int j = 0; j < K; j ++) {
            ll tot = 0;
            for (int k = 0; k < K; k++) {
                tot += a[i][k] * b[k][j];
            }
            mat[i][j] = tot % MOD;
        }
    }
}
void linTrans(int* seq, ll mat[K][K]) {
    // for(int i = 0; i < K; i ++) {
    //     for(int j = 0; j < K; j ++) {
    //         cout << mat[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    // for(int i = 0; i < 5; i ++) {
    //     cout << seq[i] << ' ';
    // }
    // cout << endl;
    vector<int> cop(K);
    for (int i = 0; i < K; i++) {
        cop[i] = seq[i];
    }
    for (int i = 0; i < K; i++) {
        ll tot = 0;
        for (int j = 0; j < K; j++) {
            tot += mat[i][j] * cop[j];
        }
        seq[i] = tot % MOD;
    }
}
void moveSeqNeg(int* seq, ll cnt) {
    int pidx = 0;
    while (cnt) {
        if (cnt & 1) {
            // cout << pidx << endl;
            linTrans(seq, negbinpow[pidx]);
        }
        cnt >>= 1;
        pidx++;
    }
        // exit(0);
}
void moveSeq(int* seq, ll cnt) {
    // for(int i = 0; i < K; i ++) {
    //     cout << seq[i] << ' ';
    // }
    // cout << "+ " << cnt << endl;
    if (cnt < 0) {
        moveSeqNeg(seq, -cnt);
        return;
    }
    int pidx = 0;
    while (cnt) {
        if (cnt & 1) {
            linTrans(seq, binpow[pidx]);
        }
        cnt >>= 1;
        pidx++;
    }
}
void sumVec(int* a, int* b, int* c) {
    for(int i = 0; i < K; i ++) {
        *(a++) = (*(b++)) + (*(c++));
    }
}

const int MAX_N = 1e5 + 5;
int as[MAX_N];
struct Seg {
    int l, r, mid;
    Seg *ls, *rs;
    ll laz = 0;
    int val[K];
    Seg(int l, int r) : l(l), r(r), mid((l + r) / 2), laz(0) {
        if (l + 1 < r) {
            ls = new Seg(l, mid);
            rs = new Seg(mid, r);
        } else {
            for (int i = 0; i < K; i++) {
                val[i] = i;
            }
            moveSeq(val, as[l]);
        }
    }
    void doLazy() {
        if(laz) {
            // cout << "MOVE" << endl;
            moveSeq(val, laz);
            // cout << "ENDMOVE" << endl;
            if(l + 1 < r) {
                ls->laz += laz;
                rs->laz += laz;
            }
            laz = 0;
        }
    }
    void update(int a, int b, int x) {
        if (a >= r || b <= l) {
            doLazy();
            return;
        }
        if (a <= l && b >= r) {
            laz += x;
            doLazy();
            return;
        }
        doLazy();
        ls->update(a, b, x);
        rs->update(a, b, x);
        // cout << "SUM" << endl;
        sumVec(val, ls->val, rs->val);
        // cout << "ENDSUM" << endl;
    }
    ll query(int a, int b) {
        if(a >= r || b <= l) {
            return 0;
        }
        doLazy();
        if(a <= l && b >= r) {
            return val[0];
        }
        return ls->query(a,b) + rs->query(a,b);
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    // for(int i = 0; i < K; i ++) {
    //     for(int j = 0; j < K; j ++) {
    //         cout << negbinpow[0][i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    for(int p = 1; p < MAX_P; p ++) {
        matmul(binpow[p],binpow[p-1],binpow[p-1]);
        matmul(negbinpow[p],negbinpow[p-1],negbinpow[p-1]);
    }
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> as[i];
    }
    Seg seg(0, n);
    // cout << "YES" << endl;
    for(int qi = 0; qi < q; qi ++) {
        int typ, l, r;
        cin >> typ >> l >> r;
        l--;
        if(typ == 1) {
            cout << seg.query(l,r) << '\n';
        } else {
            int v;
            cin >> v;
            seg.update(l,r,v);
        }
    }
    return 0;
}