#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int K = 5;

const int MOD = 1e8 + 543;
const int POWMOD = MOD-1;
const int MAX_P = 60;
const int Z = 10;

ll pows[1<<Z][K][K];
ll binpow[MAX_P][K][K] = {
    {{0,1,0,0,0},
    {0,0,1,0,0},
    {0,0,0,1,0},
    {0,0,0,0,1},
    {1,2,3,4,5}},
};
void matmul(ll mat[K][K], ll a[K][K], ll b[K][K]) {
    for (int i = 0; i < K; i++) {
        for(int j = 0; j < K; j ++) {
            ll tot = 0;
            for (int k = 0; k < K; k++) {
                tot += a[i][k] * b[k][j];
            }
            mat[i][j] = tot % MOD;
        }
    }
}
void linTrans(int* seq, ll mat[K][K]) {
    vector<int> cop(K);
    for (int i = 0; i < K; i++) {
        cop[i] = seq[i];
    }
    for (int i = 0; i < K; i++) {
        ll tot = 0;
        for (int j = 0; j < K; j++) {
            tot += mat[i][j] * cop[j];
        }
        seq[i] = tot % MOD;
    }
}

void moveSeq(int* seq, ll cnt) {
    linTrans(seq, pows[cnt&((1<<Z)-1)]);
    cnt >>= Z;
    int pidx = Z;
    while (cnt) {
        if (cnt & 1) {
            linTrans(seq, binpow[pidx]);
        }
        cnt >>= 1;
        pidx++;
    }
}
void sumVec(int* a, int* b, int* c) {
    for(int i = 0; i < K; i ++) {
        *(a++) = ((*(b++)) + (*(c++)))%MOD;
    }
}
ll mat[K][K];
ll tmp[K][K];
void genMat(int v) {
    for(int i = 0; i < K; i ++) {
        for(int j = 0; j < K; j ++) {
            mat[i][j] = i==j;
        }
    }
    int pidx = 0;
    while(v) {
        for(int i = 0; i < K; i ++) {
            for(int j = 0; j < K; j ++) {
                tmp[i][j] = mat[i][j];
            }
        }
        if(v&1) {
            matmul(mat,binpow[pidx],tmp);
        }
        v>>=1;
        pidx++;
    }
}
const int MAX_N = 1e5 + 5;
int as[MAX_N];
struct Seg {
    int l, r, mid;
    Seg *ls, *rs;
    ll laz = 0;
    int val[K];
    Seg(int l, int r) : l(l), r(r), mid((l + r) / 2), laz(0) {
        if (l + 1 < r) {
            ls = new Seg(l, mid);
            rs = new Seg(mid, r);
            sumVec(val, ls->val, rs->val);
        } else {
            for (int i = 0; i < K; i++) {
                val[i] = i;
            }
            moveSeq(val, as[l]);
        }
    }
    void doLazy() {
        if(laz) {
            // cout << "MOVE" << endl;
            moveSeq(val, laz);
            // cout << "ENDMOVE" << endl;
            if(l + 1 < r) {
                ls->laz += laz;
                if(ls->laz >= POWMOD) {
                    ls->laz -= POWMOD;
                }
                rs->laz += laz;
                if(rs->laz >= POWMOD) {
                    rs->laz -= POWMOD;
                }
            }
            laz = 0;
        }
    }
    void update(int a, int b, int x) {
        if (a >= r || b <= l) {
            doLazy();
            return;
        }
        if (a <= l && b >= r) {
            laz += x;
            laz %= POWMOD;
            doLazy();
            return;
        }
        doLazy();
        ls->update(a, b, x);
        rs->update(a, b, x);
        // cout << "SUM" << endl;
        sumVec(val, ls->val, rs->val);
        // cout << "ENDSUM" << endl;
    }
    ll query(int a, int b) {
        if(a >= r || b <= l) {
            return 0;
        }
        doLazy();
        if(a <= l && b >= r) {
            return val[0];
        }   
        return (ls->query(a,b) + rs->query(a,b))%MOD;
    }
};
void unitify(ll mattt[K][K]) {
    for (int i = 0; i < K; i++) {
        for(int j = 0; j < K; j ++) {
            mattt[i][j] = i==j;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    for(int p = 1; p < MAX_P; p ++) {
        matmul(binpow[p],binpow[p-1],binpow[p-1]);
    }
    unitify(pows[0]);
    for(int p = 1; p < (1<<Z); p ++) {
        matmul(pows[p],pows[p-1],binpow[0]);
    }
    // for(int t = 0; t < MAX_P; t ++) {
    //     for(int i = 0; i < K; i ++) {
    //         for(int j = 0; j < K; j ++) {
    //             cout << binpow[t][i][j] << ' ';
    //         }
    //         cout << endl;
    //     }
    //     cout << endl;
    // }
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        int v;
        cin >> v;
        v %= POWMOD;
        v += POWMOD;
        v %= POWMOD;
        as[i] = v;
    }
    Seg seg(0, n);
    // cout << "YES" << endl;
    for(int qi = 0; qi < q; qi ++) {
        int typ, l, r;
        cin >> typ >> l >> r;
        l--;
        if(typ == 1) {
            cout << seg.query(l,r) << '\n';
        } else {
            int v;
            cin >> v;
            v %= POWMOD;
            v += POWMOD;
            v %= POWMOD;
            seg.update(l,r,v);
        }
    }
    return 0;
}
/*
2 5
1 -1
1 1 2
2 1 1 -2
1 1 1
2 1 1 8
1 1 2
*/