#include<bits/stdc++.h>
using namespace std;
template<class T>using vec=vector<T>;
template<class T>using vvec=vec<vec<T>>;
using vi=vec<int>;
using vvi=vvec<int>;
using llong=long long;

constexpr llong MOD = 1e8+543;

struct mint
{
    llong x;
    constexpr mint():x(0) {};
    constexpr mint(llong _x):x(_x) {};
    constexpr mint operator+(const mint& m)const{return mint((x+m.x)%MOD);}
    constexpr mint operator-(const mint& m)const{return mint((x-m.x+MOD)%MOD);}
    constexpr mint operator*(const mint& m)const{return mint((x*m.x)%MOD);}
    /*constexpr mint operator^(llong p)const
    {
        llong r = 1;
        for(;p;p>>=1)
        {
            if(p&1) r = r * x % MOD;
            r = r * r % MOD;
        }
        return mint(r);
    }
    constexpr mint operator~()const{return (*this)^(MOD-2);}*/
};

constexpr mint origin[5] = {mint(4), mint(3), mint(2), mint(1), mint(0)};

struct matrix
{
    mint vals[5*5];
    constexpr matrix(){}
    constexpr mint get(int r, int c)const{return vals[5*r+c];}
    constexpr void set(int r, int c, mint v){vals[5*r+c] = v;}
    constexpr matrix operator*(const matrix& m)const
    {
        matrix r{};
        for(int i = 0; i < 5; ++i)
        {
            for(int j = 0; j < 5; ++j)
            {
                for(int k = 0; k < 5; ++k)
                {
                    r.set(i, j, r.get(i, j) + get(i, k) * m.get(k, j));
                }
            }
        }
        return r;
    }
    constexpr mint calculate(int j)const
    {
        mint r;
        for(int i = 0; i < 5; ++i)
            r = r + origin[i] * get(j, i);
        return r;
    }
    constexpr matrix operator^(llong p)const
    {
        matrix r{},a=*this; for(int i = 0; i < 5; ++i) r.set(i, i, 1);
        for(;p;p>>=1)
        {
            if(p&1) r = r * a;
            a = a * a;
        }
        return r;
    }
};

matrix M{},N{};

map<int, mint> cache;

mint get_x(int k)
{
    if(0 <= k && k <= 4)
    {
        return origin[4-k];
    };
    auto it = cache.find(k);
    if(it != cache.end())
        return it->second;
    if(k > 0)
    {
        matrix m = M ^ (k-4);
        return cache[k] = m.calculate(0);
    }
    else
    {
        matrix m = N ^ (-k);
        return cache[k] = m.calculate(4);
    }
}

vi arr;

struct segtree
{
    mint val;
    int lb, rb, a=0;
    segtree *l=nullptr,*r=nullptr;
    segtree(int _lb, int _rb):lb(_lb),rb(_rb)
    {
        if(lb == rb)
        {
            a = arr[lb];
            val = get_x(a);
            return;
        }
        int mb = (lb+rb)/2;
        l = new segtree(lb, mb);
        r = new segtree(mb+1, rb);
        val = l->val + r->val;
    }

    mint range(int _lb, int _rb)const
    {
        if(_rb < lb || rb < _lb)
            return mint(0);
        if(_lb <= lb && rb <= _rb)
            return val;
        return l->range(_lb, _rb) + r->range(_lb, _rb);
    }

    void update(int idx, int _a)
    {
        if(idx < lb || rb < idx)
            return;
        if(lb == rb)
        {
            a += _a;
            val = get_x(a);
            return;
        }
        l->update(idx, _a);
        r->update(idx, _a);
        val = l->val + r->val;
    }
};

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    //setup matrices
    for(int i = 0; i < 5; ++i)
    {
        M.set(0, i, mint(5-i));
        if(i != 4) M.set(i+1, i, mint(1));
        if(i != 0)
        {
            N.set(i, i+1, mint(1));
            N.set(4, i, mint(MOD+i-6));
        }
    }
    N.set(4, 0, mint(1));

    //cout << get_x(0).x << ' ' <<  get_x(5).x << ' ' << get_x(6).x << ' ' << get_x(-1).x << ' ' << get_x(-2).x << '\n';
    int n,q; cin>>n>>q;
    arr = vi(n); for(int i = 0; i < n; ++i)cin>>arr[i];
    segtree S(0, n-1);
    while(q--)
    {
        int type, l, r; cin >> type >> l >> r; --l; --r;
        if(type == 1)
        {
            mint prefixl = l ? S.range(0, l-1) : mint(0);
            mint prefixr = S.range(0, r);
            cout << (prefixr-prefixl).x << '\n';
        }
        else
        {
            int value; cin >> value;
            S.update(l, value);
            if(r < n-1) S.update(r+1, -value);
        }
    }
}
