#include<bits/stdc++.h>
using namespace std;
template<class T>using vec=vector<T>;
template<class T>using vvec=vec<vec<T>>;
using vi=vec<int>;
using vvi=vvec<int>;
using llong=long long;

constexpr llong MOD = 1e8+543;

constexpr llong moda(llong a) { a %= MOD-1; if(a < 0) a += MOD-1; return a; }

struct mint
{
    llong x;
    constexpr mint():x(0) {};
    constexpr mint(llong _x):x(_x) {};
    constexpr mint operator+(const mint& m)const{return mint((x+m.x)%MOD);}
    constexpr mint operator-(const mint& m)const{return mint((x-m.x+MOD)%MOD);}
    constexpr mint operator*(const mint& m)const{return mint((x*m.x)%MOD);}
};

const array<mint, 5> origin{mint(4), mint(3), mint(2), mint(1), mint(0)};

struct matrix
{
    mint vals[5*5];
    constexpr matrix(){}
    constexpr mint get(int r, int c)const{return vals[5*r+c];}
    constexpr void set(int r, int c, const mint& v){vals[5*r+c] = v;}
    constexpr matrix operator*(const matrix& m)const
    {
        matrix r{};
        for(int i = 0; i < 5; ++i)
        {
            for(int j = 0; j < 5; ++j)
            {
                for(int k = 0; k < 5; ++k)
                {
                    r.set(i, j, r.get(i, j) + get(i, k) * m.get(k, j));
                }
            }
        }
        return r;
    }
    array<mint, 5> multiply(const array<mint, 5>& nums)const
    {
        array<mint, 5> r{};
        for(int i = 0; i < 5; ++i)
            for(int j = 0; j < 5; ++j)
                r[i] = r[i] + get(i, j) * nums[j];
        return r;
    }
};

matrix precompute[28];

mint get_x(llong k)
{
    if(0 <= k && k <= 4)
    {
        return origin[4-k];
    }
    else
    {
        k = moda(k-4);
        array<mint, 5> arr = origin;
        for(int j = 0; j < 28; ++j)
        {
            if(k & (1LL << j))
            {
                arr = precompute[j].multiply(arr);
            }
        }
        return arr[0];
    }
}

vec<llong> arr;

struct segtree
{
    mint val;
    int lb, rb;
    llong a=0;
    segtree *l=nullptr,*r=nullptr;
    segtree(int _lb, int _rb):lb(_lb),rb(_rb)
    {
        if(lb == rb)
        {
            a = moda(arr[lb]);
            val = get_x(a);
            return;
        }
        int mb = (lb+rb)/2;
        l = new segtree(lb, mb);
        r = new segtree(mb+1, rb);
        val = l->val + r->val;
    }

    mint range(int _lb, int _rb)const
    {
        if(_rb < lb || rb < _lb)
            return mint(0);
        if(_lb <= lb && rb <= _rb)
            return val;
        return l->range(_lb, _rb) + r->range(_lb, _rb);
    }

    void update(int idx, llong _a)
    {
        if(idx < lb || rb < idx)
            return;
        if(lb == rb)
        {
            a += _a; a = moda(a);
            val = get_x(a);
            return;
        }
        l->update(idx, _a);
        r->update(idx, _a);
        val = l->val + r->val;
    }
};

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    //set initial matrix
    for(int i = 0; i < 5; ++i)
    {
        precompute[0].set(0, i, mint(5-i));
        if(i != 4) precompute[0].set(i+1, i, mint(1));
    }
    //calculate powers
    for(int j = 1; j < 28; ++j)
        precompute[j] = precompute[j-1] * precompute[j-1];
    /*matrix test = M ^ (MOD-2);
    for(int i = 0; i < 5; ++i)
    {
        for(int j = 0; j < 5; ++j)
        {
            cout << test.get(i, j).x << ' ';
        }
        cout << '\n';
    }
    cout << '\n';*/

    //cout << get_x(0).x << ' ' <<  get_x(5).x << ' ' << get_x(6).x << ' ' << get_x(-1).x << ' ' << get_x(-2).x << '\n';
    int n,q; cin>>n>>q;
    arr = vec<llong>(n); for(int i = 0; i < n; ++i)cin>>arr[i];
    segtree S(0, n-1);
    while(q--)
    {
        int type, l, r; cin >> type >> l >> r; --l; --r;
        if(type == 1)
        {
            mint prefixl = l ? S.range(0, l-1) : mint(0);
            mint prefixr = S.range(0, r);
            cout << (prefixr-prefixl).x << '\n';
        }
        else
        {
            llong value; cin >> value;
            S.update(l, value);
            if(r < n-1) S.update(r+1, -value);
        }
    }
}
