#include<bits/stdc++.h>
using namespace std;
template<class T>using vec=vector<T>;
template<class T>using vvec=vec<vec<T>>;
using vi=vec<int>;
using vvi=vvec<int>;
using llong=long long;

constexpr llong MOD = 1e8+543;

constexpr llong moda(llong a) { a %= MOD-1; if(a < 0) a += MOD-1; return a; }

struct mint
{
    llong x;
    constexpr mint():x(0) {};
    constexpr mint(llong _x):x(_x) {};
    constexpr mint operator+(const mint& m)const{return mint((x+m.x)%MOD);}
    constexpr mint operator-(const mint& m)const{return mint((x-m.x+MOD)%MOD);}
    constexpr mint operator*(const mint& m)const{return mint((x*m.x)%MOD);}
};

constexpr array<mint, 5> origin{mint(4), mint(3), mint(2), mint(1), mint(0)};

struct matrix
{
    mint vals[5*5];
    constexpr matrix(){}
    constexpr mint get(int r, int c)const{return vals[5*r+c];}
    constexpr void set(int r, int c, const mint& v){vals[5*r+c] = v;}
    constexpr matrix operator*(const matrix& m)const
    {
        matrix r{};
        for(int i = 0; i < 5; ++i)
        {
            for(int j = 0; j < 5; ++j)
            {
                for(int k = 0; k < 5; ++k)
                {
                    r.set(i, j, r.get(i, j) + get(i, k) * m.get(k, j));
                }
            }
        }
        return r;
    }
    array<mint, 5> multiply(const array<mint, 5>& nums)const
    {
        array<mint, 5> r{};
        for(int i = 0; i < 5; ++i)
            for(int j = 0; j < 5; ++j)
                r[i] = r[i] + get(i, j) * nums[j];
        return r;
    }
};

inline array<matrix, 27> precompute_powers()
{
    array<matrix, 27> result;
    //set initial matrix
    for(int i = 0; i < 5; ++i)
    {
        result[0].set(0, i, mint(5-i));
        if(i != 4) result[0].set(i+1, i, mint(1));
    }
    //calculate powers
    for(int j = 1; j < 27; ++j)
        result[j] = result[j-1] * result[j-1];
    return result;
}

const array<matrix, 27> precompute = precompute_powers();

constexpr array<mint, 5> multmany(llong k, array<mint, 5> vals)
{
    for(int j = 0;k;k>>=1, ++j) if(k & 1) vals = precompute[j].multiply(vals);
    return vals;
}

vec<llong> arr;

struct segtree
{
    array<mint, 5> vals;
    int lb, rb;
    llong lza=0;
    segtree *l=nullptr,*r=nullptr;
    segtree(int _lb, int _rb):lb(_lb),rb(_rb)
    {
        if(lb == rb)
        {
            vals = multmany(moda(arr[lb]), origin);
            return;
        }
        int mb = (lb+rb)/2;
        l = new segtree(lb, mb);
        r = new segtree(mb+1, rb);
        for(int i = 0; i < 5; ++i)
            vals[i] = l->vals[i] + r->vals[i];
    }

    void applylz(llong _lza) { lza += _lza; lza = moda(lza); }

    void pushlz(bool calc=true)
    {
        if(!lza) return;
        if(calc) vals = multmany(lza, vals);
        if(l) l->applylz(lza);
        if(r) r->applylz(lza);
        lza = 0;
    }

    mint range(int _lb, int _rb)
    {
        if(_rb < lb || rb < _lb)
            return mint(0);
        pushlz();
        if(_lb <= lb && rb <= _rb)
            return vals[4];
        return l->range(_lb, _rb) + r->range(_lb, _rb);
    }

    void update(int _lb, int _rb, llong _a)
    {
        if(_rb < lb || rb < _lb)
            return;
        if(_lb <= lb && rb <= _rb)
        {
            applylz(_a);
            return;
        }
        pushlz(false);
        l->update(_lb, _rb, _a); l->pushlz();
        r->update(_lb, _rb, _a); r->pushlz();
        for(int i = 0; i < 5; ++i)
            vals[i] = l->vals[i] + r->vals[i];
    }
};

int main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n,q; cin>>n>>q;
    arr = vec<llong>(n); for(int i = 0; i < n; ++i)cin>>arr[i];
    segtree S(0, n-1);
    while(q--)
    {
        int type, l, r; cin >> type >> l >> r; --l; --r;
        if(type == 1)
        {
            cout << S.range(l, r).x << '\n';
        }
        else
        {
            llong value; cin >> value;
            S.update(l, r, value);
        }
    }
}
