#include <iostream>
#include <vector>

using namespace std;

#define mod 100000543

struct node
{
	int l, r;
	long long sum = 0;
	node* lp, * rp;

	node(int lval, int rval)
	{
		l = lval; r = rval;
		lp = NULL; rp = NULL;

		if (l != r)
		{
			lp = new node(l, (l + r) / 2);
			rp = new node((l + r) / 2 + 1, r);
		}
	}

	void setVal(int pos, int val)
	{
		if (pos > r or pos < l)
			return;

		if (pos == r and pos == l)
		{
			sum = val;
			return;
		}

		lp->setVal(pos, val);
		rp->setVal(pos, val);
		sum = lp->sum + rp->sum;
	}

	long long askSumRange(int a, int b)
	{
		if (a > r or b < l)
			return 0;

		if (a <= l and r <= b)
			return sum;

		return (lp->askSumRange(a, b) + lp->askSumRange(a, b)) % mod;
	}
};

vector <long long> values;

vector <vector <long long>> mult(vector <vector <long long>> first, vector <vector <long long>> second)
{
	vector <vector <long long>> answer;
	for (int a = 0; a < second.size(); a++)
	{
		answer.push_back({});
		for (int b = 0; b < first[0].size(); b++)
			answer[a].push_back(0);
	}

	for (int k = 0; k < 5; k++)
		for (int a = 0; a < second.size(); a++)
			for (int b = 0; b < first[0].size(); b++)
				answer[a][b] = (answer[a][b] + second[a][k] * first[4 - k][b]) % mod;
	return answer;
}

vector <vector <long long>> powM(long long power)
{
	vector <vector <long long>> answer = {};
	vector <vector <long long>> mul = {
		{ 1, 0, 0, 0, 0 },
		{ 2, 0, 0, 0, 1 },
		{ 3, 0, 0, 1, 0 },
		{ 4, 0, 1, 0, 0 },
		{ 5, 1, 0, 0, 0 }
	};

	while (power != 0)
	{
		if (power % 2 == 1)
		{
			if (answer.size() != 0)
				answer = mult(answer, mul);
			else
				for (int a = 0; a < mul.size(); a++)
				{
					answer.push_back({});
					for (int b = 0; b < mul[a].size(); b++)
						answer[a].push_back(mul[a][b]);
				}
		}

		mul = mult(mul, mul);
		power /= 2;
	}

	return answer;
}

vector <long long> answers = { 0, 1, 2, 3, 4 }, minu = { 4, 3, 2, 1, 0 };

long long calc(long long pos)
{
	if (pos > -999999 and pos <= 0)
		return minu[4 - pos];
	if (pos <= 1000000)
		return answers[pos];
	else if (pos < 0)
		return 0;
	vector <vector <long long>> start = { { 4, 3, 2, 1, 0 } }, temp = powM(pos);
	auto ans = mult(temp, start);
	return ans[0][4];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, q, c;
	cin >> n >> q;
	for (int a = 0; a < n; a++)
	{
		cin >> c;
		values.push_back(c);
	}

	for (int a = 0; a < 1000000; a++)
		answers.push_back((answers[a] + answers[a + 1] * 2 + answers[a + 2] * 3 + answers[a + 3] * 4 + answers[a + 4] * 5) % mod);

	for (int a = 0; a < 1000000; a++)
		minu.push_back(((minu[a] - 5 * minu[a + 1] - 4 * minu[a + 2] - 3 * minu[a + 3] - 2 * minu[a + 4]) % mod + mod) % mod);

	node tree(0, n - 1);
	for (int a = 0; a < n; a++)
		tree.setVal(a, calc(values[a]));

	int type, l, r;
	long long value;
	for (int a = 0; a < q; a++)
	{
		cin >> type >> l >> r;
		if (type == 1)
		{
			cout << '\n' << tree.askSumRange(l - 1, r - 1);
		}
		else
		{
			cin >> value;
			for (int a = l; a <= r; a++)
			{
				values[a - 1] += value;
				tree.setVal(a - 1, calc(values[a - 1]));
			}
		}
	}
}