#include<iostream>
#include<set>
#include<vector>
#include "puzzle.h"
using namespace std;
typedef int ll;
typedef pair<ll, ll> pll;

void init(int numSubtests, double timeLimit) {
	return;
}

inline void find_nei(ll x, ll y, ll n, ll m, vector<vector<ll>>& to_num, vector<pll>& to_p, vector<set<ll>>& g, vector<vector<pll>>& in_square, vector<vector<ll>>& puzzle) {
	for (ll i = x + 1; i < n; i++) if (puzzle[i][y]) {
		g[to_num[x][y]].insert(to_num[i][y]);
		g[to_num[i][y]].insert(to_num[x][y]);
		for (ll j = x + 1; j < i; j++) in_square[to_num[j][y]].push_back({ to_num[i][y], to_num[x][y] });
		break;
	}
	for (ll i = x - 1; i >= 0; i--) if (puzzle[i][y]) {
		g[to_num[x][y]].insert(to_num[i][y]);
		g[to_num[i][y]].insert(to_num[x][y]);
		for (ll j = x - 1; j > i; j--) in_square[to_num[j][y]].push_back({ to_num[i][y], to_num[x][y] });
		break;
	}
	for (ll i = y + 1; i < m; i++) if (puzzle[x][i]) {
		g[to_num[x][y]].insert(to_num[x][i]);
		g[to_num[x][i]].insert(to_num[x][y]);
		for (ll j = y + 1; j < i; j++) in_square[to_num[x][j]].push_back({ to_num[x][j], to_num[x][y] });
		break;
	}
	for (ll i = y - 1; i >= 0; i--) if (puzzle[x][i]) {
		g[to_num[x][y]].insert(to_num[x][i]);
		g[to_num[x][i]].insert(to_num[x][y]);
		for (ll j = y - 1; j > i; j--) in_square[to_num[x][j]].push_back({ to_num[x][j], to_num[x][y] });
		break;
	}
}

bool y_match(pll& a, pll& b) {
	return a.second == b.second;
}

bool same_pair(pll& a, pll& b) {
	if (a == b) return 1;
	swap(a.first, a.second);
	return a == b;
}

inline void build_roads(ll t, ll node, ll cnt, ll n, ll m, vector<ll>& island, vector<vector<ll>>& to_num, vector<pll>& to_p, vector<set<ll>>& g, vector<vector<pll>>& in_square, vector<vector<ll>>& puzzle) {
	island[node] += g[node].size() * t;
	if (island[node] == 0) {
		for (ll k : g[node]) g[k].erase(node);
	}
	vector<ll> to_erase;
	for (ll k : g[node]) {
		island[k] += t;
		if (y_match(to_p[node], to_p[k])) {
			for (ll i = min(to_p[node].first, to_p[k].first) + 1; i < max(to_p[node].first, to_p[k].first); i++) {
				puzzle[i][to_p[node].second] = t;
				for (pll p : in_square[to_num[i][to_p[node].second]]) {
					pll p2 = { node, k };
					if (same_pair(p, p2)) continue;
					g[p.first].erase(p.second);
					g[p.second].erase(p.first);
				}
			}
		}
		else {
			for (ll i = min(to_p[node].second, to_p[k].second) + 1; i < max(to_p[node].second, to_p[k].second); i++) {
				puzzle[to_p[node].first][i] = t - 2;
				for (pll p : in_square[to_num[to_p[node].first][i]]) {
					pll p2 = { node, k };
					if (same_pair(p, p2)) continue;
					g[p.first].erase(p.second);
					g[p.second].erase(p.first);
				}
			}
		}
		if (island[k] == 0) to_erase.push_back(k);
	}
	for (ll k : to_erase) g[node].erase(k);
}

inline bool must_do(ll cnt, ll n, ll m, vector<ll> &island, vector<vector<ll>>& to_num, vector<pll>& to_p, vector<set<ll>>& g, vector<vector<pll>>& in_square, vector<vector<ll>>& puzzle) {
	for (ll i = 1; i <= cnt; i++) {
		if (island[i]) {
			if (island[i] == 1 && g[i].size() == 1) {
				build_roads(-1, i, cnt, n, m, island, to_num, to_p, g, in_square, puzzle);
				return 1;
			}
			else if (island[i] % 2 == 0 && g[i].size() * 2 == island[i]) {
				build_roads(-2, i, cnt, n, m, island, to_num, to_p, g, in_square, puzzle);
				return 1;
			}
			else if (island[i] % 2 == 1 && g[i].size() == island[i] / 2 + 1) {
				build_roads(-1, i, cnt, n, m, island, to_num, to_p, g, in_square, puzzle);
				return 1;
			}
		}
	}
	return 0;
}

bool solve(std::vector<std::vector<int>>& puzzle) {
	ll n = puzzle.size(), m = puzzle[0].size();
	vector<vector<ll>> to_num(n, vector<ll>(m));
	vector<ll> island((n * 1) * (m + 1));
	vector<pll> to_p((n * 1) * (m + 1));
	ll cnt = 0;
	for (ll i = 0; i < n; i++) for (ll j = 0; j < m; j++) to_num[i][j] = ++cnt, to_p[cnt] = { i, j }, island[cnt] = puzzle[i][j];
	vector<set<ll>> g((n + 1) * (m + 1));
	vector<vector<pll>> in_square((n + 1) * (m + 1));
	for (ll i = 0; i < n; i++) for (ll j = 0; j < n; j++) if (puzzle[i][j]) find_nei(i, j, n, m, to_num, to_p, g, in_square, puzzle);
	do {
		while (must_do(cnt, n, m, island, to_num, to_p, g, in_square, puzzle));
		bool lol = 0;
		for (ll node = 1; node <= cnt; node++) if (island[node]) {
			for (ll k : g[node]) if (island[k]) {
				lol = 1;
				island[node]--; island[k]--;
				g[node].erase(k); g[k].erase(node);
				if (y_match(to_p[node], to_p[k])) {
					for (ll i = min(to_p[node].first, to_p[k].first) + 1; i < max(to_p[node].first, to_p[k].first); i++) {
						puzzle[i][to_p[node].second] = -1;
						for (pll p : in_square[to_num[i][to_p[node].second]]) {
							pll p2 = { node, k };
							if (same_pair(p, p2)) continue;
							g[p.first].erase(p.second);
							g[p.second].erase(p.first);
						}
					}
				}
				else {
					for (ll i = min(to_p[node].second, to_p[k].second) + 1; i < max(to_p[node].second, to_p[k].second); i++) {
						puzzle[to_p[node].first][i] = -3;
						for (pll p : in_square[to_num[to_p[node].first][i]]) {
							pll p2 = { node, k };
							if (same_pair(p, p2)) continue;
							g[p.first].erase(p.second);
							g[p.second].erase(p.first);
						}
					}
				}
			}
			if (lol) break;
			return 0;
		}
	} while (1);
	return 1;
}