#include <bits/stdc++.h>

using namespace std;

bool hasOnes(int l,int r);

std::vector<int> solve(int s, int e) {
    int last = s - 1;
    vector<int> ans;
    while (last + 1 < e) {

        int l = last + 1, r = e;
        if (!ans.empty()) if (!hasOnes(l,r)) break;

        while (r > l) {
            int mid = l + (r - l) / 2;
            if (hasOnes(l,mid)) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }

        ans.push_back(l);
        last = l;
    }
    if (last + 1 == e && hasOnes(e,e))
        ans.push_back(e);

    return ans;
}

std::vector<int> guessOnes(int n,int k) {
    int boxes = k;

    vector<int> ans;
    int l = 1;
    for (int i = 0; i < boxes; ++i) {
        int next = l + n / k;
        if (next >= n) next = n;

        auto x = solve(l,next);
        for (auto y : x)
            ans.push_back(y);

        l = next + 1;
    }

    return ans;
}

#if DEBUG
static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
        std::cin>>_ones[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}
#endif

//15333017 used
//4723779 req
//