#include <bits/stdc++.h>

using namespace std;

using pii = pair<int,int>;
constexpr int EMPTY = 0;
constexpr int HOR_SINGLE = -1;
constexpr int VERT_SINGLE = -2;

constexpr int HOR_DOUBLE = -3;

constexpr int VERT_DOUBLE = -4;

void init(int numSubtests, double timeLimit) {

}

vector<vector<pii>> g;
vector<vector<int>> sel;
map<pii, int> ids;
map<int, pii> loc;
vector<int> val;
map<int, int> conStr;
int conIds = 0;
map<pii, int> conId;
#define all(x) begin(x), end(x)


vector<pii> dirs = {{1,0},{-1,0},{0,1},{0,-1}};

int dir(int a) {
    if (a > 0) return 1;
    if (a == 0) return 0;
    return -1;
}

bool canColor(int from, int to, std::vector<std::vector<int>>& puzzle) {
    auto [fromI, fromJ] = loc[from];
    auto [toI, toJ] = loc[to];

    int dI = dir(toI - fromI);
    int dJ = dir(toJ - fromJ);

    fromI += dI;
    fromJ += dJ;

    while (fromI != toI || fromJ != toJ) {
        if (puzzle[fromI][fromJ] != 0) return false;
        fromI += dI;
        fromJ += dJ;
    }
    return true;
}

void color(int from, int to, std::vector<std::vector<int>>& puzzle, int str) {
    auto [fromI, fromJ] = loc[from];
    auto [toI, toJ] = loc[to];

    int dI = dir(toI - fromI);
    int dJ = dir(toJ - fromJ);

    fromI += dI;
    fromJ += dJ;

    while (fromI != toI || fromJ != toJ) {
        if (fromI == 2 && fromJ == 8) {
            int debug = 25;
        }
        if (str == 0)
            puzzle[fromI][fromJ] = 0;
        else if (dI == 0)
            puzzle[fromI][fromJ] = -1 - (str - 1) * 2;
        else
            puzzle[fromI][fromJ] = -2 - (str - 1) * 2;
        fromI += dI;
        fromJ += dJ;
    }
}

void calcDir(int i, int j, std::vector<std::vector<int>>& puzzle) {
    for (auto [di, dj] : dirs) {
        int time = 1;
        while ((i + di * time) < puzzle.size() && (i + di * time) >= 0 && (dj * time + j) < puzzle[0].size() && (dj * time + j) >= 0) {
            int newI = i + di * time;
            int newJ = j + dj * time;

            if (puzzle[newI][newJ] > 0) {
                int fId = ids[{i,j}];
                int tId = ids[{newI,newJ}];

                if (conId.count({tId,fId}) == 0) {
                    sel[fId].emplace_back(tId);
                    sel[tId].emplace_back(fId);
                    conId[{fId,tId}] = conIds;
                    conStr[conIds] = 0;
                    conId[{tId,fId}] = conIds++;
                }

                break;
            }
            time++;
        }
    }
}

int str(int i, int j) {
    return conStr[conId[{i,j}]];
}
int countCon(int i) {
    int ans = 0;
    for (auto c : sel[i]) {
        ans += str(i,c);
    }
    return ans;
}

vector<bool> vis;

bool findMatch(int i,std::vector<std::vector<int>>& puzzle,bool add) {
    vis[i] = true; //todo edge wise ?
    for (auto child : sel[i]) {
        if (add) {
            if (str(i,child) == 2) continue;
            if (vis[child]) continue;
            if (str(i,child) == 0 && !canColor(i,child,puzzle)) continue;
            if (i == 12 && child == 11) {
                int stop = 25;
            }
            if (countCon(child) < val[child] || findMatch(child,puzzle,false)) {
                // Remove connection
                if (str(i,child) == 0 && !canColor(i,child,puzzle)) continue;
                conStr[conId[{i,child}]]++;
                color(i,child,puzzle,str(i,child));
                return true;
            }
        } else {
            if (str(i,child) == 0) continue;
            if (vis[child]) continue;
            if (findMatch(child,puzzle,true)) {
                // Make connection
                conStr[conId[{i,child}]]--;
                color(i,child,puzzle,str(i,child));
                return true;
            }
        }
    }

    return false;
}

bool solve(std::vector<std::vector<int>>& puzzle) {
    ids.clear();
    val.clear();
    conStr.clear();
    conId.clear();
    sel.clear();
    conIds = 0;
    loc.clear();

    vector<pii> data;

    int id = 0;
    for (int i = 0; i < puzzle.size();i++) {
        for (int j =0 ; j < puzzle[i].size();j++) {
            if (puzzle[i][j] > 0) {
                loc[id] = {i,j};
                data.emplace_back(puzzle[i][j],id);
                val.push_back(puzzle[i][j]);
                ids[{i,j}] = id++;
            }
        }
    }

    sel.resize(id);
    g.clear();
    g.resize(id);
    for (int i = 0; i < puzzle.size();i++) {
        for (int j =0 ; j < puzzle[i].size();j++) {
            if (puzzle[i][j] == 0) continue;
            calcDir(i,j,puzzle);
        }
    }

    sort(all(data));
    for (auto [dirs, i] : data) {
        if (countCon(i) == dirs) continue;
        for (int m = countCon(i); m < dirs;m++) {
            vis.clear();
            vis.resize(id);
            findMatch(i,puzzle,true);
        }
    }

    return true;
}


double timePassed();

#if DEBUG
static int n, m;
static std::vector<std::vector<int>> puzzle;
static std::vector<std::vector<int>> puzzleOut;

static void input()
{
    std::cin >> n >> m;

    puzzle.resize(n);
    for (int i = 0; i < n; ++i)
    {
        puzzle[i].resize(m);
        for (int j = 0; j < m; ++j)
        {
            std::cin >> puzzle[i][j];
        }
    }
}

static int numSubtests;
static int currSubtest;
static double timeLimit;

static void myAssert(bool f)
{
    if (f) return;

    std::cout << "Invalid solution on subtest: " << currSubtest + 1 <<  " / " << numSubtests << std::endl;
    std::cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
    std::cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;

    exit(0);
}

static std::vector<std::vector<bool>> visited;

static void DFS(int i, int j)
{
    if (i < 0) return;
    if (i >= n) return;
    if (j < 0) return;
    if (j >= m) return;

    if (puzzleOut[i][j] == EMPTY) return;
    if (visited[i][j]) return;

    visited[i][j] = true;

    DFS(i - 1, j);
    DFS(i + 1, j);
    DFS(i, j - 1);
    DFS(i, j + 1);
}

static bool run()
{
    puzzleOut = puzzle;
    bool res = solve(puzzleOut);

    if (!res) return false;

    std::cerr << n << " " << m << std::endl;
    for (const std::vector<int>& row : puzzleOut)
    {
        for (int elem : row)
        {
            if (elem > 0 && elem <= 8) std::cerr << elem;
            else if (elem == EMPTY) std::cerr << " ";
            else if (elem == HOR_SINGLE) std::cerr << "-";
            else if (elem == HOR_DOUBLE) std::cerr << "=";
            else if (elem == VERT_SINGLE) std::cerr << "|";
            else if (elem == VERT_DOUBLE) std::cerr << "$";
            else std::cerr << "?";
        }
        std::cerr << std::endl;
    }
    std::cerr << std::endl;

    myAssert((int) puzzleOut.size() == n);
    for (int i = 0; i < n; ++i)
    {
        myAssert((int) puzzleOut[i].size() == m);
        for (int j = 0; j < m; ++j)
        {
            if (puzzle[i][j] > 0)
            {
                myAssert(puzzleOut[i][j] == puzzle[i][j]);
            }
            else
            {
                myAssert(
                    puzzleOut[i][j] == EMPTY ||
                    puzzleOut[i][j] == HOR_SINGLE ||
                    puzzleOut[i][j] == VERT_SINGLE ||
                    puzzleOut[i][j] == HOR_DOUBLE ||
                    puzzleOut[i][j] == VERT_DOUBLE);
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {

            if (puzzleOut[i][j] > 0)
            {
                int sum = 0;
                if (j > 0 && puzzleOut[i][j - 1] == HOR_SINGLE) sum += 1;
                if (j > 0 && puzzleOut[i][j - 1] == HOR_DOUBLE) sum += 2;
                if (j < m - 1 && puzzleOut[i][j + 1] == HOR_SINGLE) sum += 1;
                if (j < m - 1 && puzzleOut[i][j + 1] == HOR_DOUBLE) sum += 2;
                if (i > 0 && puzzleOut[i - 1][j] == VERT_SINGLE) sum += 1;
                if (i > 0 && puzzleOut[i - 1][j] == VERT_DOUBLE) sum += 2;
                if (i < n - 1 && puzzleOut[i + 1][j] == VERT_SINGLE) sum += 1;
                if (i < n - 1 && puzzleOut[i + 1][j] == VERT_DOUBLE) sum += 2;
                myAssert(sum == puzzleOut[i][j]);
            }
            else if (puzzleOut[i][j] != EMPTY)
            {
                if (puzzleOut[i][j] == HOR_SINGLE)
                {
                    myAssert(j > 0 && (puzzleOut[i][j - 1] == HOR_SINGLE || puzzleOut[i][j - 1] > 0));
                    myAssert(j < m - 1 && (puzzleOut[i][j + 1] == HOR_SINGLE || puzzleOut[i][j + 1] > 0));
                }
                if (puzzleOut[i][j] == HOR_DOUBLE)
                {
                    myAssert(j > 0 && (puzzleOut[i][j - 1] == HOR_DOUBLE || puzzleOut[i][j - 1] > 0));
                    myAssert(j < m - 1 && (puzzleOut[i][j + 1] == HOR_DOUBLE || puzzleOut[i][j + 1] > 0));
                }
                if (puzzleOut[i][j] == VERT_SINGLE)
                {
                    myAssert(i > 0 && (puzzleOut[i - 1][j] == VERT_SINGLE || puzzleOut[i - 1][j] > 0));
                    myAssert(i < n - 1 && (puzzleOut[i + 1][j] == VERT_SINGLE || puzzleOut[i + 1][j] > 0));
                }
                if (puzzleOut[i][j] == VERT_DOUBLE)
                {
                    myAssert(i > 0 && (puzzleOut[i - 1][j] == VERT_DOUBLE || puzzleOut[i - 1][j] > 0));
                    myAssert(i < n - 1 && (puzzleOut[i + 1][j] == VERT_DOUBLE || puzzleOut[i + 1][j] > 0));
                }
            }
        }
    }

    visited.clear();
    visited.resize(n);
    for (int i = 0; i < n; ++i)
    {
        visited[i].resize(m, false);
    }

    bool found = false;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (puzzleOut[i][j] == EMPTY) continue;
            if (!found)
            {
                DFS(i, j);
                found = true;
            }
            myAssert(visited[i][j]);
        }
    }

    return true;
}

static clock_t startT;

double timePassed()
{
    clock_t currT = clock();

    return (double) (currT - startT) / CLOCKS_PER_SEC;
}

int main()
{
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cin >> numSubtests;
    std::cin >> timeLimit;

    startT = clock();

    init(numSubtests, timeLimit);

    for (currSubtest = 0; currSubtest < numSubtests; ++currSubtest)
    {
        input();
        if (!run())
        {
            std::cout << "Stopped on subtest: " << currSubtest + 1 << " / " << numSubtests << std::endl;
            break;
        }
        if (timePassed() > timeLimit)
        {
            std::cout << "Timed out during subtest: " << currSubtest + 1 << " / " << numSubtests << std::endl;
            break;
        }
    }

    std::cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
    std::cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;

    return 0;
}
#endif