#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<vector<ll>> dataVec(5,vector<ll>(5));
vector<vector<ll>> vec1(5,vector<ll>(5));

constexpr int MOD = 1e8 + 543;

vector<vector<ll>> mult(vector<vector<ll>> a, vector<vector<ll>> b) {
    vector<vector<ll>> c(a.size(),vector<ll>(a[0].size()));

    for (ll i = 0; i < a.size();i++) {
        for (ll j = 0; j < a[0].size();j++) {
            for (ll k = 0; k < a.size();k++) {
                c[i][k] += (a[i][j] % MOD) * (b[j][k] % MOD);
                c[i][k] %= MOD;
            }
        }
    }

    return c;
}

vector<vector<ll>> pow(vector<vector<ll>> a, ll b) {
    if (b == 0) return vec1;
    if (b == 1) return a;

    vector<vector<ll>> ans = pow(a, b / 2);
    ans = mult(ans,ans);
    if (b % 2 == 1) ans = mult(ans,a);

    return ans;
}

struct Segment {
    Segment *left = nullptr, *right = nullptr;
    ll l, r, mid;
    ll val = 0;
    vector<vector<ll>> m;

    Segment(ll l, ll r) : l(l), r(r), mid((r + l) /2 ), m(5,vector<ll>(5)) {
        for (ll i = 0; i < 5;i++) {
            m[i][i] = 1;
        }
        if (r - l > 1) {
            left = new Segment(l,mid);
            right = new Segment(mid,r);
        }
    }

    ll get(ll a, ll b) {
        if (a >= r || b <= l) return 0;
        if (a <= l && b >= r)
            return val;

        return left->get(a,b) + right->get(a,b);
    }

    void update(ll a, ll b, ll u) {
        if (r - l <= 1) {
            m = mult(m,pow(dataVec,u - 1));
            val = m[4][4];
            return;
        }

        if (a >= mid) {
            right->update(a,b,u);
            val = right->val + left->val;
            val %= MOD;
        } else {
            left->update(a,b,u);
            val = right->val + left->val;
            val %= MOD;
        }
    }
};

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll n, q; cin >> n >> q;

    for (ll i = 0; i < 5;i++) {
        dataVec[4][i] = i + 1;
        if (i != 4) dataVec[i][i + 1] = 1;
        vec1[i][i] = 1;
    }

    Segment seg(0,n + 1);

    for (ll i = 1; i <= n;i++) {
        ll x; cin >> x;
        seg.update(i,i,x);
    }

    //1 5
    //1
    //1 1 1
    //2 1 1 -2
    //1 1 1
    //2 1 1 8
    //1 1 1
    for (ll i = 0; i < q;i++) {
        ll t; cin >> t;
        if (t == 1) {
            ll l, r; cin >> l >> r;
            cout << seg.get(l,r + 1) << "\n";
        }
    }

    return 0;
}
