#include <iostream>
#include <bits/stdc++.h>
using namespace std;
typedef __int128_t ll;
int M = 1e8+543;

struct mint {
    ll i;
    mint(ll k) {
        i=k;
    }
    mint operator*(mint b) {
        return {(i*b.i)%M};
    }
    mint operator+(mint b) {
        return {(i+b.i)%M};
    }
    mint operator-(mint a) {
        return {(i-a.i+M)%M};
    }
};
mint exp(mint a,ll b) {
    mint base = a;
    mint res = 1;
    for (ll i = b;i>0;i/=2) {
        if(i%2==1) res = base * res;
        base = (base * base);
    }
    return res;
}
vector<mint> sol = {1405049,10002474,36684046,69727867,82181655};
vector<mint> coeff = {4868204,92161528,51211683,37815043,13944628};
typedef pair<mint,mint> pi;
struct Seg {
    int n;
    vector<pi> s;
    Seg(int m) {
        for(n=1;n<m;n*=2);
        s = vector<pi>(2*n,{1,1});
        for (int i = n-1; i>0;i--) {
            s[i].first=s[2*i].first+s[2*i+1].first;
        }
    }
    void push(int l) {
        if(l<n) {
            s[2*l+1].second=s[2*l+1].second*s[l].second;
            s[2*l].second=s[2*l].second*s[l].second;
        }
        int k = l;
        int i = 0;
        for(;k<2*n;k*=2)i++;
        s[l].first=s[l].first*s[l].second;
        s[l].second=1;
    }
    void mpush(int l) {
        if(l==0) return;
        mpush(l/2);
        push(l);
    }
    void mpush2(int l) {
        if(l==0) return;
        mpush(l/2);
        push(l-1);
    }
    void Update(int l,int r,mint mult) {
        mint sum = Query(l,r);
        l+=n;
        r+=n;
        int d = r-l;
        while(l<r) {
            if(l%2==1) {
                s[l].second = s[l].second * mult;
                l++;
            }
            if(r%2==1) {
                r--;
                s[r].second = s[r].second*mult;
            }
            l = l/2;
            r = r/2;
        }
        while(l>0) {
            s[l].first= s[l].first + sum * (mult-1);
            l=l/2;
        }
    }
    mint Query(int l,int r) {
        l+=n;
        r+=n;
        mpush(l); mpush2(r);
        mint res = 0;
        while(l<r) {
            if(l%2==1) {
                res = res +s[l].first;
                l++;
            }
            if(r%2==1) {
                r--;
                res = res + s[r].first;
            }
            l = l/2;
            r = r/2;
        }
        return res;
    }
};
int main()
{
    int n,q;
    cin>>n>>q;
    vector<Seg> s = vector<Seg>(5,n+2);
    for (int i = 0; i<q;i++) {
        int t;
        cin>>t;
        if(t==1) {
            int l,r;
            cin>>l>>r;
            r++;
            mint res = 0;
            for (int j =0; j<5; j++) {
                res = res + s[j].Query(l,r)*coeff[j];
            }
            cout<<(long long)res.i<<"\n";
        }else {
            int l,r,v;
            cin>>l>>r>>v;
            r++;
            for (int j =0; j<5; j++) {
                mint mult = exp(sol[j],v);
                s[j].Update(l,r,mult);
            }
        }
    }
}
