#include <bits/stdc++.h>
#include "ones.h"
using namespace std;


vector<int> naive(int s, int e, int k) {
    if (s == e) return {s};
    int count = 0, cur = s;
    vector<int> ans(k);
    while (count < k) {
        int lo = cur, hi = e;
        while (lo < hi) {
          int mid = (lo+hi)/2;
          if (hasOnes(cur, mid)) hi = mid;
          else lo = mid+1;
        }
        ans[count++] = lo;
        cur = lo+1;
    }
    return ans;
}
vector<int> revNaive(int s, int e, int k) {
    if (s == e) return {s};
    int count = 0, cur = s;
    vector<int> ans(k);
    while (count < k) {
        int lo = cur, hi = e;
        while (lo < hi) {
            int mid = (lo+hi)/2;
            if (hasOnes(mid+1, hi)) lo = mid+1;
            else hi = mid;
        }
        ans[count++] = lo;
        cur = lo+1;
    }
    return ans;
}
vector<int> guess(int start, int end, int sz, int k) {
    if (start == end) return {start};
    bool right = hasOnes(start, start + sz / 2 -1);
    vector<int> ans;
    if (right) {
        vector<int> temp = guess(start, start + sz / 2-1, sz / 2, k);
        for (int i : temp) ans.push_back(i);
    }
    if (ans.size() < k && hasOnes(start+sz/2, end)) {
        vector<int> temp = guess(start+sz/2, end, sz-sz/2, k);
        for (int i : temp) ans.push_back(i);
    }

    return ans;
}
vector<int> iter(int start, int end, int k) {
    queue<pair<int,int>> q;
    q.push({start, end});
    while (q.size() < k) {
        int s = q.front().first, e = q.front().second;
        q.pop();
        if (s == e) {
            q.push({s,e});
            continue;
        }
        int sz = (e-s)/2;
        if (hasOnes(s, s + sz)) q.push({s,s+sz});
        if (hasOnes(s+sz+1, e)) q.push({s+sz+1, e});
    }
    vector<pair<int,int>> ranges;
    while (!q.empty()) {
        ranges.push_back(q.front()); q.pop();
    }
    sort(ranges.begin(), ranges.end());

    vector<int> ans;
    for (pair<int,int> p : ranges) {
        ans.push_back(naive(p.first, p.second, 1)[0]);
    }
    return ans;
}
vector<int> bounds(int start, int end, int k) {
    if (k == 0) return {};
    if (k == 1) return naive(start, end, 1);
    int first = naive(start, end, 1)[0];
    int second = revNaive(first+1, end, 1)[0];
    vector<int> other = bounds(first+1, second-1, k-2);
    other.push_back(first); other.push_back(second);
    return other;
}
vector<int> guessOnes(int n, int k) {
    int jump = 15;
    vector<int> ans;
    int i = 1;
    while (i+jump-1 <= n) {
        int last = i+jump-1, cur = i;
        while (cur <= last && hasOnes(cur, last)) {
            int first = naive(cur, last, 1)[0];
            cur = first+1;
            ans.push_back(first);
            if (ans.size() == k) return ans;
        }
        int left = k-ans.size();
        i += jump;
        jump = (5*max(4,(n-i)/left))/4;
        if (i+jump-1>n) jump=n-i+1;
    }
    return {};
}
/*
 * 10000 5 1
  300 2100 3200 6400 10000
 */