#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll MOD = 1e8 + 543;
typedef vector<ll> vll;
typedef vector<vll> mat;
const int sz = 5;
mat T(5, vll(5, 0)), id(5, vll(5, 0));
vector<mat> powers(32);
mat mult(mat &a, mat &b) {
    mat res(sz, vll(sz, 0));
    for (int i = 0; i<sz; ++i) {
        for (int j = 0; j<sz; ++j) {
            for (int l = 0; l<sz; ++l) {
                res[i][j] = (res[i][j] + a[i][l] * b[l][j]) % MOD;
            }
        }
    }
    return res;
}
void init() {
    T[0] = {0, 1, 0, 0, 0};
    T[1] = {0, 0, 1, 0, 0};
    T[2] = {0, 0, 0, 1, 0};
    T[3] = {0, 0, 0, 0, 1};
    T[4] = {1, 2, 3, 4, 5};
    for (int i = 0; i<sz; ++i) id[i][i] = 1;
    powers[0] = T;
    for (int i = 1; i<32; ++i) powers[i] = mult(powers[i-1], powers[i-1]);
}

mat fastPow(ll b) {
    /*if (b == 0) return id;
    if (b == 1) return a;
    if (b%2) return mult(a,fastPow(a,b-1));
    return fastPow(mult(a,a), b/2);*/
    mat res = T;
    for (int i = 1; i<31; ++i) if (b & (1 << i)) res = mult(res, powers[i]);
    return res;
}
ll extract(mat &a) {
    ll ans = 0;
    for (int i = 1; i<5; ++i) ans = (ans + i*a[4][i]) % MOD;
    return ans;
}
ll getVal(ll a) {
    if (a <= 4) return a;
    mat res = fastPow(a-4);
    return extract(res);
}
int main() {
    init();
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int n, q; cin >> n >> q;
    vll a(n); for (ll &i : a) cin >> i;
    vll ans(n+1); ans[0] = 0;
    for (int i = 1; i<=n; ++i) ans[i] = (ans[i-1] + getVal(a[i-1])) % MOD;
    while (q--) {
        int t,l,r; cin >> t >> l >> r;
       // if (t == 2) while (1);
        cout << ((ans[r]-ans[l-1]) % MOD + MOD) % MOD << '\n';
    }
}