#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll MOD = 1e8 + 543;
typedef vector<ll> vll;
typedef vector<vll> mat;
const int sz = 5;
mat T(5, vll(5, 0)), id(5, vll(5, 0));
vector<mat> powers(32);
mat mult(mat &a, mat &b) {
    mat res(sz, vll(sz, 0));
    for (int i = 0; i<sz; ++i) {
        for (int j = 0; j<sz; ++j) {
            for (int l = 0; l<sz; ++l) {
                res[i][j] = (res[i][j] + a[i][l] * b[l][j]) % MOD;
            }
        }
    }
    return res;
}
void init() {
    T[0] = {0, 1, 0, 0, 0};
    T[1] = {0, 0, 1, 0, 0};
    T[2] = {0, 0, 0, 1, 0};
    T[3] = {0, 0, 0, 0, 1};
    T[4] = {1, 2, 3, 4, 5};
    for (int i = 0; i<sz; ++i) id[i][i] = 1;
    powers[0] = T;
    for (int i = 1; i<32; ++i) powers[i] = mult(powers[i-1], powers[i-1]);
}

mat fastPow(ll b) {
    /*if (b == 0) return id;
    if (b == 1) return a;
    if (b%2) return mult(a,fastPow(a,b-1));
    return fastPow(mult(a,a), b/2);*/
    mat res = id;
    for (int i = 0; i<31; ++i) if (b & (1 << i)) res = mult(res, powers[i]);
    return res;
}
ll extract(mat &a) {
    ll ans = 0;
    for (int i = 1; i<5; ++i) ans = (ans + i*a[4][i]) % MOD;
    return ans;
}
ll getVal(ll a) {
    if (a <= 4) return a;
    mat res = fastPow(a-4);
    return extract(res);
}

struct Seg {
    int sz = 1;
    vector<ll> v;
    Seg(int n, vll &in) {
        for (; sz<n; sz *= 2);
        v.resize(2*sz);
        for (int i = 0; i<n; ++i) v[i+sz] = getVal(in[i]);
        for (int i = sz-1; i; --i) v[i] = (v[2*i] + v[2*i+1]) % MOD;
    }
    ll query(ll l, ll r) {
        ll ans = 0;
        for (l += sz, r += sz; l<=r; l /= 2, r /= 2) {
            if (l % 2) ans = (ans + v[l++]) % MOD;
            if (r%2 == 0) ans = (ans + v[r--]) % MOD;
        }
        return ans;
    }
    void update(ll i, ll x) {
        i += sz;
        ll newVal = getVal(x);
        ll ad = newVal-v[i];
        for (; i; i /= 2) v[i] += ad;
    }
};
int main() {
    init();
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int n, q; cin >> n >> q;
    vll a(n); for (ll &i : a) cin >> i;
    Seg seg(n, a);
    //vll ans(n+1); ans[0] = 0;
    //for (int i = 1; i<=n; ++i) ans[i] = (ans[i-1] + getVal(a[i-1])) % MOD;
    while (q--) {
        int t,l,r, val; cin >> t >> l >> r;
        --l; --r;
        //if (t == 2) while (1);
        if (t == 2) {
            cin >> val;
            seg.update(l, a[l] += val);
        }
        else cout << seg.query(l,r) << '\n';
    }
}
/*
 * 1 3 1
1 1 1
2 1 1 6
1 1 1
 */