#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll MOD = 1e8 + 543;
typedef vector<ll> vll;
typedef vector<vll> mat;

const int sz = 5;
map<ll,ll> calc;
mat T(5, vll(5,0)), id(5, vll(5, 0));
mat powers[32];
mat mult(mat a, mat b) {
    mat res(sz, vll(sz, 0));
    for (int i = 0; i<sz; ++i) {
        for (int l = 0; l<sz; ++l) {
            for (int j = 0; j < sz; ++j) {
                res[i][j] = (res[i][j] + a[i][l] * b[l][j]) % MOD;
            }
        }
    }
    return res;
}
mat fastPow(ll b) {
    /*if (b == 0) return id;
    if (b == 1) return a;
    if (b%2) return mult(a,fastPow(a,b-1));
    return fastPow(mult(a,a), b/2);*/
    mat res = id;
    for (int i = 0; i<32 && (1ll << i) <= b; ++i) if (b & (1ll << i)) res = mult(res, powers[i]);
    return res;
}


ll extract(mat a) {
    ll ans = 0;
    for (int i = 1; i<5; ++i) ans = (ans + i*a[4][i]) % MOD;
    return ans;
}
mat poww(mat a, ll b) {
    if (b == 1) return a;
    if (b & 1) return mult(a,poww(a,b-1));
    return poww(mult(a,a), b/2);
}
void init(set<ll> &values) {
    T[0] = {0, 1, 0, 0, 0};
    T[1] = {0, 0, 1, 0, 0};
    T[2] = {0, 0, 0, 1, 0};
    T[3] = {0, 0, 0, 0, 1};
    T[4] = {1, 2, 3, 4, 5};
    for (int i = 0; i<sz; ++i) id[i][i] = 1;
    powers[0] = T;
    for (ll i = 1; i<32; ++i) powers[i] = mult(powers[i-1], powers[i-1]);
    ll bef = 1;
    mat cur = T;
    for (ll i : values) {
        ll toAdd = i-bef;
        mat ne = fastPow(toAdd);
        mat ex = mult(ne, cur);
        calc[i] = extract(cur = ex);
        /*mat ne = poww(T, toAdd);
        mat ex = mult(ne, cur);*/
        //calc[i] = extract(fastPow(i));
    }
}

ll getVal(ll a) {
    if (a <= 4) return a;
    if (a == 5) return 40;
    assert(calc.find(a-4) != calc.end());
    return calc[a-4];
    mat res = fastPow(a-4);
    return extract(res);
}

struct Seg {
    int sz = 1;
    vector<ll> v;
    Seg(int n, vll &in) {
        for (; sz<n; sz *= 2);
        v.resize(2*sz);
        for (int i = 0; i<n; ++i) v[i+sz] = getVal(in[i]);
        for (int i = sz-1; i; --i) v[i] = (v[2*i] + v[2*i+1]) % MOD;
    }
    ll query(ll l, ll r) {
        ll ans = 0;
        for (l += sz, r += sz; l<=r; l /= 2, r /= 2) {
            if (l % 2) ans = (ans + v[l++]) % MOD;
            if (r%2 == 0) ans = (ans + v[r--]) % MOD;
        }
        return ans;
    }
    void update(ll i, ll x) {
        ll old = v[i += sz];
        ll newVal = getVal(x);
        for (; i; i /= 2) {
            v[i] = (((v[i] - old + newVal) % MOD) + MOD) % MOD;
        }
    }
};
int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int n, q; cin >> n >> q;
    set<ll> values;
    vll a(n);
    for (ll &i : a) {
        cin >> i;
        if (i > 5) values.insert(i-4);
    }
    vll b = a;
    vector<vector<ll>> quer(q, vll(4));
    for (int i = 0; i<q; ++i) {
        ll t,l,r, val; cin >> t >> l >> r;
        --l; --r;
        quer[i][0] = t; quer[i][1] = l; quer[i][2] = r;
        if (t == 2) {
            cin >> val;
            b[l] = (b[l]+val)%(MOD-1);
            if (b[l] > 5) values.insert(b[l]-4);
            quer[i][3] = val;
        }
    }
    init(values);
    Seg seg(n, a);
    for (int i = 0; i<q; ++i) {
        ll t = quer[i][0], l = quer[i][1], r = quer[i][2], val;
        if (t == 2) {
            val = quer[i][3];
            a[l] = (a[l]+val)%(MOD-1);
            seg.update(l, a[l]);
        }
        else cout << seg.query(l,r) << '\n';
    }
}
/*
 * 1 3 1
1 1 1
2 1 1 6
1 1 1



 2 7
3 3
1 1 2
2 1 1 2
1 1 2
2 2 2 3
1 1 2
2 2 2 -3
1 1 2
 */
