#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll,ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e8 + 543;
const double temp = 0.9999;

#include "puzzle.h"

ll myNumSubtests;
double myTimeLimit;

void init(int nnumSubtests, double ntimeLimit)
{
    myNumSubtests = nnumSubtests;
    myTimeLimit = ntimeLimit;
}

bool intersect(ll x1, ll y1, ll x2, ll y2, ll x3, ll y3, ll x4, ll y4)
{
    bool firstLine = (y1 == y2);
    bool secondLine = (y3 == y4);
    if (x1 > x2) swap(x1, x2);
    if (y1 > y2) swap(y1, y2);
    if (x3 > x4) swap(x3, x4);
    if (y3 > y4) swap(y3, y4);
    if (firstLine && secondLine)
    {
        if (y1 != y3) return false;
        if ((x1 <= x3 && x2 > x3) || (x1 < x4 && x1 >= x3)) return true;
        if ((x3 <= x1 && x4 > x1) || (x3 < x2 && x3 >= x1)) return true;
        return false;
    }
    if (!firstLine && !secondLine)
    {
        if (x1 != x3) return false;
        if ((y1 <= y3 && y2 > y3) || (y1 < y4 && y1 >= y3)) return true;
        if ((y3 <= y1 && y4 > y1) || (y3 < y2 && y3 >= y1)) return true;
        return false;
    }
    if (firstLine && !secondLine)
    {
        swap(x1, x3);
        swap(y1, y3);
        swap(x2, x4);
        swap(y2, y4);
        swap(firstLine, secondLine);
    }
    if (x1 >= x3 && x1 <= x4 && y1 <= y3 && y2 >= y3 && p(x1, y1) != p(x3, y3) && p(x1, y1) != p(x4, y4) && p(x2, y2) != p(x3, y3) && p(x2, y2) != p(x4, y4) ) return true;
    return false;
}
bool solve(std::vector<std::vector<int>>& puzzle)
{
    vtri cells;
    ll n = puzzle.size(), m = puzzle[0].size();
    for (ll i = 0; i < n; i++)
    {
        for (ll j = 0; j < m; j++)
        {
            if (puzzle[i][j] > 0) cells.eb(puzzle[i][j], p(j, i));
        }
    }
    ll sum = 0;
    for (auto x : cells) sum += x.f;
    double time = temp;
    ll iterations = 1000;
    ll c = cells.size();
    vv amount(c, v(c, 0));
    vp edges;
    ll score = sum + c;
    ll lastUpdate = 0;
    while (score > 1)
    {
        if (timePassed() > myTimeLimit) return false;
        if (lastUpdate == 10)
        {
            ll e = rand() % edges.size();
            p removed = edges[e];
            edges.erase(edges.begin() + e);
            amount[removed.f][removed.s]--;
            amount[removed.s][removed.f]--;
            v degree(c, 0);
            for (auto x : edges)
            {
                degree[x.f]++;
                degree[x.s]++;
            }
            ll newScore = 0;
            for (ll i = 0; i  < c; i++)
            {
                newScore += abs(cells[i].f - degree[i]);
            }
            ll intersects = 0;
            for (auto x : edges)
            {
                for (auto y : edges)
                {
                    if (x != y && x != p(y.s, y.f) && intersect(cells[x.f].s.f, cells[x.f].s.s, cells[x.s].s.f, cells[x.s].s.s, cells[y.f].s.f, cells[y.f].s.s, cells[y.s].s.f, cells[y.s].s.s)) 
                    {
                        intersects++;
                    }
                }
            }
            if (intersects) newScore = INF;
            vv graph(c);
            for (auto x : edges)
            {
                graph[x.f].pb(x.s);
                graph[x.s].pb(x.f);
            }
            vb visited(c, false);
            ll con = 0;
            for (ll i = 0; i < c; i++)
            {
                if (visited[i]) continue;
                con++;
                stack<ll> dfs;
                dfs.push(i);
                while (!dfs.empty())
                {
                    ll top = dfs.top();
                    dfs.pop();
                    if (visited[top]) continue;
                    visited[top] = true;
                    for (ll x : graph[top]) dfs.push(x);
                }
            }
            newScore += con;
            score = newScore;
            lastUpdate = 0;
            continue;
        }
        ll a = rand() % c, b = rand() % c;
        while (b == a || !(cells[a].s.f == cells[b].s.f || cells[a].s.s == cells[b].s.s)) b = rand() % c;
        ll amt = amount[a][b];
        ll newAmt = amt + 1;
        if (amt == 2) newAmt = amt - 1;
        if (amt == 1 && rand() % 2 == 0) newAmt = amt - 1;
        amount[a][b] = amount[b][a] = newAmt;
        vp prevEdges;
        for (auto x : edges) prevEdges.pb(x);
        if (newAmt < amt)
        {
            vp newEdges;
            ll remaining = newAmt;
            for (p x : edges) 
                if (x == p(a, b) || x == p(b, a) && remaining > 0)
                {
                    remaining--;
                    newEdges.pb(x);
                }
                else if (x != p(a, b) && x != p(b, a)) newEdges.pb(x);
            edges = newEdges;
        }
        else edges.eb(a, b);
        v degree(c, 0);
        for (auto x : edges)
        {
            degree[x.f]++;
            degree[x.s]++;
        }
        ll newScore = 0;
        for (ll i = 0; i  < c; i++)
        {
            newScore += abs(cells[i].f - degree[i]);
        }
        ll intersects = 0;
        for (auto x : edges)
        {
            for (auto y : edges)
            {
                if (x != y && x != p(y.s, y.f) && intersect(cells[x.f].s.f, cells[x.f].s.s, cells[x.s].s.f, cells[x.s].s.s, cells[y.f].s.f, cells[y.f].s.s, cells[y.s].s.f, cells[y.s].s.s)) 
                {
                    intersects++;
                }
            }
        }
        if (intersects) newScore = INF;
        vv graph(c);
        for (auto x : edges)
        {
            graph[x.f].pb(x.s);
            graph[x.s].pb(x.f);
        }
        vb visited(c, false);
        ll con = 0;
        for (ll i = 0; i < c; i++)
        {
            if (visited[i]) continue;
            con++;
            stack<ll> dfs;
            dfs.push(i);
            while (!dfs.empty())
            {
                ll top = dfs.top();
                dfs.pop();
                if (visited[top]) continue;
                visited[top] = true;
                for (ll x : graph[top]) dfs.push(x);
            }
        }
        newScore += con;
        if (newScore < score || rand() % (ll)exp((newScore - score) / 2.0 * time + 1) == 0)
        {
            score = newScore; lastUpdate = 0;
        }
        else
        {
            edges = prevEdges;
            amount[a][b] = amount[b][a] = amt; lastUpdate++;
        }
        time *= temp;
    }
    for (auto x : edges)
    {
        if (cells[x.f].s.f == cells[x.s].s.f)
        {
            if (cells[x.f].s.s > cells[x.s].s.s) swap(x.f, x.s);
            for (ll i = cells[x.f].s.s + 1; i < cells[x.s].s.s; i++)
            {
                puzzle[i][cells[x.f].s.f] -= 2;
            }
        }
        else
        {
            if (cells[x.f].s.f > cells[x.s].s.f) swap(x.f, x.s);
            for (ll i = cells[x.f].s.f + 1; i < cells[x.s].s.f; i++)
            {
                if (puzzle[cells[x.f].s.s][i] == 0) puzzle[cells[x.f].s.s][i] = -1;
                else puzzle[cells[x.f].s.s][i] -= 2;
            }
        }
    }
    return true;
}

ifstream ccin;
static int n, m;
static std::vector<std::vector<int>> puzzle;
static std::vector<std::vector<int>> puzzleOut;

static void input()
{
    ccin >> n >> m;

    puzzle.resize(n);
    for (int i = 0; i < n; ++i)
    {
        puzzle[i].resize(m);
        for (int j = 0; j < m; ++j)
        {
            ccin >> puzzle[i][j];
        }
    }
}

static int numSubtests;
static int currSubtest;
static double timeLimit;

static void myAssert(bool f)
{
    if (f) return;

    std::cout << "Invalid solution on subtest: " << currSubtest + 1 <<  " / " << numSubtests << std::endl;
    std::cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
    std::cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;

    exit(0);
}

static std::vector<std::vector<bool>> visited;

static void DFS(int i, int j)
{
    if (i < 0) return;
    if (i >= n) return;
    if (j < 0) return;
    if (j >= m) return;

    if (puzzleOut[i][j] == EMPTY) return;
    if (visited[i][j]) return;

    visited[i][j] = true;

    DFS(i - 1, j);
    DFS(i + 1, j);
    DFS(i, j - 1);
    DFS(i, j + 1);
}

static bool run()
{
    puzzleOut = puzzle;
    bool res = solve(puzzleOut);

    if (!res) return false;

    std::cerr << n << " " << m << std::endl;
    for (const std::vector<int>& row : puzzleOut)
    {
        for (int elem : row)
        {
            if (elem > 0 && elem <= 8) std::cerr << elem;
            else if (elem == EMPTY) std::cerr << " ";
            else if (elem == HOR_SINGLE) std::cerr << "-";
            else if (elem == HOR_DOUBLE) std::cerr << "=";
            else if (elem == VERT_SINGLE) std::cerr << "|";
            else if (elem == VERT_DOUBLE) std::cerr << "$";
            else std::cerr << "?";
        }
        std::cerr << std::endl;
    }
    std::cerr << std::endl;

    myAssert((int) puzzleOut.size() == n);
    for (int i = 0; i < n; ++i)
    {
        myAssert((int) puzzleOut[i].size() == m);
        for (int j = 0; j < m; ++j)
        {
            if (puzzle[i][j] > 0)
            {
                myAssert(puzzleOut[i][j] == puzzle[i][j]);
            }
            else
            {
                myAssert(
                    puzzleOut[i][j] == EMPTY ||
                    puzzleOut[i][j] == HOR_SINGLE ||
                    puzzleOut[i][j] == VERT_SINGLE ||
                    puzzleOut[i][j] == HOR_DOUBLE ||
                    puzzleOut[i][j] == VERT_DOUBLE);
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {

            if (puzzleOut[i][j] > 0)
            {
                int sum = 0;
                if (j > 0 && puzzleOut[i][j - 1] == HOR_SINGLE) sum += 1;
                if (j > 0 && puzzleOut[i][j - 1] == HOR_DOUBLE) sum += 2;
                if (j < m - 1 && puzzleOut[i][j + 1] == HOR_SINGLE) sum += 1;
                if (j < m - 1 && puzzleOut[i][j + 1] == HOR_DOUBLE) sum += 2;
                if (i > 0 && puzzleOut[i - 1][j] == VERT_SINGLE) sum += 1;
                if (i > 0 && puzzleOut[i - 1][j] == VERT_DOUBLE) sum += 2;
                if (i < n - 1 && puzzleOut[i + 1][j] == VERT_SINGLE) sum += 1;
                if (i < n - 1 && puzzleOut[i + 1][j] == VERT_DOUBLE) sum += 2;
                myAssert(sum == puzzleOut[i][j]);
            }
            else if (puzzleOut[i][j] != EMPTY)
            {
                if (puzzleOut[i][j] == HOR_SINGLE)
                {
                    myAssert(j > 0 && (puzzleOut[i][j - 1] == HOR_SINGLE || puzzleOut[i][j - 1] > 0));
                    myAssert(j < m - 1 && (puzzleOut[i][j + 1] == HOR_SINGLE || puzzleOut[i][j + 1] > 0));
                }
                if (puzzleOut[i][j] == HOR_DOUBLE)
                {
                    myAssert(j > 0 && (puzzleOut[i][j - 1] == HOR_DOUBLE || puzzleOut[i][j - 1] > 0));
                    myAssert(j < m - 1 && (puzzleOut[i][j + 1] == HOR_DOUBLE || puzzleOut[i][j + 1] > 0));
                }
                if (puzzleOut[i][j] == VERT_SINGLE)
                {
                    myAssert(i > 0 && (puzzleOut[i - 1][j] == VERT_SINGLE || puzzleOut[i - 1][j] > 0));
                    myAssert(i < n - 1 && (puzzleOut[i + 1][j] == VERT_SINGLE || puzzleOut[i + 1][j] > 0));
                }
                if (puzzleOut[i][j] == VERT_DOUBLE)
                {
                    myAssert(i > 0 && (puzzleOut[i - 1][j] == VERT_DOUBLE || puzzleOut[i - 1][j] > 0));
                    myAssert(i < n - 1 && (puzzleOut[i + 1][j] == VERT_DOUBLE || puzzleOut[i + 1][j] > 0));
                }
            }
        }
    }

    visited.clear();
    visited.resize(n);
    for (int i = 0; i < n; ++i)
    {
        visited[i].resize(m, false);
    }

    bool found = false;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            if (puzzleOut[i][j] == EMPTY) continue;
            if (!found)
            {
                DFS(i, j);
                found = true;
            }
            myAssert(visited[i][j]);
        }
    }

    return true;
}

static clock_t startT;

double timePassed()
{
    clock_t currT = clock();

    return (double) (currT - startT) / CLOCKS_PER_SEC;
}

int main()
{
    ccin = ifstream("C:\\Users\\labuser.CCDOM\\Contest\\sample\\puzzle.04.in");

    ccin >> numSubtests;
    ccin >> timeLimit;

    startT = clock();

    init(numSubtests, timeLimit);

    for (currSubtest = 0; currSubtest < numSubtests; ++currSubtest)
    {
        input();
        if (!run())
        {
            cout << "Stopped on subtest: " << currSubtest + 1 << " / " << numSubtests << std::endl;
            break;
        }
        if (timePassed() > timeLimit)
        {
            cout << "Timed out during subtest: " << currSubtest + 1 << " / " << numSubtests << std::endl;
            break;
        }
    }

    cout << "Subtests solved: " << currSubtest << " / " << numSubtests << std::endl;
    cout << "Time taken: " << timePassed() << " / " << timeLimit << std::endl;

    return 0;
}
/**/