#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef vector<vvv> vvvv;
typedef pair<ll,ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e8 + 543;

vv multiply(vv &a, vv &b)
{
    vv res(a.size(), v(b[0].size(), 0));
    for (ll i = 0 ;i < a.size(); i++)
    {
        for (ll j = 0; j < b[0].size(); j++)
        {
            for (ll k = 0; k < a[0].size(); k++)
            {
                res[i][j] += ((long long)a[i][k] * b[k][j]) % mod;
            }
            res[i][j] %= mod;
        }
    }
    return res;
}

vv toColumn(v &a)
{
    vv res(a.size(), v(1));
    for (ll i =0 ; i < a.size(); i++) res[i][0] = a[i];
    return res;
}

vv identity = {
    {1,0,0,0,0},
    {0,1,0,0,0},
    {0,0,1,0,0},
    {0,0,0,1,0},
    {0,0,0,0,1}
};

const ll DP = 2e4;

vvvv dp(2, vvv(DP + 1, vv(0)));

vv exponent(vv &a, ll exp, ll type)
{
    if (exp == 0)
    {
        return identity;
    }
    if (exp == 1) return a;
    if (exp <= DP && dp[type][exp].size() > 0) return dp[type][exp];
    vv res = exponent(a, exp / 2, type);
    res = multiply(res, res);
    if (exp % 2 == 1) res = multiply(res, a);
    if (exp <= DP) dp[type][exp] = res;
    return res;
}

vv sum(vv &a, vv &b)
{
    vv res(a.size(), v(a[0].size()));
    for (ll i = 0; i < a.size(); i++)
    {
        for (ll j = 0 ;j < a[0].size(); j++)
        {
            res[i][j] = (a[i][j] + b[i][j]) % mod;
        }
    }
    return res;
}

void push(vvv &st, vvv &lazy, ll i)
{
    ll N = st.size() / 2;
    if (i >= 2 * N) return;
    if (i >= N)
    {
        lazy[i] = identity;
        return;
    }
    vv res = multiply(lazy[i], st[2 * i]);
    st[2 * i] = res;
    res = multiply(lazy[i], st[2 * i + 1]);
    st[2 * i + 1] = res;
    res = multiply(lazy[i], lazy[2 * i]);
    lazy[2 * i] = res;
    res = multiply(lazy[i], lazy[2 * i + 1]);
    lazy[2 * i + 1] = res;
    lazy[i] = identity;
}

void update(ll i, vv &mat, ll l, ll r, ll tl, ll tr, vvv &st, vvv &lazy)
{
    push(st, lazy, i);
    if (tl >= l && tr <= r)
    {
        st[i] = multiply(mat, st[i]);
        lazy[i] = multiply(mat, lazy[i]);
        return;
    }
    if (tr < l || tl > r) return;
    ll tmid = (tl + tr) / 2;
    update(2 * i, mat, l, min(r, tmid), tl, tmid, st, lazy);
    update(2 * i + 1, mat, max(l, tmid + 1), r, tmid + 1, tr, st, lazy);
    st[i] = sum(st[2 * i], st[2 * i + 1]);
}

ll query(ll i, ll l, ll r, ll tl, ll tr, vvv &st, vvv &lazy)
{
    push(st, lazy, i);
    if (tl >= l && tr <= r)
    {
        return st[i][0][0];
    }
    if (tr < l || tl > r) return 0;
    ll tmid = (tl + tr) / 2;
    return (query(2 * i, l, min(r, tmid), tl, tmid, st, lazy) + query(2 * i + 1, max(l, tmid + 1), r, tmid + 1, tr, st, lazy)) % mod;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    ll n, q;
    cin >> n >> q;
    v a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    ll N = pow(2, ceil(log2(n)));
    vvv segmentTree(2 * N), lazy(2 * N);
    vv mat = {
        {0,1,0,0,0},
        {0,0,1,0,0},
        {0,0,0,1,0},
        {0,0,0,0,1},
        {1,2,3,4,5}
    };
    vv inv = {
        {(-2 + mod),(-3 + mod),(-4 + mod),(-5 + mod),1},
        {1, 0, 0, 0, 0},
        {0, 1, 0, 0, 0},
        {0, 0, 1, 0, 0},
        {0, 0, 0, 1, 0}
    };
    vv initial = {{0},{1},{2},{3},{4}};
    for (ll i = 0; i < n; i++)
    {

        vv exp = exponent((a[i] >= 0)? mat : inv, abs(a[i]), a[i] >= 0);
        segmentTree[i + N] = multiply(exp, initial);
        lazy[i + N] = identity;
    }
    for (ll i = n + N; i < 2 * N; i++)
    {
        segmentTree[i] = initial;
        lazy[i] = identity;
    }
    for (ll i = N - 1; i > 0; i--)
    {
        lazy[i] = identity;
        segmentTree[i] = sum(segmentTree[2 * i], segmentTree[2 * i + 1]);
    }
    while (q--)
    {
        ll type, l, r;
        cin >> type >> l >> r; l--; r--;
        if (type == 1)
        {
            cout << query(1,l, r, 0, N - 1, segmentTree, lazy) << "\n";
        }
        else
        {
            ll val;
            cin >> val;
            vv mul = exponent((val >= 0)? mat : inv, abs(val), val >= 0);
            update(1,mul, l, r, 0, N - 1, segmentTree, lazy);
        }
    }
    return 0;
}