#include <bits/stdc++.h>
#include "ones.h"
using namespace std;


bool hasOnes(int l,int r);


vector<int> onesPlaces(int start, int end)
{
    if (!(end - start)) 
    {
        vector<int> t;

        if (hasOnes(start, end)) t.push_back(start);

        return t;
    }


    vector<int> ans;
    int sqr = (int) sqrtl(end - start);

    for (int i = 0; i < sqr; i++)
    {
        if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1))
        {
            vector<int> temp = onesPlaces(i * sqr + start, sqr * (i + 1) + start - 1);
            for (int j : temp) ans.push_back(j);
        }
    }

    if (hasOnes(sqr * sqr + start, end))
    {
        vector<int> temp = onesPlaces(sqr * sqr + start, end);
        for (int j : temp) ans.push_back(j);
    }


    return ans;
}


vector<int> logOne(int start, int end, int k)
{
    if (start == end)
    {
        vector<int> t = {start};
        return t;
    }

    vector<int> ans;

    int m = (start + end) >> 1;

    if (hasOnes(start, m))
    {
        vector<int> t = logOne(start, m, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m + 1, end))
    {
        vector<int> t = logOne(m + 1, end, k);
        for (int j : t) ans.push_back(j);
    }

    return ans;
}




vector<int> logTwo(int start, int end, int k)
{
    if (start == end)
    {
        vector<int> t = {start};
        return t;
    }

    vector<int> ans;

    int m1 = (start + end) / 3;
    int m2 = m1 * 2;

    if (hasOnes(start, m1))
    {
        vector<int> t = logOne(start, m1, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m1 + 1, m2))
    {
        vector<int> t = logOne(m1 + 1, m2, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m2 + 1, end))
    {
        vector<int> t = logOne(m2 + 1, end, k);
        for (int j : t) ans.push_back(j);
    }

    return ans;
}




vector<int> logThree(int start, int end, int k)
{
    if (start == end)
    {
        vector<int> t = {start};
        return t;
    }

    vector<int> ans;

    int m1 = (start + end) >> 2;
    int m2 = m1 << 1;
    int m3 = m1 + m2;

    if (hasOnes(start, m1))
    {
        vector<int> t = logOne(start, m1, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m1 + 1, m2))
    {
        vector<int> t = logOne(m1 + 1, m2, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m2 + 1, m3))
    {
        vector<int> t = logOne(m2 + 1, m3, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m3 + 1, end))
    {
        vector<int> t = logOne(m3 + 1, end, k);
        for (int j : t) ans.push_back(j);
    }

    return ans;
}







vector<int> twosPlaces(int start, int end, int k)
{
    if (!(end - start)) 
    {
        vector<int> t = {start};
        return t;
    }


    vector<int> ans;
    int sqr = (int) sqrtl(end - start);

    for (int i = 0; i < sqr; i++)
    {
        if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1))
        {
            vector<int> temp = onesPlaces(i * sqr + start, sqr * (i + 1) + start - 1);
            for (int j : temp) ans.push_back(j);
            if (ans.size() == k) return ans;
        }
    }

    if (hasOnes(sqr * sqr + start, end))
    {
        vector<int> temp = onesPlaces(sqr * sqr + start, end);
        for (int j : temp) ans.push_back(j);
    }


    return ans;
}



int findFirstOne(int start, int end)
{
    if (!(end - start)) return end;

    int sqr = (int) sqrtl(end - start);

    for (int i = 0; i < sqr; i++) if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1)) return findFirstOne(i * sqr + start, sqr * (i + 1) + start - 1);

    if (hasOnes(sqr * sqr + start, end)) return findFirstOne(sqr * sqr + start, end);

    return -1;
}



vector<int> findAllFirstOnes(int n, int k)
{
    vector<int> ans;
    int found = 0;

    for (int i = 0; i < k; i++)
    {
        int find = findFirstOne(found + 1, n);
        ans.push_back(find);
        found = find;
    }

    return ans;
}


int findFirstBinary(int start, int end)
{
    if (!(start != end)) return start;

    int m = ((start + end) >> 1);

    if (hasOnes(start, m)) return findFirstBinary(start, m);
    return findFirstBinary(m + 1, end);
}


vector<int> findAllBinaryFirsts(int n, int k)
{
    vector<int> ans;

    int found = 0;

    for (int i = 0; i < k; i++)
    {
        int find = findFirstBinary(found + 1, n);
        ans.push_back(find);
        found = find;
    }

    return ans;
}



vector<int> guessOnes(int n, int k)
{
    vector<int> ans = findAllBinaryFirsts(n, k);
    return ans;
}















// #include <vector>
// #include <iostream>
// #include <utility>
// #include <algorithm>
// #include <random>
// #include <iomanip>
// #include <numeric>
// #include <cstring>

// static const int N = 1e5 + 3;

// static int n, k, n_tests;
// static int input[N];

// static long long number_of_queries;

// static std::vector<int> readOnes()
// {
//     for(int i=1;i<=n;i++)
//         input[i]=0;

//     std::vector<int> _ones(k,0);

//     vector<int> temp = {1, 7, 100, 1800, 50000, 18, 999, 654, 786, 73478};
//     for(int i=0;i<k;i++)
//     {
//         // std::cin>>_ones[i];
//         _ones[i] = temp[i];
//         input[_ones[i]]=1;
//     }

//     for(int i=1;i<=n;i++)input[i]+=input[i-1];

//     sort(_ones.begin(),_ones.end());

//     return _ones;
// }

// bool hasOnes(int l,int r)
// {
//     number_of_queries++;

//     if(1>l || l>n || 1>r || r>n || l>r)
//     {
//         std::cout << "Your program made an invalid query." << std::endl;
//         exit(0);
//     }

//     return input[r] != input[l-1];
// }

// static long long runOneTest(){
//     number_of_queries = 0;

//     std::vector<int> _ones = readOnes();

//     std::vector<int> guess = guessOnes(n,k);

//     if(_ones != guess)
//     {
//         std::cout << "Your program returned an incorrect answer." << std::endl;
//         exit(0);
//     }

//     std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

//     return number_of_queries;
// }

// int main(){
//     //std::cin >> n >> k >> n_tests;
//     n = 100000; k = 10; n_tests = 10;

//     long long sum_queries = 0;
//     for(int i = 0; i < n_tests; ++i)
//         sum_queries = sum_queries + runOneTest();

//     std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
// }
