#include <bits/stdc++.h>
#include "ones.h"   
using namespace std;


bool hasOnes(int l,int r);


vector<int> onesPlaces(int start, int end)
{
    if (!(end - start)) 
    {
        vector<int> t;

        if (hasOnes(start, end)) t.push_back(start);

        return t;
    }


    vector<int> ans;
    int sqr = (int) sqrtl(end - start);

    for (int i = 0; i < sqr; i++)
    {
        if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1))
        {
            vector<int> temp = onesPlaces(i * sqr + start, sqr * (i + 1) + start - 1);
            for (int j : temp) ans.push_back(j);
        }
    }

    if (hasOnes(sqr * sqr + start, end))
    {
        vector<int> temp = onesPlaces(sqr * sqr + start, end);
        for (int j : temp) ans.push_back(j);
    }


    return ans;
}


vector<int> logOne(int start, int end, int k)
{
    if (start == end)
    {
        vector<int> t = {start};
        return t;
    }

    vector<int> ans;

    int m = (start + end) >> 1;

    if (hasOnes(start, m))
    {
        vector<int> t = logOne(start, m, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m + 1, end))
    {
        vector<int> t = logOne(m + 1, end, k);
        for (int j : t) ans.push_back(j);
    }

    return ans;
}




vector<int> logTwo(int start, int end, int k)
{
    if (start == end)
    {
        vector<int> t = {start};
        return t;
    }

    vector<int> ans;

    int m1 = (start + end) / 3;
    int m2 = m1 * 2;

    if (hasOnes(start, m1))
    {
        vector<int> t = logOne(start, m1, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m1 + 1, m2))
    {
        vector<int> t = logOne(m1 + 1, m2, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m2 + 1, end))
    {
        vector<int> t = logOne(m2 + 1, end, k);
        for (int j : t) ans.push_back(j);
    }

    return ans;
}




vector<int> logThree(int start, int end, int k)
{
    if (start == end)
    {
        vector<int> t = {start};
        return t;
    }

    vector<int> ans;

    int m1 = (start + end) >> 2;
    int m2 = m1 << 1;
    int m3 = m1 + m2;

    if (hasOnes(start, m1))
    {
        vector<int> t = logOne(start, m1, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m1 + 1, m2))
    {
        vector<int> t = logOne(m1 + 1, m2, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m2 + 1, m3))
    {
        vector<int> t = logOne(m2 + 1, m3, k);
        for (int j : t) ans.push_back(j);
    }

    if (ans.size() == k) return ans;

    if (hasOnes(m3 + 1, end))
    {
        vector<int> t = logOne(m3 + 1, end, k);
        for (int j : t) ans.push_back(j);
    }

    return ans;
}







vector<int> twosPlaces(int start, int end, int k)
{
    if (!(end - start)) 
    {
        vector<int> t = {start};
        return t;
    }


    vector<int> ans;
    int sqr = (int) sqrtl(end - start);

    for (int i = 0; i < sqr; i++)
    {
        if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1))
        {
            vector<int> temp = onesPlaces(i * sqr + start, sqr * (i + 1) + start - 1);
            for (int j : temp) ans.push_back(j);
            if (ans.size() == k) return ans;
        }
    }

    if (hasOnes(sqr * sqr + start, end))
    {
        vector<int> temp = onesPlaces(sqr * sqr + start, end);
        for (int j : temp) ans.push_back(j);
    }


    return ans;
}



int findFirstOne(int start, int end)
{
    if (!(end - start)) return end;

    int sqr = (int) sqrtl(end - start);

    for (int i = 0; i < sqr; i++) if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1)) return findFirstOne(i * sqr + start, sqr * (i + 1) + start - 1);

    if (hasOnes(sqr * sqr + start, end)) return findFirstOne(sqr * sqr + start, end);

    return -1;
}


int findLastOne(int start, int end)
{
    if (!(end - start)) return end;

    int sqr = (int) sqrtl(end - start);

    if (hasOnes(sqr * sqr + start, end)) return findLastOne(sqr * sqr + start, end);

    for (int i = sqr - 1; i >= 0; i--) if (hasOnes(i * sqr + start, sqr * (i + 1) + start - 1)) return findLastOne(i * sqr + start, sqr * (i + 1) + start - 1);


    return -1;
}


vector<int> findAllFirstOnes(int n, int k)
{
    vector<int> ans;
    int found = 0;

    for (int i = 0; i < k; i++)
    {
        int find = findFirstOne(found + 1, n);
        ans.push_back(find);
        found = find;
    }

    return ans;
}


vector<int> findAllSquigllyOnes(int n, int k)
{
    vector<int> start = {0}, end = {n + 1};

    for (int i = 0; i < (k >> 1); i++)
    {
        start.push_back(findFirstOne(start.back() + 1, end.back() - 1));
        end.push_back(findLastOne(start.back() + 1, end.back() - 1));
    }

    if (k & 1) start.push_back(findLastOne(start.back() + 1, end.back() - 1));

    vector<int> ans;

    for (int i = 1; i < start.size(); i++) ans.push_back(start[i]);
    for (int i = end.size() - 1; i > 0; i--) ans.push_back(end[i]);

    return ans;
}



int findFirstBinary(int start, int end)
{
    if (!(start != end)) return start;

    int m = ((start + end) >> 1);

    if (hasOnes(start, m)) return findFirstBinary(start, m);
    return findFirstBinary(m + 1, end);
}

int findLastBinary(int start, int end)
{
    if (!(start != end)) return start;

    int m = ((start + end) >> 1);

    if (hasOnes(m + 1, end)) return findLastBinary(m + 1, end);
    return findLastBinary(start, m);
}


vector<int> findBinarySquid(int n, int k)
{
    vector<int> start = {0}, end = {n + 1};

    for (int i = 0; i < (k >> 1); i++)
    {
        start.push_back(findFirstBinary(start.back() + 1, end.back() - 1));
        end.push_back(findLastBinary(start.back() + 1, end.back() - 1));
    }

    if (k & 1) start.push_back(findLastBinary(start.back() + 1, end.back() - 1));

    vector<int> ans;

    for (int i = 1; i < start.size(); i++) ans.push_back(start[i]);
    for (int i = end.size() - 1; i > 0; i--) ans.push_back(end[i]);

    return ans;
}


vector<int> findAllBinaryFirsts(int n, int k)
{
    vector<int> ans;

    int found = 0;

    for (int i = 0; i < k; i++)
    {
        int find = findFirstBinary(found + 1, n);
        ans.push_back(find);
        found = find;
    }

    return ans;
}



int findFirstTrinary(int start, int end)
{
    if (!(~(start ^ (~end)))) return start;

    int dis = end - start + 1;
    int m1 = start + dis / 3;
    int m2 = start + (dis << 1) / 3;

    if (hasOnes(start, m1)) return findFirstTrinary(start, m1);
    if (hasOnes(m1 + 1, m2)) return findFirstTrinary(m1 + 1, m2);
    return findFirstTrinary(m2 + 1, end);
}


int findLastTrinary(int start, int end)
{
    if (!(~(start ^ (~end)))) return start;

    if (abs(start - end) < 2)
    {
        if (hasOnes(end, end)) return end;
        return start;
    }

    int dis = end - start + 1;
    int m1 = start + dis / 3;
    int m2 = start + (dis << 1) / 3;


    if (hasOnes(m2, end)) return findLastTrinary(m2, end);
    if (hasOnes(m1, m2 - 1)) return findLastTrinary(m1, m2 - 1);
    return findLastTrinary(start, m1 - 1);
}



vector<int> findAllTrees(int n, int k)
{
    vector<int> ans;

    int found = 0;

    for (int i = 0; i < k; i++)
    {
        int find = findFirstTrinary(found + 1, n);
        ans.push_back(find);
        found = find;
    }

    return ans;
}


vector<int> findAllTreaps(int n, int k)
{
    vector<int> start = {0}, end = {n + 1};

    for (int i = 0; i < (k >> 1); i++)
    {
        start.push_back(findFirstTrinary(start.back() + 1, end.back() - 1));
        end.push_back(findLastTrinary(start.back() + 1, end.back() - 1));
    }

    if (k & 1) start.push_back(findFirstTrinary(start.back() + 1, end.back() - 1));

    vector<int> ans;

    for (int i = 1; i < start.size(); i++) ans.push_back(start[i]);
    for (int i = end.size() - 1; i > 0; i--) ans.push_back(end[i]);

    return ans;
}


vector<int> findAllMix1(int n, int k)
{
    vector<int> start = {0}, end = {n + 1};

    for (int i = 0; i < (k >> 1); i++)
    {
        start.push_back(findFirstBinary(start.back() + 1, end.back() - 1));
        end.push_back(findLastTrinary(start.back() + 1, end.back() - 1));
    }

    if (k & 1) start.push_back(findLastTrinary(start.back() + 1, end.back() - 1));

    vector<int> ans;

    for (int i = 1; i < start.size(); i++) ans.push_back(start[i]);
    for (int i = end.size() - 1; i > 0; i--) ans.push_back(end[i]);

    return ans;
}


vector<int> findAllMix2(int n, int k)
{
    vector<int> start = {0}, end = {n + 1};

    for (int i = 0; i < (k >> 1); i++)
    {
        start.push_back(findFirstTrinary(start.back() + 1, end.back() - 1));
        end.push_back(findLastBinary(start.back() + 1, end.back() - 1));
    }

    if (k & 1) start.push_back(findFirstBinary(start.back() + 1, end.back() - 1));

    vector<int> ans;

    for (int i = 1; i < start.size(); i++) ans.push_back(start[i]);
    for (int i = end.size() - 1; i > 0; i--) ans.push_back(end[i]);

    return ans;
}




vector<int> guessOnes(int n, int k)
{
    vector<int> ans = findAllMix1(n, k);
    return ans;
}










// #include <vector>
// #include <iostream>
// #include <utility>
// #include <algorithm>
// #include <random>
// #include <iomanip>
// #include <numeric>
// #include <cstring>

// static const int N = 1e5 + 3;

// static int n, k, n_tests;
// static int input[N];

// static long long number_of_queries;

// static std::vector<int> readOnes()
// {
//     for(int i=1;i<=n;i++)
//         input[i]=0;

//     std::vector<int> _ones(k,0);

//     vector<int> temp = {1, 7, 100, 1800, 50000, 18, 999, 654, 786, 73478};
//     for(int i=0;i<k;i++)
//     {
//         // std::cin>>_ones[i];
//         _ones[i] = temp[i];
//         input[_ones[i]]=1;
//     }

//     for(int i=1;i<=n;i++)input[i]+=input[i-1];

//     sort(_ones.begin(),_ones.end());

//     return _ones;
// }

// bool hasOnes(int l,int r)
// {
//     number_of_queries++;

//     if(1>l || l>n || 1>r || r>n || l>r)
//     {
//         std::cout << "Your program made an invalid query." << std::endl;
//         exit(0);
//     }

//     return input[r] != input[l-1];
// }

// static long long runOneTest(){
//     number_of_queries = 0;

//     std::vector<int> _ones = readOnes();

//     std::vector<int> guess = guessOnes(n,k);

//     if(_ones != guess)
//     {
//         std::cout << "Your program returned an incorrect answer." << std::endl;
//         exit(0);
//     }

//     std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

//     return number_of_queries;
// }

// int main(){
//     //std::cin >> n >> k >> n_tests;
//     n = 100000; k = 10; n_tests = 10;

//     long long sum_queries = 0;
//     for(int i = 0; i < n_tests; ++i)
//         sum_queries = sum_queries + runOneTest();

//     std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
// }
