#include <iostream>
#include <vector>
#include <cmath>
#include "ones.h"
using namespace std;

void solve(int l, int r, int d, vector<int> &res, int &idx) {
    if (d == 1) {
        for (;l <= r; ++l)
            if (hasOnes(l,l))
                res[idx++] = l;
        return;
    }

    for (; l <= r - d && idx < res.size(); l += d + 1) {
        if (hasOnes(l, l + d)) {
            if (d > 1) solve(l, l + d, d / 2, res, idx);
            else
                for (int j = l; j <= l + d; ++j)
                    if (hasOnes(j, j)) res[idx++] = j;
        }
    }

    if (l != r) solve(l, r, max(d/2, 1), res, idx);
}

std::vector<int> guessOnes(int n, int k) {
    vector<int> res(k);


    int idx = 0;
    int d = (n - k) / k;

    solve(1, n, d, res, idx);

    return res;
}
