#include <iostream>
#include <vector>
using namespace std;

const int M = 1e8 + 543;
typedef vector<vector<int>> mx;
typedef int64_t ll;

mx operator+(const mx& m1, const mx &m2) {
    mx res(5, vector<int>(5));

    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            res[i][j] = ((ll)m1[i][j] + m2[i][j])% M;
        }
    }

    return res;
}
mx operator*(const mx& m1, const mx &m2) {
    vector<vector<int>> res(5, vector<int>(5));
    for (int i = 0; i < 5; ++i) {
        for (int j = 0; j < 5; ++j) {
            for (int k = 0; k < 5; ++k) {
                res[i][j] = (res[i][j] + ((ll)m1[i][k]*m2[k][j]) % M)%M;
            }
        }
    }
    return res;
}

const mx mat = {{5,4,3,2,1},{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0}, {0,0,0,1,0}};
const mx ID = {{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0}, {0,0,0,1,0}, {0, 0, 0, 0 ,1}};
vector<mx> v(32);

void init() {
    v[0] = mat;

    for (int i = 1; i < 32; ++i)
        v[i] = v[i - 1]*v[i - 1];

}
mx exp(const mx &a, int b) {
    if (b == 1) return a;

    mx tmp = exp(a, b/2);
    tmp = tmp*tmp;

    if (b%2) return tmp*a;

    return tmp;
}

mx myexp(int b) {
    mx res = ID;
    for (int i = 0; i < 32; ++i) {
        if ((b >> i) & 1) {
            res = v[i] * res;
        }
    }

    return res;
}

int x(int i) {
    if (i < 5) return i;

    mx m = myexp(i - 4);
    int res = 0;

    for (int k = 0; k < 5; ++k)
        res = (res + ((ll)(5 - k - 1)*m[0][k])%M)%M;

    return res;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    init();
    int n, q; cin >> n >> q;
    vector<int> a(n), z(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        z[i] = x(a[i]);
    }

    int l, r, type, val;

    while(q--) {
        cin >> type;
        if (type == 1) {
            cin >> l >> r;
            printf("%d\n", z[l - 1]);
        } else {
            cin >> l >> r >> val;
            a[l - 1] = (a[l - 1] + val) % M;
            z[l - 1] = x(a[l - 1]);
        }
    }
}