#include <iostream>
#include <vector>
using namespace std;

const int M = 1e8 + 543;
typedef vector<vector<int>> mx;
typedef int64_t ll;

mx operator+(const mx& m1, const mx &m2) {
    mx res(5, vector<int>(5));

    for (int i = 0; i < 5; ++i)
        for (int j = 0; j < 5; ++j)
            res[i][j] = ((ll)m1[i][j] + m2[i][j])% M;

    return res;
}
mx operator*(const mx& m1, const mx &m2) {
    vector<vector<int>> res(5, vector<int>(5));

    for (int i = 0; i < 5; ++i)
        for (int j = 0; j < 5; ++j)
            for (int k = 0; k < 5; ++k)
                res[i][j] = ((ll)res[i][j] + ((ll)m1[i][k]*m2[k][j]) % M)%M;

    return res;
}

const mx mat = {{5,4,3,2,1},{1,0,0,0,0},{0,1,0,0,0},{0,0,1,0,0}, {0,0,0,1,0}};

mx exp(const mx &a, ll b) {
    if (b == 1) return a;

    mx tmp = exp(a, b/2);
    tmp = tmp*tmp;

    if (b%2) return tmp*a;

    return tmp;
}

int x(ll i) {
    if (i < 5) return (int)i;

    mx m = exp(mat, i - 4);
    int res = 0;

    for (int k = 0; k < 5; ++k)
        res = ((ll)res + ((ll)(5 - k - 1)*m[0][k])%M)%M;

    return res;
}


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    int n, q; cin >> n >> q;
    vector<ll> a(n);
    for(ll &i : a) cin >> i;

    int l, r, type;
    ll val;

    while(q--) {
        cin >> type >> l >> r;

        if (type == 1) cout << x(a[l - 1]) << '\n';
        else { cin >> val; a[l - 1] += val; }
    }
}