#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
//#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

const int Mod = 1e8 + 543;

template <typename _F, typename _S>
auto add(_F &x, const _S &y) -> void{
    x = (x + y) % Mod;
    if ( x < 0 ){
        x += Mod;
    }
}

struct Fenw{
    vector <int> fenw;
    int n;
    Fenw(int n) : fenw(n + 1, 0), n(n) {}
    void upd(int i, int val){
        for (; i <= n; i += i & -i ){
            add(fenw[i], val);
        }
    }
    int get(int i){
        int cnt = 0;
        for (; i > 0; i -= i & -i ){
            add(cnt, fenw[i]);
        }
        return cnt;
    }
    int get(int l, int r){
        return (get(r) - get(l - 1) + Mod) % Mod;
    }
};

auto operator *(const auto &A, const auto &B){
    auto ret = A;
    for ( auto &x: ret ){
        for ( auto &y: x ){
            y = 0;
        }
    }
    for ( int i = 0; i < ret.size(); i++ ){
        for ( int j = 0; j < ret[i].size(); j++ ){
            for ( int k = 0; k < ret[i].size(); k++ ){
                add(ret[i][j], A[i][k] * 1LL * B[k][j] % Mod);
            }
        }
    }
    return ret;
}

void operator *=(auto &A, const auto &B){
    A = A * B;
}

auto binPow(auto A, int k){
    auto ret = A;
    for ( int i = 0; i < ret.size(); i++ ){
        for ( int j = 0; j < ret.size(); j++ ){
            if ( i == j ){
                ret[i][j] = 1;
            } else ret[i][j] = 0;
        }
    }
    while ( k > 0 ){
        if ( k & 1 ){
            ret *= A;
        }
        A *= A;
        k >>= 1;
    }
    return ret;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q; cin >> n >> q;
    vector <i64> a(n + 1), v(n + 1);
    Fenw fn(n);
    vector <vector<int>> p(5, vector <int> (5));
    { // matrix filling
        for ( int i = 1; i < 5; i++ ){
            p[i][i - 1] = 1;
        }
        for ( int i = 0; i < 5; i++ ){
            p[i][4] = i + 1;
        }
    }
    vector <vector<vector<int>>> t(30), g(n + 1);
    for ( auto &u: g ){
        u.resize(5);
        for ( int i = 0; i < 5; i++ ){
            u[i].resize(5);
            for ( int j = 0; j < 5; j++ ){
                u[i][j] = (i == j);
            }
        }
    }
    for ( int i = 0; i < 30; i++ ){
        t[i] = binPow(p, 1 << i);
    }
    int it = -1;
    auto f = [&](int k){
        if ( k < 5 ){
            return k;
        } k -= 4;
        int ans = 0;
        auto tmp = p;
        for ( int i = 0; i < 5; i++ ){
            for ( int j = 0; j < 5; j++ ){
                tmp[i][j] = (i == j);
            }
        }
        for ( int b = 0; b < 30; b++ ){
            if ( k >> b & 1 ){
                tmp *= t[b];
            }
        }
        g[it] = tmp;
        vector <vector<int>> cnt(1, vector <int> (5));
        cnt[0] = {0, 1, 2, 3, 4};
        cnt *= tmp;
        return cnt[0].back();
    };
    for ( int i = 1; i <= n; i++ ){
        int x; cin >> x;
        it = i;
        v[i] = f(x);
        fn.upd(i, v[i]);
        a[i] = x;
    }
    while ( q-- ){
        int tt, l, r; cin >> tt >> l >> r;
        if ( tt == 1 ){
            cout << fn.get(l, r) << ln;
        } else{
            int delta; cin >> delta;
            for ( int i = l; i <= r; i++ ){
                fn.upd(i, -v[i]);
                if ( a[i] < 5 && a[i] + delta >= 5 ){
                    it = i;
                    a[i] += delta;
                    v[i] = f(a[i]);
                    fn.upd(i, v[i]);
                    continue;
                }
                a[i] += delta;
                if ( a[i] < 5 ){
                    v[i] = a[i];
                } else{
                    auto &arr = g[i];
                    for ( int j = 0; j < 30; j++ ){
                        if ( delta >> j & 1 ){
                            arr *= t[j];
                        }
                    }
                    vector <vector<int>> cnt(1, vector <int> (5));
                    cnt[0] = {0, 1, 2, 3, 4};
                    cnt *= arr;
                    v[i] = cnt[0].back();
                }
                fn.upd(i, v[i]);
            }
        }
    }

    cout << '\n';
}
