#include <bits/stdc++.h>

const int M = 1e+8 + 543;

int n;
std::vector < int > t;

inline int add(int a, int b) {
    return a + b >= M ? a + b - M : a + b;
}

inline int getPref(int id) {
    int sum = 0;

    for (; id > 0; id -= id & -id)
        sum = add(sum, t[id]);

    return sum;
}

inline int update(int id, int val) {
    for (; id <= n; id += id & -id)
        t[id] = add(t[id], val);
}

std::vector < std::vector < int > > mult(std::vector < std::vector < int > > a, std::vector < std::vector < int > > b) {
    std::vector < std::vector < int > > c(5, std::vector < int >(5));

    for (int i = 0; i < 5; i++)
        for (int j = 0; j < 5; j++)
            for (int k = 0; k < 5; k++)
                c[i][j] = (c[i][j] + (long long)a[i][k] * b[k][j]) % M;

    return c;
}

std::vector < std::vector < int > >
mtPlus = { { 5, 1, 0, 0, 0 },
           { 4, 0, 1, 0, 0 },
           { 3, 0, 0, 1, 0 },
           { 2, 0, 0, 0, 1 },
           { 1, 0, 0, 0, 0 } };

std::vector < std::vector < int > >
mtZero = { { 1, 0, 0, 0, 0 },
           { 0, 1, 0, 0, 0 },
           { 0, 0, 1, 0, 0 },
           { 0, 0, 0, 1, 0 },
           { 0, 0, 0, 0, 1 } };

std::vector < std::vector < int > >
mtStart = { { 4, 3, 2, 1, 0 },
           { 0, 0, 0, 0, 0 },
           { 0, 0, 0, 0, 0 },
           { 0, 0, 0, 0, 0 },
           { 0, 0, 0, 0, 0 } };

std::vector < std::vector < int > > binPow(std::vector < std::vector < int > > x, int n) {
    auto ans = mtZero;

    while (n > 0)
        if (n & 1)
            ans = mult(ans, x), n--;
        else
            x = mult(x, x), n >>= 1;

    return ans;
}

int getX(int id) {
    if (id < 0)
        assert(0);

    if (id < 5)
        return id;

    return binPow(mtStart, id - 4)[0][0];
}

int main() {
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    int q; std::cin >> n >> q;

    t.resize(n + 1);

    std::vector < int > a(n + 1);

    for (int i = 1; i <= n; i++) {
        std::cin >> a[i];

        a[i] = getX(a[i]);
        update(i, a[i]);
    }

    for (int qi = 1, type, l, r, i, val; qi <= q; qi++) {
        std::cin >> type;

        if (type == 1) {
            std::cin >> l >> r;

            std::cout << add(0, add(getPref(r), M - getPref(l - 1))) << "\n";
        } else {
            std::cin >> i >> val;

            update(i, -a[i]);
            a[i] = getX(val);
            update(i, a[i]);
        }
    }
}
