#include <bits/stdc++.h>

typedef long long ll;

int n;
const int M = 1e+8 + 543;

std::vector < std::vector < std::vector < int > > > power(50, mtZero);

inline int add(int a, int b) {
    return a + b >= M ? a + b - M : a + b;
}

std::vector < int > t;

inline int getPref(int id) {
    int sum = 0;

    for (; id > 0; id -= id & -id)
        sum = add(sum, t[id]);

    return sum;
}

inline void update(int id, int val) {
    for (; id <= n; id += id & -id)
        t[id] = add(t[id], val);
}

void mult2(std::vector < int > &a, ll n) {
    std::vector < int > res(5);

    for (int p = 49; p >= 0; p--)
        if (n >> p & 1) {
            std::fill(res.begin(), res.end(), 0);

            for (int j = 0; j < 5; j++)
                for (int k = 0; k < 5; k++)
                    res[j] = (res[j] + (ll)a[k] * power[p][k][j]) % M;

            a = res;
        }
}

int getX(ll id) {
    if (id < 0)
        return M - 22;

    if (id < 5)
        return id;

    std::vector < int > ans = { 4, 3, 2, 1, 0 };

    mult2(ans, id - 4);

    return ans[0];
}

int main() {
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    power[0] = { { 5, 1, 0, 0, 0 },
                 { 4, 0, 1, 0, 0 },
                 { 3, 0, 0, 1, 0 },
                 { 2, 0, 0, 0, 1 },
                 { 1, 0, 0, 0, 0 } };

    std::vector < std::vector < int > > res(5, std::vector < int >(5));

    for (int p = 1; p < 50; p++) {
        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                res[i][j] = 0;

        for (int i = 0; i < 5; i++)
            for (int j = 0; j < 5; j++)
                for (int k = 0; k < 5; k++)
                    res[i][j] = (res[i][j] + (ll)power[p - 1][i][k] * power[p - 1][k][j]) % M;

        power[p] = res;
    }

    int q; std::cin >> n >> q;

    t.resize(n + 1);

    std::vector < ll > a(n + 1);

    for (int i = 1; i <= n; i++) {
        std::cin >> a[i];

        update(i, getX(a[i]));
    }

    for (int qi = 1, type, l, r, val; qi <= q; qi++) {
        std::cin >> type;

        if (type == 1) {
            std::cin >> l >> r;

            std::cout << add(0, add(getPref(r), M - getPref(l - 1))) << "\n";
        } else {
            std::cin >> l >> r >> val;

            update(l, add(0, M - getX(a[l])));
            a[l] += val;
            update(l, getX(a[l]));
        }
    }
}
