#include <bits/stdc++.h>
#include "ones.h"
#include "Lgrader.cpp"
using namespace std;
#define ll long long
#define pll pair<ll, ll>
#define fs first
#define sc second
struct Segment{
    ll l, r;
};
class Segtree{
 private:
    ll n;
    vector<ll> t;
    vector<ll> lazy;
    void push(ll x, ll lx, ll rx) {
        if (lazy[x] == 0) return;
        t[x] = lazy[x];
        if (lx != rx) {
            lazy[2 * x] = lazy[x];
            lazy[2 * x + 1] = lazy[x];
        }
        lazy[x] = 0;
    }
    void update(ll x, ll lx, ll rx, ll l, ll r, ll val) {
        push(x, lx, rx);
        if (lx > r || rx < l) return;
        if (lx >= l && rx <= r) {
            lazy[x] = val;
            push(x, lx, rx);
            return;
        }
        ll mid = (lx + rx) / 2;
        update(2 * x, lx, mid, l, r, val);
        update(2 * x + 1, mid + 1, rx, l, r, val);
        t[x] = t[2 * x] + t[2 * x + 1];
    }
    ll get(ll x, ll lx, ll rx, ll l, ll r) {
        if (lx > r || rx < l) return 1;
        if (lx >= l && rx <= r) return t[x];
        ll mid = (lx + rx) / 2;
        return min(get(2 * x, lx, mid, l, r), get(2 * x + 1, mid + 1, rx, l, r));
    }
 public:
    Segtree(ll n) {
        this->n = n;
        t.resize(4 * n); lazy.resize(4 * n);
    }
    void update(ll l, ll r) {
        update(1, 1, n, l, r, -1);
    }
    ll get(ll val) {
        return get(1, 1, n, val, val);
    }
};
vector<ll> guessOnes(ll n, ll k) {
    Segtree tree(n);
    queue<Segment> q = {{1, n}};
    while (!q.empty()) {
        auto [l, r] = q.front();
        q.pop();
        ll mid = (l + r) / 2;
        if (hasOnes(l, mid)) {
            q.push({l, mid});
        } else {
            tree.update(l, mid);
        }
        if (hasOnes(mid + 1, r)) {
            q.push({mid + 1, r});
        } else {
            tree.update(mid + 1, r);
        }
    }
    vector<ll> ans;
    for (ll i = 1; i <= n; i++) {
        if (tree.get(i) == -1) ans.pb(i);
    }
    return ans;
}
