#include <bits/stdc++.h>
using namespace std;
#define int long long
const int mod = 1e8+543;

struct val{
    int v[5] = {4,3,2,1,0};
};

struct matrix{
    int t[5][5];
    val apply(val a){
        val res; for (int i=0; i<5; i++) res.v[i] = 0;
        for (int i=0; i<5; i++){
            for (int j=0; j<5; j++){
                res.v[i] += t[i][j] * a.v[j]; res.v[i]%=mod;
            }
        }
        return res;
    }
};

matrix mult(matrix a, matrix b){
    matrix res; for (int i=0; i<5; i++) for (int j=0; j<5; j++) res.t[i][j] =0;
    for (int i=0; i<5; i++){
        for (int j=0; j<5; j++){
            for (int k=0; k<5; k++){
                res.t[i][j] += a.t[k][j] * b.t[i][k]; res.t[i][j]%=mod;
            }
        }
    }
    return res;
}

matrix pw(matrix t, int p){
    if (!p){
        matrix one; for (int i=0; i<5; i++) for (int j=0; j<5; j++) one.t[i][j] = 0; one.t[0][0] =1; one.t[1][1] = 1; one.t[2][2] = 1; one.t[3][3] = 1; one.t[4][4] = 1;
        return one;
    }
    if (p&1) return mult(t, pw(t,p-1));
    matrix p_2 = pw(t, p/2);
    return mult(p_2, p_2);
}

matrix ml(int t){
    // INCREASE BY 1
    matrix inc; for (int i=0; i<5; i++) for (int j=0; j<5; j++) inc.t[i][j] = 0;
    for (int i=0; i<5; i++) inc.t[0][i] = 5-i; inc.t[1][0] =1; inc.t[2][1] = 1; inc.t[3][2] = 1; inc.t[4][3] = 1;
    // DECREASE BY 1
    matrix dec; for (int i=0; i<5; i++) for (int j=0; j<5; j++) dec.t[i][j] = 0;
    dec.t[0][1]=1;dec.t[1][2]=1; dec.t[2][3] = 1; dec.t[3][4] = 1; dec.t[4][0] =1; dec.t[4][1] = mod-5; dec.t[4][2] = mod-4; dec.t[4][3] = mod-3; dec.t[4][4] = mod-2;


    if (!t) return mult(inc, dec);
    if (t>0) return pw(inc,t);
    return pw(dec, -t);
}
signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);



    int n,q; cin>>n>>q;
    vector<int> a(n,0);
    for (int i=0; i<n; i++) cin>>a[i];

    while (q--){
        int t; cin>>t;
        if (t==1){
            int l,r; cin>>l>>r; l--;r--;
            int res = 0;
            for (int i=l; i<=r; i++){
                val r; r = ml(a[i]).apply(r);
                res += r.v[4]; res %=mod;
            }
            cout<<res<<'\n';

        } else {
            int l,r,v; cin>>l>>r>>v; l--; r--;
            for (int i=l; i<=r; i++) a[i] +=v;
        }
    }
}

