#include <bits/stdc++.h>
using namespace std;
#define int long long
const int mod = 1e8+543;

struct val{
    int v[5] = {4,3,2,1,0};
};

struct matrix{
    int t[5][5];
    val apply(val a){
        val res; for (int i=0; i<5; i++) res.v[i] = 0;
        for (int i=0; i<5; i++){
            for (int j=0; j<5; j++){
                res.v[i] += t[i][j] * a.v[j]; res.v[i]%=mod;
            }
        }
        return res;
    }
};

matrix mult(matrix a, matrix b){
    matrix res; for (int i=0; i<5; i++) for (int j=0; j<5; j++) res.t[i][j] =0;
    for (int i=0; i<5; i++){
        for (int j=0; j<5; j++){
            for (int k=0; k<5; k++){
                res.t[i][j] += a.t[k][j] * b.t[i][k]; res.t[i][j]%=mod;
            }
        }
    }
    return res;
}

matrix inc2[60], dec2[60];

matrix pw(int v, int p){
    matrix res; for (int i=0; i<5; i++) for (int j=0; j<5; j++) res.t[i][j] = 0; res.t[0][0] =1; res.t[1][1] = 1; res.t[2][2] = 1; res.t[3][3] = 1; res.t[4][4] = 1;

    int pr = 1;
    while (p){
        if (p&1) res = mult(res,v>0? inc2[pr]: dec2[pr]);
        pr ++;
        p>>=1;
    }
    return res;

}

void precalc(){
    // INCREASE BY 1
    matrix inc; for (int i=0; i<5; i++) for (int j=0; j<5; j++) inc.t[i][j] = 0;
    for (int i=0; i<5; i++) inc.t[0][i] = 5-i; inc.t[1][0] =1; inc.t[2][1] = 1; inc.t[3][2] = 1; inc.t[4][3] = 1;
    // DECREASE BY 1
    matrix dec; for (int i=0; i<5; i++) for (int j=0; j<5; j++) dec.t[i][j] = 0;
    dec.t[0][1]=1;dec.t[1][2]=1; dec.t[2][3] = 1; dec.t[3][4] = 1; dec.t[4][0] =1; dec.t[4][1] = mod-5; dec.t[4][2] = mod-4; dec.t[4][3] = mod-3; dec.t[4][4] = mod-2;

    for (int i=1; i<60; i++){
        inc2[i] = inc;
        inc = mult(inc,inc);

        dec2[i] = dec;
        dec = mult(dec,dec);
    }

}


signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);



    int n,q; cin>>n>>q;
    vector<int> a(n,0);
    for (int i=0; i<n; i++) cin>>a[i];
    precalc();
    while (q--){
        int t; cin>>t;
        if (t==1){
            int l,r; cin>>l>>r; l--;r--;
            int res = 0;
            for (int i=l; i<=r; i++){
                val r; r = pw(a[i], abs(a[i])).apply(r);
                res += r.v[4]; res %=mod;
            }
            cout<<res<<'\n';

        } else {
            int l,r,v; cin>>l>>r>>v; l--; r--;
            for (int i=l; i<=r; i++) a[i] +=v;
        }
    }
}

