#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>

#define MOD 100000543
#define identity {1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1}
#define int long long

using namespace std;

array<int, 25> M = {0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 2, 3, 4, 5};

vector<array<int, 25>> p;

array<int, 25> multM(array<int, 25> &A, array<int, 25> &B)
{
    array<int, 25> C = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            for(int k = 0; k < 5; k++)
            {
                C[i*5+k]+=(A[i*5+j]*B[j*5+k]);
            }
        }
    }
    for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            C[i*5+j]%=MOD;
        }
    }
    return C;
}

array<int, 5> multV(array<int, 25> &M, array<int, 5> &V)
{
    array<int, 5> C = {0, 0, 0, 0, 0};
    for(int i = 0; i < 5; i++)
    {
        for(int j = 0; j < 5; j++)
        {
            C[i]+=M[i*5+j]*V[j];
        }
    }
    for(int i = 0; i < 5; i++)
    {
        C[i]%=MOD;
    }
    return C;
}

array<int, 5> addV(array<int, 5> &A, array<int, 5> &B)
{
    array<int, 5> C = {0, 0, 0, 0, 0};
    for(int i = 0; i < 5; i++)
    {
        C[i]+=A[i]+B[i];
    }
    for(int i = 0; i < 5; i++)
    {
        C[i]%=MOD;
    }
    return C;
}

const int N = 100005;
int n, q;
array<int, 5> a[N];

array<int, 5> tree[4*N];

array<int, 25> lazy[4*N];
bool I[4*N];
bool leaf[4*N];

void build(int v, int l, int r)
{
    if(l > r || l > n)
    {
        return;
    }
    if(l == r)
    {
        tree[v] = a[l];
        leaf[v] = true;
        return;
    }
    int mid = l+r>>1;
    build(2*v+1, l, mid);
    build(2*v+2, mid+1, r);
    tree[v] = addV(tree[2*v+1], tree[2*v+2]);
}

void push(int v)
{
    if(!I[v])
    {
        return;
    }
    tree[v] = multV(lazy[v], tree[v]);
    if(!leaf[v])
    {
        if(I[2*v+1])
        {
            lazy[2*v+1] = multM(lazy[2*v+1], lazy[v]);
        }
        else
        {
            lazy[2*v+1] = lazy[v];
        }
        if(I[2*v+2])
        {
            lazy[2*v+2] = multM(lazy[2*v+2], lazy[v]);
        }
        else
        {
            lazy[2*v+2] = lazy[v];
        }
        I[2*v+1] = true;
        I[2*v+2] = true;
    }
    lazy[v] = identity;
    I[v] = false;
}

int query(int v, int l, int r, int tl, int tr)
{
    push(v);
    if(l > tr)
    {
        return 0;
    }
    if(r < tl)
    {
        return 0;
    }
    if(l >= tl && r <= tr)
    {
        return tree[v][0];
    }
    int mid = l+r>>1;
    return query(2*v+1, l, mid, tl, tr)+query(2*v+2, mid+1, r, tl, tr);
}

void update(int v, int l, int r, int tl, int tr, array<int, 25> &value)
{
    push(v);
    if(l > tr)
    {
        return;
    }
    if(r < tl)
    {
        return;
    }
    if(l >= tl && r <= tr)
    {
        lazy[v] = value;
        I[v] = true;
        push(v);
        return;
    }
    int mid = l+r>>1;
    update(2*v+1, l, mid, tl, tr, value);
    update(2*v+2, mid+1, r, tl, tr, value);
    return;
}

int32_t main()
{
    ios_base::sync_with_stdio(false); cin.tie(0);
    p.push_back(M);
    while(p.size() < 27)
    {
        p.push_back(multM(p.back(), p.back()));
    }
    cin >> n >> q;
    array<int, 5> z = {0, 1, 2, 3, 4};
    for(int i = 1; i <= n; i++)
    {
        int ai;
        cin >> ai;
        array<int, 25> res = identity;
        int power = 0;
        while(ai > 0)
        {
            if(ai%2 == 1)
            {
                res = multM(res, p[power]);
            }
            power++;
            ai/=2;
        }
        a[i] = multV(res, z);
    }
    build(0, 1, n);
    //cout << tree[0][0] << endl;
    for(int i = 0; i < q; i++)
    {
        int type, l, r;
        cin >> type >> l >> r;
        if(type == 1)
        {
            cout << query(0, 1, n, l, r) << endl;
        }
        else
        {
            int val;
            cin >> val;
            array<int, 25> res = identity;
            int power = 0;
            while(val > 0)
            {
                if(val%2 == 1)
                {
                    res = multM(res, p[power]);
                }
                power++;
                val/=2;
            }
            update(0, 1, n, l, r, res);
        }
    }
}

/*
7 4
0 1 2 3 4 5 6
 */
