#include<bits/stdc++.h>

using namespace std;

const int mod = 1e8 + 543;
typedef long long ll;
#define matrix vector<vector<int> >

matrix identity;

matrix multi(matrix & a, matrix & b) // both n * n
{
  int n = a.size();
  matrix ans(n, vector<int> (n, 0));

  for(int r = 0; r < n; r ++) 
    for(int c = 0; c < n; c++)
      {
	for(int i = 0; i < n; i ++)
	  ans[r][c] = (ans[r][c] + (1ll * a[r][i] * b[i][c] % mod)) % mod;
      }
  return ans;
}


matrix pw(vector<vector<int> > &a, ll b)
{
  if(!b) return identity;
  matrix ans = pw(a, b / 2);
  ans = multi(ans, ans);
  if(b & 1)
    ans = multi(ans, a);
  return ans;
}

int f[10];

int find_kth(int k)
{
  if(0 <= k && k <= 8)
    return f[k];
  matrix a =
    {
      {f[8], f[7], f[6], f[5], f[4]},
      {f[7], f[6], f[5], f[4], f[3]},
      {f[6], f[5], f[4], f[3], f[2]},
      {f[5], f[4], f[3], f[2], f[1]},
      {f[4], f[3], f[2], f[1], f[0]},
    };

  matrix p =
    {
      {5, 4, 3, 2, 1},
      {1, 0, 0, 0, 0},
      {0, 1, 0, 0, 0},
      {0, 0, 1, 0, 0},
      {0, 0, 0, 1, 0},
    };
  
  p = pw(p, k - 8);
  return multi(p, a)[0][0];
}

const int N = 1e5+5;
int ft[N];

void update(int d, int i)
{
  while(i < N)
    {
      ft[i] = (ft[i] + d) % mod;
      i += (i & (-i));
    }
}

int get(int l)
{
  int ans = 0;
  while(l > 0)
    {
      ans = (ans + ft[l]) % mod;
      l -= (l & (-l));
    }
  return ans;
}

int main()
{
  ios::sync_with_stdio(false);
  cin.tie(0), cout.tie(0);
  
  int Msize = 5;
  identity = matrix(Msize, vector<int> (Msize, 0));
  for(int i = 0; i < Msize; i ++)
    identity[i][i] = 1;
  int k = 8;
  f[0] = 0, f[1] = 1, f[2] = 2, f[3] = 3, f[4] = 4;
  for(int i = 5; i <= k; i ++)
    for(int j = 1; j <= 5; j ++)
      f[i] += f[i - j] * (5 - j + 1), f[i] %= mod;

  int n, q;
  cin >> n >> q;
  ll x[n + 1], a[n + 1];

  for(int i = 1; i <= n; i ++)
    {
      cin >> a[i];
      x[i] = find_kth(a[i]);
      update(x[i], i);
    }

  while(q--)
    {
      int t, l, r, v;
      cin >> t >> l >> r;
      if(t == 1)
	cout << get(r) - get(l - 1) << '\n';
      else
	{
	  cin >> v;
	  for(int i = l; i <= r; i ++)
	    {
	      a[i] += v;
	      int temp = find_kth(a[i]);
	      cerr << temp << ' ' << x[i] << endl;
	      int ttmp = temp;
	      temp -= x[i];
	      temp = (temp % mod + mod) % mod;
	      update(temp, i);
	      x[i] = ttmp;
	    }
	}
    }
  
  return 0; 
}
