#include <bits/stdc++.h>
#define int long long

using namespace std;

const int Mod = 1e8 + 543;
const int nmax = 1e5;
const int bsize = 10000;

int n,q;
int v[nmax + 5];

vector<int> ai[4 * nmax + 5];
int lazy[4 * nmax + 5];

vector<vector<int>> p;
vector<int> u;

int aux[5][5];

vector<vector<int>> put_r[bsize + 5], put_d[2 * bsize + 5];

vector<vector<int>> lgput(int b)
{
    vector<vector<int>> a = p;
    vector<vector<int>> rez;
    rez.resize(5);
    for(int i=0;i<5;i++)
    {
        rez[i].resize(5);
        rez[i][i] = 1;
    }
    while(b)
    {
        if(b % 2 == 0)
        {
            b /= 2;
            for(int i=0;i<5;i++)
            {
                for(int j=0;j<5;j++)
                {
                    for(int k=0;k<5;k++)
                    {
                        aux[i][j] += 1LL * a[i][k] * a[k][j] % Mod;
                        aux[i][j] = (aux[i][j] % Mod + Mod) % Mod;
                    }
                }
            }
            for(int i=0;i<5;i++)
            {
                for(int j=0;j<5;j++)
                {
                    a[i][j] = aux[i][j];
                    aux[i][j] = 0;
                }
            }
        }
        else
        {
            --b;
            for(int i=0;i<5;i++)
            {
                for(int j=0;j<5;j++)
                {
                    for(int k=0;k<5;k++)
                    {
                        aux[i][j] += 1LL * rez[i][k] * a[k][j] % Mod;
                        aux[i][j] = (aux[i][j] % Mod + Mod) % Mod;
                    }
                }
            }
            for(int i=0;i<5;i++)
            {
                for(int j=0;j<5;j++)
                {
                    rez[i][j] = aux[i][j];
                    aux[i][j] = 0;
                }
            }
        }
    }
    return rez;
}

void debug_2d(vector<vector<int>> v)
{
    for(auto it1 : v)
    {
        for(auto it2 : it1)
        {
            cerr<<it2<<' ';
        }
        cerr<<'\n';
    }
    cerr<<'\n';
}

vector<vector<int>> big_mul(vector<vector<int>> x, vector<vector<int>> y)
{
    vector<vector<int>> rez;
    rez.resize(5);
    for(int i=0;i<5;i++)
    {
        rez[i].resize(5);
    }
    for(int i=0;i<5;i++)
    {
        for(int j=0;j<5;j++)
        {
            for(int k=0;k<5;k++)
            {
                rez[i][j] += 1LL * x[i][k] * y[k][j] % Mod;
                rez[i][j] = (rez[i][j] % Mod + Mod) % Mod;
            }
        }
    }
    return rez;
}

vector<vector<int>> put(int b)
{
    return big_mul(put_r[b % bsize], put_d[b / bsize]);
}

vector<int> add(vector<int> a, vector<int> b)
{
    vector<int> rez(5);
    for(int i=0;i<5;i++)
    {
        rez[i] = ((a[i] + b[i]) % Mod + Mod) % Mod;
    }
    return rez;
}

vector<int> mul(vector<int> a, vector<vector<int>> b)
{
    vector<int> rez(5);
    for(int i=0;i<5;i++)
    {
        for(int k=0;k<5;k++)
        {
            rez[i] += 1LL * a[k] * b[k][i] % Mod;
            rez[i] = (rez[i] % Mod + Mod) % Mod;
        }
    }
    return rez;
}

void propag(int nod)
{
    if(lazy[nod] == 0)
    {
        return;
    }
    lazy[nod * 2] += lazy[nod];
    lazy[nod * 2] = (lazy[nod * 2] + lazy[nod]) % (Mod - 1);
    lazy[nod * 2 + 1] = (lazy[nod * 2 + 1] + lazy[nod]) % (Mod - 1);
    ai[nod * 2] = mul(ai[nod * 2], put(lazy[nod]));
    ai[nod * 2 + 1] = mul(ai[nod * 2 + 1], put(lazy[nod]));
    lazy[nod] = 0;
}

void update(int ua, int ub, int val, int nod, int a, int b)
{
    if(ua <= a && ub >= b)
    {
        lazy[nod] = (lazy[nod] + val) % (Mod - 1);
        ai[nod] = mul(ai[nod], put(val));
        return;
    }
    propag(nod);
    int mij = (a + b) >> 1;
    if(ua <= mij)
    {
        update(ua,ub,val,nod*2,a,mij);
    }
    if(ub > mij)
    {
        update(ua,ub,val,nod*2+1,mij+1,b);
    }
    ai[nod] = add(ai[nod * 2], ai[nod * 2 + 1]);
}

int query(int qa, int qb, int nod, int a, int b)
{
    if(qa <= a && qb >= b)
    {
        return ai[nod][0];
    }
    propag(nod);
    int mij = (a + b) >> 1;
    if(qa <= mij && qb > mij)
    {
        return ((query(qa,qb,nod*2,a,mij) + query(qa,qb,nod*2+1,mij+1,b)) % Mod + Mod) % Mod;
    }
    if(qa <= mij)
    {
        return query(qa,qb,nod*2,a,mij);
    }
    return query(qa,qb,nod*2+1,mij+1,b);
}

void debug(vector<int> aux)
{
    for(auto it : aux)
    {
        cerr<<it<<' ';
    }
    cerr<<'\n';
}

void init(int nod, int a, int b)
{
    if(a == b)
    {
        ai[nod] = mul(u, put(v[a]));
        return;
    }
    int mij = (a + b) >> 1;
    init(nod*2,a,mij);
    init(nod*2+1,mij+1,b);
    ai[nod] = add(ai[nod * 2], ai[nod * 2 + 1]);
}

void init_mul()
{
    u.resize(5);
    p.resize(5);
    for(int i=0;i<5;i++)
    {
        p[i].resize(5);
    }

    for(int i=1;i<5;i++)
    {
        p[i][i - 1] = 1;
    }
    p[0][4] = 1, p[1][4] = 2, p[2][4] = 3, p[3][4] = 4, p[4][4] = 5;

    u[0] = 0, u[1] = 1, u[2] = 2, u[3] = 3, u[4] = 4;

    put_r[0] = lgput(0);
    for(int i=1;i<=bsize;i++)
    {
        put_r[i] = big_mul(put_r[i - 1], p);
    }
    put_d[0] = put_r[0];
    for(int i=bsize;i<=Mod-2;i+=bsize)
    {
        put_d[i / bsize] = big_mul(put_d[i / bsize - 1], put_r[bsize]);
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    #ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
    #endif // home
    init_mul();
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
        v[i] = (v[i] % (Mod - 1) + Mod - 1) % (Mod - 1);
    }
    init(1,1,n);
    for(int i=1;i<=q;i++)
    {
        int tip, l, r;
        cin>>tip>>l>>r;
        if(tip == 1)
        {
            cout<<query(l,r,1,1,n)<<'\n';
        }
        else
        {
            int val;
            cin>>val;
            val = (val % (Mod - 1) + Mod - 1) % (Mod - 1);
            update(l,r,val,1,1,n);
        }
    }
    return 0;
}