#include <bits/stdc++.h>

using namespace std;

const int Mod = 1e8 + 543;
const int nmax = 1e5;
const int bsize = 10000;

int n,q;
int v[nmax + 5];

int *ai[4 * nmax + 5];
int lazy[4 * nmax + 5];

int **p;
int *u;

int aux[5][5];

int **put_r[bsize + 5], **put_d[2 * bsize + 5];

int **cur_put;
int **cur_put2;

int **big_mul(int **x, int **y)
{
    int **rez;
    rez = new int*[5];
    for(int i=0;i<5;i++)
    {
        rez[i] = new int[5];
        for(int j=0;j<5;j++)
        {
            rez[i][j] = 0;
        }
    }
    for(int i=0;i<5;i++)
    {
        for(int j=0;j<5;j++)
        {
            for(int k=0;k<5;k++)
            {
                rez[i][j] += 1LL * x[i][k] * y[k][j] % Mod;
                rez[i][j] = (rez[i][j] % Mod + Mod) % Mod;
            }
        }
    }
    return rez;
}

int **put(int b)
{
    return big_mul(put_r[b % bsize], put_d[b / bsize]);
}

int *add(int a[5], int b[5])
{
    int *rez = new int[5];
    for(int i=0;i<5;i++)
    {
        rez[i] = 0;
    }
    for(int i=0;i<5;i++)
    {
        rez[i] = ((a[i] + b[i]) % Mod + Mod) % Mod;
    }
    return rez;
}

int *mul(int a[5], int **b)
{
    int *rez = new int[5];
    for(int i=0;i<5;i++)
    {
        rez[i] = 0;
    }
    for(int i=0;i<5;i++)
    {
        for(int k=0;k<5;k++)
        {
            rez[i] += 1LL * a[k] * b[k][i] % Mod;
            rez[i] = (rez[i] % Mod + Mod) % Mod;
        }
    }
    return rez;
}

void propag(int nod)
{
    if(lazy[nod] == 0)
    {
        return;
    }
    lazy[nod * 2] = (lazy[nod * 2] + lazy[nod]) % (Mod - 1);
    lazy[nod * 2 + 1] = (lazy[nod * 2 + 1] + lazy[nod]) % (Mod - 1);
    cur_put2 = put(lazy[nod]);
    ai[nod * 2] = mul(ai[nod * 2], cur_put2);
    ai[nod * 2 + 1] = mul(ai[nod * 2 + 1], cur_put2);
    lazy[nod] = 0;
}

void update(int ua, int ub, int val, int nod, int a, int b)
{
    if(ua <= a && ub >= b)
    {
        lazy[nod] = (lazy[nod] + val) % (Mod - 1);
        ai[nod] = mul(ai[nod], cur_put);
        return;
    }
    propag(nod);
    int mij = (a + b) >> 1;
    if(ua <= mij)
    {
        update(ua,ub,val,nod*2,a,mij);
    }
    if(ub > mij)
    {
        update(ua,ub,val,nod*2+1,mij+1,b);
    }
    ai[nod] = add(ai[nod * 2], ai[nod * 2 + 1]);
}

int query(int qa, int qb, int nod, int a, int b)
{
    if(qa <= a && qb >= b)
    {
        return ai[nod][0];
    }
    propag(nod);
    int mij = (a + b) >> 1;
    if(qa <= mij && qb > mij)
    {
        return ((query(qa,qb,nod*2,a,mij) + query(qa,qb,nod*2+1,mij+1,b)) % Mod + Mod) % Mod;
    }
    if(qa <= mij)
    {
        return query(qa,qb,nod*2,a,mij);
    }
    return query(qa,qb,nod*2+1,mij+1,b);
}

void init(int nod, int a, int b)
{
    if(a == b)
    {
        ai[nod] = mul(u, put(v[a]));
        return;
    }
    int mij = (a + b) >> 1;
    init(nod*2,a,mij);
    init(nod*2+1,mij+1,b);
    ai[nod] = add(ai[nod * 2], ai[nod * 2 + 1]);
}

void init_mul()
{
    u = new int[5];
    for(int i=0;i<5;i++)
    {
        u[i] = 0;
    }
    p = new int*[5];
    for(int i=0;i<5;i++)
    {
        p[i] = new int[5];
        for(int j=0;j<5;j++)
        {
            p[i][j] = 0;
        }
    }

    for(int i=1;i<5;i++)
    {
        p[i][i - 1] = 1;
    }
    p[0][4] = 1, p[1][4] = 2, p[2][4] = 3, p[3][4] = 4, p[4][4] = 5;

    u[0] = 0, u[1] = 1, u[2] = 2, u[3] = 3, u[4] = 4;

    put_r[0] = new int*[5];
    put_d[0] = new int*[5];
    for(int i=0;i<5;i++)
    {
        put_r[0][i] = new int[5];
        put_d[0][i] = new int[5];
        for(int j=0;j<5;j++)
        {
            put_r[0][i][j] = 0;
            put_d[0][i][j] = 0;
        }
        put_r[0][i][i] = put_d[0][i][i] = 1;
    }
    for(int i=1;i<=bsize;i++)
    {
        put_r[i] = big_mul(put_r[i - 1], p);
    }
    for(int i=bsize;i<=Mod-2;i+=bsize)
    {
        put_d[i / bsize] = big_mul(put_d[i / bsize - 1], put_r[bsize]);
    }
}

const int buffer_size = (1<<10) + 1;
char buffer[buffer_size];
int pp = 0;

void ReadInt(int &nr)
{
    while(!isdigit(buffer[pp]) && buffer[pp] != '-')
    {
        if(pp == buffer_size - 1)
        {
            fread(buffer, 1, buffer_size, stdin);
            pp = 0;
        }
        else
        {
            ++pp;
        }
    }
    nr = 0;
    int semn = 1;
    if(buffer[pp] == '-')
    {
        semn = -1;
        if(pp == buffer_size - 1)
        {
            fread(buffer, 1, buffer_size, stdin);
            pp = 0;
        }
        else
        {
            ++pp;
        }
    }
    while(isdigit(buffer[pp]))
    {
        nr = nr * 10 + buffer[pp] - '0';
        if(pp == buffer_size - 1)
        {
            fread(buffer, 1, buffer_size, stdin);
            pp = 0;
        }
        else
        {
            ++pp;
        }
    }
    nr *= semn;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    #ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
    #endif // home
    init_mul();
    ReadInt(n);
    ReadInt(q);
    for(int i=1;i<=n;i++)
    {
        ReadInt(v[i]);
        v[i] = (v[i] % (Mod - 1) + Mod - 1) % (Mod - 1);
    }
    init(1,1,n);
    for(int i=1;i<=q;i++)
    {
        int tip, l, r;
        ReadInt(tip);
        ReadInt(l);
        ReadInt(r);
        if(tip == 1)
        {
            cout<<query(l,r,1,1,n)<<'\n';
        }
        else
        {
            int val;
            ReadInt(val);
            val = (val % (Mod - 1) + Mod - 1) % (Mod - 1);
            cur_put = put(val);
            update(l,r,val,1,1,n);
        }
    }
    return 0;
}
