#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;

const int NMAX = 50;

int N, M;
int mat[NMAX][NMAX];

vector <pair <int, int> > V;

int need[NMAX][NMAX];

bool found_ans;

void init(int numSubtests, double timeLimit) {

}

int dx[] = {-1, 0, 1, 0};
int dy[] = {0, 1, 0, -1};
int val[] = {-2, -1, -2, -1};
int d_val[] = {-4, -3, -4, -3};

bool Interior (int x, int y) {
    return 0 <= x && x < N && 0 <= y && y < M;
}

bool Can (int S_x, int S_y, int dir) {
    int x = S_x + dx[dir];
    int y = S_y + dy[dir];

    if (mat[x][y] != val[dir] && mat[x][y] != 0) return false;

    int val = mat[x][y];

    while (Interior(x, y)) {
        if (mat[x][y] != val && mat[x][y] <= 0) return false;

        if (need[x][y] > 0 && need[x][y] > mat[x][y]) return true;

        x += dx[dir];
        y += dy[dir];
    }

    return false;
}

void Change (int S_x, int S_y, int dir) {
    int x = S_x + dx[dir];
    int y = S_y + dy[dir];

    int new_val = (mat[x][y] == 0 ? val[dir] : d_val[dir]);
    mat[S_x][S_y] ++;

    while (Interior(x, y)) {
        mat[x][y] = new_val;

        x += dx[dir];
        y += dy[dir];

        if (need[x][y] > 0) {
            mat[x][y] ++;
            return;
        }
    }
}

void Undo (int S_x, int S_y, int dir) {
    int x = S_x + dx[dir];
    int y = S_y + dy[dir];

    int new_val = (mat[x][y] == val[dir] ? 0 : val[dir]);
    mat[S_x][S_y] --;

    while (Interior(x, y)) {
        mat[x][y] = new_val;

        x += dx[dir];
        y += dy[dir];

        if (need[x][y] > 0) {
            mat[x][y] --;
            return;
        }
    }
}

int ans[NMAX][NMAX];

void Answer () {
    for (int i = 0; i < N; ++ i ) {
        for (int j = 0; j < M; ++ j ) {
            ans[i][j] = mat[i][j];
        }
    }
}

void Back (int k) {
    if (k == V.size()) {
        Answer();
        found_ans = true;
        return;
    }

    int x = V[k].first;
    int y = V[k].second;

    if (mat[x][y] == need[x][y]) {
        Back(k+1);
        return;
    }

    for (int i = 0; i < 4 && !found_ans; ++ i ) {
        if (Can(x, y, i)) {
            Change(x, y, i);
            Back(k);
            Undo(x, y, i);
        }
    }
}

bool solve(std::vector<std::vector<int>>& puzzle) {
    N = puzzle.size();
    M = puzzle[0].size();

    for (int i = 0; i < N; ++ i ) {
        for (int j = 0; j < M; ++ j ) {
            if (puzzle[i][j] != 0) {
                V.push_back({i, j});
            }

            need[i][j] = puzzle[i][j];
        }
    }
    Back(0);

    for (int i = 0; i < N; ++ i ) {
        for (int j = 0; j < M; ++ j )
            puzzle[i][j] = ans[i][j];
    }

    return true;
}
