#include <bits/stdc++.h>

using namespace std;

constexpr int MOD = 1e8 + 543;
constexpr int NMAX = 1e5 + 5;
typedef long long LL;

int Modulo (LL x) {
    int ab = abs(x) % MOD;

    if (x < 0) return MOD - ab;

    return ab;
}

struct Matrix {
    int l, c;

    vector <vector <int> > values;

    Matrix (int n, int m) {
        values.resize(n);
        for (int i = 0; i < n; ++ i )
            values[i].resize(m, 0);
        l = n;
        c = m;
    }

    Matrix () {
        l = 0;
        c = 0;
    }

    Matrix operator * (Matrix other) {
        Matrix answer(l, other.c);

        if (c != other.l) {
            cout << "Impossible\n";
            return answer;
        }

        for (int i = 0; i < answer.l; ++ i ) {
            for (int j = 0; j < answer.c; ++ j ) {
                for (int k = 0; k < c; ++ k ) {
                    answer.values[i][j] = Modulo(1LL * answer.values[i][j] + 1LL * Modulo(1LL * values[i][k] * other.values[k][j]));
                }
            }
        }

        return answer;
    }

    Matrix operator + (Matrix other) {
        Matrix answer(l, c);

        if (l != other.l || c != other.c) {
            cout << "Impossible\n";
            return answer;
        }

        for (int i = 0; i < answer.l; ++ i ) {
            for (int j = 0; j < answer.c; ++ j ) {
                answer.values[i][j] = Modulo(1LL * values[i][j] + 1LL * other.values[i][j]);
            }
        }

        return answer;
    }

    bool operator == (Matrix other) {
        if (l != other.l || c != other.c) return false;

        for (int i = 0; i < l; ++ i )
            for (int j = 0; j < c; ++ j )
                if (values[i][j] != other.values[i][j]) return false;

        return true;
    }
};

Matrix normal(5, 5), invers(5, 5);
Matrix Ident(5, 5);

int N, Q;
LL A[NMAX];

Matrix LgPut (Matrix a, LL b) {
    Matrix ans = Ident;

    while (b != 0) {
        if (b % 2 == 0) {
            b /= 2;
            a = a * a;
        }
        else {
            -- b;
            ans = ans * a;
        }
    }

    return ans;
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> Q;

    for (int i = 1; i <= N; ++ i ) {
        cin >> A[i];
        A[i] -= 4;
    }
}

void Precompute () {
    for (int i = 0; i < 5; ++ i )
        Ident.values[i][i] = 1;

    normal.values[1][0] = normal.values[2][1] = normal.values[3][2] = normal.values[4][3] = 1;
    for (int i = 0; i < 5; ++ i )
        normal.values[i][4] = i + 1;
    invers.values[3][4] = invers.values[2][3] = invers.values[1][2] = invers.values[0][1] = 1;
    invers.values[4][0] = 1;
    for (int i = 0; i < 4; ++ i )
        invers.values[i][0] = -i - 2;

    assert(invers * normal == Ident);
}

void Solve () {
    Matrix sir(1, 5);
    for (int i = 0; i < 5; ++ i )
        sir.values[0][i] = i;

    for (; Q; -- Q ) {
        int type, l, r;

        cin >> type >> l >> r;

        if (type == 1) {
            int answer = 0;
            for (int i = l; i <= r; ++ i ) {
                Matrix aux = sir * (A[i] < 0 ? LgPut(invers, -A[i]) : LgPut(normal, A[i]));

                answer = Modulo(answer + aux.values[0][4]);
            }

            cout << answer << '\n';
        }
        else {
            LL v;
            cin >> v;

            for (int i = l; i <= r; ++ i )
                A[i] += v;
        }
    }
}

int main()
{
    Precompute();
    Read();
    Solve();

    return 0;
}
