#include <bits/stdc++.h>

using namespace std;

constexpr int MOD = 1e8 + 543;
constexpr int NMAX = 1e5 + 5;
typedef long long LL;
const int perioada = 1e4;

int Modulo (LL x) {
    int ab = abs(x) % MOD;

    if (x < 0) return MOD - ab;

    return ab;
}

struct Matrix {
    int l, c;

    vector <vector <int> > values;

    Matrix (int n, int m) {
        values.resize(n);
        for (int i = 0; i < n; ++ i )
            values[i].resize(m, 0);
        l = n;
        c = m;
    }

    Matrix () {
        l = 0;
        c = 0;
    }

    Matrix operator * (Matrix other) {
        Matrix answer(l, other.c);

        if (c != other.l) {
            cout << "Impossible inmult\n";
            return answer;
        }

        for (int i = 0; i < answer.l; ++ i ) {
            for (int j = 0; j < answer.c; ++ j ) {
                for (int k = 0; k < c; ++ k ) {
                    answer.values[i][j] = Modulo(1LL * answer.values[i][j] + 1LL * Modulo(1LL * values[i][k] * other.values[k][j]));
                }
            }
        }

        return answer;
    }

    Matrix operator + (Matrix other) {
        Matrix answer(l, c);

        if (l != other.l || c != other.c) {
            cout << "Impossible adun\n";
            return answer;
        }

        for (int i = 0; i < answer.l; ++ i ) {
            for (int j = 0; j < answer.c; ++ j ) {
                answer.values[i][j] = Modulo(1LL * values[i][j] + 1LL * other.values[i][j]);
            }
        }

        return answer;
    }

    Matrix operator - (Matrix other) {
        Matrix answer(l, c);

        if (l != other.l || c != other.c) {
            cout << "Impossible scad\n";
            return answer;
        }

        for (int i = 0; i < answer.l; ++ i ) {
            for (int j = 0; j < answer.c; ++ j ) {
                answer.values[i][j] = Modulo(1LL * values[i][j] - 1LL * other.values[i][j]);
            }
        }

        return answer;
    }

    bool operator == (Matrix other) {
        if (l != other.l || c != other.c) return false;

        for (int i = 0; i < l; ++ i )
            for (int j = 0; j < c; ++ j )
                if (values[i][j] != other.values[i][j]) return false;

        return true;
    }
};

Matrix normal(5, 5), invers(5, 5);
Matrix Ident(5, 5), sir(1, 5);

Matrix Mentin_Normal[perioada+5];
Matrix Mentin_Invers[perioada+5];
Matrix MentinBucket_Normal[MOD/perioada + 5];
Matrix MentinBucket_Invers[MOD/perioada + 5];

Matrix PNormal (int b) {
    return MentinBucket_Normal[b / perioada] * Mentin_Normal[b % perioada];
}

Matrix PInvers (int b) {
    return MentinBucket_Invers[b / perioada] * Mentin_Invers[b % perioada];
}

Matrix Who (int b) {
    if (b < 0) return PInvers(-b);

    return PNormal(b);
}

void Precompute_Matrix () {
    for (int i = 0; i < 5; ++ i )
        Ident.values[i][i] = 1;

    normal.values[1][0] = normal.values[2][1] = normal.values[3][2] = normal.values[4][3] = 1;
    for (int i = 0; i < 5; ++ i )
        normal.values[i][4] = i + 1;
    invers.values[3][4] = invers.values[2][3] = invers.values[1][2] = invers.values[0][1] = 1;
    invers.values[4][0] = 1;
    for (int i = 0; i < 4; ++ i )
        invers.values[i][0] = -i - 2;

    for (int i = 0; i < 5; ++ i )
        sir.values[0][i] = i;

    Mentin_Normal[0] = Mentin_Invers[0] = MentinBucket_Normal[0] = MentinBucket_Invers[0] = Ident;
    for (int i = 1; i <= perioada; ++ i ) {
        Mentin_Normal[i] = Mentin_Normal[i-1] * normal;
        Mentin_Invers[i] = Mentin_Invers[i-1] * invers;
    }
    Matrix aux_normal = Mentin_Normal[perioada];
    Matrix aux_invers = Mentin_Invers[perioada];
    for (int i = 1; i <= MOD / perioada; ++ i ) {
        MentinBucket_Normal[i] = MentinBucket_Normal[i-1] * aux_normal;
        MentinBucket_Invers[i] = MentinBucket_Invers[i-1] * aux_invers;
    }
}

int N, Q;
int A[NMAX];

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> Q;

    for (int i = 1; i <= N; ++ i )
        cin >> A[i];
}


const int BUCKET = 3200;
Matrix SumBatog[NMAX/BUCKET + 5];
Matrix Lazy[NMAX/BUCKET + 5];
Matrix need[NMAX];

int WhatBucket (int pos) {
    return (pos + BUCKET - 1) / BUCKET;
}
int FirstBucket (int b) {
    return b * BUCKET + 1;
}
int LastBucket (int b) {
    return min((b+1) * BUCKET, N);
}

void Propag (int b) {
    for (int i = FirstBucket(b); i <= LastBucket(b); ++ i )
        need[i] = need[i] * Lazy[b];
    Lazy[b] = Ident;
}

void Update (int l, int r, Matrix upd) {
    Propag(WhatBucket(l));
    Propag(WhatBucket(r));

    for (int i = l; i <= r && WhatBucket(l) == WhatBucket(i); ++ i ){
        SumBatog[WhatBucket(l)] = SumBatog[WhatBucket(l)] - need[i];
        need[i] = need[i] * upd;
        SumBatog[WhatBucket(l)] = SumBatog[WhatBucket(l)] + need[i];
    }

    if (WhatBucket(l) == WhatBucket(r)) return;

    for (int i = r; i >= l && WhatBucket(r) == WhatBucket(i); -- i ) {
        SumBatog[WhatBucket(r)] = SumBatog[WhatBucket(r)] - need[i];
        need[i] = need[i] * upd;
        SumBatog[WhatBucket(r)] = SumBatog[WhatBucket(r)] + need[i];
    }

    for (int i = WhatBucket(l) + 1; i < WhatBucket(r); ++ i ) {
        SumBatog[i] = SumBatog[i] * upd;
        Lazy[i] = Lazy[i] * upd;
    }
}

Matrix Query (int l, int r) {
    Propag(WhatBucket(l));
    Propag(WhatBucket(r));

    Matrix answer(1, 5);
    for (int i = l; i <= r && WhatBucket(l) == WhatBucket(i); ++ i )
        answer = answer + need[i];

    if (WhatBucket(l) == WhatBucket(r)) return answer;

    for (int i = r; i >= l && WhatBucket(r) == WhatBucket(i); -- i )
        answer = answer + need[i];

    for (int i = WhatBucket(l) + 1; i < WhatBucket(r); ++ i )
        answer = answer + SumBatog[i];

    return answer;
}

void Precompute () {
    Matrix emp(1, 5);
    for (int i = 1; i <= WhatBucket(N); ++ i )
        SumBatog[i] = emp;

    for (int i = 1; i <= N; ++ i ) {
        need[i] = sir;
        Lazy[WhatBucket(i)] = Ident;
        SumBatog[WhatBucket(i)] = SumBatog[WhatBucket(i)] + need[i];
    }

    for (int i = 1; i <= N; ++ i )
        Update(i, i, Who(A[i]));
}

void Solve () {
    for (; Q; -- Q ) {
        int type, l, r;

        cin >> type >> l >> r;

        if (type == 1) {
            cout << Query(l, r).values[0][0] << '\n';
        }
        else {
            int v;
            cin >> v;

            Update(l, r, Who(v));
        }
    }
}

int main()
{
    Precompute_Matrix();
    Read();
    Precompute();
    Solve();

    return 0;
}
