#include <vector>
#include <iostream>
#include <utility>
#include <algorithm>
#include <random>
#include <iomanip>
#include <numeric>
#include <cstring>
#include <queue>

static const int N = 1e5 + 3;

static int n, k, n_tests;
static int input[N];

static long long number_of_queries;

static std::vector<int> readOnes()
{
    for(int i=1;i<=n;i++)
        input[i]=0;

    std::vector<int> _ones(k,0);

    for(int i=0;i<k;i++)
    {
        std::cin>>_ones[i];
        input[_ones[i]]=1;
    }

    for(int i=1;i<=n;i++)input[i]+=input[i-1];

    sort(_ones.begin(),_ones.end());

    return _ones;
}

bool hasOnes(int l,int r)
{
    number_of_queries++;

    if(1>l || l>n || 1>r || r>n || l>r)
    {
        std::cout << "Your program made an invalid query." << std::endl;
        exit(0);
    }

    return input[r] != input[l-1];
}

std::vector <int> guessOnes( int n, int k ) {

    std::vector <int> v;

    if ( k * 2 < n ) {

        std::queue< std::pair<int, int>> q;

        int st = 1, dr = n / 32;

        while ( dr != n ) {
            q.push({st, dr});
            st = dr + 1;

            dr = dr + n / 32;

            if ( dr > n )
                dr = n;
        }

        q.push({st, dr});

        while ( q.size() != 0 && v.size() < k ) {

            int st = q.front().first;
            int dr = q.front().second;

            q.pop();

            if ( hasOnes(st, dr) == 1 ) {
                if ( st == dr )
                    v.push_back(st);
                else {
                    q.push ({st, (st + dr) / 2});
                    q.push ({(st + dr) / 2 + 1, dr});
                }
            }
        }

        sort ( v.begin(), v.end() );
    }

    else {
        for ( int i = 1; i <= n && v.size() < k; i++ ) {
            if ( hasOnes (i, i) == true )
                v.push_back (i);
        }
    }

    return v;
}

static long long runOneTest(){
    number_of_queries = 0;

    std::vector<int> _ones = readOnes();

    std::vector<int> guess = guessOnes(n,k);

    if(_ones != guess)
    {
        std::cout << "Your program returned an incorrect answer." << std::endl;
        exit(0);
    }

    std::cout << "Your program successfully returned the correct positions and used " << number_of_queries << " queries." << std::endl;

    return number_of_queries;
}

int main(){
    std::cin >> n >> k >> n_tests;

    long long sum_queries = 0;
    for(int i = 0; i < n_tests; ++i)
        sum_queries = sum_queries + runOneTest();

    std::cout << "Your program successfully returned the correct positions and used " << sum_queries << " queries in total." << std::endl;
}
