#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100001;
const int BLOCK = 1001;
const int MOD = 100000543;
const int INF = 1e9;
const int VALMAX = MOD;

int v[NMAX];

int aint[NMAX * 4];
int lazy[NMAX * 4];
int rec[5][5];

void add(int &x, int val) {
    x += val;
    if(x < 0)
        x += MOD;
    if(x >= MOD)
        x -= MOD;
}

void propaga(int node, int st, int dr) {
    if(lazy[node] == 0) return;
    if(st != dr) {
        lazy[node * 2] += lazy[node];
        lazy[node * 2 + 1] += lazy[node];
    }
    aint[node] = (1LL * lazy[node] * (dr - st + 1)) % MOD;
    lazy[node] = 0;
}

void update(int node, int st, int dr, int a, int b, int val) {
    propaga(node, st, dr);
    if(a <= st && dr <= b) {
        lazy[node] = val;
        return;
    }
    int mid = (st + dr) / 2;
    if(a <= mid)
        update(node * 2, st, mid, a, b, val);
    if(b > mid)
        update(node * 2 + 1, mid + 1, dr, a, b, val);
    propaga(node * 2, st, mid);
    propaga(node * 2 + 1, mid + 1, dr);
    aint[node] = aint[node * 2] + aint[node * 2 + 1];
}

int query(int node, int st, int dr, int a, int b) {
    propaga(node, st, dr);
    if(a <= st && dr <= b)
        return aint[node];
    int mid = (st + dr) / 2;
    int sum = 0;
    if(a <= mid)
        add(sum, query(node * 2, st, mid, a, b));
    if(b > mid)
        add(sum, query(node * 2 + 1, mid + 1, dr, a, b));
    return sum;
}


int prod[5][5];
int rez[5][5];
int mat[5][5];

void ridica(int put) {
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            prod[i][j] = (i == j);
        }
    }
    while(put) {
        if(put&1) {
            for(int i = 0; i < 5; i++) {
                for(int j = 0; j < 5; j++) {
                    rez[i][j] = 0;
                    for(int k = 0; k < 5; k++) {
                        add(rez[i][j], (1LL * prod[i][k] * mat[k][j]) % MOD);
                    }
                }
            }
            for(int i = 0; i < 5; i++) {
                for(int j = 0; j < 5; j++) prod[i][j] = rez[i][j];
            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) {
                rez[i][j] = 0;
                for(int k = 0; k < 5; k++) {
                    add(rez[i][j], (1LL * mat[i][k] * mat[k][j]) % MOD);
                }
            }
        }
        for(int i = 0; i < 5; i++) {
            for(int j = 0; j < 5; j++) mat[i][j] = rez[i][j];
        }
        put /= 2;
    }
}

int compute(int cv) {
    if(cv >= 0 && cv <= 4)
        return cv;
    for(int i = 0; i < 5; i++) {
        for(int j = 0; j < 5; j++) {
            mat[i][j] = rec[i][j];
        //debug(rec[i][j]);
        }
    }
    ridica(cv - 4);
    int total = 0;
    add(total, (prod[0][0] * 4) % MOD);
    add(total, (prod[0][1] * 3) % MOD);
    add(total, (prod[0][2] * 2) % MOD);
    add(total, (prod[0][3] * 1) % MOD);
    return total;
}

int main() {
#ifdef HOME
    ifstream cin(".in");
    ofstream cout(".out");
#endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q, i;
    cin >> n >> q;
    rec[0][0] = 5;
    rec[0][1] = 4;
    rec[0][2] = 3;
    rec[0][3] = 2;
    rec[0][4] = 1;
    rec[1][0] = 1;
    rec[2][1] = 1;
    rec[3][2] = 1;
    rec[4][3] = 1;
    for(i = 1; i <= n; i++) {
        cin >> v[i];
        update(1, 1, n, i, i, compute(v[i]));
    }
    for(i = 1; i <= q; i++) {
        int l, r, t, vl;
        cin >> t >> l >> r;
        if(t == 1) {
            cout << query(1, 1, n, l, r) << "\n";
        } else {
            int vl;
            cin >> vl;
            for(int j = l; j <= r; j++){
                v[j] += vl;
                update(1, 1, n, j, j, compute(v[j]));
            }
        }
    }
    return 0;
}
