#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e5;
const int MOD = 1e8 + 543;
const long long MAX_A = 1e15;
const int MAX_LOG_A = 50;
const int PLUS[5][5] = { 
	{ 0, 0, 0, 0, 1 },
	{ 1, 0, 0, 0, 2 },
	{ 0, 1, 0, 0, 3 },
	{ 0, 0, 1, 0, 4 },
	{ 0, 0, 0, 1, 5 },
};
const int MINUS[5][5] = { 
	{ -2, 1, 0, 0, 0, },
	{ -3, 0, 1, 0, 0 },
	{ -4, 0, 0, 1, 0 },
	{ -5, 0, 0, 0, 1 },
	{  1, 0, 0, 0, 0 },
};

int a[MAX_N + 1];
int pls[MAX_LOG_A + 1][5][5], mnus[MAX_LOG_A + 1][5][5];

void initMat() {
	for ( int i = 0; i < 5; i++ ) {
		for ( int j = 0; j < 5; j++ ) {
			pls[0][i][j] = PLUS[i][j];
			mnus[0][i][j] = MINUS[i][j];
		}
	}
	for ( int p = 1; p <= MAX_LOG_A; p++ ) {
		for ( int i = 0; i < 5; i++ ) {
			for ( int j = 0; j < 5; j++ ) {
				for ( int k = 0; k < 5; k++ ) {
					pls[p][i][j] = (pls[p][i][j] + (long long)pls[p - 1][i][k] * pls[p - 1][k][j] % MOD) % MOD;
					mnus[p][i][j] = (mnus[p][i][j] + (long long)mnus[p - 1][i][k] * mnus[p - 1][k][j] % MOD) % MOD;
				}
			}
		}
	}
}

int calc( long long x ) {
	if ( x < 0 )
		return MOD - 22;
		
	int v[5] = { 0, 1, 2, 3, 4 }, newV[5];
	for ( int p = MAX_LOG_A; p >= 0; p-- ) {
		if ( x >= (1LL << p) ) {
			x -= (1LL << p);
			for ( int i = 0; i < 5; i++ ) {
				newV[i] = 0;
				for ( int j = 0; j < 5; j++ )
					newV[i] = (newV[i] + (long long)v[j] * pls[p][j][i]) % MOD;
			}
			for ( int i = 0; i < 5; i++ )
				v[i] = newV[i];
		}
	}
	return v[0];
}

struct AINT {
	int lst, rst;
	long long aint[4 * MAX_N];
	
	void init( int l, int r ) {
		lst = l;
		rst = r;
	}
	
	void update( int v, int l, int r, int p, int x ) {
		if ( l > p || r < p )
			return;
			
		if ( l == r ) {
			aint[v] = x;
			return;
		}
		
		int mid = (l + r) / 2;
		update( v * 2 + 1, l, mid, p, x );
		update( v * 2 + 2, mid + 1, r, p, x );
		aint[v] = aint[v * 2 + 1] + aint[v * 2 + 2];
	}
	void update( int p, int x ) {
		update( 0, lst, rst, p, x );
	}
	
	long long query( int v, int l, int r, int lq, int rq ) {
		if ( l > rq || r < lq )
			return 0;
			
		if ( lq <= l && r <= rq ) 
			return aint[v];
		
		int mid = (l + r) / 2;
		return query( v * 2 + 1, l, mid, lq, rq ) + query( v * 2 + 2, mid + 1, r, lq, rq );
	}
	long long query( int l, int r ) {
		return query( 0, lst, rst, l, r );
	}
} aint;

int main() {
	cin.tie( NULL );
	ios_base::sync_with_stdio( false );
	
	int n, q;
	
	cin >> n >> q;
	for ( int i = 1; i <= n; i++ ) {
		cin >> a[i];
		aint.update( i, calc( a[i] ) );
	}
		
	initMat();
	aint.init( 1, n );
	for ( int i = 0; i < q; i++ ) {
		int t, l, r;
		
		cin >> t >> l >> r;
		if ( t == 1 ) 
			cout << aint.query( l, r ) % MOD << "\n";
		else {
			int x;
			cin >> x;
			a[l] += x;
			//printf( "ba %d %d %d\n", l, a[l], calc( a[l] ) );
			aint.update( l, calc( a[l] ) );
		}
	}
}
