
#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e5;
const int MOD = 1e8 + 543;
const long long MAX_A = 1e15;
const int MAX_LOG_A = 50;
const int PLUS[5][5] = { 
    { 0, 0, 0, 0, 1 },
    { 1, 0, 0, 0, 2 },
    { 0, 1, 0, 0, 3 },
    { 0, 0, 1, 0, 4 },
    { 0, 0, 0, 1, 5 },
};
const int MINUS[5][5] = { 
    { MOD -2, 1, 0, 0, 0 },
    { MOD -3, 0, 1, 0, 0 },
    { MOD -4, 0, 0, 1, 0 },
    { MOD -5, 0, 0, 0, 1 },
    { MOD +1, 0, 0, 0, 0 },
};
const int I5[5][5] = { 
    { 1, 0, 0, 0, 0 },
    { 0, 1, 0, 0, 0 },
    { 0, 0, 1, 0, 0 },
    { 0, 0, 0, 1, 0 },
    { 0, 0, 0, 0, 1 },
};

long long a[MAX_N + 1];
int pls[MAX_LOG_A + 1][5][5], mnus[MAX_LOG_A + 1][5][5];

void initMat() {
    for ( int i = 0; i < 5; i++ ) {
        for ( int j = 0; j < 5; j++ ) {
            pls[0][i][j] = PLUS[i][j];
            mnus[0][i][j] = MINUS[i][j];
        }
    }
    for ( int p = 1; p <= MAX_LOG_A; p++ ) {
        for ( int i = 0; i < 5; i++ ) {
            for ( int j = 0; j < 5; j++ ) {
                for ( int k = 0; k < 5; k++ ) {
                    pls[p][i][j] = (pls[p][i][j] + (long long)pls[p - 1][i][k] * pls[p - 1][k][j] % MOD) % MOD;
                    mnus[p][i][j] = (mnus[p][i][j] + (long long)mnus[p - 1][i][k] * mnus[p - 1][k][j] % MOD) % MOD;
                }
            }
        }
    }
}

struct infoLazy {
    int mat[5][5];
        
    infoLazy operator * ( const infoLazy &b ) const {
        infoLazy ans;
            
        for ( int i = 0; i < 5; i++ ) {
            for ( int j = 0; j < 5; j++ ) {
                ans.mat[i][j] = 0;
                for ( int k = 0; k < 5; k++ )
                    ans.mat[i][j] = (ans.mat[i][j] + (long long)mat[i][k] * b.mat[k][j]) % MOD;
            }		
        }
            
        return ans;
    }
};
    
struct infoAint {
    int sir[5];
        
    infoAint operator + ( const infoAint &b ) const {
        infoAint ans;
            
        for ( int i = 0; i < 5; i++ ) 
            ans.sir[i] = (sir[i] + b.sir[i] >= MOD ? sir[i] + b.sir[i] - MOD : sir[i] + b.sir[i]);
            
        return ans;
    }
        
    infoAint operator * ( const infoLazy &b ) const {
        infoAint ans;
            
        for ( int i = 0; i < 5; i++ ) {
            ans.sir[i] = 0;
            for ( int j = 0; j < 5; j++ )
                ans.sir[i] = (ans.sir[i] + (long long)sir[j] * b.mat[j][i]) % MOD;
        }
            
        return ans;
    }
    
};


infoLazy calcInfoLazy( long long x ) {
    int s = (x > 0 ? 1 : -1);
    x = abs( x );
    infoLazy c;
    for ( int i = 0; i < 5; i++ ) {
        for ( int j = 0; j < 5; j++ )
            c.mat[i][j] = I5[i][j];
    }
    
    for ( int p = log2( x ); p >= 0; p-- ) {
        if ( (x >= (1LL << p) ) ) {
            x -= (1LL << p);
            infoLazy d;
            for ( int i = 0; i < 5; i++ ) {
                for ( int j = 0; j < 5; j++ )
                    d.mat[i][j] = (s > 0 ? pls[p][i][j] : mnus[p][i][j]);
            }
            c = c * d;
        }
    }
    
    return c;
}

struct AINT {
    
    
    int lst, rst;
    infoAint aint[4 * MAX_N];
    infoLazy lazy[4 * MAX_N];
    
    void init( int v, int l, int r ) {
        for ( int i = 0; i < 5; i++ ) {
            for ( int j = 0; j < 5; j++ )
                lazy[v].mat[i][j] = I5[i][j];
        }
        if ( l == r ) {
            aint[v] = { { 0, 1, 2, 3, 4 } };
            aint[v] = aint[v] * calcInfoLazy( a[l] );
            return;
        }
        
        int mid = (l + r) / 2;
        init( v * 2 + 1, l, mid );
        init( v * 2 + 2, mid + 1, r );
        aint[v] = aint[v * 2 + 1] + aint[v * 2 + 2];
    }
    void init( int l, int r ) {
        lst = l;
        rst = r;
        for ( int v = 0; v < 4 * (r - l + 1); v++ ) {
            aint[v] = { { 0, 1, 2, 3, 4 } };
            for ( int i = 0; i < 5; i++ ) {
                for ( int j = 0; j < 5; j++ )
                    lazy[v].mat[i][j] = I5[i][j];
            }
        }
        init( 0, l, r );
    }
    
    void propag( int v, int l, int r ) {
        aint[v] = aint[v] * lazy[v];
        if ( l != r ) {
            lazy[v * 2 + 1] = lazy[v * 2 + 1] * lazy[v];
            lazy[v * 2 + 2] = lazy[v * 2 + 2] * lazy[v];
        }
        for ( int i = 0; i < 5; i++ ) {
            for ( int j = 0; j < 5; j++ )
                lazy[v].mat[i][j] = I5[i][j];
        }
    }
    
    void update( int v, int l, int r, int lu, int ru, infoLazy &x ) {
        propag( v, l, r );
        
        
        if ( l > ru || r < lu )
            return;
            
        if ( lu <= l && r <= ru ) {
            lazy[v] = x;
            propag( v, l, r );
            return;
        }
        
        int mid = (l + r) / 2;
        update( v * 2 + 1, l, mid, lu, ru, x );
        update( v * 2 + 2, mid + 1, r, lu, ru, x );
        aint[v] = aint[v * 2 + 1] + aint[v * 2 + 2];
    }
    void update( int l, int r, infoLazy &x ) {
        update( 0, lst, rst, l, r, x );
    }
    
    long long query( int v, int l, int r, int lq, int rq ) {
        propag( v, l, r );
        
        if ( l > rq || r < lq )
            return 0;
            
        if ( lq <= l && r <= rq ) 
            return aint[v].sir[0];
        
        int mid = (l + r) / 2;
        return query( v * 2 + 1, l, mid, lq, rq ) + query( v * 2 + 2, mid + 1, r, lq, rq );
    }
    long long query( int l, int r ) {
        return query( 0, lst, rst, l, r );
    }
} aint;


int main() {
    cin.tie( NULL );
    ios_base::sync_with_stdio( false );
    
    int n, q;
    
    cin >> n >> q;
    initMat();
    for ( int i = 1; i <= n; i++ ) 
        cin >> a[i];
    aint.init( 1, n );
    for ( int i = 0; i < q; i++ ) {
        int t, l, r;
        
        cin >> t >> l >> r;
        if ( t == 1 ) 
            cout << aint.query( l, r ) % MOD << "\n";
        else {
            int x;
            cin >> x;
            infoLazy c = calcInfoLazy( x );
            aint.update( l, r, c );
        }
    }
}