#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e5;
const int MOD = 1e8 + 543;
const long long MAX_A = 1e15;
const int MAX_LOG_A = 50;
const int PLUS[5][5] = { 
	{ 0, 0, 0, 0, 1 },
	{ 1, 0, 0, 0, 2 },
	{ 0, 1, 0, 0, 3 },
	{ 0, 0, 1, 0, 4 },
	{ 0, 0, 0, 1, 5 },
};
const int MINUS[5][5] = { 
	{ MOD -2, 1, 0, 0, 0 },
	{ MOD -3, 0, 1, 0, 0 },
	{ MOD -4, 0, 0, 1, 0 },
	{ MOD -5, 0, 0, 0, 1 },
	{ MOD +1, 0, 0, 0, 0 },
};
const int I5[5][5] = { 
	{ 1, 0, 0, 0, 0 },
	{ 0, 1, 0, 0, 0 },
	{ 0, 0, 1, 0, 0 },
	{ 0, 0, 0, 1, 0 },
	{ 0, 0, 0, 0, 1 },
};

long long a[MAX_N + 1];
int pls[MAX_LOG_A + 1][5][5], mnus[MAX_LOG_A + 1][5][5];

void initMat() {
	for ( int i = 0; i < 5; i++ ) {
		for ( int j = 0; j < 5; j++ ) {
			pls[0][i][j] = PLUS[i][j];
			mnus[0][i][j] = MINUS[i][j];
		}
	}
	for ( int p = 1; p <= MAX_LOG_A; p++ ) {
		for ( int i = 0; i < 5; i++ ) {
			for ( int j = 0; j < 5; j++ ) {
				for ( int k = 0; k < 5; k++ ) {
					pls[p][i][j] = (pls[p][i][j] + (long long)pls[p - 1][i][k] * pls[p - 1][k][j]) % MOD;
					mnus[p][i][j] = (mnus[p][i][j] + (long long)mnus[p - 1][i][k] * mnus[p - 1][k][j]) % MOD;
				}
			}
		}
	}
}

struct infoLazy {
	int mat[5][5];
		
	infoLazy operator * ( const infoLazy &b ) const {
		infoLazy ans;
			
		for ( int i = 0; i < 5; i++ ) {
			for ( int j = 0; j < 5; j++ ) {
				ans.mat[i][j] = 0;
				for ( int k = 0; k < 5; k++ )
					ans.mat[i][j] = (ans.mat[i][j] + (long long)mat[i][k] * b.mat[k][j]) % MOD;
			}		
		}
			
		return ans;
	}
};
	
struct infoAint {
	int sir[5];
		
	infoAint operator + ( const infoAint &b ) const {
		infoAint ans;
			
		for ( int i = 0; i < 5; i++ ) 
			ans.sir[i] = (sir[i] + b.sir[i] >= MOD ? sir[i] + b.sir[i] - MOD : sir[i] + b.sir[i]);
			
		return ans;
	}
		
	infoAint operator * ( const infoLazy &b ) const {
		infoAint ans;
			
		for ( int i = 0; i < 5; i++ ) {
			ans.sir[i] = 0;
			for ( int j = 0; j < 5; j++ )
				ans.sir[i] = (ans.sir[i] + (long long)sir[j] * b.mat[j][i]) % MOD;
		}
			
		return ans;
	}
	
};


struct AINT {
	
	
	int lst, rst;
	int aint[4 * MAX_N][5];
	int lazy[4 * MAX_N][5][5];
	
	void init( int v, int l, int r ) {
		for ( int i = 0; i < 5; i++ ) {
			for ( int j = 0; j < 5; j++ )
				lazy[v][i][j] = I5[i][j];
		}
		if ( l == r ) {
			int x = a[l];
			int s = (x > 0 ? 1 : -1);
			x = abs( x );
			int c[5][5];
			for ( int i = 0; i < 5; i++ ) {
				for ( int j = 0; j < 5; j++ )
					c[i][j] = I5[i][j];
			}
			
			for ( int p = MAX_LOG_A; p >= 0; p-- ) {
				if ( (x >= (1LL << p) ) ) {
					x -= (1LL << p);
					int d[5][5];
					for ( int i = 0; i < 5; i++ ) {
						for ( int j = 0; j < 5; j++ )
							d[i][j] = (s > 0 ? pls[p][i][j] : mnus[p][i][j]);
					}
					int ans[5][5];
					for ( int i = 0; i < 5; i++ ) {
						for ( int j = 0; j < 5; j++ ) {
							ans[i][j] = 0;
							for ( int k = 0; k < 5; k++ )
								ans[i][j] = (ans[i][j] + (long long)c[i][k] * d[k][j]) % MOD;
						}		
					}
					for ( int i = 0; i < 5; i++ ) {
						for ( int j = 0; j < 5; j++ )
							c[i][j] = ans[i][j];
					}
				}
			}
			for ( int i = 0; i < 5; i++ ) {
				aint[v][i] = 0;
				for ( int j = 0; j < 5; j++ )
					aint[v][i] = (aint[v][i] + (long long)j * c[j][i]) % MOD;
			}
			return;
		}
		
		int mid = (l + r) / 2;
		init( v * 2 + 1, l, mid );
		init( v * 2 + 2, mid + 1, r );
		for ( int i = 0; i < 5; i++ ) 
			aint[v][i] = (aint[v * 2 + 1][i] + aint[v * 2 + 2][i] >= MOD ? aint[v * 2 + 1][i] + aint[v * 2 + 2][i] - MOD : aint[v * 2 + 1][i] + aint[v * 2 + 2][i]);
	}
	void init( int l, int r ) {
		lst = l;
		rst = r;
		init( 0, l, r );
	}
	
	void propag( int v, int l, int r ) {
		int a1[5];
		for ( int i = 0; i < 5; i++ ) {
			a1[i] = 0;
			for ( int j = 0; j < 5; j++ )
				a1[i] = (a1[i] + (long long)aint[v][j] * lazy[v][j][i]) % MOD;
		}
		for ( int i = 0; i < 5; i++ ) 
			aint[v][i] = a1[i];
		if ( l != r ) {
			int m1[5][5], m2[5][5];
			for ( int i = 0; i < 5; i++ ) {
				for ( int j = 0; j < 5; j++ ) {
					m1[i][j] = m2[i][j] = 0;
					for ( int k = 0; k < 5; k++ ) {
						m1[i][j] = (m1[i][j] + (long long)lazy[v * 2 + 1][i][k] * lazy[v][k][j]) % MOD;
						m2[i][j] = (m2[i][j] + (long long)lazy[v * 2 + 2][i][k] * lazy[v][k][j]) % MOD;
					}
				}
			}
			for ( int i = 0; i < 5; i++ ) {
				for ( int j = 0; j < 5; j++ ) {
					lazy[v * 2 + 1][i][j] = m1[i][j];
					lazy[v * 2 + 2][i][j] = m2[i][j];
				}
			}
		}
		for ( int i = 0; i < 5; i++ ) {
			for ( int j = 0; j < 5; j++ )
				lazy[v][i][j] = I5[i][j];
		}
	}
	
	void update( int v, int l, int r, int lu, int ru, int x[5][5] ) {
		propag( v, l, r );
		
		
		if ( l > ru || r < lu )
			return;
			
		if ( lu <= l && r <= ru ) {
			for ( int i = 0; i < 5; i++ ) {
				for ( int j = 0; j < 5; j++ )
					lazy[v][i][j] = x[i][j];
			}
			propag( v, l, r );
			return;
		}
		
		int mid = (l + r) / 2;
		update( v * 2 + 1, l, mid, lu, ru, x );
		update( v * 2 + 2, mid + 1, r, lu, ru, x );
		for ( int i = 0; i < 5; i++ ) 
			aint[v][i] = (aint[v * 2 + 1][i] + aint[v * 2 + 2][i] >= MOD ? aint[v * 2 + 1][i] + aint[v * 2 + 2][i] - MOD : aint[v * 2 + 1][i] + aint[v * 2 + 2][i]);
	}
	void update( int l, int r, int x[5][5] ) {
		update( 0, lst, rst, l, r, x );
	}
	
	long long query( int v, int l, int r, int lq, int rq ) {
		propag( v, l, r );
		
		if ( l > rq || r < lq )
			return 0;
			
		if ( lq <= l && r <= rq ) 
			return aint[v][0];
		
		int mid = (l + r) / 2;
		return query( v * 2 + 1, l, mid, lq, rq ) + query( v * 2 + 2, mid + 1, r, lq, rq );
	}
	long long query( int l, int r ) {
		return query( 0, lst, rst, l, r );
	}
} aint;


int main() {
	cin.tie( NULL );
	ios_base::sync_with_stdio( false );
	
	int n, q;
	
	cin >> n >> q;
	initMat();
	for ( int i = 1; i <= n; i++ ) 
		cin >> a[i];
	aint.init( 1, n );
	for ( int i = 0; i < q; i++ ) {
		int t, l, r;
		
		cin >> t >> l >> r;
		if ( t == 1 ) 
			cout << aint.query( l, r ) % MOD << "\n";
		else {
			int x;
			cin >> x;
			int s = (x > 0 ? 1 : -1);
			x = abs( x );
			int c[5][5];
			for ( int i = 0; i < 5; i++ ) {
				for ( int j = 0; j < 5; j++ )
					c[i][j] = I5[i][j];
			}
			
			for ( int p = MAX_LOG_A; p >= 0; p-- ) {
				if ( (x >= (1LL << p) ) ) {
					x -= (1LL << p);
					int d[5][5];
					for ( int i = 0; i < 5; i++ ) {
						for ( int j = 0; j < 5; j++ )
							d[i][j] = (s > 0 ? pls[p][i][j] : mnus[p][i][j]);
					}
					int ans[5][5];
					for ( int i = 0; i < 5; i++ ) {
						for ( int j = 0; j < 5; j++ ) {
							ans[i][j] = 0;
							for ( int k = 0; k < 5; k++ )
								ans[i][j] = (ans[i][j] + (long long)c[i][k] * d[k][j]) % MOD;
						}		
					}
					for ( int i = 0; i < 5; i++ ) {
						for ( int j = 0; j < 5; j++ )
							c[i][j] = ans[i][j];
					}
				}
			}
			aint.update( l, r, c );
		}
	}
}
