#include <iostream>
#include <cstring>
#include <unordered_map>
using namespace std;

const int mod = 1e8 + 543;
const int nmax = 100000;
const int valmax = 1e6;
int n,m;
long long v[nmax + 5];

long long sol[valmax+ 5];
long long xs[nmax + 5];

struct mat{
long long v[5][5];
void reset()
{
   memset(v,0,sizeof(v));
}
void identity()
{
    memset(v,0,sizeof(v));
    for(int i=0;i<5;i++)
        v[i][i]=1;
}
void order1()
{
    memset(v,0,sizeof(v));
    v[0][0]=5,v[0][1]=4,v[0][2]=3,v[0][3]=2,v[0][4]=1;
    for(int i=1;i<5;i++)
        v[i][i-1]=1;
}
void multiply(const mat& b)
{
    mat c;
    c.reset();
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            for(int k=0;k<5;k++){
                c.v[i][j] = 1LL*c.v[i][j] + 1LL*v[i][k] * b.v[k][j];
            }
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            v[i][j]=c.v[i][j]%mod;
}
};
mat put(mat base,long long exp)
{
    mat sol;
    sol.identity();
    while(exp)
    {
        if(exp&1)
            sol.multiply(base);
        base.multiply(base);
        exp/=2;
    }
    return sol;
}

long long get_elem(const mat& x)
{
    return (4*x.v[0][0] + 3*x.v[0][1] + 2*x.v[0][2] + 1*x.v[0][3])%mod;
}

/*
6 4
1 2 3 4 5 6
1 5 5
2 5 5 1
1 5 5
1 4 4

*/


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    mat one;
    one.order1();
    mat q;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>v[i];
        if(v[i]<=4){
            xs[i]=v[i];
            continue;
        }
        q = put(one,v[i]-4);
        xs[i]=get_elem(q);
    }

    for(int i=1;i<=m;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            cout<<xs[l]<<'\n';
        }
        else
        {
            long long val;
            cin>>val;
            v[l]+=val;
            if(v[l]<=4)
                xs[l]=v[l];
            else
            {
                mat q = put(one,v[l]-4);
                xs[l] = get_elem(q);
            }
        }
    }

}
