#include <iostream>
#include <cstring>
using namespace std;

const int mod = 1e8 + 543;
const int nmax = 100000;
int n,m;
long long v[nmax + 5];

struct mat{
long long v[5][5];
int ord = 0;
void reset()
{
   memset(v,0,sizeof(v));
}
void identity()
{
    memset(v,0,sizeof(v));
    for(int i=0;i<5;i++)
        v[i][i]=1;
}
void order1()
{
    ord = 1;
    memset(v,0,sizeof(v));
    v[0][0]=5,v[0][1]=4,v[0][2]=3,v[0][3]=2,v[0][4]=1;
    for(int i=1;i<5;i++)
        v[i][i-1]=1;
}
void multiply(const mat& b)
{
    ord+=b.ord;
    mat c;
    c.reset();
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            for(int k=0;k<5;k++)
                c.v[i][j] = (c.v[i][j] + (v[i][k] * b.v[k][j]))%mod;
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            v[i][j]=c.v[i][j];
}
};
mat put(mat base,long long exp)
{
    mat sol;
    sol.identity();
    while(exp)
    {
        if(exp&1)
            sol.multiply(base);
        base.multiply(base);
        exp/=2;
    }
    return sol;
}

long long get_elem(const mat& x)
{
    return 4*x.v[0][0] + 3*x.v[0][1] + 2*x.v[0][2] + x.v[0][3];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    /*
    mat x;
    x.order1();
    x = put(x,2);
    mat q;
    q.reset();
    q.v[0][0]=4;
    q.v[1][1]=3;
    q.v[2][2]=2;
    q.v[3][3]=1;

    int s=  x.v[0][0] *4 + x.v[0][1] *3 + x.v[0][2] *2 + x.v[0][3]*1;
    cout<<s;*/
    cin>>n>>m;
    for(int i=1;i<=n;i++)
        cin>>v[i];
    for(int i=1;i<=m;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            long long s = 0;
            for(int j = l;j<=r;j++)
            {
                int el = v[j];
                if(el<5)
                    s+=el;
                else
                {
                    el-=4;
                    mat x;
                    x.order1();
                    x = put(x,el);
                    s = (s + get_elem(x))%mod;
                }
            }
            cout<<s<<'\n';
        }
        else
        {
            long long val;
            cin>>val;
            for(int j=l;j<=r;j++)
                v[j]+=val;
        }
    }
}
