#include <iostream>
#include <cstring>
using namespace std;

const int mod = 1e8 + 543;
const int nmax = 100000;
int n,m;
long long v[nmax + 5];

struct mat{
long long v[5][5];
void reset()
{
   memset(v,0,sizeof(v));
}
void identity()
{
    memset(v,0,sizeof(v));
    for(int i=0;i<5;i++)
        v[i][i]=1;
}
void order1()
{
    memset(v,0,sizeof(v));
    v[0][0]=5,v[0][1]=4,v[0][2]=3,v[0][3]=2,v[0][4]=1;
    for(int i=1;i<5;i++)
        v[i][i-1]=1;
}
void multiply(const mat& b)
{
    mat c;
    c.reset();
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            for(int k=0;k<5;k++)
                c.v[i][j] = (c.v[i][j] + (v[i][k] * b.v[k][j]))%mod;
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            v[i][j]=c.v[i][j];
}
};
mat put(mat base,long long exp)
{
    mat sol;
    sol.identity();
    while(exp)
    {
        if(exp&1)
            sol.multiply(base);
        base.multiply(base);
        exp/=2;
    }
    return sol;
}

long long get_elem(const mat& x)
{
    return (4*x.v[0][0] + 3*x.v[0][1] + 2*x.v[0][2] + x.v[0][3])%mod;
}

mat one;

struct NNod{
mat val;
int nr=-1;
int sum;
}aint[4*nmax + 5];

void build(int nod,int st,int dr)
{
    if(st==dr)
    {
        aint[nod].nr = v[st];
        if(v[st] > 4){
            aint[nod].val = put(one,v[st]-4);
            aint[nod].sum = get_elem(aint[nod].val);
        }
        else
            aint[nod].sum = v[st];
        return;
    }
    int mid = (st+dr)/2;
    build(nod*2,st,mid);
    build(nod*2+1,mid+1,dr);
    aint[nod].sum = (aint[nod*2].sum + aint[nod*2+1].sum)%mod;
}
void update(int nod,int st,int dr,int poz,long long x)
{
    if(st==dr)
    {
        if(v[st] < 4)
        {
            if(v[st] + x > 4){
                v[st] += x;
                aint[nod].val = put(aint[nod].val,v[st]-4);
                aint[nod].sum = get_elem(aint[nod].val);
                return;
            }
            v[st] += x;
            aint[nod].sum = v[st];
            return;
        }
        v[st]+=x;
        mat q;
        q = put(one,x);
        aint[nod].val.multiply(q);
        aint[nod].sum = get_elem(aint[nod].val);
        return;
    }
    int mid = (st+dr)/2;
    if(poz<=mid)
        update(nod*2,st,mid,poz,x);
    else
        update(nod*2,mid+1,dr,poz,x);
    aint[nod].sum = (aint[nod*2].sum + aint[nod*2+1].sum)%mod;
}
long long query(int nod,int st,int dr,int x,int y)
{
    if(x<=st && dr<=y)
        return aint[nod].sum;
    int mid = (st+dr)/2;
    long long s1 = 0;
    long long s2 = 0;
    if(x<=mid)
        s1 = query(nod*2,st,mid,x,y);
    if(y>mid)
        s2 = query(nod*2+1,mid+1,dr,x,y);
    return s1 + s2;
}


int main()
{
    one.order1();
    /*
    mat x;
    x.order1();
    x = put(x,2);
    mat q;
    q.reset();
    q.v[0][0]=4;
    q.v[1][1]=3;
    q.v[2][2]=2;
    q.v[3][3]=1;

    int s=  x.v[0][0] *4 + x.v[0][1] *3 + x.v[0][2] *2 + x.v[0][3]*1;
    cout<<s;*/

    /*
    20 4
    1000 65 42 124 7555 6 100000 100000 100000 100000 100000 100000 100000 100000 100000 0 0 0 0 0
    1 1 15
    1 1 15
    2 1 20 100000
    1 1 15


    */

    cin>>n>>m;
    for(int i=1;i<=n;i++)
        cin>>v[i];
    build(1,1,n);
    for(int i=1;i<=m;i++)
    {
        long long t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            cout<<query(1,1,n,l,r)<<'\n';
        }
        else
        {
            int val;
            cin>>val;
            for(int j = l;j<=r;j++)
                update(1,1,n,j,val);
        }
    }
}
