#include <iostream>
#include <cstring>
using namespace std;

const int mod = 1e8 + 543;
const int nmax = 100000;
const int valmax = 1e6;
int n,m;
long long v[nmax + 5];

long long sol[valmax+ 5];

struct mat{
long long v[5][5];
void reset()
{
   memset(v,0,sizeof(v));
}
void identity()
{
    memset(v,0,sizeof(v));
    for(int i=0;i<5;i++)
        v[i][i]=1;
}
void order1()
{
    memset(v,0,sizeof(v));
    v[0][0]=5,v[0][1]=4,v[0][2]=3,v[0][3]=2,v[0][4]=1;
    for(int i=1;i<5;i++)
        v[i][i-1]=1;
}
void multiply(const mat& b)
{
    mat c;
    c.reset();
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            for(int k=0;k<5;k++)
                c.v[i][j] = (c.v[i][j] + (v[i][k] * b.v[k][j]))%mod;
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            v[i][j]=c.v[i][j];
}
};
mat put(mat base,long long exp)
{
    mat sol;
    sol.identity();
    while(exp)
    {
        if(exp&1)
            sol.multiply(base);
        base.multiply(base);
        exp/=2;
    }
    return sol;
}

long long a[nmax * 4 + 5];

void build(int nod,int st,int dr)
{
    if(st==dr){
        a[nod]=v[st];
        return;
    }
    int mid = (st+dr)/2;
    build(nod*2,st,mid);
    build(nod*2+1,mid+1,dr);
    a[nod] = (a[nod*2]+a[nod*2+1])%mod;
}
long long query(int nod,int st,int dr,int x,int y)
{
    if(x<=st && dr<=y)
        return a[nod];
    int mid = (st+dr)/2;
    long long s1=0,s2=0;
    if(x<=mid) s1 = query(nod*2,st,mid,x,y);
    if(y>mid) s2 = query(nod*2+1,mid+1,dr,x,y);
    return (s1 + s2)%mod;

}


/*
6 4
1 2 3 4 5 6
1 1 1
1 1 6
1 1 4
1 1 5

*/


int main()
{
    sol[0]=0,sol[1]=1,sol[2]=2,sol[3]=3,sol[4]=4;
    for(int i =5;i<=valmax;i++) sol[i] = (5*sol[i-1] + 4*sol[i-2] + 3*sol[i-3] + 2*sol[i-4] + sol[i-5])%mod;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>v[i];
        v[i]=sol[v[i]];
    }
    build(1,1,n);
    for(int i=1;i<=m;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        cout<<query(1,1,n,l,r)<<'\n';
    }

}
