#include <iostream>
#include <cstring>
using namespace std;

const int mod = 1e8 + 543;
const int nmax = 100000;
const int valmax = 1e6;
int n,m;
long long v[nmax + 5];

long long sol[valmax+ 5];

struct mat{
int v[5][5];
void reset()
{
   memset(v,0,sizeof(v));
}
void identity()
{
    memset(v,0,sizeof(v));
    for(int i=0;i<5;i++)
        v[i][i]=1;
}
void order1()
{
    memset(v,0,sizeof(v));
    v[0][0]=5,v[0][1]=4,v[0][2]=3,v[0][3]=2,v[0][4]=1;
    for(int i=1;i<5;i++)
        v[i][i-1]=1;
}
void multiply(const mat& b)
{
    mat c;
    c.reset();
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            for(int k=0;k<5;k++){
                c.v[i][j] = (1LL*c.v[i][j] + (1LL*v[i][k] * b.v[k][j]))%mod;
            }
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            v[i][j]=c.v[i][j];
}
};
mat put(mat base,long long exp)
{
    mat sol;
    sol.identity();
    while(exp)
    {
        if(exp&1)
            sol.multiply(base);
        base.multiply(base);
        exp/=2;
    }
    return sol;
}

long long get_elem(const mat& x)
{
    return (4LL*x.v[0][0] + 3LL*x.v[0][1] + 2LL*x.v[0][2] + 1LL*x.v[0][3])%mod;
}

/*
6 4
1 2 3 4 5 6
1 1 1
2 1 1 10000000000
1 1 1
1 1 4

*/


int main()
{
    mat one;
    one.order1();
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>v[i];
    }
    for(int i=1;i<=m;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            if(v[l] < 4)
                cout<<v[l]<<'\n';
            else{
                mat x = put(one,v[l]-4);
                cout<<get_elem(x)<<'\n';
            }
        }
        else
        {
            long long val;
            cin>>val;
            v[l]+=val;
        }
    }

}
