#include <iostream>
#include <cstring>
#include <unordered_map>
using namespace std;

const int mod = 1e8 + 543;
const int nmax = 100000;
const int valmax = 1e6;
int n,m;
long long v[nmax + 5];

long long sol[valmax+ 5];


struct mat{
long long v[5][5];
void reset()
{
   memset(v,0,sizeof(v));
}
void identity()
{
    memset(v,0,sizeof(v));
    for(int i=0;i<5;i++)
        v[i][i]=1;
}
void order1()
{
    memset(v,0,sizeof(v));
    v[0][0]=5,v[0][1]=4,v[0][2]=3,v[0][3]=2,v[0][4]=1;
    for(int i=1;i<5;i++)
        v[i][i-1]=1;
}
void multiply(const mat& b)
{
    mat c;
    c.reset();
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            for(int k=0;k<5;k++){
                c.v[i][j] = 1LL*c.v[i][j] + 1LL*v[i][k] * b.v[k][j];
                while(c.v[i][j] >= mod)
                    c.v[i][j]-=mod;
            }
    for(int i=0;i<5;i++)
        for(int j=0;j<5;j++)
            v[i][j]=c.v[i][j];
}
};
long long get_elem(const mat& x)
{
    return (4LL*x.v[0][0] + 3LL*x.v[0][1] + 2LL*x.v[0][2] + 1LL*x.v[0][3])%mod;
}
mat sl;
long long put(mat base,long long exp)
{

    sl.identity();
    while(exp)
    {
        if(exp&1)
            sl.multiply(base);
        base.multiply(base);
        exp/=2;
    }
    return get_elem(sl);
}



/*
6 4
1 2 3 4 5 6
1 5 5
2 5 5 1
1 5 5
1 4 4

*/


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    sol[0]=0,sol[1]=1,sol[2]=2,sol[3]=3,sol[4]=4;
    for(int i =5;i<=valmax;i++) sol[i] = (5*sol[i-1] + 4*sol[i-2] + 3*sol[i-3] + 2*sol[i-4] + sol[i-5])%mod;
    mat one;
    one.order1();
    mat q;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>v[i];
    }

    for(int i=1;i<=m;i++)
    {
        int t,l,r;
        cin>>t>>l>>r;
        if(t==1)
        {
            if(v[l]<=valmax)
                cout<<sol[v[l]]<<'\n';
            else
                cout<<put(one,v[l]-4)<<'\n';

        }
        else
        {
            long long val;
            cin>>val;
            v[l]+=val;
        }
    }

}
