#include "ones.h"
#include <random>
#include <chrono>

using namespace std;

#define BULAN_MULT 1.5d
#define BULAN_ADD 2

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int binSearch(int st, int dr)
{
    /// ( ]
    int mij;
    while (dr-st > 1) {
        mij = (st+dr) / 2;
        if (hasOnes(st+1, mij)) {
            dr = mij;
        }
        else {
            st = mij;
        }
    }
    return dr;
}

vector<int> guessOnes(int n, int k)
{
    vector<int> ans;
    int st = 0;
    while (k--) {
        int funnyLen = min(1.0d, ((double)(n-st) * BULAN_MULT + BULAN_ADD) / k);
        int dr = min(n, st+funnyLen);
        while (!hasOnes(st+1, dr)) {
            dr = min(n, dr+funnyLen);
        }
        ans.push_back(binSearch(st, dr));
        st = ans.back();
    }
    return ans;
}
