#include "ones.h"
#include <iostream>
#include <random>
#include <chrono>

using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const double bulanMinMult = 1.2d;
const double bulanMaxMult = 1.7d;
const double bulanMinAdd = -5.0;
const double bulanMaxAdd = 5.0;

const double binMinMult = 0.05d;
const double binMaxMult = 0.08d;
const double binMinAdd = -2.0;
const double binMaxAdd = 2.0;

double randInRange(double a, double b)
{
    unsigned int rngVal = rng();
    return a + (double)(rngVal) / (double)(0xffffffff) * (b-a);
}

int getFunnyNumber(int n, int k)
{
    double amogus = ((double)(n)) / k;
    double funny = amogus * randInRange(bulanMinMult, bulanMaxMult) + randInRange(bulanMinAdd, bulanMaxAdd);
    return max(1, int(funny));
}

int getBinSearchMid(int st, int dr)
{
    double fuzzyLen = (dr-st) * randInRange(binMinMult, binMaxMult);
    double absoluteMid = ((double)(st+dr)) / 2.0d;
    double fuzzyMid = randInRange(absoluteMid - fuzzyLen / 2.0, absoluteMid + fuzzyLen / 2.0) + randInRange(binMinAdd, binMaxAdd);
    return max(st+1, min(dr, int(fuzzyMid)));
}

int binSearch(int st, int dr)
{
    /// ( ]
    int mij;
    while (dr-st > 1) {
        mij = getBinSearchMid(st, dr);
        if (hasOnes(st+1, mij)) {
            dr = mij;
        }
        else {
            st = mij;
        }
    }
    return dr;
}

vector<int> guessOnes(int n, int k)
{
    vector<int> ans;
    int st = 0;
    while (k) {
        int dr = min(n, st + getFunnyNumber(n-st, k));
        while (!hasOnes(st+1, dr)) {
            dr = min(n, dr + getFunnyNumber(n-st, k));
        }
        ans.push_back(binSearch(st, dr));
        st = ans.back();
        k--;
    }
    return ans;
}
