#include <bits/stdc++.h>
#pragma GCC target ("avx2")

using namespace std;

const int mod = 1e8 + 543;

int n, q, v[200002];
pair<int, int>p[200002];
struct vec5 {
  int v[5];
  vec5() {
    memset(v, 0, sizeof(v));
  }
  vec5 operator + (const vec5 &b) const {
    vec5 a;
    for (int i = 0; i < 5; i++) {
      a.v[i] = (v[i] + b.v[i]);
      if (a.v[i] >= mod) a.v[i] -= mod;
      if (a.v[i] < 0) a.v[i] += mod;
    }
    return a;
  }
} S0, N0, aux[200002];

struct mat55 {
  int v[5][5];
  mat55() {
    memset(v, 0, sizeof(v));
  }
  mat55 operator * (const mat55 &b) const {
    mat55 a;
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        for (int k = 0; k < 5; k++) {
          a.v[i][j] = (a.v[i][j] + 1ll * v[i][k] * b.v[k][j] % mod);
          if (a.v[i][j] >= mod) a.v[i][j] -= mod;
          if (a.v[i][j] < 0) a.v[i][j] += mod;
        }
    return a;
  }
  bool operator != (const mat55 &b) const {
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        if (v[i][j] != b.v[i][j])
          return 1;
    return 0;
  }
} I5, mat, rev;

vec5 operator * (const vec5 &a, const mat55 &b)  {
  vec5 c;
  for (int j = 0; j < 5; j++)
    for (int k = 0; k < 5; k++) {
      c.v[j] = (c.v[j] + 1ll * a.v[k] * b.v[k][j] % mod); 
      if (c.v[j] >= mod) c.v[j] -= mod;
      if (c.v[j] < 0) c.v[j] += mod;
    }
  return c;
}

mat55 logpow (mat55 mat, int x) {
  mat55 p = I5;
  while (x) {
    if (x & 1) {
      p = p * mat;
    }
    mat = mat * mat;
    x /= 2;
  }
  return p;
}
vec5 calc (int x) {
  if (x >= 0)
    return S0*logpow(mat, x);
  else
    return S0*logpow(rev, -x);
}


struct Aint {

  vector<vec5>aint;
  vector<mat55>lazy;
  vector<bool>fraer;
  Aint (int n) : aint(4 * n + 2), lazy(4 * n + 2), fraer(4 * n + 2) {
    for (int i = 1; i <= 4*n; i++)
      lazy[i] = I5;
  }
  void push (int nod, int st, int dr) {
    if (fraer[nod]) {
      aint[nod] = aint[nod] * lazy[nod];
      if (st != dr) {
          lazy[2 * nod] = lazy[2 * nod] * lazy[nod];
        lazy[2 * nod + 1] = lazy[2 * nod + 1] * lazy[nod];
        fraer[2 * nod] = fraer[2 * nod + 1] = 1;
      }
      lazy[nod] = I5;
      fraer[nod] = 0;
    }
  }
  void build (vec5 *v, int nod = 1, int st = 1, int dr = n) {
    if (st == dr) {
      aint[nod] = *(v + st);
      return;
    }
    int mid = (st + dr) / 2;
    build(v, 2 * nod, st, mid);
    build(v, 2 * nod + 1, mid + 1, dr);
    aint[nod] = aint[2 * nod] + aint[2 * nod + 1];
  }
  void update (int a, int b, mat55 &val, int nod = 1, int st = 1, int dr = n) {
    push(nod, st, dr);
    if (a > b || b < st || a > dr)
      return;
    if (a <= st && dr <= b) {
      aint[nod] = aint[nod] * val;
      if (st != dr) {
        lazy[2 * nod] = lazy[2 * nod] * val;
        lazy[2 * nod + 1] = lazy[2 * nod + 1] * val;
        fraer[2 * nod] = fraer[2 * nod + 1] = 1;
      }
      return;
    }
    int mid = (st + dr) / 2;
    update(a, b, val, 2 * nod, st, mid);
    update(a, b, val, 2 * nod + 1, mid + 1, dr);
    aint[nod] = aint[2 * nod] + aint[2 * nod + 1];
  }
  vec5 query (int a, int b, int nod = 1,int st = 1, int dr = n) {
    push(nod, st, dr);
    if (a > b || b < st || a > dr)
      return N0;
    if (a <= st && dr <= b) {
      return aint[nod];
    }
    int mid = (st + dr) / 2;
    if (b <= mid)
      return query(a, b, 2 * nod, st, mid);
    else if (a > mid)
      return query(a, b, 2 * nod + 1, mid + 1, dr);
    else
      return query(a, b, 2 * nod, st, mid) + query(a, b, 2 * nod + 1, mid + 1, dr);
  }
};



int main () 
{
  ios_base::sync_with_stdio(false);
  cin.tie(0); cout.tie(0);
  for (int i = 0; i < 5; i++) {
    S0.v[i] = i;
    I5.v[i][i] = 1;
  }
  for (int i = 0; i < 4; i++)
    mat.v[i + 1][i] = 1;
  for (int i = 0; i < 5; i++)
    mat.v[i][4] = i + 1;
  // for (int k = 1; k <= 10; k++) {
  //   auto x = logpow(mat, k);
  //   for (int i = 0; i < 5; i++, cout << "\n")
  //     for (int j = 0; j < 5; j++)
  //       cout << x.v[i][j] << " ";
  //     cout << "\n\n";
  // }
  rev.v[0][0] = -2;
  rev.v[1][0] = -3;
  rev.v[2][0] = -4;
  rev.v[3][0] = -5;
  rev.v[4][0] = 1;
  for (int i = 0; i < 4; i++)
    rev.v[i][i + 1] = 1;
  cin >> n >> q;
  for (int i = 1; i <= n; i++) {
    int x;
    cin >> x;
    v[i] = x;
    p[i] = {x + 4, i};
  }
  sort(p + 1, p + n + 1);
  int j = 1;
  long long a = 0, b = 1, c = 2, d = 3, e = 4, f;
  for (int i = 4; i <= mod + 10; i++) {
    vec5 idk;
    idk.v[0] = a;
    idk.v[1] = b;
    idk.v[2] = c;
    idk.v[3] = d;
    idk.v[4] = e;
    while (j <= n && p[j].first == i) {
      aux[p[j].second] = idk;
      j++;
    }
    f = 5*e + 4 * d + 3 * c + 2 * b + a;
    f %= mod;
    a = b;
    b = c;
    c = d;
    d = e;
    e = f;
  }
  Aint pom(n);
  pom.build(aux);
  for (int i = 1; i <= q; i++) {
    int t=1;
    cin >> t;
    if (t == 1) {
      int l, r;
      cin >> l >> r;
     // l = (1ll * rand() * rand() + rand()) % n +1;
      //r = (1ll * rand() * rand() + rand()) % n + 1;
      //if (l > r) swap(l, r);
      cout << (pom.query(l, r).v[0]) << "\n";
    }
    else {
      int l, r, val;
      cin >> l >> r >> val;
      mat55 aux = (val > 0 ? logpow(mat, val) : logpow(rev, -val));
      pom.update(l, r, aux);
    }
  }
  return 0;
}