#include <bits/stdc++.h>

using namespace std;

const int mod = 1e8 + 543;

int n, q, maxA;
vector <int> v, elem;
int rec[6][6];

void copyMatrix(int a[][6], int b[][6])
{
    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
            a[i][j] = b[i][j];
}

void multiply(int a[][6], int b[][6])
{
    int c[6][6];
    for(int i = 1; i <= 5; i ++)
    {
        for(int j = 1; j <= 5; j ++)
        {
            c[i][j] = 0;
            for(int k = 1; k <= 5; k ++)
                c[i][j] += a[i][k] * b[k][j];
        }
    }

    copyMatrix(a, c);
}

void afis(int a[][6])
{
    for(int i = 1; i <= 5; i ++)
    {
        for(int j = 1; j <= 5; j ++)
            cout << a[i][j] << " ";
        cout << "\n";
    }
    cout << "\n";
}

void init(int a[][6])
{
    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
    {
        if(i == j)
            a[i][j] = 1;
        else
            a[i][j] = 0;
    }
}

int logPow(int exp, int ans[][6])
{
    int base[6][6];
    init(ans); copyMatrix(base, rec);
    while(exp)
    {
//        afis(ans);
        if(exp & 1)
            multiply(ans, base);
//        afis(ans);
//        afis(base);
        multiply(base, base);
        exp /= 2;
    }
}

int findNthElem(int x)
{
    if(x < 5)
        return x;
    if(x < maxA)
        return elem[x];
    int a[6][6];
    logPow(x - 4, a);
//    afis(a);
    int nr = 0;
    for(int i = 1; i <= 5; i ++)
        nr += (5 - i) * a[i][1];
    return nr;
}

class SegmentTree
{
    vector <int> t;
public :
    SegmentTree (int n)
    {
        t.resize(4 * n + 1);
    }

    void build(int v, int l, int r, vector <int> a)
    {
        if(l == r)
        {
            t[v] = elem[a[l]];
            return;
        }
        int m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m + 1, r, a);
        t[v] = t[2 * v] + t[2 * v + 1];
    }

    int query(int v, int l, int r, int tl, int tr)
    {
        if(tl > tr)
        {
            return 0;// cred?
        }
        if(l == tl  &&  tr == r)
            return t[v];
        int m = (l + r) / 2;
        return query(2 * v, l, m, tl, min(tr, m)) + query(2 * v + 1, m + 1, r, max(m + 1, tl), tr);
    }

    void update(int v, int l, int r, int pos, int val)
    {
        if(l == r)
        {
            t[v] = val;
            return;
        }

        int m = (l + r) / 2;
        if(pos <= m)
            update(2 * v, l, m, pos, val);
        else
            update(2 * v + 1, m + 1, r, pos, val);
        t[v] = t[2 * v] + t[2 * v + 1];// treb si asta nu ?
    }
};

int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);

//    freopen(".in", "r", stdin);
//    freopen(".out", "w", stdout);

    cin >> n >> q;
    v.resize(n + 1);

    for(int i = 1; i <= 5; i ++)
        for(int j = 1; j <= 5; j ++)
           rec[i][j] = 0;

    rec[1][1] = 5; rec[1][2] = 1;
    rec[2][1] = 4; rec[2][3] = 1;
    rec[3][1] = 3; rec[3][4] = 1;
    rec[4][1] = 2; rec[4][5] = 1;
    rec[5][1] = 1;

    // sa nu uit sa adaug modul in aint
//    int maxA = 0;
    for(int i = 1; i <= n; i ++)
    {
        cin >> v[i];
        maxA = max(maxA, v[i]);
//        elem[i] = findNthElem(v[i]);
//        cout << v[i] << " " << elem[i] << " a\n";
    }

    elem.resize(maxA + 1);
//    cout << maxA << " f\n";
    for(int i = 1; i <= 4; i ++)
        elem[i] = i;
    for(int i = 5; i <= maxA; i ++)
    {
        elem[i] = 5 * elem[i - 1];
        elem[i] %= mod;
        elem[i] += 4 * elem[i - 2];
        elem[i] %= mod;
        elem[i] += 3 * elem[i - 3];
        elem[i] %= mod;
        elem[i] += 2 * elem[i - 4];
        elem[i] %= mod;
        elem[i] += elem[i - 5];
        elem[i] %= mod;
    }

//    for(int i = 1; i <= n; i ++)
//    {
//        cout << elem[v[i]] << "\n";
//    }


    SegmentTree aint(n);
    aint.build(1, 1, n, v);

    for(int i = 1; i <= q; i ++)
    {
        int type, l, r;
        cin >> type >> l >> r;
        if(type == 1)
        {
            cout << aint.query(1, 1, n, l, r) << "\n";
        }
        else
        {
            int value;
            cin >> value;
            v[l] += value;
            int x = findNthElem(v[l]);
//            cout << value << " " << v[l] << " " << x << "\n";
            aint.update(1, 1, n, l, x);
        }
    }

    return 0;
}
