#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;

int cnt_tests; double time_limit;

void init (int _cnt_tests, double _time_limit) {
    cnt_tests = _cnt_tests; time_limit = _time_limit;
}

double timePassed ();

int N, M;
vector <vector <int>> P;
vector <vector <int>> Q;

bool inside (int i, int j) {
    return (0 <= i && i < N && 0 <= j && j < M);
}
const int dx[] = {-1, 0, +1, 0};
const int dy[] = {0, +1, 0, -1};

int f (int d, int cnt) {
    if (d & 1) {
        return (cnt == 1 ? HOR_SINGLE : HOR_DOUBLE);
    } else {
        return (cnt == 1 ? VERT_SINGLE : VERT_DOUBLE);
    }
}

void DFS (int x, int y) {
    Q[x][y] = 1;
    for (int d = 0; d < 4; d++) {
        int xd = x + dx[d], yd = y + dy[d];
        if (inside(xd, yd) == true && P[xd][yd] != 0 && Q[xd][yd] == 0) {
            DFS(xd, yd);
        }
    }
}

bool bkt (int x = 0, int y = 0) {
//        cerr << "";
    if (x == N) {
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < M; j++) {
                if (Q[i][j] > 0) {
                    return false;
                }
            }
        }
        int flag = 0;
        for (int i = 0; i < N && flag != 2; i++) {
            for (int j = 0; j < M; j++) {
                if (P[i][j] != 0 && Q[i][j] == 0) {
                    if (flag == 0) {
                        DFS(i, j);
                        flag = 1;
                    } else {
                        flag = 2; break;
                    }
                }
            }
        }
        if (flag < 2) {
            return true;
        }
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < M; j++) {
                Q[i][j] = 0;
            }
        }
        return false;
    }
    int x1 = x, y1 = y + 1;
    if (y1 == M) {
        x1++; y1 = 0;
    }
    if (P[x][y] <= 0) {
        return bkt(x1, y1);
    }
    int fx[4], fy[4];
    vector <int> vx[4], vy[4];
    for (int d = 0; d < 4; d++) {
        fx[d] = x + dx[d], fy[d] = y + dy[d];
        while (inside(fx[d], fy[d]) == true
               && P[fx[d]][fy[d]] == 0) {
            vx[d].push_back(fx[d]);
            vy[d].push_back(fy[d]);
            fx[d] += dx[d]; fy[d] += dy[d];
        }
        if (inside(fx[d], fy[d]) == false
            || P[fx[d]][fy[d]] < 0) {
            fx[d] = fy[d] = -1;
        }
    }
    int cd[4];
    for (int cd0 : {0, 1, 2}) {
        if (cd0 > (fx[0] == -1 ? 0 : Q[fx[0]][fy[0]])) {
            continue;
        }
        cd[0] = cd0;
        for (int cd1 : {0, 1, 2}) {
            if (cd[1] > (fx[1] == -1 ? 0 : Q[fx[1]][fy[1]])) {
                continue;
            }
            cd[1] = cd1;
            for (int cd2 : {0, 1, 2}) {
                if (cd2 > (fx[2] == -1 ? 0 : Q[fx[2]][fy[2]])) {
                    continue;
                }
                cd[2] = cd2;
                cd[3] = Q[x][y] - cd[0] - cd[1] - cd[2];
                if (cd[3] < 0 || cd[3] > 2
                    || cd[3] > (fx[3] == -1 ? 0 : Q[fx[3]][fy[3]])) {
                    continue;
                }
                for (int d = 0; d < 4; d++) {
                    if (cd[d] == 0) {
                        continue;
                    }
                    for (int i = 0; i < (int) vx[d].size(); i++) {
                        P[vx[d][i]][vy[d][i]] = f(d, cd[d]);
                    }
                    Q[x][y] -= cd[d];
                    Q[fx[d]][fy[d]] -= cd[d];
                }
                if (bkt(x1, y1) == true) {
                    return true;
                }
                for (int d = 0; d < 4; d++) {
                    if (cd[d] == 0) {
                        continue;
                    }
                    for (int i = 0; i < (int) vx[d].size(); i++) {
                        P[vx[d][i]][vy[d][i]] = 0;
                    }
                    Q[x][y] += cd[d];
                    Q[fx[d]][fy[d]] += cd[d];
                }
            }
        }
    }
}

bool solve (vector <vector <int>> &puzzle) {
    P = puzzle; Q = P;
    N = (int) P.size(); M = (int) P[0].size();
    if (bkt() == true) {
        puzzle = P;
        return true;
    } else {
        return false;
    }
}
