#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;

int cnt_tests; double time_limit;

void init (int _cnt_tests, double _time_limit) {
    cnt_tests = _cnt_tests; time_limit = _time_limit;
}

double timePassed ();

int N, M;
vector <vector <int>> P;
vector <vector <int>> Q;
vector <vector <int>> deg;

bool inside (int i, int j) {
    return (0 <= i && i < N && 0 <= j && j < M);
}
const int dx[] = {-1, 0, +1, 0};
const int dy[] = {0, +1, 0, -1};

int f (int d, int cnt) {
    if (d & 1) {
        return (cnt == 1 ? HOR_SINGLE : HOR_DOUBLE);
    } else {
        return (cnt == 1 ? VERT_SINGLE : VERT_DOUBLE);
    }
}

void dfs (int x, int y) {
    Q[x][y] = 1;
    for (int d = 0; d < 4; d++) {
        int xd = x + dx[d], yd = y + dy[d];
        if (inside(xd, yd) == true && P[xd][yd] != 0 && Q[xd][yd] == 0) {
            dfs(xd, yd);
        }
    }
}

vector <pair <int, int>> order;

void print () {
    for (const std::vector<int>& row : P)
    {
        for (int elem : row)
        {
            if (elem > 0 && elem <= 8) std::cerr << elem;
            else if (elem == EMPTY) std::cerr << " ";
            else if (elem == HOR_SINGLE) std::cerr << "-";
            else if (elem == HOR_DOUBLE) std::cerr << "=";
            else if (elem == VERT_SINGLE) std::cerr << "|";
            else if (elem == VERT_DOUBLE) std::cerr << "$";
            else std::cerr << "?";
        }
        std::cerr << std::endl;
    }
    std::cerr << "\n\n\n";
}

bool bkt (int curr) {
    int x, y; tie(x, y) = order[curr];
//    print();
    if (curr == (int) order.size()) {
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < M; j++) {
                if (Q[i][j] > 0) {
                    return false;
                }
            }
        }
        int flag = 0;
        for (int i = 0; i < N && flag != 2; i++) {
            for (int j = 0; j < M; j++) {
                if (P[i][j] != 0 && Q[i][j] == 0) {
                    if (flag == 0) {
                        dfs(i, j);
                        flag = 1;
                    } else {
                        flag = 2; break;
                    }
                }
            }
        }
        if (flag < 2) {
            return true;
        }
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < M; j++) {
                Q[i][j] = 0;
            }
        }
        return false;
    }
    if (P[x][y] <= 0 || Q[x][y] == 0) {
        return bkt(curr + 1);
    }
    int fx[4], fy[4];
    for (int d = 0; d < 4; d++) {
        fx[d] = x + dx[d], fy[d] = y + dy[d];
        while (inside(fx[d], fy[d]) == true
               && P[fx[d]][fy[d]] == 0) {
            fx[d] += dx[d]; fy[d] += dy[d];
        }
        if (inside(fx[d], fy[d]) == false
            || P[fx[d]][fy[d]] < 0) {
            fx[d] = fy[d] = -1;
        }
    }
    int cd[4]; cd[0] = 0; cd[3] = 0;
    vector <int> v = {0, 1, 2};
    random_shuffle(v.begin(), v.end());
    for (int cd1 : v) {
        if (cd1 > (fx[1] == -1 ? 0 : Q[fx[1]][fy[1]])) {
            continue;
        }
        cd[1] = cd1;
        cd[2] = Q[x][y] - cd[1];
        if (cd[2] < 0 || cd[2] > 2
            || cd[2] > (fx[2] == -1 ? 0 : Q[fx[2]][fy[2]])) {
            continue;
        }
        bool ok = true;
        for (int d = 1; d < 3; d++) {
            if (cd[d] == 0) {
                continue;
            }
            int i = x + dx[d], j = y + dy[d];
            while (P[i][j] == 0) {
                P[i][j] = f(d, cd[d]);
                i += dx[d]; j += dy[d];
            }
            Q[x][y] -= cd[d];
            Q[fx[d]][fy[d]] -= cd[d];
            deg[fx[d]][fy[d]]--;
            if (Q[fx[d]][fy[d]] > deg[fx[d]][fy[d]] * 2) {
                ok = false;
            }
        }
        if (ok == true && bkt(curr + 1) == true) {
            return true;
        }
        for (int d = 1; d < 3; d++) {
            if (cd[d] == 0) {
                continue;
            }
            int i = x + dx[d], j = y + dy[d];
            while (P[i][j] < 0) {
                P[i][j] = 0;
                i += dx[d]; j += dy[d];
            }
            Q[x][y] += cd[d];
            Q[fx[d]][fy[d]] += cd[d];
            deg[fx[d]][fy[d]]++;
        }
    }
    return false;
}

bool solve (vector <vector <int>> &puzzle) {
    P = puzzle; Q = P;
    N = (int) P.size(); M = (int) P[0].size();
    order.clear();
    deg = vector <vector <int>> (N, vector <int> (M));
        for (int j = 0; j < M; j++) {
    for (int i = 0; i < N; i++) {
            if (P[i][j] > 0) {
                order.push_back({i, j});
                deg[i][j] = 0;
                for (int d = 0; d < 4; d++) {
                    int x = i + dx[d], y = j + dy[d];
                    while (inside(x, y) == true && P[x][y] == 0) {
                        x += dx[d]; y += dy[d];
                    }
                    if (inside(x, y) == true && P[x][y] > 0) {
                        deg[i][j]++;
                    }
                }
            }
        }
    }
    mt19937 rnd(time(0));
//    shuffle(order.begin(), order.end(), rnd);
    if (bkt(0) == true) {
        puzzle = P;
        return true;
    } else {
        return false;
    }
}
