#include "ones.h"
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

int query(int l, int r) {
    // cerr << l + 1 << ' ' << r + 1 << '\n';
    return hasOnes(l, r);
}

vector<int> sol;

auto cmp = [](pii a, pii b) { return a.second - a.first < b.second - b.first; };

priority_queue<pii, vector<pii>, decltype(cmp)> st(cmp);
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

int optimal_mid(int l, int r, int k) { 
	if(r - l <= 2) return l + r >> 1;
	double T = 1./(double(k));
	return min(r, max(l, (int)round((double)l * T + (double)r * (1. - T))));
}

void divide(int l, int r, int& k) {
	auto push = [&](int a, int b) {
		st.emplace(a, b);
		// cerr << '\t' << '\t' << a << ' ' << b << '\n';
	};
	
	auto cycle = [&]() {
		auto [l, r] = st.top();
		st.pop();
		if(l == r) {
			// cerr << "ADAUG " << l << ' ' << r << '\n';
			sol.emplace_back(l);
			k--;
			return;
		}
		int mid = l + r >> 1, a = l, b = mid, c = mid + 1, d = r;
		// cerr << '\t' << a << ' ' << b << ", " << c << ' ' << d << '\n';
		if(rng() % 2) swap(a, c), swap(b, d);
		bool T;
		if((T = query(a, b))) push(a, b);
		if(!T || (sz(st) < k && query(c, d))) push(c, d);
		return;
	};
	
	function<void(int)> do_cycle = [&](int turns) -> void {
		if(sz(st) == 0 || turns <= 0) return;
		if(k == 0) return;
		if(sz(st) == k) { cycle(); do_cycle(turns); return; }
		cycle();
		do_cycle(turns - 1);
	};
	
    int B = (r - l + 1 + k - 1) / k;
    for(int i = l; i <= r; i += B) {
        int a = i, b = min(r, i + B - 1);
        if(query(a, b)) push(a, b);
        if(sz(st) >= (int)ceil((double)k - (double)floor(sqrt(k))))
				do_cycle(50);
    }
	
	do_cycle(1000000);
	
	return;
}

std::vector<int> guessOnes(int n,int k) {
    sol.clear();
    divide(1, n, k);
    sort(all(sol));
    return sol;
}
