#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int mod = 1e8 + 543;
struct Mint {
	int x;
	Mint(ll y): x(y) {;}
	Mint operator +(const Mint& a) const { return Mint(x + a.x >= mod? x + a.x - mod : x + a.x); }
	Mint operator -(const Mint& a) const { return Mint(x - a.x < 0? x - a.x + mod : x - a.x); }
	Mint operator *(const Mint& a) const { return Mint((ll)x * a.x % mod); }
	Mint operator +=(const Mint& a) { return *this = *this + a; }
	Mint operator -=(const Mint& a) { return *this = *this - a; }
	Mint operator *=(const Mint& a) { return *this = *this * a; }
};

struct Matrix {
	vector<vector<Mint>> mat;
	int n, m;
	void init(int n_, int m_, int a = 0) {
		n = n_;
		m = m_;
		mat.assign(n, vector<Mint>(m, 0));
		if(a) {
			for(int i = 0; i < n; i++)
				mat[i][i] = a;
		}
	}
	Matrix operator * (const Matrix& x) const {
		Matrix rez;
		rez.init(n, x.m);
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m; j++) {
				for(int h = 0; h < x.m; h++) {
					rez.mat[i][h] += mat[i][j] * x.mat[j][h];
				}
			}
		}
		return rez;
	}
	Matrix operator + (const Matrix& x) const {
		Matrix rez;
		rez.init(n, m);
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m; j++)
				rez.mat[i][j] += mat[i][j] + x.mat[i][j];
		}
		return rez;
	}
};

Matrix A, Ainv;

Matrix expplus[50], expminus[50];

void printMat(Matrix& X) {	
	// cerr << X.n << ", " << X.m << ":\n";
	// for(int i = 0; i < X.n; i++)
		// for(int j = 0; j < X.m; j++)
			// cerr << X.mat[i][j].x << " \n"[j == X.m - 1];	
}

Matrix raiseTo(int x) {
	if(x > 0) {
		Matrix rez;
		rez.init(5, 5, 1);
		for(int i = 30; i >= 0; i--) {
			if((1 << i) & x) {
				rez = rez * expplus[i];
			}
		}
		return rez;
	}
	if(x <= 0) {
		x = -x;
		Matrix rez;
		rez.init(5, 5, 1);
		for(int i = 30; i >= 0; i--) {
			if((1 << i) & x) rez = rez * expminus[i];
		}
		return rez;
	}
	return A;
}

const int nmax = 1e5 + 5;
#define array yastoboimyebati

Matrix array[nmax];

signed main() {
	cin.tie(0) -> sync_with_stdio(0);
	
	{
		A.init(5, 5);
		Ainv.init(5, 5);
		for(int i = 0; i < 4; i++) Ainv.mat[i][i + 1] = 1;
		for(int i = 1; i < 5; i++) A.mat[i][i - 1] = 1;
		for(int i = 0; i < 4; i++) Ainv.mat[i][0] = -i - 2;
		Ainv.mat[4][0] = 1;
		for(int i = 0; i < 5; i++) A.mat[i][4] = i + 1;
		
		expplus[0] = A;
		for(int i = 1; i < 31; i++)
			expplus[i] = expplus[i - 1] * expplus[i - 1];
			
		expminus[0] = Ainv;
		for(int i = 1; i < 31; i++)
			expminus[i] = expminus[i - 1] * expminus[i - 1];
	}
	
	int n, q;
	cin >> n >> q;
	for(int i = 1; i <= n; i++) {
		array[i].init(1, 5);
		for(int j = 0; j < 5; j++) array[i].mat[0][j] = j;
		
		int x;
		cin >> x;
		array[i] = array[i] * raiseTo(x - 4);
	}
	
	exit(0);
	
	for(int tc = 1; tc <= q; tc++) {
		int type;
		cin >> type;
		if(type == 1) {
			int l, r;
			cin >> l >> r;
			Mint rez = 0;
			for(int i = l; i <= r; i++) rez = rez + array[i].mat[0][4];
			cout << rez.x << '\n';
		}
		else {
			int l, r, x;
			cin >> l >> r >> x;
			Matrix tmp = raiseTo(x);
			
			for(int i = l; i <= r; i++) array[i] = array[i] * tmp;
		}
	}
	 
}
