#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int mod = 1e8 + 543;

struct Matrix {
    ll mat[5][5];
    int n = 0, m = 0;
    void init(int n_, int m_, int a = 0) {
        n = n_;
        m = m_;
        for(int i = 0; i < n; i++) for(int j = 0; j < 5; j++) mat[i][j] = 0;
        if(a) {
            for(int i = 0; i < n; i++)
                mat[i][i] = a;
        }
    }
    Matrix operator * (const Matrix& x) const {
        Matrix rez;
        rez.init(n, x.m);
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++) {
                for(int h = 0; h < x.m; h++) {
                    rez.mat[i][h] += mat[i][j] * x.mat[j][h];
                }
            }
        }
		  for(int i = 0; i < n; i++)
				for(int j = 0; j < x.m; j++) {
					rez.mat[i][j] = rez.mat[i][j] % mod;
				}
				
        return rez;
    }
    Matrix operator + (const Matrix& x) const {
        Matrix rez;
        rez.init(n, m);
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++)
                rez.mat[i][j] = mat[i][j] + x.mat[i][j],
                rez.mat[i][j] = (rez.mat[i][j] >= mod? rez.mat[i][j] - mod : rez.mat[i][j]);
        }
        return rez;
    }
    // void tenure() { 
		 // for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) mat[i][j].tenure();
    // }
};

Matrix A, Ainv;

Matrix expplus[65], expminus[65];

void printMat(Matrix& X) {	
    for(int i = 0; i < X.n; i++)
        for(int j = 0; j < X.m; j++)
            cerr << X.mat[i][j] << " \n"[j == X.m - 1];	
}

// #define int ll
void raiseTo(Matrix& target, ll x) {
    if(x > 0) {
        for(int i = 26; i >= 0; i--) {
            if((1ll << i) & x)
                target = target * expplus[i];
        }
        return;
    }
    if(x <= 0) {
        x = -x;
        for(int i = 26; i >= 0; i--) {
            if((1ll << i) & x) target = target * expminus[i];
        }
        return;
    }
    return;
}
// #undef int

const int nmax = 1e5 + 5;
#define array yastoboimyebati

Matrix array[nmax];

#define int ll
struct Node {
    Matrix col;
    ll lazy;
    Node() { col.init(1, 5); lazy = 0; }
    void apply(ll a) {
        raiseTo(col, a);
        lazy = (lazy + a) % (mod - 1);
    }
    void push(Node& a, Node& b) {
        if(lazy == 0) return;
        a.apply(lazy);
        b.apply(lazy);
        lazy = 0;
        return;
    }
    void pull(Node& a, Node& b) {
        col = a.col + b.col;
    }
};
#undef int

template<typename Node>
struct Aint {	
    vector<Node> aint;
    int n;
    void init(int n_)	 {
        n = n_;
        aint.assign(n * 2 + 5, Node());
    }
    template<class CB> void walk(CB&& cb) { walk(cb, 1, n); }
    template<class CB> void walk(CB&& cb, int l, int r) { walk(cb, l, r, 1, 1, n); }
    template<class CB> void walk(CB&& cb, int l, int r, int node, int cl, int cr) {
        if(cr < l || r < cl) return;
        if(l <= cl && cr <= r && !cb(aint[node], cl, cr)) return;
        int mid = (cl + cr) >> 1, L = node + 1, R = node + (mid - cl + 1) * 2;
        aint[node].push(aint[L], aint[R]);
        walk(cb, l, r, L, cl, mid);
        walk(cb, l, r, R, mid + 1, cr);
        aint[node].pull(aint[L], aint[R]);
        
        return;
    }
};

signed main() {
    cin.tie(0) -> sync_with_stdio(0);
    
    {
        A.init(5, 5);
        Ainv.init(5, 5);
        for(int i = 0; i < 4; i++) Ainv.mat[i][i + 1] = 1;
        for(int i = 1; i < 5; i++) A.mat[i][i - 1] = 1;
        for(int i = 0; i < 4; i++) Ainv.mat[i][0] = mod - i - 2;
        Ainv.mat[4][0] = 1;
        for(int i = 0; i < 5; i++) A.mat[i][4] = i + 1;
        
        expplus[0] = A;
        for(int i = 1; i < 61; i++)
            expplus[i] = expplus[i - 1] * expplus[i - 1];
            // expplus[i].tenure();
            
        expminus[0] = Ainv;
        for(int i = 1; i < 61; i++)
            expminus[i] = expminus[i - 1] * expminus[i - 1];
            // expplus[i - 1].tenure();
    }
    
    int n, q;
    cin >> n >> q;
    Aint<Node> aint;
    aint.init(n);
    aint.walk([&](Node& a, int cl, int cr) {
        if(cl != cr) return 1;
        int x;
        cin >> x;
        for(int i = 0; i < 5; i++) a.col.mat[0][i] = i;
        a.apply(x - 4);
        // printMat(a.col);
        return 0;
    });
    
    // exit(0);
    
    for(int tc = 1; tc <= q; tc++) {
        int type;
        cin >> type;
        if(type == 1) {
            int l, r;
            cin >> l >> r;
            ll rez = 0;
            aint.walk([&](Node& a, int cl, int cr) {
                rez += a.col.mat[0][4];
                return 0;
            }, l, r);
            cout << rez % mod << '\n';
        }
        else {
            int l, r, x;
            cin >> l >> r >> x;
            aint.walk([&](Node& a, int cl, int cr) {
                a.apply(x);
                return 0;
            }, l, r);
        }
    }
     
}
