// #ifndef DLOCAL
	// #pragma GCC optimize("O3,fast-math,unroll-loops")
	// #pragma GCC target("avx,avx2,sse3,sse4")
// #endif
#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll
#define sz(x) ((int)(x).size())

using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int mod = 1e8 + 543;

struct Matrix {
    ll mat[5][5];
    int n = 0, m = 0;
    void init(int n_, int m_, int a = 0) {
        n = n_;
        m = m_;
        for(int i = 0; i < n; i++) for(int j = 0; j < 5; j++) mat[i][j] = 0;
        if(a) {
            for(int i = 0; i < n; i++)
                mat[i][i] = a;
        }
    }
    Matrix operator * (const Matrix& x) const {
        Matrix rez;
        rez.init(n, x.m);
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++) {
                for(int h = 0; h < x.m; h++) {
                    rez.mat[i][h] += mat[i][j] * x.mat[j][h];
                }
            }
        }
          for(int i = 0; i < n; i++)
                for(int j = 0; j < x.m; j++) {
                    rez.mat[i][j] = rez.mat[i][j] % mod;
                }
                
        return rez;
    }
    Matrix operator + (const Matrix& x) const {
        Matrix rez;
        rez.init(n, m);
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < m; j++)
                rez.mat[i][j] = mat[i][j] + x.mat[i][j],
                rez.mat[i][j] = (rez.mat[i][j] >= mod? rez.mat[i][j] - mod : rez.mat[i][j]);
        }
        return rez;
    }
    // void tenure() { 
         // for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) mat[i][j].tenure();
    // }
};

struct Unit {
    ll v[5];
    Unit() { fill(v, v + 5, 0); }
};
static inline Unit operator * (const Unit& x, const Matrix& y) {
    Unit a;
    for(int j = 0; j < 5; j++)
        for(int h = 0; h < 5; h++)
            a.v[h] += x.v[j] * y.mat[j][h];
    for(int i = 0; i < 5; i++)
        a.v[i] = a.v[i] % mod;
    return a;
}
static inline Unit operator + (const Unit& x, const Unit& y) {
    Unit a;
    for(int h = 0; h < 5; h++)
        a.v[h] = x.v[h] + y.v[h],
        a.v[h] = a.v[h] >= mod? a.v[h] - mod : a.v[h];
    return a;
}

Matrix A, Ainv;

const int B = 10500;

Matrix expplus[65], expminus[65];
Matrix batch[B];
Matrix bigbatch[B];

// void printMat(Matrix& X) {	
    // for(int i = 0; i < X.n; i++)
        // for(int j = 0; j < X.m; j++)
            // cerr << X.mat[i][j] << " \n"[j == X.m - 1];	
// }

// #define int ll
void raiseTo(Unit& target, int x) {
	target = (target * batch[x % B]) * bigbatch[x / B];
    return;
}
// #undef int

const int nmax = 1e5 + 5;

// #define int ll
struct Node {
    Unit col;
    int lazy;
    Node() { lazy = 0; }
    void apply(int a) {
        raiseTo(col, a);
        lazy = lazy + a >= mod - 1? lazy + a - mod + 1 : lazy + a;
    }
    void push(Node& a, Node& b) {
        if(lazy == 0) return;
        a.apply(lazy);
        b.apply(lazy);
        lazy = 0;
        return;
    }
    void pull(Node& a, Node& b) {
        col = a.col + b.col;
    }
};
// #undef int

template<typename Node>
struct Aint {	
    vector<Node> aint;
    int n;
    void init(int n_)	 {
        n = n_;
        aint.assign(n * 2 + 5, Node());
    }
    template<class CB> void walk(CB&& cb) { walk(cb, 1, n); }
    template<class CB> void walk(CB&& cb, int l, int r) { walk(cb, l, r, 1, 1, n); }
    template<class CB> void walk(CB&& cb, int l, int r, int node, int cl, int cr) {
        if(cr < l || r < cl) return;
        if(l <= cl && cr <= r && !cb(aint[node], cl, cr)) return;
        int mid = (cl + cr) >> 1, L = node + 1, R = node + (mid - cl + 1) * 2;
        aint[node].push(aint[L], aint[R]);
        walk(cb, l, r, L, cl, mid);
        walk(cb, l, r, R, mid + 1, cr);
        aint[node].pull(aint[L], aint[R]);
        
        return;
    }
};

  ll rez[5][5];
  
void start_the() {
  A.n = 5;
  A.m = 5;
  for(int i = 1; i < 5; i++) A.mat[i][i - 1] = 1;
  for(int i = 0; i < 5; i++) A.mat[i][4] = i + 1;
  
  batch[0].n = 5;
  batch[0].m = 5;
  for(int i = 0; i < 5; i++) batch[0].mat[i][i] = 1;
  for(int i = 1; i < B; i++) batch[i] = batch[i - 1] * A;
  
  bigbatch[1] = batch[B - 1];
  bigbatch[1] = batch[B - 1] * A;
  
  bigbatch[0].init(5, 5, 1);
  
  for(int i = 0; i < 5; i++)
	for(int j = 0; j < 5; j++)
		expplus[0].mat[i][j] = rez[i][j] % mod;
  
  for(int i = 1; i < B; i++) bigbatch[i] = bigbatch[i - 1] * bigbatch[1];
}

signed main() {
    
    start_the();
    cin.tie(0) -> sync_with_stdio(0);
    
    int n, q;
    cin >> n >> q;
    Aint<Node> aint;
    aint.init(n);
    aint.walk([&](Node& a, int cl, int cr) {
        if(cl != cr) return 1;
        int x;
        cin >> x;
        for(int i = 0; i < 5; i++) a.col.v[i] = i;
        a.apply((2 * mod - 2 + x - 4) % (mod - 1));
        // printMat(a.col);
        return 0;
    });
    
    // exit(0);
    
    vector<int> REZ;
    // int cnt = 0;
    
    for(int tc = 1; tc <= q; tc++) {
        int type;
        cin >> type;
        if(tc % 10000 == 0) {
			 aint.walk([&](Node& a, int cl, int cr) {
				  if(cl != cr) return 1;
				  return 0;
			});
		  }
        if(type == 1) {
            int l, r;
            cin >> l >> r;
            ll rez = 0;
            aint.walk([&](Node& a, int cl, int cr) {
                rez += a.col.v[4];
                return 0;
            }, l, r);
            REZ.emplace_back(rez % mod);
        }
        else {
            int l, r, x;
            cin >> l >> r >> x;
            x = (x + 2 * mod - 2) % (mod - 1);
            aint.walk([&](Node& a, int cl, int cr) {
                a.apply(x);
                return 0;
            }, l, r);
        }
    }
     
}
