#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;
ifstream cin("a.in");
ofstream cout("a.out");
int a[100005];
long long mod=10e8+543;
int mat[60][7][7];
int invs[60][7][7];
void afis(vector<int>vec)
{
  for(int i=0;i<vec.size();i++)
  {
    cout<<vec[i]%mod<<" ";
  }
  cout<<'\n';
}
vector<int>rez;
vector<int> mlt(vector<int>vec,int pwer)
{
  int i,j;
  long long sum;
  rez.clear();
  for(i=1;i<=5;i++)
  {
    sum=0;
    for(j=1;j<=5;j++)
    {
        sum+=1ll*vec[j-1]*mat[pwer][i][j];
    }
    rez.push_back((sum+mod*mod)%mod);
  }
  return rez;
}
vector<int> mlt2(vector<int>vec,int pwer)
{
  int i,j;
  long long sum;
  rez.clear();
  for(i=1;i<=5;i++)
  {
    sum=0;
    for(j=1;j<=5;j++)
    {
        sum+=1ll*vec[j-1]*invs[pwer][i][j];
    }
    rez.push_back((sum+mod*mod)%mod);
    // cout<<sum<<" ";
  }
  return rez;
}
void multiply(int pw)
{
  int i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*mat[pw-1][i][z]*mat[pw-1][z][j];
         }
         sum%=mod;
         mat[pw][i][j]=sum;
      }
  }
}
void multiply2(int pw)
{
  int i,j,z;
  long long sum;
  for(i=1;i<=5;i++)
  {
      for(j=1;j<=5;j++)
      {
         sum=0;
         for(z=1;z<=5;z++)
         {
           sum+=1ll*invs[pw-1][i][z]*invs[pw-1][z][j];
         }
         sum%=mod;
         invs[pw][i][j]=sum;
      }
  }
}
vector<int> sclar(vector<int>a,long long exp,int tip)
{
  int cnt=1;
  if(tip==1)
  {
    swap(a[0],a[4]);
    swap(a[1],a[3]);
    while(exp)
    {
      if(exp%2==1)
      {
        a=mlt(a,cnt);
      }
      cnt++;
      exp=exp/2;
    }
    swap(a[0],a[4]);
    swap(a[1],a[3]);
  }
  else
  {
    while(exp)
    {
      if(exp%2==1)
      {
        a=mlt2(a,cnt);
      }
      cnt++;
      exp=exp/2;
    }
  }
  return a;
}
long long lz[550005];
vector<int> coef[550005];
void build(int node,int st,int dr)
{
  if(st!=dr)
  {
    int mij=(st+dr)/2;
    build(node*2,st,mij);
    build(node*2+1,mij+1,dr);
    for(int i=0;i<=4;i++)
    {
      coef[node].push_back((coef[node*2][i]+coef[node*2+1][i])%mod);
    }
    return;
  }
  for(int i=0;i<=4;i++)
  {
    coef[node].push_back(i);
  }
}
void push_lazy(int node,int st,int dr)
{
  if(lz[node]!=0)
  {
    if(lz[node]>0)
      coef[node]=sclar(coef[node],lz[node],1);
    else
      coef[node]=sclar(coef[node],abs(lz[node]),-1);
    if(st!=dr)
    {
      lz[node*2]+=lz[node];
      lz[node*2+1]+=lz[node];
    }
    lz[node]=0;
  }
}
void update(int node,int st,int dr,int qst,int qdr,int val)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return ;
  }
  if(qst<=st && dr<=qdr)
  {
    lz[node]=val;
    push_lazy(node,st,dr);
    return;
  }
  int mij=(st+dr)/2;
  update(node*2,st,mij,qst,qdr,val);
  update(node*2+1,mij+1,dr,qst,qdr,val);
  for(int i=0;i<=4;i++)
  {
    coef[node][i]=(1ll*coef[node*2][i]+coef[node*2+1][i])%mod;
  }
}
int qr(int node,int st,int dr,int qst,int qdr)
{
  push_lazy(node,st,dr);
  if(st>dr || st>qdr|| qst>dr ||qst>qdr)
  {
    return 0;
  }
  if(qst<=st && dr<=qdr)
  {
    return coef[node][0];
  }
  int mij=(st+dr)/2;
  return(qr(node*2,st,mij,qst,qdr)+qr(node*2+1,mij+1,dr,qst,qdr))%mod;
}
signed  main()
{
    int n,i,j,k,l,q;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>q;
    for(i=1;i<=5;i++)
    {
        mat[1][1][i]=6-i;
    }
    mat[1][2][1]=1;
    mat[1][3][2]=1;
    mat[1][4][3]=1;
    mat[1][5][4]=1;
    for(i=1;i<=5;i++)
    {
      invs[1][1][i]=mod-(i+1);
    }
    invs[1][1][5]=1;
    invs[1][2][1]=1;
    invs[1][3][2]=1;
    invs[1][4][3]=1;
    invs[1][5][4]=1;
    for(i=2;i<=30;i++)
    {
      multiply(i);
    }
    for(i=2;i<=50;i++)
    {
      multiply2(i);
    }
    build(1,1,n);
    for(i=1;i<=n;i++)
    {
      cin>>a[i];
      update(1,1,n,i,i,a[i]);
    }
    int tip,r;
    int x;
    for(i=1;i<=q;i++)
    {
      cin>>tip;
      if(tip==2)
      {
        cin>>l>>r>>x;
        update(1,1,n,l,r,x);
      }
      else
      {
        cin>>l>>r;
        cout<<qr(1,1,n,l,r)%mod<<'\n';
      }
    }
    return 0;
}
