#include "ones.h"
#include <iostream>
#include <time.h>
#include <random>

#define vt vector
#define pb push_back

using namespace std;

mt19937 rng(time(0));

int gen(int l, int r){
    return (rng() % (r - l + 1)) + l;
}

int find_first(int l, int r){
    int st = l, dr = r, ans = -1;
    while(st <= dr){
        int mid = (st + dr) / 2;
        if(hasOnes(l, mid)){
            ans = mid;
            dr = mid - 1;
        }else{
            st = mid + 1;
        }
    }
    return ans;
}

vt <int> attempt1(int n, int k){
    vt <int> ans;
    int last = 0;
    for(int i = 1; i <= k; i++){
        ans.pb(find_first(last + 1, n));
        last = ans.back();
    }
    return ans;
}

vt <int> attempt2(int n, int k){
    vt <int> split;
    for(int i = 1; i <= k; i++){
        split.pb((i * n) / k);
    }

    split.pb(n + 1);

    vt <int> ans;
    int last = 0;
    for(int i = 0; i < k; i++){
        int x = find_first(split[i], split[i + 1] - 1);
        if(x == -1){
            x = find_first(last + 1, split[i]);
        }
        last = x;
        ans.pb(x);
    }

    if(ans.size() < k){
        exit(69);
    }
    return ans;
}

vector<int> guessOnes(int n,int k){
    //return attempt1(n, k);
    return attempt2(n, k);

}

/*
10 2 1
6 9
*/
