#include "ones.h"
#include <iostream>
#include <time.h>
#include <random>
#include <algorithm>

#define vt vector
#define pb push_back

using namespace std;

mt19937 rng(time(0));

int gen(int l, int r){
    return (rng() % (r - l + 1)) + l;
}

int find_first(int l, int r){
    int st = l, dr = r, ans = -1;
    while(st <= dr){
        int mid = (st + dr) / 2;
        if(hasOnes(l, mid)){
            ans = mid;
            dr = mid - 1;
        }else{
            st = mid + 1;
        }
    }
    return ans;
}

vt <int> attempt1(int n, int k){
    vt <int> ans;
    int last = 0;
    for(int i = 1; i <= k; i++){
        ans.pb(find_first(last + 1, n));
        last = ans.back();
    }
    return ans;
}

const int EPS = 400;

vt <int> attempt2(int n, int k){
    vt <int> split;
    for(int i = 1; i <= k; i++){
        split.pb((i * n) / k);
    }

    split.pb(n + 1);

    vt <int> ans;

    for(int i = 0; i < k; i++){
        int l = max(1, split[i] - EPS);
        if((int)ans.size() > 0){
            l = max(l, ans.back() + 1);
        }
        int r = min(n, split[i] + EPS);
        if(l <= r){
            int x = find_first(l, r);
            if(x != -1){
                ans.pb(x);
            }
        }
    }

    sort(ans.begin(), ans.end());
    int last = 0;
    vt <int> more;
    for(int i = 0; i < ans.size(); i++){
        while(last + 1 <= ans[i] - 1 && hasOnes(last + 1, ans[i] - 1)){
            int x = find_first(last + 1, ans[i] - 1);
            more.pb(x);
            //cout << "?? " << x << endl;
            last = x;
        }
        last = max(last, ans[i]);
    }
    while(last + 1 <= n && hasOnes(last + 1, n)){
        int x = find_first(last + 1, n);
        more.pb(x);
        //cout << "?? " << x << endl;
        last = x;
    }

    for(int x : more){
        ans.pb(x);
    }
    sort(ans.begin(), ans.end());

    return ans;
}

vector<int> guessOnes(int n,int k){
    //return attempt1(n, k);
    return attempt2(n, k);

}

/*
10 2 1
6 9

100000 10 1
1 34 567 1000 10000 23456 67890 89034 95467 98888
*/
