#include <iostream>
#include <vector>
#include <chrono>
#include <time.h>

//#pragma GCC optimize("Ofast")
//#pragma GCC optmiize("unroll-loops")

using ll = long long;

//#define int __int128
//#define int long long // poate strica tot!!!!!!
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector
#define sz(x) (x).size()

#define vvt vt <vt <int>>

using namespace std;

const int NMAX = 1e5;
const int MOD = 1e8 + 543;

int a[NMAX + 1];

vvt A;
vvt invA;
vvt I;
vvt O;

vvt mult(vvt X, vvt Y){
    vvt Z = O;
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            for(int k = 0; k < 5; k++){
                (Z[i][j] += (1ll * X[i][k] * Y[k][j]) % MOD) %= MOD;
            }
        }
    }
    return Z;
}

vvt fast_exp(int exp){
    if(exp == 0){
        return I;
    }

    vvt aux = A;
    vvt ans = I;

    if(exp < 0){
        exp = -exp;
        aux = invA;
    }

    while(exp > 0){
        if(exp & 1){
            ans = mult(ans, aux);
        }
        aux = mult(aux, aux);
        exp >>= 1;
    }
    return ans;
}

vvt sum(vvt X, vvt Y){
    vvt Z = O;
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            Z[i][j] = (1ll * X[i][j] + Y[i][j]) % MOD;
        }
    }
    return Z;
}

int get_ans(vvt X){
    int ans = 0;
    for(int i = 1; i <= 5; i++){
        (ans += (1ll * X[i - 1][4] * (i - 1)) % MOD) %= MOD;
    }
    return ans;
}

namespace AINT{
    vvt aint[4 * NMAX + 1];
    int lazy[NMAX + 1];

    void build(int node, int l, int r){
        lazy[node] = 0;
        if(l == r){
            aint[node] = fast_exp(a[l] - 4);
            return;
        }

        int mid = (l + r) / 2;
        build(2 * node, l, mid);
        build(2 * node + 1, mid + 1, r);
        aint[node] = sum(aint[2 * node], aint[2 * node + 1]);
    }

    void propag(int node, int l, int r){
        aint[node] = mult(aint[node], fast_exp(lazy[node]));
        if(l < r){
            lazy[2 * node] += lazy[node];
            lazy[2 * node + 1] += lazy[node];
        }
        lazy[node] = 0;
    }

    void update(int node, int l, int r, int ql, int qr, int val){
        propag(node, l, r);

        if(ql <= l && r <= qr){
            lazy[node] += val;
            propag(node, l, r);
            return;
        }

        int mid = (l + r) / 2;
        if(ql <= mid){
            update(2 * node, l, mid, ql, qr, val);
        }
        if(mid + 1 <= qr){
            update(2 * node + 1, mid + 1, r, ql, qr, val);
        }

        propag(2 * node, l, mid);
        propag(2 * node + 1, mid + 1, r);
        aint[node] = sum(aint[2 * node], aint[2 * node + 1]);
    }

    vvt query(int node, int l, int r, int ql, int qr){
        propag(node, l, r);

        if(ql <= l && r <= qr){
            return aint[node];
        }

        int mid = (l + r) / 2;
        vvt ans = O;

        if(ql <= mid){
            ans = sum(ans, query(2 * node, l, mid, ql, qr));
        }
        if(mid + 1 <= qr){
            ans = sum(ans, query(2 * node + 1, mid + 1, r, ql, qr));
        }

        return ans;
    }
}

signed main(){

    int n, q;
    cin >> n >> q;

    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }

    O = vector <vt <int>> (5, vt <int> (5, 0));
    A = O;
    invA = O;
    I = O;

    A[0] = {0, 0, 0, 0, 1};
    A[1] = {1, 0, 0, 0, 2};
    A[2] = {0, 1, 0, 0, 3};
    A[3] = {0, 0, 1, 0, 4};
    A[4] = {0, 0, 0, 1, 5};

    invA[0] = {-2, 1, 0, 0, 0};
    invA[1] = {-3, 0, 1, 0, 0};
    invA[2] = {-4, 0, 0, 1, 0};
    invA[3] = {-5, 0, 0, 0, 1};
    invA[4] = {+1, 0, 0, 0, 0};

    I[0] = {1, 0, 0, 0, 0};
    I[1] = {0, 1, 0, 0, 0};
    I[2] = {0, 0, 1, 0, 0};
    I[3] = {0, 0, 0, 1, 0};
    I[4] = {0, 0, 0, 0, 1};

    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            invA[i][j] = (invA[i][j] + MOD) % MOD;
        }
    }

    AINT::build(1, 1, n);

    /*vvt Z = mult(A, A);
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            cout << Z[i][j] << ' ';
        }
        cout << endl;
    }
    Z = fast_exp(1);
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            cout << Z[i][j] << ' ';
        }
        cout << endl;
    }

    x[0] = 0, x[1] = 1, x[2] = 2, x[3] = 3, x[4] = 4;
    for(int i = 5; i <= 100; i++){
        x[i] = 5 * x[i - 1] + 4 * x[i - 2] + 3 * x[i - 3] + 2 * x[i - 4] + x[i - 5];
    }



    cout << get_ans(fast_exp(5)) << ' ' << x[9] << endl;
    cout << get_ans(fast_exp(-6)) << ' ' << x[9] << endl;

    //return 0;*/

    while(q--){
        int type;
        cin >> type;

        if(type == 1){
            int l, r;
            cin >> l >> r;
            vvt X = AINT::query(1, 1, n, l, r);
            cout << (get_ans(X) + MOD) % MOD << '\n'; /// la negative poate crapa???
        }else{
            int l, r, val;
            cin >> l >> r >> val;
            AINT::update(1, 1, n, l, r, val);
        }
    }

    return 0;
}
/// add modulo!!!

/*
1 5
1
1 1 1
2 1 1 -2
1 1 1
2 1 1 8
1 1 1

10 5
34 23 11 10 -6 34 23 11 10 -6
1 1 1
2 1 1 -2
1 1 1
2 1 1 8
1 1 1


*/
