#include <iostream>
#include <vector>
#include <chrono>
#include <time.h>
#include <algorithm>

//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")

using ll = long long;

//#define int __int128
//#define int long long // poate strica tot!!!!!!
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector
#define sz(x) (x).size()

#define vvt vector <vector <int>>

using namespace std;

const int NMAX = 1e5;
const int MOD = 1e8 + 543;

int a[NMAX + 1];

vector <vector <int>> A;
vector <vector <int>> invA;
vector <vector <int>> I;
vector <vector <int>> zero;

vector <vector <int>> mult(vector <vector <int>> X, vector <vector <int>> Y){
    vector <vector <int>> Z = zero;
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            for(int k = 0; k < 5; k++){
                Z[i][j] += (1ll * X[i][k] * Y[k][j]) % MOD;
                if(Z[i][j] > MOD){
                    Z[i][j] -= MOD;
                }
            }
        }
    }
    return Z;
}

vector <vector <int>> fast_exp(int exp){
    if(exp == 0){
        return I;
    }

    vector <vector <int>> aux = A;
    vector <vector <int>> ans = I;

    if(exp < 0){
        exp = -exp;
        aux = invA;
    }

    while(exp > 0){
        if(exp & 1){
            ans = mult(ans, aux);
        }
        aux = mult(aux, aux);
        exp >>= 1;
    }
    return ans;
}

vector <vector <int>> sum(vector <vector <int>> X, vector <vector <int>> Y){
    vector <vector <int>> Z = zero;
    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            Z[i][j] = X[i][j] + Y[i][j];
            if(Z[i][j] > MOD){
                Z[i][j] -= MOD;
            }
        }
    }
    return Z;
}

int get_ans(vt <int> Y, vector <vector <int>> X){
    int ans = 0;
    for(int i = 1; i <= 5; i++){
        ans += (1ll * X[i - 1][4] * Y[i - 1]) % MOD;
        if(ans > MOD){
            ans -= MOD;
        }
    }
    return ans;
}

vt <ll> pers[NMAX + 1];

namespace AINT{
    vector <vector <int>> aint[4 * NMAX + 1];
    vvt lazy[4 * NMAX + 1];

    void build(int node, int l, int r){
        lazy[node] = I;
        if(l == r){
            aint[node] = zero;
            for(int i = 0; i < 5; i++){
                aint[node][0][i] = pers[l][i];
            }
            return;
        }

        int mid = (l + r) / 2;
        build(2 * node, l, mid);
        build(2 * node + 1, mid + 1, r);
        aint[node] = sum(aint[2 * node], aint[2 * node + 1]);
    }

    void propag(int node, int l, int r){
        aint[node] = mult(aint[node], lazy[node]);
        if(l < r){
            lazy[2 * node] = mult(lazy[2 * node], lazy[node]);
            lazy[2 * node + 1] = mult(lazy[2 * node + 1], lazy[node]);
        }
        lazy[node] = I;
    }

    void update(int node, int l, int r, int ql, int qr, vvt val){
        propag(node, l, r);

        if(ql <= l && r <= qr){
            lazy[node] = mult(lazy[node], val);
            propag(node, l, r);
            return;
        }

        int mid = (l + r) / 2;
        if(ql <= mid){
            update(2 * node, l, mid, ql, qr, val);
        }
        if(mid + 1 <= qr){
            update(2 * node + 1, mid + 1, r, ql, qr, val);
        }

        propag(2 * node, l, mid);
        propag(2 * node + 1, mid + 1, r);
        aint[node] = sum(aint[2 * node], aint[2 * node + 1]);
    }

    vector <vector <int>> query(int node, int l, int r, int ql, int qr){
        propag(node, l, r);

        if(ql <= l && r <= qr){
            return aint[node];
        }

        int mid = (l + r) / 2;
        vector <vector <int>> ans = zero;

        if(ql <= mid){
            ans = sum(ans, query(2 * node, l, mid, ql, qr));
        }
        if(mid + 1 <= qr){
            ans = sum(ans, query(2 * node + 1, mid + 1, r, ql, qr));
        }

        return ans;
    }
}


signed main(){

    int n, q;
    cin >> n >> q;

    vt <pii> ppl;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
        ppl.pb({a[i], i});
    }
    sort(all(ppl));

    int ind = 4;
    vt <ll> aux = {0, 1, 2, 3, 4};
    vt <ll> new_aux(5, 0);
    for(int i = 0; i < n; i++){
        if(ppl[i].fr >= ind){
            while(ind < ppl[i].fr){
                new_aux[4] = (5 * aux[4] + 4 * aux[3] + 3 * aux[2] + 2 * aux[1] + 1 * aux[0]); // ovf?
                while(new_aux[4] > MOD){
                    new_aux[4] -= MOD;
                }
                new_aux[3] = aux[4];
                new_aux[2] = aux[3];
                new_aux[1] = aux[2];
                new_aux[0] = aux[1];
                aux = new_aux;
                ++ind;
            }
            pers[ppl[i].sc] = aux;
        }
    }

    aux = {0, 1, 2, 3, 4};
    new_aux = vt <ll> (5, 0);
    ind = 4;
    for(int i = n - 1; i >= 0; i--){
        if(ppl[i].fr <= ind){
            while(ppl[i].fr < ind){
                new_aux[0] = aux[4];
                new_aux[0] = (new_aux[0] - 5 * aux[4] - 4 * aux[3] - 3 * aux[2] - 2 * aux[1] - aux[0]) % MOD;
                new_aux[0] += MOD;
                if(new_aux[0] > MOD){
                    new_aux[0] -= MOD;
                }
                new_aux[1] = aux[0];
                new_aux[2] = aux[1];
                new_aux[3] = aux[2];
                new_aux[4] = aux[3];
                aux = new_aux;
                --ind;
            }
            pers[ppl[i].sc] = aux;
        }
    }

    return 0;

    zero = vector <vector <int>> (5, vector <int> (5, 0));
    A = vector <vector <int>> (5, vector <int> (5, 0));
    invA = vector <vector <int>> (5, vector <int> (5, 0));
    I = vector <vector <int>> (5, vector <int> (5, 0));


    A[0] = {0, 0, 0, 0, 1};
    A[1] = {1, 0, 0, 0, 2};
    A[2] = {0, 1, 0, 0, 3};
    A[3] = {0, 0, 1, 0, 4};
    A[4] = {0, 0, 0, 1, 5};

    invA[0] = {-2, 1, 0, 0, 0};
    invA[1] = {-3, 0, 1, 0, 0};
    invA[2] = {-4, 0, 0, 1, 0};
    invA[3] = {-5, 0, 0, 0, 1};
    invA[4] = {+1, 0, 0, 0, 0};

    I[0] = {1, 0, 0, 0, 0};
    I[1] = {0, 1, 0, 0, 0};
    I[2] = {0, 0, 1, 0, 0};
    I[3] = {0, 0, 0, 1, 0};
    I[4] = {0, 0, 0, 0, 1};


    for(int i = 0; i < 5; i++){
        for(int j = 0; j < 5; j++){
            invA[i][j] = (invA[i][j] + MOD) % MOD;
        }
    }
    AINT::build(1, 1, n);

    while(q--){
        int type;
        cin >> type;

        if(type == 1){
            int l, r;
            cin >> l >> r;
            //cout << 0 << '\n';
            vector <vector <int>> X = AINT::query(1, 1, n, l, r);
            cout << X[0][4] << '\n'; /// la negative poate crapa???
        }else{
            int l, r, val;
            cin >> l >> r >> val;
            AINT::update(1, 1, n, l, r, fast_exp(val));
        }
    }

    return 0;
}
/// add modulo!!!

/*
1 5
1
1 1 1
2 1 1 -2
1 1 1
2 1 1 8
1 1 1

20 5
34 23 11 10 -6 34 23 11 10 -6 34 23 11 10 -6 34 23 11 10 -6
1 1 10
1 2 17
2 1 1 -2
1 2 10
1 2 17
||=== Build: Debug in shumen_a (compiler: GNU GCC Compiler) ===|
C:\Users\KL6-PC15\Desktop\IATI 2022\shumen_a\main.cpp||In function 'int main()':|
C:\Users\KL6-PC15\Desktop\IATI 2022\shumen_a\main.cpp|204|error: cannot convert 'std::vector<long long int>' to '__gnu_cxx::__alloc_traits<std::allocator<int>, int>::value_type' {aka 'int'} in assignment|
C:\Users\KL6-PC15\Desktop\IATI 2022\shumen_a\main.cpp|210|error: redeclaration of 'int ind'|
C:\Users\KL6-PC15\Desktop\IATI 2022\shumen_a\main.cpp|187|note: 'int ind' previously declared here|
C:\Users\KL6-PC15\Desktop\IATI 2022\shumen_a\main.cpp|227|error: cannot convert 'std::vector<long long int>' to '__gnu_cxx::__alloc_traits<std::allocator<int>, int>::value_type' {aka 'int'} in assignment|
C:\Users\KL6-PC15\Desktop\IATI 2022\shumen_a\main.cpp|273|error: 'i' was not declared in this scope|
||=== Build failed: 4 error(s), 0 warning(s) (0 minute(s), 1 second(s)) ===|


*/
