//#pragma GCC optimize("O3", "unroll-loops")
#include <iostream>
#include <unordered_map>

using namespace std;

const int MOD = 1e8 + 543;

struct Mat {
    int v[5][5];

    Mat operator * (const Mat &other) const {
        Mat sol;
        for (int i = 0; i < 5; ++i) {
            for (int j = 0; j < 5; ++j) {
                sol.v[i][j] = 0;
                for (int k = 0; k < 5; ++k)
                    sol.v[i][j] = (sol.v[i][j] + 1ll * v[i][k] * other.v[k][j]) % MOD;
            }
        }
        return sol;
    }

    Mat operator + (const Mat &other) const {
        Mat sol;
        for (int i = 0; i < 5; ++i)
            for (int j = 0; j < 5; ++j)
                sol.v[i][j] = v[i][j] + other.v[i][j];
        return sol;
    }

    Mat operator *= (const Mat &other) {
        *this = *this * other;
        return *this;
    }

    int Val(int w[]) {
        return (v[0][0] * w[0] +\
                v[0][1] * w[1] +\
                v[0][2] * w[2] +\
                v[0][3] * w[3] +\
                v[0][4] * w[4]) % MOD;
    }

    int Val() {
        return (v[0][0] * 0 +\
                v[0][1] * 1 +\
                v[0][2] * 2 +\
                v[0][3] * 3 +\
                v[0][4] * 4) % MOD;
    }

    void Debug() {
        for (int i = 0; i < 5; ++i)
            for (int j = 0; j < 5; ++j)
                cout << v[i][j] << " \n"[j == 4];
    }
};

struct Vec {
    int v[5];

    Vec operator * (const Mat &other) const {
        Vec ans;
        for (int i = 0; i < 5; ++i) {
            ans.v[i] = 0;
            for (int j = 0; j < 5; ++j)
                ans.v[i] = (ans.v[i] + 1ll * v[j] * other.v[i][j]) % MOD;
        }
        return ans;
    }

    Vec operator *= (const Mat &other) {
        *this = *this * other;
        return *this;
    }

    Vec operator + (const Vec &other) const {
        Vec ans;
        for (int i = 0; i < 5; ++i)
            ans.v[i] = v[i] + other.v[i];
        return ans;
    }
};

const Vec Z = {{0, 1, 2, 3, 4}};


const Mat P = {{{0, 1, 0, 0, 0},\
                {0, 0, 1, 0, 0},\
                {0, 0, 0, 1, 0},\
                {0, 0, 0, 0, 1},\
                {1, 2, 3, 4, 5}}},\
          M = {{{MOD - 2, MOD - 3, MOD - 4, MOD - 5, 1},\
                {1, 0, 0, 0, 0},\
                {0, 1, 0, 0, 0},\
                {0, 0, 1, 0, 0},\
                {0, 0, 0, 1, 0}}},
          I = {{{1, 0, 0, 0, 0},\
                {0, 1, 0, 0, 0},\
                {0, 0, 1, 0, 0},\
                {0, 0, 0, 1, 0},\
                {0, 0, 0, 0, 1}}};

Mat LogPow(Mat b, int e) {
    Mat a(I);
    for (; e; e >>= 1, b *= b)
        if (e&1)
            a *= b;
    return a;
}

unordered_map < int, Mat > put;

Mat fMat(int val) {
    if (put.find(val) != put.end())
        return put[val];
    if (val >= 0)
        return put[val] = LogPow(P, val);
    else
        return put[val] = LogPow(M, -val);
}

const int N = 1e5 + 7, N2 = (1<<18) + 7;

int v[N];

int n, q;

namespace AI {
    ///nu cred ca e nevoie sa propag lazyul... nu-s sigur... ma pis pe ea de problema
    struct Nod {
        Vec suma;
        int lazy;

        Nod () : suma(Z), lazy(0) {}
    };

    Nod t[N2];

    int st, dr;

    void prop(int nod) { ///nu apelez din frunze, cred ca e ok
        t[nod * 2].suma *= fMat(t[nod].lazy);
        t[nod * 2].lazy += t[nod].lazy;
        t[nod * 2 + 1].suma *= fMat(t[nod].lazy);
        t[nod * 2 + 1].lazy += t[nod].lazy;
        t[nod].lazy = 0;
    }

    int suma(int nod = 1, int l = 1, int r = n) {
        if (st <= l && r <= dr)
            return t[nod].suma.v[0];
        prop(nod);
        int mij((l + r) / 2);
        int ans(0);
        if (st <= mij)
            ans += suma(nod * 2, l, mij);
        if (dr > mij)
            ans += suma(nod * 2 + 1, mij + 1, r);
        if (ans >= MOD)
            ans -= MOD;
        return ans;
    }

    int val;

    void mult(int nod = 1, int l = 1, int r = n) {
        if (st <= r && l <= dr) {
            t[nod].lazy += val;
            t[nod].suma *= fMat(val);
            return;
        }
        prop(nod);
        int mij((l + r) / 2);
        if (st <= mij)
            mult(nod * 2, l, mij);
        if (dr > mij)
            mult(nod * 2 + 1, mij + 1, dr);
        t[nod].suma = t[nod * 2].suma + t[nod * 2 + 1].suma; ///ups
    }

    int Suma(int mySt, int myDr) {
        st = mySt, dr = myDr;
        return suma();
    }

    void Mult(int myVal, int mySt, int myDr) {
        st = mySt, dr = myDr, val = myVal;
        mult();
    }

    void Debug() {
        cout << "valori:\n";
        for (int i = 1; i <= n; ++i)
            cout << Suma(i, i) << ' ';
        cout << "\n\n";
    }

    void init(int nod = 1, int l = 1, int r = n) {
        if (l == r) {
            t[nod].suma = Z * fMat(v[l]);
            return;
        }
        int mij((l + r) / 2);
        init(nod * 2, l, mij);
        init(nod * 2 + 1, mij + 1, r);
        t[nod].suma = t[nod * 2].suma + t[nod * 2 + 1].suma;
    }
}

//#define D

void solveNormal() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    AI::init();
    #ifdef D
    AI::Debug();
    #endif // D
    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        if (type == 2) {
            int val;
            cin >> val;
            AI::Mult(val, l, r);
        }
        else
            cout << AI::Suma(l, r) << '\n';
    }
}

void solveBesina() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 1; i <= q; ++i) {
        int type, l, r;
        cin >> type >> l >> r;
        if (type == 1)
            cout << fMat(v[l]).Val() << '\n';
        else {
            int val;
            cin >> val;
            v[l] += val;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) {
        cin >> v[i];
        #ifdef D
//        fMat(v[i]).Debug();
        #endif // D
//        AI::Mult(fMat(val), i, i); ///mi-e lene sa scriu initializare
    }
    solveBesina();
    return 0;
}
/**
3 5
1 -1 7
1 1 1
1 1 2
1 1 3
1 2 2
1 2 3

1 5
1
1 1 1
2 1 1 -2
1 1 1
2 1 1 8
1 1 1
*/
