#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;

double TIME_LIMIT;

void init(int numSubtests, double timeLimit)
{
    TIME_LIMIT = timeLimit;
}

int n,m;

struct edge
{
    int x1,y1,x2,y2;
};

bool cmp (edge A,edge B)
{
    if (A.x1 != B.x1)
        return A.x1 < B.x1;
    if (A.y1 != B.y1)
        return A.y1 < B.y1;
    return A.x2 < B.x2;
}

vector<pair<int,int>> islands;
vector<edge> edges;
vector<vector<int>> sol;
vector<vector<int>> puz;
vector<vector<int>> who;
vector<int>iau;
bool foundsol;

bool crossing(vector<edge>e)
{
    vector<edge>hor,ver;
    for (auto it : e)
    {
        if (it.x1 == it.x2)
            hor.push_back(it);
        else
            ver.push_back(it);
    }
    for (auto it1 : hor)
    {
        for (auto it2 : ver)
        {
            if (it1.x1 > it2.x1 and it1.x1 < it2.x2 and it1.y1 < it2.y1 and it1.y2 > it2.y1)
                return true;
        }
    }
    return false;
}

vector<int>t,sz;

int nrcc;

void join(int x,int y)
{
    while (x != t[x])
        x = t[x];
    while (y != t[y])
        y = t[y];
    if (x == y)
        return;
    nrcc--;
    if (sz[x] < sz[y])
        swap(x,y);
    t[y] = x;
    sz[x] += sz[y];
}

bool onecc(vector<edge> e)
{
    t.clear();
    sz.clear();
    t.resize(islands.size());
    sz.resize(islands.size());
    for (int i = 0; i < islands.size(); i++)
        t[i] = i,sz[i] = 1;
    nrcc = islands.size();
    for (auto it : e)
    {
        int isl1 = who[it.x1][it.y1],isl2 = who[it.x2][it.y2];
        join(isl1,isl2);
    }
    if (nrcc == 1)
        return true;
    return false;
}

vector<vector<int>> fr;

bool okdeg(vector<edge> e)
{
    fr.clear();
    fr.resize(n);
    for (int i = 0; i < n; i++)
        fr[i].resize(m);
    for (auto it : e)
    {
        fr[it.x1][it.y1]++;
        fr[it.x2][it.y2]++;
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (fr[i][j] != puz[i][j])
                return false;
    return true;
}

void try_sol(vector<edge> e)
{
    sort(e.begin(),e.end(),cmp);
    /*for (int i = 0; i < (int)e.size() - 1; i++)
        if (e[i].x1 == e[i + 1].x1 and e[i].x2 == e[i + 1].x2 and e[i].y1 == e[i + 1].y1 and e[i].y2 == e[i + 1].y2)
            cout << "yup" << endl;*/
    if (!onecc(e))
        return;
    if (!okdeg(e))
        return;
    foundsol = true;
    /*for (auto it : e)
    {
        cout << it.x1 << ' ' << it.y1 << ' ' << it.x2 << ' ' << it.y2 << endl;
    }
    cout << endl;*/
    sol.clear();
    sol.resize(n);
    for (int i = 0; i < n; i++)
    {
        sol[i].resize(m);
        for (int j = 0; j < m; j++)
        {
            if (puz[i][j] == 0)
                sol[i][j] = 0;
            else
                sol[i][j] = puz[i][j];
        }
    }
    for (auto it : e)
    {
        //cout << it.x1 << ' ' << it.y1 << ' ' << it.x2 << ' ' << it.y2 << endl;
        if (it.x1 == it.x2)
        {
            for (int j = it.y1 + 1; j <= it.y2 - 1; j++)
            {
                sol[it.x1][j]--;
                if (sol[it.x1][j] != -1)
                    sol[it.x1][j]--;
            }
        }
        else
        {
            for (int j = it.x1 + 1; j <= it.x2 - 1; j++)
            {
                sol[j][it.y1] -= 2;
            }
        }
    }
    /*for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            cout << sol[i][j] << ' ';
        cout << endl;
    }*/
}

void afis()
{
    vector<edge> cur_edges;
    for (int i = 0; i < edges.size(); i++)
        for (int j = 0; j < iau[i]; j++)
            cur_edges.push_back(edges[i]);
    try_sol(cur_edges);
}

bool inters(int pos)
{
    vector<edge>e;
    for (int i = 0; i < pos; i++)
        for (int j = 0; j < iau[i]; j++)
            e.push_back(edges[i]);
    if (crossing(e))
        return true;
    return false;
}

void bkt(int pos)
{
    if (foundsol)
        return;
    if (inters(pos))
        return;
    if (pos == edges.size())
        afis();
    else
    {
        iau[pos] = 1;
        bkt(pos + 1);
        iau[pos] = 2;
        bkt(pos + 1);
        iau[pos] = 0;
        bkt(pos + 1);
    }
}

bool solve(vector<vector<int>> &puzzle)
{
    who.clear();
    puz = puzzle;
    edges.clear();
    islands.clear();
    n = puzzle.size();
    m = puzzle[0].size();
    who.clear();
    who.resize(n);
    for (int i = 0; i < n; i++)
        who[i].resize(m);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (puzzle[i][j] != 0)
                islands.push_back({i,j}),who[i][j] = islands.size() - 1;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (puzzle[i][j] != 0)
            {
                for (int q = j + 1; q < m; q++)
                {
                    if (puzzle[i][q] != 0)
                    {
                        edge aux;
                        aux.x1 = aux.x2 = i;
                        aux.y1 = j;
                        aux.y2 = q;
                        edges.push_back(aux);
                        break;
                    }
                }
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
        {
            if (puzzle[i][j] != 0)
            {
                for (int q = i + 1; q < n; q++)
                {
                    if (puzzle[q][j] != 0)
                    {
                        edge aux;
                        aux.y1 = aux.y2 = j;
                        aux.x1 = i;
                        aux.x2 = q;
                        edges.push_back(aux);
                        break;
                    }
                }
            }
        }
    }
    iau.clear();
    foundsol = false;
    iau.resize(edges.size());
    bkt(0);
    /*for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < m; j++)
            cout << sol[i][j] << ' ';
        cout << '\n';
    }*/
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            puzzle[i][j] = sol[i][j];
    return true;
}
