#include <bits/stdc++.h>
#include "puzzle.h";

using namespace std;

using vi = vector<int>;
using ii = pair<int, int>;

double RealTL;
void init(int nrSubtest, double timeLimit) {
    RealTL = timeLimit / (nrSubtest + 1);

}
mt19937 rng(1);

struct DSU {
    int nrcomp;
    vi e;

    DSU(int n) : nrcomp(n), e(n, -1) {}

    int repr(int u) {
        while(e[u] >= 0) u = e[u];
        return u;
    }

    void join(int u, int v) {
        u = repr(u);
        v = repr(v);
        if(u == v) return;
        if(e[u] > e[v]) swap(u, v);
        e[u] += e[v];
        e[v] = u;
        --nrcomp;
    }
};

int greedy_solve(int n, int l, int c, vector<vi> &puzzle,
        vector<vi> L, vector<vi> Id, vector<ii> Coord, vi S) {
    vi Perm;
    for(int i = 0; i < n; ++i) Perm.push_back(i);
    shuffle(Perm.begin(), Perm.end(), rng);

    auto liber = [&](int p1, int p2) {
        auto [x1, y1] = Coord[p1];
        auto [x2, y2] = Coord[p2];
        if(x1 == x2) {
            for(int j = min(y1, y2) + 1; j < max(y1, y2); ++j)
                if(puzzle[x1][j]) return 0;
            return 1;
        }
        if(y1 == y2) {
            for(int i = min(x1, x2) + 1; i < max(x1, x2); ++i)
                if(puzzle[i][y1]) return 0;
            return 1;
        }
    };
    DSU Sol(n);

    auto drum = [&](int p1, int p2) {
        Sol.join(p1, p2);
        auto [x1, y1] = Coord[p1];
        auto [x2, y2] = Coord[p2];
        if(x1 == x2) {
            for(int j = min(y1, y2) + 1; j < max(y1, y2); ++j) {
                if(puzzle[x1][j]) puzzle[x1][j] -= 2;
                else puzzle[x1][j] = -1;
            }
        }
        if(y1 == y2) {
            for(int i = min(x1, x2) + 1; i < max(x1, x2); ++i) {
                if(puzzle[i][y1]) puzzle[i][y1] -= 2;
                else puzzle[i][y1] = -2;
            }
        }
    };


    for(auto u : Perm) {
        shuffle(L[u].begin(), L[u].end(), rng);
        vector<ii> Vec;
        for(auto v : L[u]) {
            if(liber(u, v) && S[u] && S[v]) {
                --S[u]; --S[v];
                drum(u, v);
                if(S[v])
                    Vec.push_back({S[v], v});
            }
        }
        if(S[u]) {
            sort(Vec.rbegin(), Vec.rend());
            for(auto [sv, v] : Vec) {
                if(S[u] && S[v]) {
                    --S[u]; --S[v];
                    drum(u, v);
                }
            }
        }
    }
    if(Sol.nrcomp != 1) return 0;
    for(auto it : S) if(it) return 0;
    return 1;
}

bool solve(vector<vi> &puzzle) {
    int n = 0, l = puzzle.size(), c = puzzle[0].size();
    vi S;
    vector<vi> Id(l, vi(c, -1));
    vector<ii> Coord;
    for(int i = 0; i < l; ++i) {
        for(int j = 0; j < c; ++j) {
            if(puzzle[i][j]) {
                Coord.push_back({i, j});
                Id[i][j] = n++;
                S.push_back(puzzle[i][j]);
            }
        }
    }
    vector<vi> L(n);
    for(int i = 0; i < l; ++i) {
        for(int j = 0; j < c; ++j) {
            if(puzzle[i][j]) {
                for(int i2 = i + 1; i2 < l; ++i2)
                    if(Id[i2][j] != -1 && i != i2) {
                        L[Id[i][j]].push_back(Id[i2][j]);
                        break;
                    }
                for(int i2 = i - 1; i2 >= 0; --i2)
                    if(Id[i2][j] != -1 && i != i2) {
                        L[Id[i][j]].push_back(Id[i2][j]);
                        break;
                    }
                for(int j2 = j + 1; j2 < c; ++j2)
                    if(Id[i][j2] != -1 && j2 != j) {
                        L[Id[i][j]].push_back(Id[i][j2]);
                        break;
                    }
                for(int j2 = j - 1; j2 >= 0; --j2)
                    if(Id[i][j2] != -1 && j2 != j) {
                        L[Id[i][j]].push_back(Id[i][j2]);
                        break;
                    }
            }
        }
    }
    double t0 = timePassed();
    bool ok = false;
    while(timePassed() - t0 < RealTL) {
        vector<vi> copiePuzzle = puzzle;
        if(greedy_solve(n, l, c, copiePuzzle, L, Id, Coord, S)) {
            puzzle = copiePuzzle;
            ok = true;
            break;
        }
    }
    return ok;
}
