#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5;
const int MOD = 1e8 + 543;

int a[NMAX];

struct matrix {
  int a[5][5];
  matrix (int n) {
    for (int i = 0; i < 5; i++) {
      for (int j = 0; j < 5; j++)
        a[i][j] = 0;
      a[i][i] = n;
    }
  }

  matrix() {}

  matrix (int b[5][5]) {
    for (int i = 0; i < 5; i++)
      for (int j = 0; j < 5; j++)
        a[i][j] = b[i][j];
  }
};

struct vect {
  int v[5];
};

matrix mult(matrix &a, matrix &b) {
  matrix c(0);
  long long s;
  for (int i = 0; i < 5; i++)
    for (int j = 0; j < 5; j++) {
      s = 0;
      for (int k = 0; k < 5; k++)
        s += (long long)a.a[i][k] * b.a[k][j];
      c.a[i][j] = s % MOD;
    }
  return c;
}

matrix lgput(matrix a, long long b) {
  matrix p(1);
  while (b) {
    if (b % 2)
      p = mult(p, a);
    a = mult(a, a);
    b /= 2;
  }
  return p;
}

int m[5][5] = {
  {5, 4, 3, 2, 1},
  {1, 0, 0, 0, 0},
  {0, 1, 0, 0, 0},
  {0, 0, 1, 0, 0},
  {0, 0, 0, 1, 0},
};
matrix M(m);

int mi[5][5] = {
  {0, 1, 0, 0, 0},
  {0, 0, 1, 0, 0},
  {0, 0, 0, 1, 0},
  {0, 0, 0, 0, 1},
  {1,-5,-4,-3,-2},
};
matrix MI(mi);

int v[5] = {4, 3, 2, 1, 0};
vect V;

const int LOGMAX = 44;

matrix PM[2][LOGMAX + 1];
void precalc() {
  matrix id(1);
  PM[0][0] = PM[1][0] = id;
  PM[0][1] = M;
  for (int i = 2; i <= LOGMAX; i++)
    PM[0][i] = mult(PM[0][i - 1], PM[0][i - 1]);
  PM[1][1] = MI;
  for (int i = 2; i <= LOGMAX; i++)
    PM[1][i] = mult(PM[1][i - 1], PM[1][i - 1]);
}

unordered_map<long long, matrix> pr;
matrix powmat(long long n) {
  if (n == 0)
    return PM[0][0];
  if (pr.find(n) != pr.end())
    return pr[n];
  int p = (n < 0), bit = 0;
  n = max(n, -n);
  while ((n & (1 << bit)) == 0)
    bit++;
  matrix ans = PM[p][bit + 1];
  n ^= (1 << bit);
  bit++;
  while (n) {
    if (n & (1 << bit)) {
      ans = mult(ans, PM[p][bit + 1]);
      n ^= (1 << bit);
    }
    bit++;
  }
  return (pr[n] = ans);
}

struct info {
  vect v;
  long long lazy;
};

info comb(info &a, info &b) {
  info c;
  c.lazy = 0;
  for (int i = 0; i < 5; i++)
    c.v.v[i] = (a.v.v[i] + b.v.v[i]) % MOD;
  return c;
}

vect mult(matrix &a, vect &v) {
  vect rez;
  for (int i = 0; i < 5; i++) {
    long long s = 0;
    for (int j = 0; j < 5; j++)
      s += (long long)a.a[i][j] * v.v[j];
    rez.v[i] = s % MOD;
  }

  return rez;
}

struct AINT {
  int n;
  info aint[2 * NMAX];

  void init(int _n) {
    n = _n;
  }

  void build(int node, int st, int dr) {
    if (st == dr) {
      matrix A = powmat(a[st] - 4);
      aint[node].v = mult(A, V);
      return;
    }
    int mij = (st + dr) / 2;
    build(node + 1, st, mij);
    build(node + 2 * (mij - st + 1), mij + 1, dr);

    aint[node] = comb(aint[node + 1], aint[node + 2 * (mij - st + 1)]);
  }

  void build(int n) {
    init(n);
    build(0, 0, n - 1);
  }

  void propag(int node, int st, int dr) {
    if (aint[node].lazy) {
      int mij = (st + dr) / 2;

      matrix A = powmat(aint[node].lazy);
      aint[node + 1].v = mult(A, aint[node + 1].v);
      aint[node + 1].lazy += aint[node].lazy;
      aint[node + 2 * (mij - st + 1)].v = mult(A, aint[node + 2 * (mij - st + 1)].v);
      aint[node + 2 * (mij - st + 1)].lazy += aint[node].lazy;
      aint[node].lazy = 0;
    }
  }

  void update(int node, int st, int dr, int a, int b, int val) {
    if (st == a && dr == b) {
      matrix A = powmat(val);
      aint[node].v = mult(A, aint[node].v);
      aint[node].lazy += val;
      return;
    }

    propag(node, st, dr);
    int mij = (st + dr) / 2;
    if (b <= mij)
      update(node + 1, st, mij, a, b, val);
    else if (a > mij)
      update(node + 2 * (mij - st + 1), mij + 1, dr, a, b, val);
    else {
      update(node + 1, st, mij, a, mij, val);
      update(node + 2 * (mij - st + 1), mij + 1, dr, mij + 1, b, val);
    }

    aint[node] = comb(aint[node + 1], aint[node + 2 * (mij - st + 1)]);
  }

  void update(int st, int dr, int val) {
    update(0, 0, n - 1, st, dr, val);
  }

  int query(int node, int st, int dr, int a, int b) {
    if (st == a && dr == b)
      return aint[node].v.v[0];

    propag(node, st, dr);
    int mij = (st + dr) / 2;
    if (b <= mij)
      return query(node + 1, st, mij, a, b);
    if (a > mij)
      return query(node + 2 * (mij - st + 1), mij + 1, dr, a, b);
    return (query(node + 1, st, mij, a, mij) + query(node + 2 * (mij - st + 1), mij + 1, dr, mij + 1, b)) % MOD;
  }

  int query(int l, int r) {
    return query(0, 0, n - 1, l, r);
  }

};

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);

  int n, q, tip, l, r, val;
  cin >> n >> q;
  for (int i = 0; i < n; i++)
    cin >> a[i];

  for (int i = 0; i < 5; i++)
    V.v[i] = v[i];

  precalc();

  AINT aint;

  aint.build(n);

  for (int i = 0; i < q; i++) {
    cin >> tip >> l >> r;
    l--, r--;
    if (tip == 1) { // query
      cout << (aint.query(l, r) + MOD) % MOD << '\n';
    } else { // update
      cin >> val;
      aint.update(l, r, val);
    }
  }


  /*

  matrix A = powmat(2);
  vect V1 = mult(M, V);

  for (int i = 0; i < 5; i++)
    for (int j = 0; j < 5; j++)
      cout << PM[1][1].a[i][j] << " \n"[j == 4];

  for (int i = 0; i < 5; i++)
    cout << V1.v[i] << " \n"[i == 4];
*/

  return 0;
}
