#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5;

const int VMAX = ( 1 << 18 );
const int MOD = 1e8 + 543;

struct vec {
    int v[5];
    vec() {
        for ( int i = 0; i < 5; i ++ ) v[i] = 0;
    }
};
struct mat {
    int a[5][5];

    mat( int diag = 0 ) {
        for ( int i = 0; i < 5; i ++ ) {
            for ( int j = 0; j < 5; j ++ ) {
                a[i][j] = 0;
            }
            a[i][i] = diag;
        }
    }
} ident(1);
mat rec;
vec recVec;
struct node {
    vec v;
    mat a;
} aint[VMAX + 1];

mat inmultMat( mat a, mat b ) {
    mat rez;
    for ( int i = 0; i < 5; i ++ ) {
        for ( int j = 0; j < 5; j ++ ) {
            for ( int k = 0; k < 5; k ++ ) {
                rez.a[i][j] = (rez.a[i][j] + (long long)a.a[i][k] * b.a[k][j]) % MOD;
            }
        }
    }
    return rez;
}
mat lgput( mat a, long long k ) {
    mat p( 1 );
    k %= MOD - 1;
    if ( k < 0 ) k += MOD - 1;
    while ( k > 0 ) {
        if ( k % 2 == 1 ) {
            p = inmultMat( p, a );
        }
        a = inmultMat( a, a );
        k /= 2;
    }
    return p;
}
vec addVec( vec a, vec b ) {
    vec v;
    for ( int i = 0; i < 5; i ++ ) {
        v.v[i] = (a.v[i] + b.v[i]) % MOD;
    }
    return v;
}
vec inmultVec( vec a, mat b ) {
    vec v;
    for ( int i = 0; i < 5; i ++ ) {
        for ( int j = 0; j < 5; j ++ ) {
            v.v[i] = ( v.v[i] + (long long)a.v[j] * b.a[j][i] ) % MOD;
        }
    }
    return v;
}
bool eq( mat a, mat b ) {
    for ( int i = 0; i < 5; i ++ ) {
        for ( int j = 0; j < 5; j ++ ) {
            if ( a.a[i][j] != b.a[i][j] ) return false;
        }
    }
    return true;
}
void propag( int i ) {
    if ( !eq( aint[i].a, ident ) ) {
        aint[i * 2 + 1].a = inmultMat( aint[i * 2 + 1].a, aint[i].a );
        aint[i * 2 + 2].a = inmultMat( aint[i * 2 + 2].a, aint[i].a );
        aint[i * 2 + 1].v = inmultVec( aint[i * 2 + 1].v, aint[i].a );
        aint[i * 2 + 2].v = inmultVec( aint[i * 2 + 2].v, aint[i].a );
        aint[i].a = ident;
    }
}

vec query( int st, int dr, int a, int b, int i = 0 ) {
    if ( st == a && dr == b ) {
        return aint[i].v;
    }
    propag( i );
    int mij = ( st + dr ) / 2;
    if ( b <= mij ) return query( st, mij, a, b, i * 2 + 1 );
    if ( a > mij ) return query( mij + 1, dr, a, b, i * 2 + 2 );
    vec v1 = query( st, mij, a, mij, i * 2 + 1 ), v2 = query( mij + 1, dr, mij + 1, b, i * 2 + 2 );
    for ( int i = 0; i < 5; i ++ ) v1.v[i] = (v1.v[i] + v2.v[i]) % MOD;
    return v1;
}
void update( int st, int dr, int a, int b, mat m, int i = 0 ) {
    if ( st == a && dr == b ) {
        aint[i].a = inmultMat( aint[i].a, m );
        aint[i].v = inmultVec( aint[i].v, m );
    } else {
        propag( i );
        int mij = ( st + dr ) / 2;
        if ( b <= mij ) update( st, mij, a, b, m, i * 2 + 1 );
        else if ( a > mij ) update( mij + 1, dr, a, b, m, i * 2 + 2 );
        else {
            update( st, mij, a, mij, m, i * 2 + 1 );
            update( mij + 1, dr, mij + 1, b, m, i * 2 + 2 );
        }
        for ( int j = 0; j < 5; j ++ ) {
            aint[i].v.v[j] = (aint[i * 2 + 1].v.v[j] + aint[i * 2 + 2].v.v[j]) % MOD;
        }
    }
}
void afis( mat x ) {
    for ( int i = 0; i < 5; i ++ ) {
        for ( int j = 0; j < 5; j ++ ) {
            cout << x.a[i][j] << ' ';
        }
        cout << endl;
    }
    cout << endl;
}

long long v[VMAX + 1];

mat put[30];

vec lgput2( vec a, long long k ) {
    k %= MOD - 1;
    if ( k < 0 ) k += MOD - 1;
    for ( int bit = 29; bit >= 0; bit -- ) {
        if ( k & ( 1 << bit ) ) {
            a = inmultVec( a, put[bit] );
        }
    }
    return a;
}

int brut( int x ) {
    int v[5] = { 0, 1, 2, 3, 4 };
    if ( x <= 4 ) {
        return v[x];
    }
    for ( int i = 4; i < x; i ++ ) {
        int nou = ((long long)v[4] * 5 + v[3] * 4 + v[2] * 3 + v[1] * 2 + v[0]) % MOD;
        v[0] = v[1];
        v[1] = v[2];
        v[2] = v[3];
        v[3] = v[4];
        v[4] = nou;
    }
    return v[4];
}

//struct query {
//    int tip;
//    int l;
//    int r;
//    int x;
//}  querys[QMAX + 1];

void build( int st, int dr, int i = 0 ) {
    if ( st == dr ) {
        aint[i].v = lgput2( recVec, v[st] - 4 );
        aint[i].a = ident;
    } else {
        int mij = ( st + dr ) / 2;
        build( st, mij, i * 2 + 1 );
        build( mij + 1, dr, i * 2 + 2 );
        aint[i].v = addVec( aint[i * 2 + 1].v, aint[i * 2 + 2].v );
        aint[i].a = ident;
    }
}
int main() {
    ios_base::sync_with_stdio( false );
    cin.tie( NULL );
    cout.tie( NULL );
    for ( int i = 0; i < 5; i ++ ) {
        for ( int j = 0; j < 5; j ++ ) {
            if ( j != 4 ) {
                rec.a[i][j] = (i == j + 1);
            } else {
                rec.a[i][j] = i + 1;
            }
        }
        recVec.v[i] = i;
    }
    put[0] = rec;
    for ( int i = 1; i < 30; i ++ ) {
        put[i] = inmultMat( put[i - 1], put[i - 1] );
    }

    int n, q;
    cin >> n >> q;
    for ( int i = 1; i <= n; i ++ ) cin >> v[i];

//    bool subtask2 = false;
//    for ( int i = 1; i <= q; i ++ ) {
//        cin >> querys[i].tip >> querys[i].l >> querys[i].r;
//        if ( tip == 2 )
//            cin >> querys[i].x;
//    }
//    for ( int i = 1; i <= q; i ++ ) {
//        cin >> querys[i].tip >> querys[i].l >> querys[i].r;
//        if ( tip == 1 ) {
//            long long ans = 0;
//            for ( int i = l; i <= r; i ++ ) {
//                ans += lgput2( recVec, v[i] - 4 ).v[4];
//            }
//            cout << ans << ' ' << brut( v[l] ) << '\n';
//        } else {
//            cin >> querys[i].x;
//            for ( int i = l; i <= r; i ++ ) v[i] += x;
//        }
//    }
    build( 1, n );
    while ( q-- ) {
        int tip, l, r, x;
        cin >> tip >> l >> r;
        if ( tip == 1 ) {
            auto ans = query( 1, n, l, r );
            cout << ans.v[4] << '\n';
        } else {
            cin >> x;
            mat inmult = lgput( rec, x );
            update( 1, n, l, r, inmult );
        }
    }
    return 0;
}