// Ignut

#include <bits/stdc++.h>
#include "puzzle.h"

using namespace std;
using ll = long long;
using ld = long double;

double timePassed();

void init(int numSubtests, double timeLimit) {
}

vector<vector<int>> pzl;

const int N = 100;
int n, m;

int a[N][N];
int p[N][N];

struct Point {
    int i, j;
};

// =============== checking ============================ //

bool used[N][N];
int cntGo = 0;

vector<pair<int, int>> d = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};

bool GoodPos(int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < m && !used[i][j] && (p[i][j] != 0 || pzl[i][j] > 0);
}

void dfs(int i, int j) {
    cntGo ++;
    used[i][j] = true;
    for (auto [di, dj] : d) {
        int ci = i + di, cj = j + dj;
        if (GoodPos(ci, cj)) {
            dfs(ci, cj);
        }
    }
}

struct DSU {
    int cntUnite = 0;
    vector<int> p, sz;
    void Init(int n) {
        cntUnite = 0;
        for (int i = 0; i < n; i ++) p.push_back(i), sz.push_back(1);
    }
    int Get(int v) {
        return p[v] == v ? v : p[v] = Get(p[v]);
    }
    void Unite(int u, int v) {
        u = Get(u), v = Get(v);
        if (u == v) return;
        cntUnite ++;
        if (sz[u] > sz[v]) swap(u, v);
        sz[v] += sz[u];
        p[u] = v;
    }
};

bool Check() {
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            if (pzl[i][j] >= 1 && p[i][j] != 0) return false;
            if (pzl[i][j] == 0 && p[i][j] >= 1) return false;
            if (pzl[i][j] == 0) continue;
            int sm = 0;
            if (i >= 1 && p[i - 1][j] == -3) sm ++;
            if (i >= 1 && p[i - 1][j] == -4) sm += 2;
            if (i + 1 < n && p[i + 1][j] == -3) sm ++;
            if (i + 1 < n && p[i + 1][j] == -4) sm += 2;

            if (j >= 1 && p[i][j - 1] == -1) sm ++;
            if (j >= 1 && p[i][j - 1] == -2) sm += 2;
            if (j + 1 < m && p[i][j + 1] == -1) sm ++;
            if (j + 1 < m && p[i][j + 1] == -2) sm += 2;

            if (sm != pzl[i][j]) return false;
        }
    }

    DSU dsu;
    dsu.Init(n * m);

    int cntV = 0;
    for (int i = 0; i < n; i ++)
        for (int j = 0; j < m; j ++)
            if (pzl[i][j] >= 1)
                cntV ++;
    
    for (int j = 0; j < m; j ++) {
        for (int i1 = 0; i1 < n; i1 ++) {
            if (pzl[i1][j] == 0) continue;
            for (int i2 = i1 + 2; i2 < n; i2 ++) {
                if (pzl[i2][j] == 0) continue;
                if (p[i2 - 1][j] != -3 && p[i2 - 1][j] != -4) break;
                dsu.Unite(i1 * m + j, i2 * m + j);
                break;
            }
        }
    }

    for (int i = 0; i < n; i ++) {
        for (int j1 = 0; j1 < m; j1 ++) {
            if (pzl[i][j1] == 0) continue;
            for (int j2 = j1 + 2; j2 < m; j2 ++) {
                if (pzl[i][j2] == 0) continue;
                if (p[i][j2 - 1] != -1 && p[i][j2 - 1] != -2) break;
                dsu.Unite(i * m + j1, i * m + j2);
                break;
            }
        }
    }

    return (cntV == dsu.cntUnite + 1);
}

// =============== recursion ============================ //

bool FIND_RES = false;

void Rec() {
    if (FIND_RES) return;
    int i = -1, j = -1;
    for (int pi = 0; pi < n; pi ++) {
        for (int pj = 0; pj < m; pj ++) {
            if (p[pi][pj] > 0) {
                i = pi, j = pj; break;
            }
        }
        if (i != -1) break;
    }
    if (i == -1) {
        if (Check()) {
            FIND_RES = true;
            for (int i = 0; i < n; i ++)
                for (int j = 0; j < m; j ++)
                    if (pzl[i][j] == 0)
                        pzl[i][j] = p[i][j];
        }
        return;
    }

    // ========== going right =============================== //

    int rj = -1;
    for (int jj = j + 1; jj < m; jj ++) {
        if (p[i][jj] < 0) break;
        if (pzl[i][jj] > 0) {
            if (p[i][jj] == 0) break;
            rj = jj;
            break;
        }
    }
    if (rj != -1 && p[i][j] >= 1 && p[i][rj] >= 1) {
        for (int jj = j + 1; jj < rj; jj ++)
            p[i][jj] = -1;
        p[i][j] --, p[i][rj] --;
        Rec();
        if (p[i][j] >= 1 && p[i][rj] >= 1) {
            for (int jj = j + 1; jj < rj; jj ++)
                p[i][jj] = -2;
            p[i][j] --, p[i][rj] --;
            Rec();
            p[i][j] ++, p[i][rj] ++;
        }
        p[i][j] ++, p[i][rj] ++;
        for (int jj = j + 1; jj < rj; jj ++)
            p[i][jj] = 0;
    }

    // ================= going left ========================== //

    int lj = -1;
    for (int jj = j - 1; jj >= 0; jj --) {
        if (p[i][jj] < 0) break;
        if (pzl[i][jj] > 0) {
            if (p[i][jj] == 0) break;
            lj = jj;
            break;
        }
    }
    if (lj != -1 && p[i][j] >= 1 && p[i][lj] >= 1) {
        for (int jj = j - 1; jj > lj; jj --)
            p[i][jj] = -1;
        p[i][j] --, p[i][lj] --;
        Rec();
        if (p[i][j] >= 1 && p[i][lj] >= 1) {
            for (int jj = j - 1; jj > lj; jj --)
                p[i][jj] = -2;
            p[i][j] --, p[i][lj] --;
            Rec();
            p[i][j] ++, p[i][lj] ++;
        }
        p[i][j] ++, p[i][lj] ++;
        for (int jj = j - 1; jj > lj; jj --)
            p[i][jj] = 0;
    }

    return;
}

bool solve(std::vector<std::vector<int>>& puzzle) {
    FIND_RES = false;

    pzl = puzzle;
    n = puzzle.size();
    m = puzzle[0].size();
    for (int i = 0; i < n; i ++)
        for (int j = 0; j < m; j ++)
            p[i][j] = puzzle[i][j];

    if (n * m >= 20) return false;

    vector<pair<Point, Point>> ve;
    for (int j = 0; j < m; j ++) {
        for (int i1 = 0; i1 < n; i1 ++) {
            if (p[i1][j] == 0) continue;
            for (int i2 = i1 + 2; i2 < n; i2 ++) {
                if (p[i2][j] == 0) continue;
                ve.push_back({{i1, j}, {i2, j}});
                break;
            }
        }
    }

    int mx = 1;
    for (int i = 0; i < ve.size(); i ++) mx *= 3;

    int COUNT = 0;

    for (int mask = 0; mask < mx; mask ++) {
        FIND_RES = false;
        pzl = puzzle;
        for (int i = 0; i < n; i ++)
            for (int j = 0; j < m; j ++)
                p[i][j] = puzzle[i][j];
        
        bool goodSol = true;

        int mm = mask;
        for (int ind = 0; ind < ve.size(); ind ++) {
            auto [p1, p2] = ve[ind]; int j = p1.j;
            int d = mm % 3; mm /= 3;
            p[p1.i][j] -= d;
            p[p2.i][j] -= d;
            if (p[p1.i][j] < 0 || p[p2.i][j] < 0) {
                goodSol = false;
                break;
            }
            for (int i = p1.i + 1; i < p2.i; i ++)
                p[i][j] = (d == 0 ? 0 : -2 - d);
        }

        if (!goodSol) continue;


        COUNT ++;

        Rec();

        if (!FIND_RES) {
            continue;
        }

        for (int i = 0; i < n; i ++)
            for (int j = 0; j < m; j ++)
                puzzle[i][j] = pzl[i][j];
        
        return true;

        // seems to be OK
        // cout << "variant:\n";
        // for (int i = 0; i < n; i ++) {
        //     for (int j = 0; j < m; j ++) cout << p[i][j] << ' ';
        //     cout << '\n';
        // }
        // cout << "--------------------\n";
    
    
    }

    // cout << COUNT << '\n';
    return false;
}
