#include <bits/stdc++.h>

using namespace std;

constexpr int MOD = 1e8 + 543;
using ll = long long;

vector<vector<int>> matmul(vector<vector<int>>& a, vector<vector<int>>& b) {
    vector<vector<int>> c(a.size(), vector<int>(b[0].size()));

    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < b[0].size(); j++) {
            for (int k = 0; k < a[0].size(); k++) {
                ll f = a[i][k], s = b[k][j];
                int ad = (f * s) % MOD;
                c[i][j] = (c[i][j] + ad) % MOD;
            }
        }
    }

    return c;
}

vector<vector<int>> pmult[60];

int getind(ll i) {
    if (i < 5) return i;
    i -= 4;

    vector<vector<int>> cur = {{0, 1, 2, 3, 4}};

    int j = 0;

    while (i > 0) {
        if (i & 1) {
            cur = matmul(cur, pmult[j]);
        }
        j++;
        i /= 2;
    }

    return cur[0][4];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;

    ll a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }  

    pmult[0] = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, 2}, {0, 1, 0, 0, 3},
                                {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};

    for (int i = 1; i < 60; i++) {
        pmult[i] = matmul(pmult[i - 1], pmult[i - 1]);
    }

    int vals[n];
    for (int i = 0; i < n; i++) {
        vals[i] = getind(a[i]);
    }

    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        l--; r--;
        if (type == 1) {
            printf("%i\n", vals[l]);
        }
        else {
            ll diff;
            cin >> diff;
            a[l] += diff;
            vals[l] = getind(a[l]);
        }
    }

    


}