#include <bits/stdc++.h>

#define ar array<int, 5>

using namespace std;

constexpr int MOD = 1e8 + 543;
using ll = long long;

vector<vector<int>> matmul(vector<vector<int>>& a, vector<vector<int>>& b) {
    vector<vector<int>> c(a.size(), vector<int>(b[0].size()));

    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < b[0].size(); j++) {
            for (int k = 0; k < a[0].size(); k++) {
                ll f = a[i][k], s = b[k][j];
                int ad = (f * s) % MOD;
                c[i][j] = (c[i][j] + ad) % MOD;
            }
        }
    }

    return c;
}

vector<vector<int>> pmult[60];

int getind(ll i) {
    if (i < 5) return i;
    i -= 4;

    vector<vector<int>> cur = {{0, 1, 2, 3, 4}};

    int j = 0;

    while (i > 0) {
        if (i & 1) {
            cur = matmul(cur, pmult[j]);
        }
        j++;
        i /= 2;
    }

    return cur[0][4];
}

ar getind(ar& curr, ll i) {
    int j = 0;

    vector<vector<int>> cur = {{0, 0, 0, 0, 0}};
    for (int i = 0; i < 5; i++) {
        cur[0][i] = curr[i];
    }

    while (i > 0) {
        if (i & 1) {
            cur = matmul(cur, pmult[j]);
        }
        j++;
        i /= 2;
    }
    ar ans;
    for (int i = 0; i < 5; i++) {
        ans[i] = cur[0][i];
    }

    return ans;
}




struct Segment {
    int n;
    vector<ar> seg;
    vector<int> lazy;

    Segment(vector<ar>& v) {
        n = v.size();
        seg.resize(4 * n);
        lazy.resize(4 * n);
        build(0, 0, n - 1, v);
    }

    void build(int ind, int low, int high, vector<ar>& v) {
        if (low == high) {
            seg[ind] = v[low];
        }
        else {
            int mid = (low + high) / 2;
            build(ind * 2 + 1, low, mid, v);
            build(ind * 2 + 2, mid + 1, high, v);
            for (int i = 0; i < 5; i++) {
                seg[ind][i] = (seg[ind *2 + 1][i] + seg[ind * 2 + 2][i]) % MOD;
            }
        }
    }

    int query(int ind, int low, int high, int l, int r) {
        if (lazy[ind] != 0) {
            seg[ind] = getind(seg[ind], lazy[ind]);
            if (low != high) {
                lazy[ind * 2 + 1] = (lazy[ind *2 + 1] + lazy[ind]) % MOD;
                lazy[ind * 2 + 2] = (lazy[ind * 2 + 2] + lazy[ind]) % MOD;
            }
            lazy[ind] = 0;
        }
        if (low > r || high < l || low > high) return 0;
        if (l <= low && high <= r) {
            return seg[ind][4];
        }
        else {
            int mid = (low + high) / 2;
            return query(ind * 2 + 1, low, mid, l, r) + query(ind * 2 + 2, mid + 1, high, l, r);
        }
    }

    int query(int l, int r) {
        return query(0, 0, n - 1, l, r);
    }


    void update(int ind, int low, int high, int l, int r, int val) {
        if (lazy[ind] != 0) {
            seg[ind] = getind(seg[ind], lazy[ind]);
            if (low != high) {
                lazy[ind * 2 + 1] = (lazy[ind *2 + 1] + lazy[ind]) % MOD;
                lazy[ind * 2 + 2] = (lazy[ind * 2 + 2] + lazy[ind]) % MOD;
            }
            lazy[ind] = 0;
        }
        if (low > r || high < l || low > high) return;
        if (l <= low && high <= r) {
            seg[ind] = getind(seg[ind], val);
            if (low != high) {
                lazy[ind * 2 + 1] = (lazy[ind *2 + 1] + val) % MOD;
                lazy[ind * 2 + 2] = (lazy[ind * 2 + 2] + val) % MOD;
            }
        }
        else {
            int mid = (low + high) / 2;
            update(ind * 2 + 1, low, mid, l, r, val);
            update(ind * 2 + 2, mid + 1, high, l, r, val);
            for (int i = 0; i < 5; i++) {
                seg[ind][i] = (seg[ind *2 + 1][i] + seg[ind * 2 + 2][i]) % MOD;
            }
        }
    }

    void update(int l, int r, int val) {
        val = ((val % (MOD - 1)) + MOD - 1) % (MOD - 1);
        update(0, 0, n - 1, l, r, val);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    pmult[0] = {{0, 0, 0, 0, 1}, {1, 0, 0, 0, 2}, {0, 1, 0, 0, 3},
                                {0, 0, 1, 0, 4}, {0, 0, 0, 1, 5}};

    for (int i = 1; i < 60; i++) {
        pmult[i] = matmul(pmult[i - 1], pmult[i - 1]);
    }


    int n, q;
    cin >> n >> q;

    ll a[n];
    vector<ar> v(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        for (int j = a[i] - 4; j <= a[i]; j++) {
            v[i][j - (a[i] - 4)] = getind(((j % (MOD - 1)) + MOD - 1) % (MOD - 1));
        }
    }  

    Segment seg = Segment(v);





    while (q--) {
        int type, l, r;
        cin >> type >> l >> r;
        l--; r--;
        if (type == 1) {
            printf("%i\n", seg.query(l, r));
        }
        else {
            ll diff;
            cin >> diff;
            seg.update(l, r, diff);
        }
    }

    


}