#include <iostream>
#include <vector>
#define ll long long
#define ld long double
#define inf (ll)(2*1e18)
#define endl '\n'
using namespace std;

const ll dim = 31, mod=1e8+543;

vector<vector<ll>> SHIFT(dim, vector<ll>(5));

void shiftBack(vector<ll>& a, ll x) {
    vector<ll> c(5);
    for (int i = 0; i < x; ++i) {
        for (int j = 1; j <= 4; ++j) {
            c[j] = -(5 - j + 1) * a[4] + a[j - 1];
            c[j] %= mod;
        }
        c[0] = a[4];
        swap(c, a);
    }
}

void shiftFront(vector<ll>& a, ll x) {
    vector<ll> c(5);
    for (int i = 0; i < x; ++i) {
        for (int j = 0; j < 4; ++j) {
            c[j] = (5 - j) * a[0] + a[j + 1];
            c[j] %= mod;
        }
        c[4] = a[0];
        swap(c, a);
    }
}

void shift(vector<ll>& a, ll x, ll k) {
    if (x == 0) return;
    vector<ll> res(5), b(5);
    int s = x;
    for (int i = 0; i < 5; ++i) {
        if (x > 0) {
            for (int j = 0; j < 5; ++j) {
                b[j] = (SHIFT[k][j] * a[i])%mod;
            }
            shiftBack(b, i);
            for (int j = 0; j < 5; ++j) {
                res[j] += b[j];
                res[j] %= mod;
            }
        }
        else {
            res[i - s] += a[i];
            res[i - s] %= mod;
        }
        --x;
    }
    swap(res, a);
}

ll get(vector<ll>& a, vector<ll>& b) {
    ll res = 0;
    for (int j = 0; j < 5; ++j) {
        res += (b[j] * a[j]) % mod;
        res %= mod;
    }
    return (res + mod) % mod;
}

int main()
{
    ll n, q, i, x, type, k, j, l, r;
    cin >> n >> q;
    vector<ll> b(5), c;
    SHIFT[0][0] = 5;
    SHIFT[0][1] = 4;
    SHIFT[0][2] = 3;
    SHIFT[0][3] = 2;
    SHIFT[0][4] = 1;
    b[4] = 0;
    b[3] = 1;
    b[2] = 2;
    b[1] = 3;
    b[0] = 4;
    for (i = 1; i < dim; ++i) {
        for(j=0;j<5;++j) SHIFT[i][j] = SHIFT[i - 1][j];
        shift(SHIFT[i], (1 << (i - 1)), i-1);
    }
    vector<ll> a(n);
    for (i = 0; i < n; ++i) {
        cin >> x;
        c = SHIFT[0];
        shiftBack(c, 5);
        for (j = 0; j < dim; ++j) {
            if (((1 << j) & x) == 0) continue;
            shift(c, (1 << j), j);
        }
        a[i] = get(c, b);
    }
    for (i = 1; i < n; ++i) a[i] += a[i - 1];
    for (i = 0; i < q; ++i) {
        cin >> type >> l >> r;
        --l;
        --r;
        if (type == 1) {
            if (l == 0) cout << a[r] << endl;
            else cout << a[r] - a[l-1] << endl;
        }
        else {
            cin >> x;
            a[l] += x;
        }
    }
}

