#include <iostream>
#include <vector>
#define ll long long
#define ld long double
#define inf (ll)(2*1e18)
#define endl '\n'
using namespace std;

const ll dim = 31, mod = 1e8 + 543;

vector<vector<ll>> SHIFT(dim, vector<ll>(5));

void shiftBack(vector<ll>& a, ll x) {
    vector<ll> c(5);
    for (int i = 0; i < x; ++i) {
        for (int j = 1; j <= 4; ++j) {
            c[j] = -(5 - j + 1) * a[4] + a[j - 1];
            c[j] %= mod;
        }
        c[0] = a[4];
        swap(c, a);
    }
}

void shiftFront(vector<ll>& a, ll x) {
    vector<ll> c(5);
    for (int i = 0; i < x; ++i) {
        for (int j = 0; j < 4; ++j) {
            c[j] = (5 - j) * a[0] + a[j + 1];
            c[j] %= mod;
        }
        c[4] = a[0];
        swap(c, a);
    }
}

void shift(vector<ll>& a, ll x, ll k) {
    if (x == 0) return;
    vector<ll> res(5), b(5);
    int s = x;
    for (int i = 0; i < 5; ++i) {
        if (x > 0) {
            for (int j = 0; j < 5; ++j) {
                b[j] = (SHIFT[k][j] * a[i]) % mod;
            }
            shiftBack(b, i);
            for (int j = 0; j < 5; ++j) {
                res[j] += b[j];
                res[j] %= mod;
            }
        }
        else {
            res[i - s] += a[i];
            res[i - s] %= mod;
        }
        --x;
    }
    swap(res, a);
}

ll get(vector<ll>& a, vector<ll>& b) {
    ll res = 0;
    for (int j = 0; j < 5; ++j) {
        res += (b[j] * a[j]) % mod;
        res %= mod;
    }
    return (res + mod) % mod;
}

void build(ll id, ll l, ll r, vector<vector<ll>>& a, vector<vector<ll>>& tree) {
    if (l == r) {
        tree[id] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(2 * id, l, m, a, tree);
    build(2 * id + 1, m + 1, r, a, tree);
    for (int i = 0; i < 5; ++i) {
        tree[id][i] = (tree[2 * id][i] + tree[2 * id + 1][i]) % mod;
    }
}

ll get(ll id, ll l, ll r, ll tl, ll tr, vector<ll>& b, vector<vector<ll>>& tree) {
    if (r < l or r < tl) return 0;
    if (tl <= l and r <= tr) {
        return get(tree[id], b);
    }
    ll m = (l + r) / 2;
    return (get(2 * id, l, m, tl, tr, b, tree) + get(2 * id + 1, m + 1, r, tl, tr, b, tree)) % mod;
}

int main()
{
    ll n, q, i, x, type, k, j, l, r;
    cin >> n >> q;
    vector<ll> b(5), c;
    SHIFT[0][0] = 5;
    SHIFT[0][1] = 4;
    SHIFT[0][2] = 3;
    SHIFT[0][3] = 2;
    SHIFT[0][4] = 1;
    b[4] = 0;
    b[3] = 1;
    b[2] = 2;
    b[1] = 3;
    b[0] = 4;
    for (i = 1; i < dim; ++i) {
        for (j = 0; j < 5; ++j) SHIFT[i][j] = SHIFT[i - 1][j];
        shift(SHIFT[i], (1 << (i - 1)), i - 1);
    }
    c = SHIFT[0];
    shiftBack(c, 5);
    vector<vector<ll>> a(n, c), tree(4*n, vector<ll>(5));
    for (i = 0; i < n; ++i) {
        cin >> x;
        for (j = 0; j < dim; ++j) {
            if (((1 << j) & x) == 0) continue;
            shift(a[i], (1 << j), j);
        }
    }
    build(1, 0, n - 1, a, tree);
    for (i = 0; i < q; ++i) {
        cin >> type >> l >> r;
        --l;
        --r;
        if (type == 1) {
            cout << get(1, 0, n - 1, l, r, b, tree) << endl;
        }
        else {
            cin >> x;
        }
    }
}