#include <bits/stdc++.h>
//#include <windows.h>
#include "puzzle.h"

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2")

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int N = 50;
int t[N][N];
vector < pair<int, int> > var[9];
const int dx[] = {0, 0, 1, -1};
const int dy[] = {1, -1, 0, 0};
int n, m;
int islands = 0;
double tl;

void init(int numSubtests, double timeLimit) {
    tl = timeLimit;

    for (int x = 1; x <= 8; x++)
        for (int two = 0; two <= 4; two++)
            for (int one = 0; one+two <= 4; one++)
                if (two * 2 + one == x)
                    var[x].push_back(make_pair(one, two));
}

bool inside(int x, int y) {
    return 0 <= x && x < n && 0 <= y && y < m;
}

set < pair<int, int> > vis;

bool rec(int i, int j) {
    if (timePassed() > tl / 3 * 2)
        return false;

    vis.insert(make_pair(i, j));

//    cout << i << ' ' << j << '\n';

    vector <int> free_dirs;

    int cnt0 = 0, cnt1 = 0;
    for (int d = 0; d < 4; d++) {
        int nx = i + dx[d], ny = j + dy[d];
        if (!inside(nx, ny))
            continue;
        if (t[nx][ny] == EMPTY) {
            free_dirs.push_back(d);
            continue;
        }
//        watch(t[nx][ny]);
//        watch(d);
        if (d <= 1 && (t[nx][ny] == HOR_SINGLE || t[nx][ny] == HOR_DOUBLE))
            cnt0 += (t[nx][ny] == HOR_SINGLE), cnt1 += (t[nx][ny] == HOR_DOUBLE);
        if (d > 1 && (t[nx][ny] == VERT_SINGLE || t[nx][ny] == VERT_DOUBLE))
            cnt0 += (t[nx][ny] == VERT_SINGLE), cnt1 += (t[nx][ny] == VERT_DOUBLE);
    }

    int X = t[i][j];

//    if (i == 2 && j == 0) {
//        watch(X);
//        watch(cnt0);
//        watch(cnt1);
//        watch(cnt0 + cnt1 * 2);
//    }

    if (cnt0 + 2*cnt1 > X)
        return false;

//    if (i == 0 && j == 4) {
//        watch(cnt0);
//        watch(cnt1);
//    }

//    cout << "inside!\n";

    for (auto [nt0, nt1] : var[X]) {
        if (cnt0 == nt0 && cnt1 == nt1) {
//            if (i == 2 && j == 0) {
//                cout << "THERE?\n";
//                watch(X);
//                watch(cnt0);
//                watch(cnt1);
//                watch(cnt0+2*cnt1);
//                watch(nt0+2*nt1);
//            }
            return true;
        }

        if (cnt0 > nt0 || cnt1 > nt1)
            continue;

//        if (i == 2 && j == 0) {
//            cout << "there.\n";
//            watch(nt0);
//            watch(nt1);
//        }

        nt0 -= cnt0;
        nt1 -= cnt1;

//        cout << "we are there, check variant where we have " << (nt0) << " single roads and " << (nt1) << " double roads!\n";

        // remains to place (nt0) single bridge and (nt1) double bridge.
        // we need to choose where we want to place, 4! = 2 * 3 * 4 = 24, just brute?
        // but we need to use only free of those.

        int sz = (int)free_dirs.size();

        if (sz < nt0 + nt1)
            continue;

//        if (i == 2 && j == 0) {
//            cout << "there.\n";
//        }

        vector <int> order(sz);
        iota(all(order), 0);

        do {
            // just check if we can draw, then check all neighbours that are connected to us, if we can to place for them
            bool can = true;
            for (int c = 0; c < nt0+nt1 && can; c++) {
                int v = order[c];
                v = free_dirs[v];
                // try to draw in direction (dx[v]; dy[v]), just in stupid way?
                int x = i, y = j;
                while (inside(x + dx[v], y + dy[v]) && t[x + dx[v]][y + dy[v]] == EMPTY)
                    x += dx[v], y += dy[v];
                if (!inside(x + dx[v], y + dy[v]) || t[x + dx[v]][y + dy[v]] <= 0)
                    can = false;
            }

            if (!can)
                continue;

            bool total_can = true;
            int last = -1;
            for (int c = 0; c < nt0 + nt1 && total_can; c++) {
                int v = order[c];
                v = free_dirs[v];
                int x = i, y = j;
                int value = 0;
                if (c < nt0) {
                    // single
                    if (dx[v]) value = VERT_SINGLE;
                    else value = HOR_SINGLE;
                } else {
                    // double
                    if (dx[v]) value = VERT_DOUBLE;
                    else value = HOR_DOUBLE;
                }
                if (t[x + dx[v]][y + dy[v]] == value) {
                    last = c;
                    continue;
                }
                while (inside(x + dx[v], y + dy[v]) && t[x + dx[v]][y + dy[v]] == EMPTY) {
                    x += dx[v], y += dy[v];
//                    if (i == 1 && j == 6) watch(x), watch(y);
                    t[x][y] = value;
                }
                x += dx[v], y += dy[v];
//                if (x < 0) {
//                    watch(i);
//                    watch(j);
//                }
                // something
                last = c;

                if (!rec(x, y))
                    total_can = false;
            }

            if (total_can)
                return true;

            for (int c = last; c >= 0; c--) {
                int v = order[c];
                int x = i, y = j;

                int value = 0;
                if (c < nt0) {
                    // single
                    if (dx[v] == 0) value = VERT_SINGLE;
                    else value = HOR_SINGLE;
                } else {
                    // double
                    if (dx[v] == 0) value = VERT_DOUBLE;
                    else value = HOR_DOUBLE;
                }

                while (inside(x + dx[v], y + dy[v]) && t[v + dx[v]][y + dy[v]] == value) {
                    x += dx[v]; y += dy[v];
                    t[x][y] = EMPTY;
                }
            }

        } while (next_permutation(all(order)));
    }

//    if (i == 2 && j == 0) {
//        cout << "RETURN FALSE!\n";
//    }

    return false;
}

bool solve(std::vector<std::vector<int>>& puzzle) {
    n = (int)puzzle.size();
    m = (int)puzzle[0].size();

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            t[i][j] = puzzle[i][j];
            if (t[i][j])
                islands++;
        }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (t[i][j]) {
                if (rec(i, j) && (int)vis.size() == islands) {
                    for (int i = 0; i < n; i++)
                        for (int j = 0; j < m; j++)
                            puzzle[i][j] = t[i][j];
                    return true;
                }
//                cout << "bad, check res:\n";
//                for (int i = 0; i < n; i++, cout << '\n')
//                    for (int j = 0; j < m; j++)
//                        cout << t[i][j] << ' ';
//                cout << '\n';
//                return false;
                vis.clear();
                for (int i = 0; i < n; i++)
                    for (int j = 0; j < m; j++)
                        t[i][j] = puzzle[i][j];
            }

    return 0;
}
